#include <stdio.h>
#include <ctype.h>
/**********************************************************************/
      int free00(FILE *lun) {
      long i4; float r4; double r8; char cn,c1; short i2; int ii;
      if(lun == NULL) return(-2);
      return (freexx((int)0,lun,&i4,&r4,&r8,&cn,&c1,&i2,&ii));
}
/**********************************************************************/
      int freei4(long *i4,FILE *lun) {
      float r4; double r8; char cn,c1; short i2; int ii;
      return (freexx((int)1,lun,i4,&r4,&r8,&cn,&c1,&i2,&ii));
}
/**********************************************************************/
      int freer4(float *r4,FILE *lun) {
      long i4; double r8; char cn,c1; short i2; int ii;
      return (freexx((int)2,lun,&i4,r4,&r8,&cn,&c1,&i2,&ii));
}
/**********************************************************************/
      int freer8(double *r8,FILE *lun) {
      long i4; float r4; char cn,c1; short i2; int ii;
      return (freexx((int)3,lun,&i4,&r4,r8,&cn,&c1,&i2,&ii));
}
/**********************************************************************/
      int freecn(char *cn,FILE *lun) {
      long i4; float r4; double r8; char c1; short i2; int ii;
      return (freexx((int)4,lun,&i4,&r4,&r8,cn,&c1,&i2,&ii));
}
/**********************************************************************/
      int freec1(char *c1,FILE *lun) {
      long i4; float r4; double r8; char cn; short i2; int ii;
      return (freexx((int)5,lun,&i4,&r4,&r8,&cn,c1,&i2,&ii));
}
/**********************************************************************/
      int freei2(short *i2,FILE *lun) {
      long i4; float r4; double r8; char cn,c1; int ii;
      return (freexx((int)6,lun,&i4,&r4,&r8,&cn,&c1,i2,&ii));
}
/**********************************************************************/
      int freeii(int *ii,FILE *lun) {
      long i4; float r4; double r8; char cn,c1; short i2;
      return (freexx((int)7,lun,&i4,&r4,&r8,&cn,&c1,&i2,ii));
}
/**********************************************************************/
      int freexx(int icase,FILE *lun,long *i4,float *r4,double *r8
                ,char *cn,char *c1,short *i2,int *ii) {
/*    ============================================================    */
      static char   line[256],field[64];
      static int    istar=1,ncdat=0;
      int           ibegn,istop,itype,k,idebug=0;
      double        rvalx;
/*    ============================================================    */
/*    lun!=NULL read data from next field in new/old lines            */
/*    lun==NULL read data from old line (even if no data left)        */
/*    lun!=NULL && icase==0 :  read a new line(s)                     */
/*    ------------------------------------------------------------    */
/*    case 1 all variables must be present for this case              */
/*       use lun!=NULL & icase>0 for all variables                    */
/*    ------------------------------------------------------------    */
/*    case 2 zero's can be neglected at the tail of line              */
/*       use lun!=NULL & icase=0 to read a new line with >=1 field    */
/*           lun==NULL & icase>0 to read a variable in this line      */
/*    ============================================================    */
/*      field1             fieldxx    field3    field4  ;comment      */
/*    123456789012345678901234567890123456789012345678901234567890    */
/*    ^       ^            ^^^^^^^                   ^                */
/*        istar=9      ibegn=22  istop=28            ncdat=48         */
/*    ============================================================    */
      *i4=0; *r4=0; *r8=0; *cn='\0'; *c1='\0'; *i2=0; *ii=0;
      if(lun != NULL) {
        if(icase == 0 || istar > ncdat) {
          istar=1; ncdat=0;
          do {
            fgets(line,256,lun); if(feof(lun)) return(-1);
            for(k=0; k<256; k++) {
              if(line[k] == '\0' || line[k] == ';' ||
                 line[k] == '\n' || line[k] == '\r') break;
              if(line[k] != ' '  && line[k] != ',' ) ncdat=k+1;
            }
          } while (ncdat == 0);
        }
      }
      if(icase == 0) return(0);    /* no data required */
      if(istar > ncdat) return(0); /* all values have been set to 0 */

      datfld(line,ncdat,&istar,&ibegn,&istop,field,&itype);

      if(itype == 3 && icase != 4 && icase != 5) {
        if(numfre(field,istop-ibegn+1,&rvalx) != 0) goto L_er;
        *i4=rvalx; *r4=rvalx; *r8=rvalx; *i2=rvalx; *ii=rvalx;
        return(0);
      }

      switch(icase) {
        case 1: goto L_i4;
        case 2: goto L_r4;
        case 3: goto L_r8;
        case 4: goto L_cn;
        case 5: goto L_c1;
        case 6: goto L_i2;
        case 7: goto L_ii;
      }

 L_i4:if(sscanf(field,"%ld",i4) == 0) {printf("\nfreei4"); goto L_er;}
      if(idebug != 0) printf("%d \n",*i4);       /* *i4=atol(field); */
      return(0);
 L_r4:if(sscanf(field,"%f", r4) == 0) {printf("\nfreer4"); goto L_er;}
      if(idebug != 0) printf("%f \n",*r4);       /* *r4=atof(field); */
      return(0);
 L_r8:if(sscanf(field,"%lf",r8) == 0) {printf("\nfreer8"); goto L_er;}
      if(idebug != 0) printf("%lf\n",*r8);       /* *r8=atof(field); */
      return(0);
 L_cn:strcpy(cn,field);
      if(idebug != 0) printf("%s \n", cn);
      return(0);
 L_c1:if(sscanf(field,"%c", c1) == 0) {printf("\nfreec1"); goto L_er;}
      if(idebug != 0) printf("%c \n",*c1);       /* *c1=field[0];    */
      return(0);
 L_i2:if(sscanf(field,"%d", i2) == 0) {printf("\nfreei2"); goto L_er;}
      if(idebug != 0) printf("%d \n",*i2);       /* *i2=atoi(field); */
      return(0);
 L_ii:if(sscanf(field,"%d", ii) == 0) {printf("\nfreeii"); goto L_er;}
      if(idebug != 0) printf("%d \n",*ii);       /* *ii=atoi(field); */
      return(0);

 L_er:printf(" : error reading following line :");
      printf("\n%s",line);
      for(k=1; k<ibegn; k++) printf(" ");
      for(k=ibegn; k<=istop; k++) printf("^"); printf("\n");
      return(icase);
}
/**********************************************************************/
      int datfld(char datlin[],int ncdat
          ,int *istar,int *ibegn,int *istop,char field[],int *itype) {
/*    ============================================================    */
      int   nc,is,ip;
      char  datlst;
      --datlin; --field;
/*    ============================================================    */
/*    separate the data fields and identify its data type             */
/*    ------------------------------------------------------------    */
/*    input : datlin(1:ncdat),ncdat,istar                             */
/*    output: ibegn,istop,istar                                       */
/*            field(1:nc)=datlin(ibegn:istop),itype                   */
/*    ------------------------------------------------------------    */
/*    datlin: 1 10 1,51 10 x= 0,8,0 y=0, 0,5  z=2.5*6                 */
/*    field : 1 10 1 51 10 x= 0 8 0 y= 0 0 5  z= 2.5*6                */
/*    itype : 2  2 2  2  2  1 2 2 2  1 2 2 2   1     3                */
/*    ============================================================    */
      *itype=2;
      nc=0;
      is=*istar-1;
/*    +----------------------------------------------------------+    */
/*    | skip leading spaces and ','                              |    */
/*    +----------------------------------------------------------+    */
  L10:is=is+1;
      *ibegn=is;
      if(is > ncdat) goto L90;
      if(datlin[is] == ' ' || datlin[is] == ',') goto L10;
/*    +----------------------------------------------------------+    */
/*    | process 'string''s data type' --> string's data type     |    */
/*    +----------------------------------------------------------+    */
      ip=0; if(datlin[is] == '\'' && is != ncdat) {ip=1; is=is+1;}
/*    +----------------------------------------------------------+    */
/*    | save the non-space characters in data field              |    */
/*    +----------------------------------------------------------+    */
  L20:nc=nc+1;
      field[nc]=datlin[is];
      datlst=tolower(datlin[is]);
      is=is+1;
/*    +----------------------------------------------------------+    */
/*    | test if field[] = "name="                                |    */
/*    +----------------------------------------------------------+    */
      if(datlst == '=' && ip != 1) {
        *itype=1;                        /* field[] = "name=" */
      } else if(is <= ncdat) {
        if(datlin[is] == '/' || datlin[is] == '*') {*itype=3; goto L20;}
        if(datlin[is] == '+' || datlin[is] == '-') {
          if(datlst == 'e') goto L20;    /* sign in 99e+99 */
          if(datlst == 'd') goto L20;    /* sign in 99d-99 */
          *itype=3;         goto L20;    /* field[]=999-99 */
        }
/*    +----------------------------------------------------------+    */
/*    | process 'string''s data type' --> string's data type     |    */
/*    +----------------------------------------------------------+    */
        if(datlin[is] == '\'' && ip == 1) {
          is=is+1;                            /* skip char  '   */
          if(datlin[is] == '\'') goto L20;    /* ng''s --> ng's */
          goto L90;                           /* type' --> type */
        }
/*    +----------------------------------------------------------+    */
/*    | test end-of-field (space or ',')                         |    */
/*    +----------------------------------------------------------+    */
        if(datlin[is] != ' ' && datlin[is] != ',') goto L20;
        if(ip == 1) goto L20;  /* process 'string''s data type' */
      }
  L90:*istop=is-1;
      *istar=is;
      field[nc+1]='\0';
      return(0);
}
/**********************************************************************/
      int numfre(char field[],int nc,double *rvalx) {
/*    ============================================================    */
      int    ibegn,istop;
      char   opcode;
      double xval;
      --field;
/*    ============================================================    */
/*    convert type 3 data field into real value rvalx                 */
/*    ------------------------------------------------------------    */
/*    input : field(1:nc),nc;  output : rvalx                         */
/*    ------------------------------------------------------------    */
/*    field(1:nc) = -99e+9*9.99e2/99.9+999d2-999d-2/999               */
/*    rvalx =  ((((-99e+9*9.99e2)/99.9)+999d2)-999d-2)/999            */
/*    ============================================================    */
      *rvalx=0;
      ibegn=1;
      while(ibegn <= nc) {
        nfield(&field[1],nc,ibegn,&istop);
        if(sscanf(&field[ibegn],"%lf",&xval) == 0) return(-1);
        opcode=field[ibegn-1];
        if(ibegn == 1)         *rvalx=       xval;
        else if(opcode == '+') *rvalx=*rvalx+xval;
        else if(opcode == '-') *rvalx=*rvalx-xval;
        else if(opcode == '*') *rvalx=*rvalx*xval;
        else if(opcode == '/') *rvalx=*rvalx/xval;
        ibegn=istop+2;
      }
      return(0);
}
/**********************************************************************/
      int nfield(char field[],int nc,int ibegn,int *istop) {
/*    ============================================================    */
      int  is;
      char datlst;
      --field;
/*    ============================================================    */
/*    separate the numeric fields                                     */
/*    ------------------------------------------------------------    */
/*    input : field(1:nc),nc,ibegn;  output : istop                   */
/*    ------------------------------------------------------------    */
/*    field(1:nc)        = -99e+9*9.99e2/99.9+999d2-999d-2/999        */
/*    field(ibegn:istop) = -99e+9 9.99e2 99.9 999d2 999d-2 999        */
/*    ============================================================    */
      is=ibegn;
      while(is < nc) {
        if(field[is+1] == '*' || field[is+1] == '/') break;
        if(field[is+1] == '+' || field[is+1] == '-') {
          datlst=tolower(field[is]);
          if(datlst != 'e' && datlst != 'd') break;    /* not e-99 */
        }
        is=is+1;
      }
      *istop=is;
      return(0);
}
/**********************************************************************/
