#include <math.h>
double xzero(double, double, double, int, double *);
/**********************************************************************/
      int froot(double *pxx,double *pfx,double (*f)(),double xini
               ,double dx,double eps,int itmax,double flmt) {
/*    int froot(pxx,pfx,f,xini,dx,eps,itmax,flmt)
      double *pxx,*pfx,(*f)(),xini,dx,eps,flmt; int itmax;
/*    ============================================================    */
      double buf[11];
      double xo,xx,xn,fo,fx,fn,errx,flmy;
      int    nstp,istep,i;
      extern double xzero();
/*    ============================================================    */
/*    find root of f(xx)=0 from the initial guess xini                */
/*    ============================================================    */
                      nstp=itmax;
      if(nstp == 0)   nstp=12;
                      errx=eps;
      if(errx == 0.0) errx=0.000001;
      if(xini != 0.0) errx=errx*fabs(xini);
                      flmy=flmt;
      if(flmy == 0.0) flmy=1.0e30;
/*    ------------------------------------------------------------    */
      xn=xini;
      for(istep=1; istep<=nstp; istep++) {
        xx=xn;
        fx=f(xx);
        xn=xzero(xx,fx,dx,istep,buf);
        printf("\nfroot\n");
        for(i=0; i<11; i++) {
          printf("%13.5le",buf[i]);
          if(i%6 == 5) printf("\n");
        }
        if(fabs(xn-xx) <= errx) break;
        if(fabs(fx) > flmy) break;
      }
      *pxx=xx; *pfx=fx; return(0);
}
/**********************************************************************/
      int groot(double *pxn,double *pxx,double (*g)()
               ,double xini,double eps,int itmax) {
/*    int groot(xn,xx,g,xini,eps,itmax)
      double *pxn,*pxx,(*g)(),xini,eps; int itmax; {                  */
/*    ============================================================    */
      double buf[11];
      double xo,xx,xn,errx,zero=0.0;
      int    nstp,istep,i;
      extern double xzero();
/*    ============================================================    */
/*    find root of xx=g(xx) from the initial guess xini               */
/*    ============================================================    */
                      nstp=itmax;
      if(nstp == 0)   nstp=12;
                      errx=eps;
      if(errx == 0.0) errx=0.000001;
      if(xini != 0.0) errx=errx*fabs(xini);
/*    ------------------------------------------------------------    */
      xn=xini;
      for(istep=1; istep<=nstp; istep++) {
        xx=xn;
        xn=(*g)(xx);
        xn=xzero(xx,xn-xx,zero,istep,buf);
        printf("\ngroot\n");
        for(i=0; i<11; i++) {
          printf("%13.5le",buf[i]);
          if(i%6 == 5) printf("\n");
        }
        if(fabs(xn-xx) <= errx) break;
      }
      *pxn=xn; *pxx=xx; return(0);
}
/**********************************************************************/
      int sroot(double *pxx,double *pfx,double (*f)(),double xini
               ,double xfin,double dx,double eps,int itmax,double flmt){
/*    int sroot(xx,fx,f,xini,xfin,dx,eps,itmax,flmt)
      double *pxx,*pfx,(*f)(),xini,xfin,dx,eps,flmt; int itmax; {     */
/*    ============================================================    */
      double buf[11];
      double xn,xx,fo,fx,dxx,errx,flmy;
      int    nstp,istep,i;
      extern double xzero();
/*    ============================================================    */
/*    search root of f(xx)=0 from xini to xfin step dx                */
/*    ============================================================    */
                      nstp=itmax;
      if(nstp == 0)   nstp=12;
                      errx=eps;
      if(errx == 0.0) errx=0.000001;
      if(xini != 0.0) errx=errx*fabs(xini);
                      flmy=flmt;
      if(flmy == 0.0) flmy=1.0e30;
                      dxx =(xfin-xini)/16;
      if(dx   != 0.0) dxx =(xfin>xini) ? fabs(dx) : -fabs(dx);
/*    ------------------------------------------------------------    */
      xn=xini;
      fx=1.0;
      for(istep=1; istep<=nstp; istep++) {
  L10:  xx=xn;
        fo=fx;
        fx=f(xx);
/*      +--------------------------------------------------------+    */
/*      | search interval with root                              |    */
/*      +--------------------------------------------------------+    */
        if(istep == 2) {
          if((xfin-xx)*(xini-xx) > 0.0) {
            printf("\nNo root between %15.6le and %15.6le\n",xini,xfin);
            break;
          }
          if(fx*fo > 0.0) {
            xn=xzero(xx,fx,dxx,1,buf);
            printf("\nsroot\n");
            for(i=0; i<11; i++) {
              printf("%13.5le",buf[i]);
              if(i%6 == 5) printf("\n");
            }
            goto L10;
          }
        }
/*      ----------------------------------------------------------    */
        xn=xzero(xx,fx,dxx,istep,buf);
        printf("\nsroot\n");
        for(i=0; i<11; i++) {
          printf("%13.5le",buf[i]);
          if(i%6 == 5) printf("\n");
        }
        if(fabs(xn-xx) <= errx) break;
        if(fabs(fx) > flmy) break;
      }
      *pxx=xx; *pfx=fx; return(0);
}
/**********************************************************************/
