************************************************************************
      SUBROUTINE FROOT(XX,FX,F,XINI,DX,EPS,ITMAX,FLMT)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION BUF(11)
C**   ============================================================    **
C**   Find root of F(XX)=0 from the initial guess XINI                **
C**   ============================================================    **
                      NSTP=ITMAX
      IF(NSTP.EQ.0)   NSTP=12
                      ERRX=EPS
      IF(ERRX.EQ.0.0) ERRX=0.000001
      IF(XINI.NE.0.0) ERRX=ERRX*ABS(XINI)
                      FLMY=FLMT
      IF(FLMY.EQ.0.0) FLMY=1.0E30
C**   ------------------------------------------------------------    **
      XN=XINI
      DO 20 ISTEP=1,NSTP
        XX=XN
        FX=F(XX)
        XN=XZERO(XX,FX,DX,ISTEP,BUF)
        WRITE(*,'('' FROOT''/(1X,1P6E13.6))') BUF
        IF(DABS(XN-XX).LE.ERRX) RETURN
        IF(DABS(FX).GT.FLMY) RETURN
   20 CONTINUE
      RETURN
      END
************************************************************************
      SUBROUTINE GROOT(XN,XX,G,XINI,EPS,ITMAX)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION BUF(11)
      ZERO=0.0
C**   ============================================================    **
C**   Find root of XX=G(XX) from the initial guess XINI               **
C**   ============================================================    **
                      NSTP=ITMAX
      IF(NSTP.EQ.0)   NSTP=12
                      ERRX=EPS
      IF(ERRX.EQ.0.0) ERRX=0.000001
      IF(XINI.NE.0.0) ERRX=ERRX*ABS(XINI)
C**   ------------------------------------------------------------    **
      XN=XINI
      DO 20 ISTEP=1,NSTP
        XX=XN
        XN=G(XX)
        XN=XZERO(XX,XN-XX,ZERO,ISTEP,BUF)
        WRITE(*,'('' DIRSUB''/(1X,1P6E13.6))') BUF
        IF(DABS(XN-XX).LE.ERRX) RETURN
   20 CONTINUE
      RETURN
      END
************************************************************************
      SUBROUTINE SROOT(XX,FX,F,XINI,XFIN,DX,EPS,ITMAX,FLMT)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION BUF(11)
C**   ============================================================    **
C**   Search root of F(XX)=0 from XINI to XFIN step DX                **
C**   ============================================================    **
                      NSTP=ITMAX
      IF(NSTP.EQ.0)   NSTP=12
                      ERRX=EPS
      IF(ERRX.EQ.0.0) ERRX=0.000001
      IF(XINI.NE.0.0) ERRX=ERRX*ABS(XINI)
                      FLMY=FLMT
      IF(FLMY.EQ.0.0) FLMY=1.0E30
                      DXX =(XFIN-XINI)/16
      IF(DXX .NE.0.0) DXX =SIGN(ABS(DX),XFIN-XINI)
C**   ------------------------------------------------------------    **
      XN=XINI
      FX=1.0
      DO 20 ISTEP=1,NSTP
   10   XX=XN
        FO=FX
        FX=F(XX)
C**     +--------------------------------------------------------+    **
C**     | Search interval with root                              |    **
C**     +--------------------------------------------------------+    **
        IF(ISTEP.EQ.2) THEN
          IF((XFIN-XX)*(XINI-XX).GT.0.0) THEN
            WRITE(*,'('' NO ROOT BETWEEN'',1P2E15.6)') XINI,XFIN
            RETURN
          ENDIF
          IF(FX*FO.GT.0.0) THEN
            XN=XZERO(XX,FX,DXX,1,BUF)
            WRITE(*,'('' SROOT''/(1X,1P6E13.6))') BUF
            GO TO 10
          ENDIF
        ENDIF
C**     ----------------------------------------------------------    **
        XN=XZERO(XX,FX,DXX,ISTEP,BUF)
        WRITE(*,'('' SROOT''/(1X,1P6E13.6))') BUF
        IF(DABS(XN-XX).LE.ERRX) RETURN
        IF(DABS(FX).GT.FLMY) RETURN
   20 CONTINUE
      RETURN
      END
************************************************************************
