#include <math.h>
/**********************************************************************/
      int frootn(int n,double fx[],double xx[],double xn[],double x0[]
                ,double dx[],double err[],double flm[],int step[]
                ,double buf[],double (*fun)()) {
/*    int frootn(n,fx,xx,xn,x0,dx,err,flm,step,buf,fun)
      int n,step[]; double fx[],xx[],xn[],x0[],dx[],err[],flm[],buf[];
      double (*fun)(); {                                              */
/*    ============================================================    */
      int i,nt,nstep=12;
      extern double xzero();
      --fx; --xx; --xn; --x0; --dx; --err; --flm; --step;
      --buf; buf-=11;
/*    ============================================================    */
/*i   n         = number of variables                                 */
/*o   fx(n)     = function values                                     */
/*o   xx(n)     = root find by this subroutine                        */
/*w   xn(n)     = new values of x(n) during iteration                 */
/*i   x0(n)     = initial values for the first try                    */
/*i   dx(n)     = increment values for the second try                 */
/*i   err(n)    = tolerance of xx(n)                                  */
/*i   flm(n)    = limited function values of fx(n)                    */
/*w   step(n)   = current iteration step for each variable            */
/*w   buf(11,n) = buffers                                             */
/*f   fun(x,i)  = function to calculate f_i(x) for given x(n) & i     */
/*    ============================================================    */
      for(i=1; i<=n; i++) xn[i]=x0[i];
/*    ------------------------------------------------------------    */
      i=0; nt=0;
  L50:i=i+1;
/*    +----------------------------------------------------------+    */
/*    | enter i-th loop : do step(i)=1,nstep                     |    */
/*    +----------------------------------------------------------+    */
      printf("\nEnter %d loop",i);
      step[i]=1;
  L60:xx[i]=xn[i];
      if(i < n) goto L50;
/*    ------------------------------------------------------------    */
  L70:fx[i]=fun(&xx[1],i);
      xn[i]=xzero(xx[i],fx[i],dx[i],step[i],&buf[1+i*11]);
/*    printf("\n i,xx,fx %d %15.6le %15.6le",i,xx[i],fx[i]);          */
      if(fabs(xn[i]-xx[i]) <= err[i]) goto L80;
      if(fabs(fx[i]) > flm[i]) goto L90;
      step[i]=step[i]+1;
      if(step[i] <= nstep) goto L60;
/*    +----------------------------------------------------------+    */
/*    | leave i-th loop                                          |    */
/*    +----------------------------------------------------------+    */
  L80:i=i-1;
      printf("\nLeave loop %d after %d steps with fx =%15.6le"
            ,i+1,step[i+1],fx[i+1]);
      printf("\nIn loop %d step %d",i,step[i]);
      nt=nt+step[i+1];
      if(i >= 1) goto L70;
  L90:
      printf("\nNumber of function evaluations : %d",nt);
      return(0);
}
/**********************************************************************/
