#include <math.h>
/**********************************************************************/
      int gsiter(int n,double fx[],double xx[],double xn[],double x0[]
                ,double dx[],double err[],double flm[],double xi[]
                ,double buf[],double (*fun)()) {
/*    int gsiter(n,fx,xx,xn,x0,dx,err,flm,xi,buf,fun)
      int n; double fx[],xx[],xn[],x0[],dx[],err[],flm[],xi[],buf[];
      double (*fun)(); {                                              */
/*    ============================================================    */
      int i,step,nstep=12,iter,niter=500;
      extern double xzero();
      --fx; --xx; --xn; --x0; --dx; --err; --flm; --xi;
/*    ============================================================    */
/*i   n         = number of variables                                 */
/*o   fx(n)     = function values                                     */
/*o   xx(n)     = root find by this subroutine                        */
/*w   xn(n)     = new values of xx(n) during equation solving         */
/*i   x0(n)     = initial values for the first try                    */
/*i   dx(n)     = increment values for the second try                 */
/*i   err(n)    = tolerance of xx(n)                                  */
/*i   flm(n)    = limited function values of fx(n)                    */
/*w   xi(n)     = initial values of xx(n) during iteration            */
/*w   buf(11)   = buffers                                             */
/*f   fun(x,i)  = function to calculate f_i(x) for given x(n) & i     */
/*    ============================================================    */
      for(i=1; i<=n; i++) {xx[i]=x0[i]; xn[i]=x0[i];}
/*    ------------------------------------------------------------    */
      for(iter=1; iter<=niter; iter++) {
/*      ----------------------------------------------------------    */
        for(i=1; i<=n; i++) {
          xi[i]=xn[i];
/*        +------------------------------------------------------+    */
/*        | find xx(i) such that fx(i)=f_i(xx)=0                 |    */
/*        +------------------------------------------------------+    */
          for(step=1; step<=nstep; step++) {
            xx[i]=xn[i];
            fx[i]=fun(&xx[1],i);
            xn[i]=xzero(xx[i],fx[i],dx[i],step,buf);
            if(fabs(xn[i]-xx[i]) <= err[i]) break;
            if(fabs(fx[i]) > flm[i]) goto L90;
          }
/*        printf("\niter,i,step,xx[i],fx[i] : %d %d %d %15.6le %15.6le"
                   ,iter,i,step,xx[i],fx[i]);                         */
        }
/*      +--------------------------------------------------------+    */
/*      | convergence check                                      |    */
/*      +--------------------------------------------------------+    */
        for(i=1; i<=n; i++) {
          if(fabs(xx[i]-xi[i]) > err[i]) goto L80;
        }
        goto L90;
/*      ----------------------------------------------------------    */
  L80:;
      }
      printf("\nThe number of iterations exceeds %d",niter);
  L90:return(0);
}
/**********************************************************************/
