#include <math.h>
/**********************************************************************/
      int nrootn(int n,double fx[],double xx[],double x0[],double err[]
         ,double d[],int ll[],int (*jac)(),double (*fun)()) {
/*    int nrootn(n,fx,xx,x0,err,d,ll,jac,fun)
      double fx[],xx[],x0[],err[],d[],(*fun)();
      int    n,ll[],(*jac)(); {                                       */
/*    ============================================================    */
      int    nsd,i,iter,niter=500;
      extern int lufpdc(),lufpsb();
      --fx; --xx; --x0; --err; --d; d-=n; /* --ll; ll-=2; */
/*    ============================================================    */
/*i   n        = number of variables                                  */
/*o   fx(n)    = function values                                      */
/*o   xx(n)    = root find by this subroutine                         */
/*i   x0(n)    = initial values for the first try                     */
/*i   err(n)   = tolerance of x(n)                                    */
/*w   d(n,n)   = jacobian matrix                                      */
/*w   ll(2,n)  = row/column permutation index                         */
/*s   jac(x,d) = subroutine to calculate d(n,n) for given x(n)        */
/*f   fun(x,i) = function   to calculate f_i(x) for given x(n) & i    */
/*    ============================================================    */
      for(i=1; i<=n; i++) xx[i]=x0[i];
      for(iter=1; iter<=niter; iter++) {
/*    +----------------------------------------------------------+    */
/*    | compute fx(n),d(n,n)                                     |    */
/*    +----------------------------------------------------------+    */
      for(i=1; i<=n; i++) fx[i]=fun(&xx[1],i);
      jac(&xx[1],&d[1+n],n);
/*    ------------------------------------------------------------    */
/*    for(i=1; i<=n; i++) {printf("\ni = %d ",i);                     */
/*      for(j=1; j<=n; j++) printf("%15.6le",d[i+j*n]);               */
/*    }                                                               */
      printf("\niter = %d :",iter);
      for(i=1; i<=n; i++) printf("%15.6le",fx[i]);
/*    +----------------------------------------------------------+    */
/*    | solve -dx from  d(n,n)*dx(n) = -fx(n)                    |    */
/*    | get xx(n).new = xx(n).old + dx                           |    */
/*    +----------------------------------------------------------+    */
      lufpdc(&d[1+1*n],ll,n,&nsd,n);
      lufpsb(&d[1+1*n],&fx[1],ll,n,n);
      for(i=1; i<=n; i++) xx[i]=xx[i]-fx[i];
/*    ------------------------------------------------------------    */
/*    for(i=1; i<=n; i++) {printf("\ni = %d ",i);                     */
/*      for(j=1; j<=n; j++) printf("%15.6le",d[i+j*n]);               */
/*    }                                                               */
      printf("\niter = %d :",iter);
      for(i=1; i<=n; i++) printf("%15.6le",fx[i]);
/*    +----------------------------------------------------------+    */
/*    | convergence check                                        |    */
/*    +----------------------------------------------------------+    */
      for(i=1; i<=n; i++) {if(fabs(fx[i]) > err[i]) goto L80;}
      return(0);
  L80:;
      }
      printf("\nThe number of iterations exceeds",niter);
      return(0);
}
/**********************************************************************/
