#include <stdio.h>
#include <ctype.h>
#include <math.h>
double fun(double *, int);
int    jac(double *, double *, int);
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      main(int argc,char **argv) { /* *envp */
/*    ============================================================    */
      FILE   *fopen(), *fp_r, *fp_w;
      double x0[5],dx[5],err[5],flm[5];
      double fx[5],xx[5],xn[5],xi[5],buf[55],d[25]; /* buf(11,5) */
      double er[3]={0.1,0.2,0.5};                   /* d(5,5)    */
      int    step[5],ll[10],n,isub,i;               /* ll(2,5)   */
      extern double fun();
      extern int jac(),gsiter(),frootn(),nrootn();
/*    ============================================================    */
      if(argc > 1) {if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);}
      else         {if((fp_r=fopen("con",  "r"))==NULL) exit(-1);}
      if(argc > 2) {if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);}
      else         {if((fp_w=fopen("con",  "w"))==NULL) exit(-1);}
/*    ============================================================    */
 loop:freeii(&n,fp_r); if(n == 0) exit(0);
      freeii(&isub,fp_r); if(isub > 3) exit(0);
      printf("\n n,isub =%3d,%5d",n,isub);

      for(i=1; i<=5; i++) {
        x0[i-1] =i-er[isub-1];
        dx[i-1] =0.1;
        err[i-1]=1.0e-6;
        flm[i-1]=1.0e20;
        xx[i-1] =i;
      }
      for(i=1; i<=n; i++) fx[i-1]=fun(xx,i);
      fprintf(fp_w,"\nxx  ");
      for(i=1; i<=n; i++) fprintf(fp_w,"%13.5le",xx[i-1]);
      fprintf(fp_w,"\nfx  ");
      for(i=1; i<=n; i++) fprintf(fp_w,"%13.5le",fx[i-1]);
/*    ------------------------------------------------------------    */
      switch (isub) {
        case 1: gsiter(n,fx,xx,xn,x0,dx,err,flm,xi,buf,fun);   break;
        case 2: frootn(n,fx,xx,xn,x0,dx,err,flm,step,buf,fun); break;
        case 3: nrootn(n,fx,xx,x0,err,d,ll,jac,fun);
                for(i=1; i<=n; i++) fx[i-1]=fun(xx,i); break;
      }
/*    ------------------------------------------------------------    */
      fprintf(fp_w,"\nxx  ");
      for(i=1; i<=n; i++) fprintf(fp_w,"%13.5le",xx[i-1]);
      fprintf(fp_w,"\nfx  ");
      for(i=1; i<=n; i++) fprintf(fp_w,"%13.5le",fx[i-1]);
      goto loop;
}
/**********************************************************************/
      double fun(double x[],int i) {
/*    double fun(x,i)
      double x[]; int i; {                                            */
/*    ============================================================    */
      double x12,x13,x14,x22,x23,x24,x32,x33,x42,x43,x52,x53,f;
      --x;
/*    ============================================================    */
      x12=x[1]*x[1]; x13=x12*x[1]; x14=x12*x12;
      x22=x[2]*x[2]; x23=x22*x[2]; x24=x22*x22;
      x32=x[3]*x[3]; x33=x32*x[3];
      x42=x[4]*x[4]; x43=x42*x[4];
      x52=x[5]*x[5]; x53=x52*x[5];
      switch (i) {
        case 1: f=-x12-2*x22+3*x32+4*x42-5*x52+ 43; break;
        case 2: f= x13+2*x23-3*x33-4*x43+5*x53-305; break;
        case 3: f= x14-2*x23-3*x32+4*x42+5*x53-647; break;
        case 4: f= x12+2*x24-3*x33+4*x43+3*x52-283; break;
        case 5: f= x12-2*x23+3*x32-4*x43+5*x52+119; break;
      }
      return(f);
}
/**********************************************************************/
      int jac(double x[],double d[],int n) {
/*    int jac(x,d,n)
      double x[],d[]; int n; {                                        */
/*    ============================================================    */
      --x; --d; d-=n;        /* dimension x(n),d(n,n) */
/*    ============================================================    */
      d[1+1*n]= -2*x[1];
      if(n == 1) return(0);
      d[1+2*n]= -4*x[2];
      d[2+1*n]=  3*x[1]*x[1];
      d[2+2*n]=  6*x[2]*x[2];
      if(n == 2) return(0);
      d[1+3*n]=  6*x[3];
      d[2+3*n]= -9*x[3]*x[3];
      d[3+1*n]=  4*x[1]*x[1]*x[1];
      d[3+2*n]= -6*x[2]*x[2];
      d[3+3*n]= -6*x[3];
      if(n == 3) return(0);
      d[1+4*n]=  8*x[4];
      d[2+4*n]=-12*x[4]*x[4];
      d[3+4*n]=  8*x[4];
      d[4+1*n]=  2*x[1];
      d[4+2*n]=  8*x[2]*x[2]*x[2];
      d[4+3*n]= -9*x[3]*x[3];
      d[4+4*n]= 12*x[4]*x[4];
      if(n == 4) return(0);
      d[1+5*n]=-10*x[5];
      d[2+5*n]= 15*x[5]*x[5];
      d[3+5*n]= 15*x[5]*x[5];
      d[4+5*n]=  6*x[5];
      d[5+1*n]=  2*x[1];
      d[5+2*n]= -6*x[2]*x[2];
      d[5+3*n]=  6*x[3];
      d[5+4*n]=-12*x[4]*x[4];
      d[5+5*n]= 10*x[5];
      return(0);
}
/**********************************************************************/
