#include <math.h>
/**********************************************************************/
      int search(double *pxx,double *pfx,double (*f)(),double xmin
                ,double xmax,double dx,int icut,double flmt) {
/*    int search(pxx,pfx,f,xmin,xmax,dx,icut,flmt)
      double *pxx,*pfx,(*f)(),xmin,xmax,dx,flmt; int icut; {          */
/*    ============================================================    */
      double fn,fp,f1,f2=0.0,fx,xn,xp,x1,x2=0.0,xx;
      int    ir,ie=0;
/*    ============================================================    */
/*i   xx   = argument of function                                     */
/*i   fx   = function value of xx, f(xx)                              */
/*f   f(x) = function to calculate f(x)                               */
/*i   xmin,xmax,dx = search limits and increment for root             */
/*i   icut = max number of iterations                                 */
/*i   flmt = limited function values of f(xx)                         */
/*    ============================================================    */
      fn= 1.0e30;
      fp=-1.0e30;
      xx=xmin;
      ir=0;
/*    +----------------------------------------------------------+    */
/*    | compute function value                                   |    */
/*    +----------------------------------------------------------+    */
  L30:fx=f(xx);
      ir=ir+1;
      if(fx == 0.0) {*pxx=xx; *pfx=fx; return(0);}
/*    printf("\nir,fx,xx" %d,%15.6le,%15.6le",ir,fx,xx);              */
/*    +----------------------------------------------------------+    */
/*    | return on discontinuous point                            |    */
/*    +----------------------------------------------------------+    */
      if(fabs(fx) >= flmt) {*pxx=xx; *pfx=fx; return(0);}
/*    +----------------------------------------------------------+    */
/*    | push down old values, and put the new one on top         |    */
/*    +----------------------------------------------------------+    */
      x1=x2;
      x2=xx;
      f1=f2;
      f2=fx;
/*    +----------------------------------------------------------+    */
/*    | set limits for next new root                             |    */
/*    +----------------------------------------------------------+    */
      if(fx < 0.0) {
        xn=xx;
        if(fx < fn) ie=ie-1;
        fn=fx;
      } else {
        xp=xx;
        if(fx > fp) ie=ie-1;
        fp=fx;
      }
/*    +----------------------------------------------------------+    */
/*    | search interval for changing sign                        |    */
/*    +----------------------------------------------------------+    */
      if(fn*fp > 0.0) {
        if(xx > xmax) {
          printf("\nNo root between %15.6le %15.6le",xmin,xmax);
          {*pxx=xx; *pfx=fx; return(0);}
        }
        xx=xx+dx;
        ie=ir+icut;
        goto L30;
      }
/*    +----------------------------------------------------------+    */
/*    | get new root by secant method                            |    */
/*    +----------------------------------------------------------+    */
      if(f1 != f2) {
        xx=x1-f1*(x1-x2)/(f1-f2);
/*      +--------------------------------------------------------+    */
/*      | check if the new root goes outside the limits          |    */
/*      +--------------------------------------------------------+    */
        if((xx-xp)*(xx-xn) > 0.0) {
/*        +------------------------------------------------------+    */
/*        | yes: get new root by false position method           |    */
/*        +------------------------------------------------------+    */
          xx=xp-fp*(xp-xn)/(fp-fn);
        }
      }
/*    +----------------------------------------------------------+    */
/*    | check the iteration numbers                              |    */
/*    +----------------------------------------------------------+    */
      if(ir <= ie) goto L30;
      printf("\nThe number of iterations exceeds %d",icut);
      *pxx=xx; *pfx=fx; return(0);
}
/**********************************************************************/
