#include <math.h>
double powdi(double,int);
/**********************************************************************/
      int romq(double xa,double xb,double (*f)()
              ,double *parea,double *pareb,double eps,int iop[]) {
/*    int romq(xa,xb,f,parea,pareb,eps,iop)
      double xa,xb,(*f)(),*parea,*pareb,eps; int iop[]; {             */
/*    ============================================================    */
      double aa[2305],ba[2305];    int ma[411];
      double ya[41],yc[41],yd[41]; int ls[41],lv[41],lx[41],ly[41];
      int    namax=2304,nmmax=410,nymax=40;    /* max dimensions      */
      int    ltmax=41,lsmax=7,lymin=1,idebg=0; /* or set by iop(0:3)  */
      int    kfunc,ksubc,klvlm,kdimm;          /* return in iop(4:7)  */
      double xoa,hor,ess,xx,r4p,t2,h1,h2,h4;
      int    lpp,npp,lss,nss,ipp,nsf,lnv,lov,np;
      int    lmm,lor,los,lvv,ixx,iyy,lay,lns;
      if(iop[0]>0) ltmax=iop[0]; else ltmax=41;
      if(iop[1]>0) lsmax=iop[1]; else lsmax=7;
      if(iop[2]>0) lymin=iop[2]; else lymin=1;
      if(iop[3]>0) idebg=iop[3]; else idebg=0;
/*    ============================================================    */
/*           / xb                                                     */
/*    area = |   f(x) dx  such that  |area-areb| < |area|*eps         */
/*          / xa                                                      */
/*                        area is more accurate than areb             */
/*    ------------------------------------------------------------    */
/*i   ltmax = 11-41   : max. levels of total layers (31-41)           */
/*i   lsmax = 3-13    : max. levels in a layer       (7-9)            */
/*i   lymin = 0-lsmax : min. layers with full levels  (1)             */
/*i   idebg = 0-3     : index for debug output                        */
/*o   kfunc = number of function calls                                */
/*o   ksubc = number of sub-romt calls                                */
/*o   klvlm = number of total levels    <= ltmax                      */
/*o   kdimm = number of used dimensions <= namax                      */
/*         <= 2**(lsmax-1)*(ltmax-lsmax+2)    = 8704  (9,41,9)        */
/*         <= 2**(lsmax-1)*(layer-1)+2**lsmax = 8192 (13,1,13)        */
/*     2304 : (ltmax,lsmax,lymin) = (41, 7,1)                         */
/*             recommend for eps >= 1.e-8                             */
/*     8704 : (ltmax,lsmax,lymin) = (41, 9,1)                         */
/*             recommend for eps  < 1.e-8                             */
/*     8192 : (ltmax,lsmax,lymin) = (13,13,1)                         */
/*             for one layer pure romberg-table                       */
/*    ============================================================    */
      lay=1;
      xoa=xa;
      hor=xb-xa;
      lmm=0;
      lor=1;
      los=1;
      ma[1+lmm]=0;
      ma[2+lmm]=1;
      aa[1]=(*f)(xa);
      aa[2]=(*f)(xb);
      if(idebg > 1) printf("\n %12.4le%12.4le%3d%3d%3d%3d%3d%3d",
                                        xoa,hor,0,lor,1,1,los,1);
      kfunc=2;
      ksubc=0;
      klvlm=1;
      kdimm=2;
/*    ------------------------------------------------------------    */
/*    romt(xoa,hor,lor,los,lmm,lay,f,eps);                            */
/*    *parea=aa[1];                                                   */
/*    *pareb=ba[1];                                                   */
/*    return(0)                                                       */
/*    end                                                             */
/**********************************************************************/
/*    subroutine romt (xoa,hor,lor,los,lmm,lay,f,eps)                 */
/*    common/romq00/ ltmax,lsmax,lymin,idebg,kfunc,ksubc,klvlm,kdimm  */
/*    common/romq01/ aa(8704),ba(8704),ma(410)                        */
/*    +----------------------------------------------------------+    */
/*    | the whole interval (lvv,ixx)=(1,1) is correct ?          |    */
/*    | y:2000 : break from romt (no more call romt)             |    */
/*    +----------------------------------------------------------+    */
L1000:if(los >= 2) {
        ess=eps/powdi(2.0,(lor-1));
        lss=ma[1+lmm];
        if(fabs(aa[1+lss]-ba[1+lss]) <= fabs(aa[1])*ess) goto L2000;
      }
/*    +----------------------------------------------------------+    */
/*    | if any sub-interval (lvv,ixx) is correct ?               |    */
/*    | y:2100: call romt for other sub-interv (lvv,iyy)         |    */
/*    +----------------------------------------------------------+    */
      if(los == lsmax || lay > lymin) {
        nss=1;
/*      ess=eps/powdi(2.0,(lor-1));  ! not ess=eps/(1L<<(lor-1))      */
        for(lvv=2; lvv<=los-1; lvv++) {
          ess=ess/2;
          nss=nss*2;
          lss=ma[lvv+lmm];
          for(ixx=1; ixx<=nss; ixx++) {
          if(fabs(aa[ixx+lss]-ba[ixx+lss])<=fabs(aa[1])*ess) goto L2100;
          }
        }
      }
/*    +----------------------------------------------------------+    */
/*    | if max. sub-levels (lsmax) has been reached ?            |    */
/*    | y: romt for both sub-interv (lvv,1) (lvv,2)         |    */
/*    +----------------------------------------------------------+    */
      if(los == lsmax) {
        lvv=2;
        ixx=2;
        iyy=1;
        goto L2200;
      }
/*    +----------------------------------------------------------+    */
/*    | double the sub-sections                                  |    */
/*    +----------------------------------------------------------+    */
      nss=powdi(2.0,los);
      lss=ma[los+1+lmm];
      if(lss+nss > namax || lmm+los >= nmmax) goto L2000;
      ma[los+2+lmm]=lss+nss;
      npp=nss/2;
      lpp=ma[los+lmm];
      los=los+1;
      h1=hor/nss;
      h2=h1*2;
      h4=h2*2;
      xx=xoa+hor-h1;
      kfunc=kfunc+npp;
      r4p=3;
/*    +----------------------------------------------------------+    */
/*    | add one more lower level of this layer                   |    */
/*    +----------------------------------------------------------+    */
      aa[nss+1+lss]=aa[npp+1+lpp];
      for(np=npp; np>=1; np--) {
        aa[2*np-1+lss]=aa[np+lpp];
        aa[2*np  +lss]=(*f)(xx);
        ba[np+lpp]=h1*(aa[2*np-1+lss]+aa[2*np+1+lss]);
        aa[np+lpp]=(ba[np+lpp]+h4*aa[2*np+lss])/r4p;
        xx=xx-h2;
      }
/*    +----------------------------------------------------------+    */
/*    | reset romberg-tree of this layer                         |    */
/*    +----------------------------------------------------------+    */
      for(lvv=los-2; lvv>=1; lvv--) {
        r4p=r4p*4+3;
        npp=npp/2;
        lpp=ma[lvv  +lmm];
        lss=ma[lvv+1+lmm];
        for(np=npp; np>=1; np--) {
          ba[np+lpp]=aa[np+lpp];
          t2=aa[2*np-1+lss]+aa[2*np+lss];
          aa[np+lpp]=t2+(t2-ba[np+lpp])/r4p;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | total level > ltmax ?                                    |    */
/*    | n:1000 : add one more level of the tree                  |    */
/*    | y:4000 : exit from romt                                  |    */
/*    +----------------------------------------------------------+    */
      if(lor+los <= ltmax) goto L1000;
L2000:goto L4000;
/*    +----------------------------------------------------------+    */
/*    | save the given sub-interval number (correct one)         |    */
/*    +----------------------------------------------------------+    */
L2100:iyy=ixx;
/*    +----------------------------------------------------------+    */
/*    | at top level || dim > nmmax || layer > nymax ?           |    */
/*    | y:4000 : exit from romt                                  |    */
/*    | n:     : integrate the other sub-interval                |    */
/*    +----------------------------------------------------------+    */
L2200:if(lvv == 1) goto L4000;
      if(lmm+los+los-lvv+2 > nmmax || lay > nymax)  goto L4000;
      lss=ma[lvv+lmm];
      ess=eps/powdi(2.0,(lor+lvv-2));
      ixx=((ixx+1)/2)*4-ixx-1;
/*    +----------------------------------------------------------+    */
/*    | if the other sub-interval correct ?                      |    */
/*    | n:3000 : romt for the other sub-interval calls           |    */
/*    | y:2500 : correct or return from romt                     |    */
/*    +----------------------------------------------------------+    */
      if(fabs(aa[ixx+lss]-ba[ixx+lss]) > fabs(aa[1])*ess) goto L3000;
/*    +----------------------------------------------------------+    */
/*    | if both sub-intervals finish ?                           |    */
/*    | n:2200 : for 1st sub-intv do 2nd sub-intv                |    */
/*    | y:     : combine two sub-interval & up one level         |    */
/*    +----------------------------------------------------------+    */
L2500:if(ixx == iyy) goto L2200;
      lvv=lvv-1;
      ipp=(ixx+1)/2;
      lpp=ma[lvv  +lmm];
      lss=ma[lvv+1+lmm];
      ba[ipp+lpp]=ba[ixx+lss]+ba[iyy+lss];
      aa[ipp+lpp]=aa[ixx+lss]+aa[iyy+lss];
      if(idebg > 2) {
        printf("\n %27d%3d%3d%3d%19.4le%12.4le",
          -lay,lor,lvv,ipp,aa[ipp+lpp],ba[ipp+lpp]-aa[ipp+lpp]);
        printf("\n %33d%3d%31.4le%12.4le",
                 lvv+1,ixx,ba[ixx+lss]-aa[ixx+lss],aa[ixx+lss]);
        printf("\n %36d%31.4le%12.4le",
                       iyy,ba[iyy+lss]-aa[iyy+lss],aa[iyy+lss]);
      }
      ixx=ipp;
      goto L2100;
/*    +----------------------------------------------------------+    */
/*    | setup romberg-tree for next layer from old one           |    */
/*    | push  xoa,(hor,lor),los,(lmm,lay),lvv,ixx,iyy            |    */
/*    |                                   of this layer          |    */
/*    | reset xoa, hor,lor ,los, lmm,lay  of next layer          |    */
/*    | call  romt (xoa,hor,lor,los,lmm,lay,f,eps)               |    */
/*    +----------------------------------------------------------+    */
L3000:nsf=ixx-1;
      lnv=los+2;
      for(lov=lvv; lov<=los; lov++) {
        ma[lnv+lmm]=ma[lov+lmm]+nsf;
        nsf=nsf*2;
        lnv=lnv+1;
      }
      ma[lnv+lmm]=ma[los+1+lmm];
      if(idebg > 1) printf("\n %12.4le%12.4le%3d%3d%3d%3d%3d%3d",
                          xoa,hor,lay,lor,lvv,ixx,los,los-lvv+1);
      ls[lay]=los;
      lv[lay]=lvv;
      lx[lay]=ixx;
      ly[lay]=iyy;
      ya[lay]=xoa;
      yc[lay]=aa[1+ma[los  +lmm]];
      yd[lay]=aa[1+ma[los+1+lmm]];
      lay=lay+1;
      hor=hor/powdi(2.0,(lvv-1));
      xoa=xoa+hor*(ixx-1);
      lmm=lmm+los+1;
      lor=lor+lvv-1;
      los=los-lvv+1;
      goto L1000;
/*    +----------------------------------------------------------+    */
/*    | pop xoa,hor,(lor),los,(lmm,lay),lvv,ixx,iyy of this layer|    */
/*    | exit from lower level romt                               |    */
/*    +----------------------------------------------------------+    */
L4000:ksubc=ksubc+1;
      if(lor+los-1     > klvlm) klvlm=lor+los-1;
      if(ma[los+1+lmm] > kdimm) kdimm=ma[los+1+lmm];
      if(lay == 1) goto L4500;
      lns=los;
      lay=lay-1;
      iyy=ly[lay];
      ixx=lx[lay];
      lvv=lv[lay];
      los=ls[lay];
      lor=lor-lvv+1;
      lmm=lmm-los-1;
      hor=hor*powdi(2.0,(lvv-1));
      xoa=ya[lay];
      aa[1+ma[los  +lmm]]=yc[lay];
      aa[1+ma[los+1+lmm]]=yd[lay];
      if(idebg > 1)
      printf("\n %12.4le%12.4le%3d%3d%3d%3d%3d%3d%13.4le%12.4le",
           xoa,hor,-lay,lor,lvv,ixx,los,lns,aa[ixx+ma[lvv+lmm]]
                       ,ba[ixx+ma[lvv+lmm]]-aa[ixx+ma[lvv+lmm]]);
      goto L2500;
/*    +----------------------------------------------------------+    */
/*    | exit from top level romt                                 |    */
/*    +----------------------------------------------------------+    */
L4500:*parea=aa[1];
      *pareb=ba[1];
      iop[4]=kfunc;
      iop[5]=ksubc;
      iop[6]=klvlm;
      iop[7]=kdimm;
      if(idebg > 0) printf("\n %3d%3d%3d%3d%6d%6d%6d%6d%19.11le%12.4le",
                       ltmax,lsmax,lymin,idebg,kfunc,ksubc,klvlm,kdimm
                                                 ,*parea,*pareb-*parea);
      return(0);
}
/**********************************************************************/
      double powdi(double b,int i) {
/*    double powdi(b,i) double b; int i; {                            */
/*    ============================================================    */
      double p;
/*    ============================================================    */
/*    return b**i                                                     */
/*    ============================================================    */
      if(i < 0) {i=-i; b=1.0/b;}
      if((i & 1) != 0) p=b; else p=1.0;
      while ((i >>= 1) != 0) {
        b=b*b;
        if((i & 1) != 0) p=p*b;
      }
      return(p);
}
/**********************************************************************/
