#include <stdio.h>
#include <ctype.h>
#include <math.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
struct {
      double r,s,r1,s1,rs,sr;
} pio;
/**********************************************************************/
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      int  iop[8]; /* ltmax,lsmax,lymin,idebg,kfunc,ksubc,klvlm,kdimm */
      FILE   *fopen(),*fp_r,*fp_w;
      double ya,yb,za,zb,zc,ya2,yb2,eps,ara0,arb0,ara1,arb1;
      double araa,arbb,area;
      int    romq(),romr();
      double f0(),f1(),g0();
/*    ============================================================    */
/*    find the integral of exp(-y**2) from ya to yb.                  */
/*    the change of variable y=sqrt(-ln(z)) transforms                */
/*      the integral into (1/2)sqrt(-ln(z))                           */
/*      from zb=exp(-yb**2) to za=exp(-ya**2).                        */
/*    then divide the interval into [zb,1/e] and [1/e,za].            */
/*    for z:[zb,1/e] change variable to x by z^{1/3-1}dz=dx           */
/*    for z:[1/e,za] change variable to v by z=1-v                    */
/*    and v:[1-za,1-1/e] change var. to x by v^{1/2-1}dv=dx           */
/*    ============================================================    */
      if(argc<2) {printf("Usage : romqmn infile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
  L10:freer8(&ya, fp_r); if(ya == 0.0) ya = 1.0e-6; if(ya < 0) exit(0);
      freer8(&yb, fp_r); if(yb == 0.0) yb = 1.0e+6;
      freer8(&eps,fp_r); if(eps== 0.0) eps= 1.0e-7;
      freeii(&iop[0],fp_r);   /* ltmax */
      freeii(&iop[1],fp_r);   /* lsmax */
      freeii(&iop[2],fp_r);   /* lymin */
      freeii(&iop[3],fp_r);   /* idebg */
/*    +----------------------------------------------------------+    */
/*    | area = series expansions + asymptotic expansion          |    */
/*    +----------------------------------------------------------+    */
      ya2=ya*ya;
      yb2=yb*yb;
      area=sqrt(3.14159265358979)/2-ya
          *(1-ya2/(3*1)+ya2*ya2/(5*2*1)-ya2*ya2*ya2/(7*3*2*1));
      if(yb < 7.0) area=area-exp(-yb2)/(2*yb)
          *(1-1/(2*yb2)+1*3/(4*yb2*yb2)-1*3*5/(8*yb2*yb2*yb2));
      printf("\n %12.4le%12.4le%12.4le%19.11le",ya,yb,exp(-1.0),area);
/*    +----------------------------------------------------------+    */
/*    | integration by the change of variable:                   |    */
/*    | y = sqrt(-ln(z)),  z = exp(-y**2)                        |    */
/*    | z:[za,zb] divided into z:[za,1/e] and z:[1/e,zb]         |    */
/*    +----------------------------------------------------------+    */
      za=exp(-ya*ya);
      zb=exp(-yb*yb);
      zc=exp(-1.0);
      pio.s=1.0;
/*    +----------------------------------------------------------+    */
/*    | for z:[zb,1/e] change variable by z^{r-1}dz=dx           |    */
/*    |                f0(x) = g0(z)*z**(1-r)                    |    */
/*    |                g0(z) = sqrt(-ln(z))                      |    */
/*    +----------------------------------------------------------+    */
      pio.r=1.0/3.0;
      romr (zb,zc,f0,&ara0,&arb0,eps,iop);
      if(iop[3]<=0) printf("\n %3d%3d%3d%3d%6d%6d%6d%6d%19.11le%12.4le"
         ,iop[0],iop[1],iop[2],iop[3],iop[4],iop[5],iop[6],iop[7]
         ,ara0,arb0-ara0);
/*    +----------------------------------------------------------+    */
/*    | for z:[1/e,za] change variable by z=1-v to v             |    */
/*    | v:[1-za,1-1/e] change variable by v^{r-1}dv=dx           |    */
/*    |                f1(x) = g1(v)*v**(1-r)                    |    */
/*    |                g1(v) = g0(1-v) = sqrt(-ln(z))            |    */
/*    +----------------------------------------------------------+    */
      pio.r=1.0/2.0;
      romr (1.0-za,1.0-zc,f1,&ara1,&arb1,eps,iop);
      if(iop[3]<=0) printf("\n %3d%3d%3d%3d%6d%6d%6d%6d%19.11le%12.4le"
         ,iop[0],iop[1],iop[2],iop[3],iop[4],iop[5],iop[6],iop[7]
         ,ara1,arb1-ara1);
/*    ------------------------------------------------------------    */
      printf("\n %12.4le%12.4le%12.4le%19.11le%12.4le%12.4le"
            ,zb,1-za,eps,ara0+ara1,arb0+arb1-ara0-ara1,area-ara0-ara1);
/*    +----------------------------------------------------------+    */
/*    | araa = value by romberg integration tree                 |    */
/*    +----------------------------------------------------------+    */
      romq (zb,za,g0,&araa,&arbb,eps,iop);
      if(iop[3]<=0) printf("\n %3d%3d%3d%3d%6d%6d%6d%6d%19.11le%12.4le"
         ,iop[0],iop[1],iop[2],iop[3],iop[4],iop[5],iop[6],iop[7]
         ,araa,arbb-araa);
/*    ------------------------------------------------------------    */
      printf("\n %12.4le%12.4le%12.4le%19.11le%12.4le%12.4le"
                        ,zb,za,eps,araa,arbb-araa,area-araa);
      goto L10;
}
/**********************************************************************/
      int romr(double za,double zb,double (*f)()
              ,double *paraa,double *parbb,double eps,int iop[]) {
/*    int romr(za,zb,f,paraa,parbb,eps,iop)
      double za,zb,(*f)(),*paraa,*parbb,eps; int iop[];               */
/*    ============================================================    */
      double xa,xb;
      int    romq();
/*    ============================================================    */
/*       zb          zb              xb              xb               */
/*      /           /      r-1      /      s-1      /                 */
/*     | g(z) dz = | g(z) z   dz = | f(x) x   dx = | f(x) dx          */
/*    /           /               /               /                   */
/*    za          za              xa              xa                  */
/*                                       1-r                          */
/*                   f(x) = g(z) = g(z) z                             */
/*                                                                    */
/*                 s-1        1-r s-1            1/r-1 s/r-1          */
/*    f(x) = f(x) x   = g(z) z   x   = g(z) (r/s)     x               */
/*                                                                    */
/*                       r-1      s-1                                 */
/*                      z   dz = x   dx                               */
/*     -----------------------------------------------------------    */
/*     if r  !=  0 ( and  s  !=  0 ) :                                */
/*                                                                    */
/*                 1/r  s/r                     1/s  r/s              */
/*        z = (r/s)    x       and     x = (s/r)    z                 */
/*     -----------------------------------------------------------    */
/*     if r  ==  0 ( and  s  !=  0 ) :                                */
/*                                                                    */
/*                       s                           1/s              */
/*        z = exp((1/s) x )    and     x = (s log(z))                 */
/*    ============================================================    */
/*    this program requires the conditions (0) and ((1) or (2))       */
/*    (0) za > 0 and zb > 0                                           */
/*    (1) 1 > r > 0 and s > r (s = 1 is the best)                     */
/*    (2)     r = 0 and s = 1                                         */
/*    ============================================================    */
      if(pio.r != 0.0) {
         pio.r1=1.0/pio.r;
         pio.s1=1.0/pio.s;
         pio.rs=pio.r*pio.s1;
         pio.sr=pio.s*pio.r1;
         pio.r1=pow(pio.rs,pio.r1);
         pio.s1=pow(pio.sr,pio.s1);
         xa=pio.s1*pow(za,pio.rs);
         xb=pio.s1*pow(zb,pio.rs);
      } else {
         xa=log(za);
         xb=log(zb);
      }
      romq (xa,xb,f,paraa,parbb,eps,iop);
      return(0);
}
/**********************************************************************/
      double f0(double x) {
/*    double f0(x) double x; {                                        */
/*    ============================================================    */
      double z,fun;
      double g0();
/*    ============================================================    */
      if(pio.r != 0.0) {
         z=pio.r1*pow(x,pio.sr);
         if(pio.s == 1.0) {
            fun=g0(z)*pow(z,(1-pio.r));
         } else {
            fun=g0(z)*pio.r1*pio.sr*pow(x,(pio.sr-1));
         }
      } else {
         z=exp(x);
         fun=g0(z)*z;
      }
      return(fun);
}
/**********************************************************************/
      double f1(double x) {
/*    double f1(x) double x; {                                        */
/*    ============================================================    */
      double z,fun;
      double g1();
/*    ============================================================    */
      if(pio.r != 0.0) {
         z=pio.r1*pow(x,pio.sr);
         if(pio.s == 1.0) {
            fun=g1(z)*pow(z,(1-pio.r));
         } else {
            fun=g1(z)*pio.r1*pio.sr*pow(x,(pio.sr-1));
         }
      } else {
         z=exp(x);
         fun=g1(z)*z;
      }
      return(fun);
}
/**********************************************************************/
      double g0(double z) {
/*    double g0(z) double z; {                                        */
/*    ============================================================    */
      double fun;
/*    ============================================================    */
      if(z <= 0.0) {
         fun=0.0;
      } else if(z >= 1.0) {
         fun=1.0e7;
      } else {
         fun=0.5/sqrt(-log(z));
      }
      return(fun);
}
/**********************************************************************/
      double g1(double z) {
/*    double g1(z) double z; {                                        */
/*    ============================================================    */
      double fun;
/*    ============================================================    */
/*    fun=g0(1.0-z);                                                  */
      if(z <= 0.0) {
         fun=1.0e30;
      } else if(z >= 1.0) {
         fun=0.0;
      } else if(z <= 1.e-3) {
         fun=0.5/sqrt(((((z/5.+1/4.)*z+1/3.)*z+1/2.)*z+1)*z);
      } else {
         fun=0.5/sqrt(-log(1.0-z));
      }
      return(fun);
}
/**********************************************************************/
