#include <stdio.h>
#include <ctype.h>
#include <string.h>
/**********************************************************************/
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      double a[8000],rval[7];
      int    ll[2000],ival[7];
      int    n[7],nrow[7],ncol[7],nr[7],nc[7],m[7];
      char   *file[7];
      char   *stat[3]={" ","r","w"};
      char   *func[9]={"   "
      ,"add","sub","mul","inv","lud","fsb","bsb","sol"};
      int    ist[9][7]={0,0,0,0,0,0,0
      ,0,1,1,2,0,0,0  /* add o1 o2 n3 : n3 = o1 + o2 */
      ,0,1,1,2,0,0,0  /* sub o1 o2 n3 : n3 = o1 - o2 */
      ,0,1,1,2,0,0,0  /* mul o1 o2 n3 : n3 = o1 * o2 */
      ,0,1,2,0,0,0,0  /* inv o1 n2    : n2 = inv.o1 */
      ,0,1,2,0,0,0,0  /* lud o1 n2    : n2 = l.n2 + u.n2 = lu.o1 */
      ,0,1,1,2,0,0,0  /* fsb o1 o2 n3 : n3 = inv.l.o1 * o2 */
      ,0,1,1,2,0,0,0  /* bsb o1 o2 n3 : n3 = inv.u.o1 * o2 */
      ,0,1,1,2,0,0,0};/* sol o1 o2 n3 : n3 = inv.u.o1 * inv.l.o1 * o2 */
      int    ndima=8000,ndiml=2000,nfun=8;
      int    narg,i,j,k,ii,npt,mpt;
      int    ma,mb,mm,nn;
      int    not,nnt,nsd;
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | get the arguments                                        |    */
/*    +----------------------------------------------------------+    */
      narg=argc-1;
      for(i=0; i<argc; i++) {
        file[i]=(char *)malloc(strlen(argv[i])+1);
        strcpy(file[i],argv[i]);
        tolow(file[i]);
      }
/*    +----------------------------------------------------------+    */
/*    | c:\direct\add  -->  add                                  |    */
/*    +----------------------------------------------------------+    */
      if(strrchr(file[0],'\\') != NULL)
        file[0]=(char *)strrchr(file[0],'\\')+1;
      k=0;
      for(j=1; j<=nfun; j++) {
        if(strncmp(file[0],func[j],3) == 0) {k=j; break;}
      }
      if(k == 0) {printf("Error : function not found\n"); exit(-1);}
/*    +----------------------------------------------------------+    */
/*    | get old dimensions                                       |    */
/*    +----------------------------------------------------------+    */
      for(i=1; i<=narg; i++) {
        n[i]=0;
        m[i]=0;
        nrow[i]=0;
        ncol[i]=0;
        nr[i]=0;
        nc[i]=0;
        ival[i]=0;
        rval[i]=0.0;
        if(ist[k][i]%10 == 1)
          readgn(&nrow[i],&ncol[i],&nr[i],&nc[i]
                                  ,file[i],stat[ist[k][i]%10]);
        if(ist[k][i] == 6) sscanf(file[i],"%d",&ival[i]);
        if(ist[k][i] == 7) sscanf(file[i],"%lf",&rval[i]);
      }
/*    +----------------------------------------------------------+    */
/*    | set new dimensions                                       |    */
/*    +----------------------------------------------------------+    */
      if(k == 1 || k == 2) {
        nrow[3]=nrow[1];
        ncol[3]=ncol[1];
        nr[3]=nr[1];
        nc[3]=nc[1];
        if(nrow[1] != nrow[2] || ncol[1] != ncol[2]) {
          printf("Error : row.a != row.b || col.a != col.b\n");
          exit(-1);
        }
      } else if(k == 3) {
        nrow[3]=nrow[1];
        ncol[3]=ncol[2];
        nr[3]=nr[1];
        nc[3]=nc[1];
        if(ncol[1] != nrow[2]) {
          printf("Error : col.a != col.b\n");
          exit(-1);
        }
      } else if(k == 5) {
        n[2]=-1;        /* matrix-2 use the same location of matrix-1 */
        m[2]=-1;
      } else if(k == 6 || k == 7 || k == 8) {
        n[3]=-2;        /* matrix-3 use the same location of matrix-2 */
        m[3]=-2;
      }
/*    +----------------------------------------------------------+    */
/*    | allocate memory for the matrix                           |    */
/*    +----------------------------------------------------------+    */
      npt=1;
      mpt=1;
      for(i=1; i<=narg; i++) {
        if(n[i] == 0) {
          n[i]=npt;
          npt=npt+nrow[i]*ncol[i];
        } else {                 /* i-th argument use the same memory */
          ii=-n[i];              /*   of the ii-th argument */
          if(ii >= i) {printf("Error : -n[i] >= i\n"); exit(-1);}
          n[i]=n[ii];
          nrow[i]=nrow[ii];
          ncol[i]=ncol[ii];
        }
        if(m[i] == 0) {
          m[i]=mpt;
          mpt=mpt+nr[i]*nc[i];
        } else {                 /* i-th argument use the same memory */
          ii=-m[i];              /*   of the ii-th argument */
          if(ii >= i) {printf("Error : -m[i] >= i\n"); exit(-1);}
          m[i]=m[ii];
          nr[i]=nr[ii];
          nc[i]=nc[ii];
        }
      }
      if(npt >= ndima) {printf("Error : ndima too small\n"); exit(-1);}
      if(mpt >= ndiml) {printf("Error : ndiml too small\n"); exit(-1);}
/*    +----------------------------------------------------------+    */
/*    | read the matrix                                          |    */
/*    +----------------------------------------------------------+    */
      for(i=1; i<=narg; i++) {
        if(ist[k][i]%10 == 1)
        readga(&a[n[i]],nrow[i],ncol[i],nr[i],nc[i],&ll[m[i]]
                                       ,file[i],stat[ist[k][i]%10]);
      }
/*    +----------------------------------------------------------+    */
/*    | computation                                              |    */
/*    +----------------------------------------------------------+    */
      if(k == 1) {
        cadd(&a[n[1]],&a[n[2]],&a[n[3]],nrow[1],ncol[1]
                                       ,nrow[1],nrow[2],nrow[3]);
      } else if(k == 2) {
        csub(&a[n[1]],&a[n[2]],&a[n[3]],nrow[1],ncol[1]
                                       ,nrow[1],nrow[2],nrow[3]);
      } else if(k == 3) {
        cmpy(&a[n[1]],&a[n[2]],&a[n[3]],nrow[1],ncol[1],ncol[2]
                                       ,nrow[1],nrow[2],nrow[3]);
      } else if(k == 5) {
        if(nr[1] == 0 && nc[1] == 0) {         /* full matrix */
          ma=nrow[1];
          mb=ncol[1];
          mm=nrow[1];
          nn=mm;
          cudecp(&a[n[1]],nn,ma,mb,mm);
        } else if(nr[1] == 1 && nc[1] == 1) {  /* symmetric con.band */
          mb=ll[m[1]];
          mm=nrow[1];                    /*  ncol[1]*mm/(mm+1)+1  >  nn */
          nn=(long)(ncol[1]+1)*mm/(mm+1);/* (ncol[1]*mm+1)/(mm+1) <= nn */
          if(nn+(nn-1)/mm != ncol[1])    /* nn=((ncol[1]+x)*mm+1)/(mm+1)*/
            printf("nr,nc,n = %d %d %d\n",nrow[1],ncol[1],nn);
          cbdecp(&a[n[1]],mb,nn,mm);
        } else if(nr[1] == 1 && nc[1] > 1) {   /* symmetric var.band */
          vbdecp(&a[n[1]],&ll[m[1]],nc[1]);
        } else if(nr[1] == 2 && nc[1] == 1) {  /* unsym con.band */
          ma=ll[m[1]];
          mb=ll[m[1]+1];
          mm=nrow[1];
          nn=(long)(ncol[1]+1)*mm/(mm+1);
          if(nn+(nn-1)/mm != ncol[1])
            printf(" nr,nc,n = %d %d %d\n",nrow[1],ncol[1],nn);
          cudecp(&a[n[1]],nn,ma,mb,mm);
        } else if(nr[1] == 2 && nc[1] > 1) {   /* unsym var.band */
          usdecp(&a[n[1]],&ll[m[1]],nc[1],&nnt,&nsd,ndima,ndiml);
          nc  [2]=nnt                 +(nnt-nc[1]);
          ncol[2]=ll[m[1]+2*nnt-1]+nnt+(nnt-nc[1])*(nnt-nc[1]);
        }                             /* used by lufpdc() */
      } else if(k == 8) {
        if(nr[1] == 0 && nc[1] == 0) {         /*  full matrix */
          ma=nrow[1];
          mb=ncol[1];
          mm=nrow[1];
          nn=mm;
          for(j=1; j<=ncol[2]; j++) {
            cusolx(&a[n[1]],&a[n[2]+(j-1)*nrow[2]],nn,ma,mb,mm);
          }
        } else if(nr[1] == 1 && nc[1] == 1) {  /* symmetric con.band */
          mb=ll[m[1]];
          mm=nrow[1];
          nn=(long)(ncol[1]+1)*mm/(mm+1);
          if(nn+(nn-1)/mm != ncol[1])
            printf(" nr,nc,n = %d %d %d\n",nrow[1],ncol[1],nn);
          for(j=1; j<=ncol[2]; j++) {
            cbsolx(&a[n[1]],&a[n[2]+(j-1)*nrow[2]],mb,nn,mm);
          }
        } else if(nr[1] == 1 && nc[1] > 1) {   /* symmetric var.band */
          for(j=1; j<=ncol[2]; j++) {
            vbsolx(&a[n[1]],&a[n[2]+(j-1)*nrow[2]],&ll[m[1]],nc[1]);
          }
        } else if(nr[1] == 2 && nc[1] == 1) {  /* unsym con.band */
          ma=ll[m[1]];
          mb=ll[m[1]+1];
          mm=nrow[1];
          nn=(long)(ncol[1]+1)*mm/(mm+1);
          if(nn+(nn-1)/mm != ncol[1])
            printf(" nr,nc,n = %d %d %d\n",nrow[1],ncol[1],nn);
          for(j=1; j<=ncol[2]; j++) {
            cusolx(&a[n[1]],&a[n[2]+(j-1)*nrow[2]],nn,ma,mb,mm);
          }
        } else if(nr[1] == 2 && nc[1] > 1) {   /* unsym var.band */
          not=nrow[2];
          nnt=not+(nc[1]-not)/2;
          for(j=1; j<=ncol[2]; j++) {
            ussolx(&a[n[1]],&a[n[2]+(j-1)*nrow[2]],&ll[m[1]],not,nnt
                  ,&a[npt]);
          }
        }
      }
/*    +----------------------------------------------------------+    */
/*    | delete file  :  use system command : del o1              |    */
/*    +----------------------------------------------------------+    */
/*    +----------------------------------------------------------+    */
/*    | write the result matrix                                  |    */
/*    +----------------------------------------------------------+    */
      for(i=1; i<=narg; i++) {
        if(ist[k][i]%10 ==  2 || ist[k][i]%10 ==  3)
          writga(&a[n[i]],nrow[i],ncol[i],nr[i],nc[i],&ll[m[i]]
                                 ,file[i],stat[ist[k][i]%10]);
      }
      for(i=0; i<=narg; i++) {
        free(file[i]);
      }
}
/**********************************************************************/
      int readgn(int *nrow,int *ncol,int *nr,int *nc
                ,char *file,char *stat) {
/*    ============================================================    */
      FILE *fp_r;
/*    ============================================================    */
      if((fp_r=fopen(file,stat))==NULL) exit(-1);
      freeii(nrow,fp_r);
      freeii(ncol,fp_r);
      freeii(nr,  fp_r);
      freeii(nc,  fp_r);
      fclose(fp_r);
      return(0);
}
/**********************************************************************/
      int readga(double a[],int nrow,int ncol,int nr,int nc
                ,int ll[],char *file,char *stat) {
/*    ============================================================    */
      FILE *fp_r;
      int  i,j;
/*    ============================================================    */
      if((fp_r=fopen(file,stat))==NULL) exit(-1);
      freeii(&nrow,fp_r);
      freeii(&ncol,fp_r);
      freeii(&nr,  fp_r);
      freeii(&nc,  fp_r);
      for(i=0; i<nr; i++) {
        for(j=0; j<nc; j++) {
          freeii(&ll[i+j*nr],fp_r);
        }
      }
      for(i=0; i<nrow; i++) {
        for(j=0; j<ncol; j++) {
          freer8(&a[i+j*nrow],fp_r);
        }
      }
      fclose(fp_r);
      return(0);
}
/**********************************************************************/
      int writga(double a[],int nrow,int ncol,int nr,int nc
                ,int ll[],char *file,char *stat) {
/*    ============================================================    */
      FILE *fp_r;
      int  i,j;
/*    ============================================================    */
      if((fp_r=fopen(file,stat))==NULL) exit(-1);

      fprintf(fp_r,";nrow,ncol,nr,nc\n %d %d %d %d\n",nrow,ncol,nr,nc);

      fprintf(fp_r,";((ll(i,j),j=1,nc),i=1,nr)\n");
      for(i=0; i<nr; i++) {
        for(j=0; j<nc; j++) {
          fprintf(fp_r,"%13d",ll[i+j*nr]);
          if(j%6==5) fprintf(fp_r,"\n");
        }
        if(nc > 0) fprintf(fp_r,"\n");
      }

      fprintf(fp_r,";((a(i,j),j=1,ncol),i=1,nrow)\n");
      for(i=0; i<nrow; i++) {
        for(j=0; j<ncol; j++) {
          fprintf(fp_r,"%13.4le",a[i+j*nrow]);
          if(j%6==5) fprintf(fp_r,"\n");
        }
        if(ncol > 0) fprintf(fp_r,"\n");
      }

      fclose(fp_r);
      return(0);
}
/**********************************************************************/
      int tolow(char *c) {
/*    ============================================================    */
      int k,l;
/*    ============================================================    */
/*    convert c[] to lower case                                       */
/*    ============================================================    */
      l=strlen(c);
      for(k=0; k<l; k++) {
        if(c[k] > '\177') {   /* chinese code */
          k++;
        } else {
          c[k] = tolower(c[k]);
        }
      }
      return(0);
}
/**********************************************************************/
      int cmpy(double a[],double b[],double c[]
              ,int n,int m,int l,int na,int nb,int nc) {
/*    ============================================================    */
/*    double a(na,m),b(nb,m),c(nc,m) */
      double cij;
      int    i,j,k,ik,jb,jc;
      --a; a-=na; --b; b-=nb; --c; c-=nc;
/*    ============================================================    */
      for(j=1; j<=l; j++) {jb=j*nb; jc=j*nc;
        for(i=1; i<=n; i++) {
          cij=0.0;
          for(k=1,ik=i+na; k<=m; k++,ik+=na) {
            cij=cij+a[ik]*b[k+jb];
          }
          c[i+jc]=cij;
        }
      }
      return(0);
}
/**********************************************************************/
      int cadd(double a[],double b[],double c[]
              ,int n,int m,int na,int nb,int nc) {
/*    ============================================================    */
/*    double a(na,m),b(nb,m),c(nc,m) */
      int    i,j;
      --a; a-=na; --b; b-=nb; --c; c-=nc;
/*    ============================================================    */
      for(j=1; j<=m; j++) {
        for(i=1; i<=n; i++) {
          c[i+j*nc]=a[i+j*na]+b[i+j*nb];
        }
      }
      return(0);
}
/**********************************************************************/
      int csub(double a[],double b[],double c[]
              ,int n,int m,int na,int nb,int nc) {
/*    ============================================================    */
/*    double a(na,m),b(nb,m),c(nc,m) */
      int    i,j;
      --a; a-=na; --b; b-=nb; --c; c-=nc;
/*    ============================================================    */
      for(j=1; j<=m; j++) {
        for(i=1; i<=n; i++) {
          c[i+j*nc]=a[i+j*na]-b[i+j*nb];
        }
      }
      return(0);
}
/**********************************************************************/
