/**********************************************************************/
      int cudecp(double a[],int n,int ma,int mb,int mm) {
/*    int cudecp(a,n,ma,mb,mm)
      double a[]; int n,ma,mb,mm; {                                   */
/*    ============================================================    */
      double aij, aji;
      int    i,j,k,ima,jma,imb,jmb;
      int    *p;                     /* a[i+p[j]] = a(i,j) */
      --a;
      p=(int *)malloc(n*sizeof(int));
      --p; for(k=1; k<=n; k++) p[k]=k*mm-mm;
/*    ============================================================    */
/*    dimension a(mm,n+(n-1)/mm) or a((n-1)*mm+n)                     */
/*    ------------------------------------------------------------    */
/*    find [l] & [u] for given [a],        | a11 a12 a13  0   0  |    */
/*    such that  [a] = [l] [u],            | a21 a22 a23 a24  0  |    */
/*                                   [a] = |  0  a32 a33 a34 a35 |    */
/*    for example:                         |  0   0  a43 a44 a45 |    */
/*    n=5, ma=1, mb=2, mm=3 (>=ma+mb):     |  0   0   0  a54 a55 |    */
/*                                                                    */
/*          | l11  0   0   0   0  |        |  1  u12 u13  0   0  |    */
/*          | l21 l22  0   0   0  |        |  0   1  u23 u24  0  |    */
/*    [l] = |  0  l32 l33  0   0  |, [u] = |  0   0   1  u34 u35 |    */
/*          |  0   0  l43 l44  0  |        |  0   0   0   1  u45 |    */
/*          |  0   0   0  l54 l55 |        |  0   0   0   0   1  |    */
/*                                                                    */
/*    input  data in a(3,6) =  | a11 a12 a13\a43 a44 a45 |            */
/*                             |\a21 a22 a23 a24\a54 a55 |            */
/*                             |  ? \a32 a33 a34 a35\ ?  |            */
/*    or in 1-d array:                                                */
/*    a(17) = (a11 a21 ? a12 a22 a32 a13 a23 a33 a43 a24              */
/*                                       a34 a44 a54 a35 a45 a55);    */
/*                                                                    */
/*    output data in a(3,6) =  | l11 u12 u13\l43 l44 u45 |            */
/*                             |\l21 l22 u23 u24\l54 l55 |            */
/*                             |  ? \l32 l33 u34 u35\ ?  |            */
/*    or in 1-d array:                                                */
/*    a(17) = (l11 l21 ? u12 l22 l32 u13 u23 l33 l43 u24              */
/*                                       u34 l44 l54 u35 u45 l55).    */
/*    ============================================================    */
      for(j=1; j<=n; j++) {
        jmb=j-mb; if(jmb < 1) jmb=1;
        jma=j-ma; if(jma < 1) jma=1;
/*      +--------------------------------------------------------+    */
/*      | aij = a(i,j) - \sum_{k=ima}^{i-1} l(i,k)*u(k,j)        |    */
/*      | a(i,k)=l(i,k),    a(k,j)=u(k,j)                        |    */
/*      | a(i,j)=a(i,j) --> u(i,j)=aij/l(i,i)                    |    */
/*      +--------------------------------------------------------+    */
        for(i=jmb; i<=j-1; i++) {
          ima=i-ma; if(ima < jmb) ima=jmb;
          aij=a[i+p[j]];
          for(k=ima; k<=i-1; k++) {
            aij-=a[i+p[k]]*a[k+p[j]];
          }
          a[i+p[j]]=aij/a[i+p[i]];
        }
/*      +--------------------------------------------------------+    */
/*      | aji = a(j,i) - \sum_{k=imb}^{i-1} l(j,k)*u(k,i)        |    */
/*      | a(j,k)=l(j,k),    a(k,i)=u(k,i)                        |    */
/*      | a(j,i)=a(j,i) --> l(j,i)=aji                           |    */
/*      +--------------------------------------------------------+    */
        for(i=jma; i<=j; i++) {
          imb=i-mb; if(imb < jma) imb=jma;
          aji=a[j+p[i]];
          for(k=imb; k<=i-1; k++) {
            aji-=a[j+p[k]]*a[k+p[i]];
          }
          a[j+p[i]]=aji;
        }
/*      ----------------------------------------------------------    */
        if(a[j+p[j]] == 0.0) goto L55;
      }
      free(++p);
      return(0);
/*    +----------------------------------------------------------+    */
/*    | return(j) with error : l(j,j)=0                          |    */
/*    +----------------------------------------------------------+    */
  L55:printf(" a[%d,%d] = 0\n",j,j);
      free(++p);
      return(j);
}
/**********************************************************************/
      int cusolx(double a[],double b[],int n,int ma,int mb,int mm) {
/*    int cusolx(a,b,n,ma,mb,mm)
      double a[],b[]; int n,ma,mb,mm; {                               */
/*    ============================================================    */
      double bi;
      int    i,k,ima,imb;
      int    *p;                     /* a[i+p[j]] = a(i,j) */
      --a; --b;
      p=(int *)malloc(n*sizeof(int));
      --p; for(k=1; k<=n; k++) p[k]=k*mm-mm;
/*    ============================================================    */
/*    dimension a(mm,n+(n-1)/mm),b(n) or a((n-1)*mm+n),b(n)           */
/*    ------------------------------------------------------------    */
/*    find {x} from [a]{x}={b} for given {b} & [a]=[l][u].            */
/*    [l] & [u] are given & put in a(*) (get by subroutine cudecp)    */
/*    [l][u]{x}={b} ===> [l]{y}={b},  [u]{x}={y}                      */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | find {y} from {b} by forward substitution of [l]{y}={b}  |    */
/*    | bi = b(i) - \sum_{k=ima}^{i-1} l(i,k)*y(k)               |    */
/*    | a(i,k)=l(i,k), b(k)=y(k), b(i)=b(i) --> y(i)=bi/l(i,i)   |    */
/*    +----------------------------------------------------------+    */
      b[1]/=a[1+p[1]];
      for(i=2; i<=n; i++) {
        ima=i-ma; if(ima < 1) ima=1;
        bi=b[i];
        for(k=ima; k<=i-1; k++) {
          bi-=a[i+p[k]]*b[k];
        }
        b[i]=bi/a[i+p[i]];
      }
/*    +----------------------------------------------------------+    */
/*    | find {x} from {y} by backward substitution of [u]{x}={y} |    */
/*    | x(i) = bi = y(i) - \sum_{k=i+1}^{imb} u(i,k)*x(k)        |    */
/*    | a(i,k)=u(i,k), b(k)=x(k), b(i)=y(i) --> x(i)=bi          |    */
/*    +----------------------------------------------------------+    */
      for(i=n-1; i>=1; i--) {
        imb=i+mb; if(imb > n) imb=n;
        bi=b[i];
        for(k=i+1; k<=imb; k++) {
          bi-=a[i+p[k]]*b[k];
        }
        b[i]=bi;
      }
      free(++p);
      return(0);
}
/**********************************************************************/
