#include <stdio.h>
#include <ctype.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
/*    program for decomposition with full pivoting                    */
/*    ============================================================    */
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double *a,*b,*s,*t;
      int    *ll;
      int    i,j,k,n,nsd,nmax;
      extern int lufpdc(),lufpsb(),lufpsg();
/*    ============================================================    */
      if(argc<3) {printf("Usage : lufpmn infile outfile"); exit(-1);}

      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ============================================================    */
  L10:freeii(&n,fp_r); nmax=n;
      if(n == 0) exit(0);
      a=(double *)calloc(n*n,sizeof(double));
      s=(double *)calloc(n*n,sizeof(double));
      t=(double *)calloc(n*n,sizeof(double));
      b=(double *)calloc(n  ,sizeof(double));
      ll=(int *)calloc(2*n,sizeof(int));
      reada(a,n,n,nmax,fp_r);
      reada(b,1,n,1,fp_r);
/*    ------------------------------------------------------------    */
      lufpdc(a,ll,n,&nsd,nmax);
      lufpsb(a,b,ll,n,nmax);
/*    ------------------------------------------------------------    */
      fprintf(fp_w,"\n Permutation vectors\n");
      printi(ll,2,n,2,fp_w);
      fprintf(fp_w,"\n Decomposed matrix : nsd = %d\n",nsd);
      printa(a,n,n,nmax,fp_w);
      fprintf(fp_w,"\n Solution vector\n");
      printa(b,1,n,1,fp_w);
      if(nsd > 0) {
        lufpsg(a,s,ll,n,nsd,nmax);
        transpose(s,t,n,nsd,nmax,nmax);
        printa(t,nsd,n,nmax,fp_w);
      }
      free(a); free(s); free(t); free(b); free(ll);
      goto L10;
}
/**********************************************************************/
      int reada(double a[],int n,int m,int nn,FILE *fp_r) {
/*    ============================================================    */
      int i,j;
      --a; a-=nn;     /* dimension a(nn,m) */
/*    ============================================================    */
      for(i=1; i<=n; i++) {
        for(j=1; j<=m; j++) freer8(&a[i+j*nn],fp_r);
      }
      return(0);
}
/**********************************************************************/
      int printa(double a[],int n,int m,int nn,FILE *fp_w) {
/*    ============================================================    */
      int i,j,jl,jh,mm=10;
      --a; a-=nn;     /* dimension a(nn,m) */
/*    ============================================================    */
      for(jl=1; jl<=m; jl+=mm) {
        jh=jl+mm-1; if(jh > m) jh=m;
        fprintf(fp_w,"\n     ");
        for(j=jl; j<=jh; j++) fprintf(fp_w,"%10d",j);
        fprintf(fp_w,"\n");
        for(i=1; i<=n; i++) {
          fprintf(fp_w,"%5d",i);
          for(j=jl; j<=jh; j++) fprintf(fp_w,"%10.6lf",a[i+j*nn]);
          fprintf(fp_w,"\n");
        }
      }
      return(0);
}
/**********************************************************************/
      int readi(int a[],int n,int m,int nn,FILE *fp_r) {
/*    ============================================================    */
      int i,j;
      --a; a-=nn;     /* dimension a(nn,m) */
/*    ============================================================    */
      for(i=1; i<=n; i++) {
        for(j=1; j<=m; j++) fscanf(fp_r,"%d",&a[i+j*nn]);
      }
      return(0);
}
/**********************************************************************/
      int printi(int a[],int n,int m,int nn,FILE *fp_w) {
/*    ============================================================    */
      int i,j,jl,jh,mm=10;
      --a; a-=nn;     /* dimension a(nn,m) */
/*    ============================================================    */
      for(jl=1; jl<=m; jl+=mm) {
        jh=jl+mm-1; if(jh > m) jh=m;
        fprintf(fp_w,"\n     ");
        for(j=jl; j<=jh; j++) fprintf(fp_w,"%10d",j);
        fprintf(fp_w,"\n");
        for(i=1; i<=n; i++) {
          fprintf(fp_w,"%5d",i);
          for(j=jl; j<=jh; j++) fprintf(fp_w,"%10d",a[i+j*nn]);
          fprintf(fp_w,"\n");
        }
      }
      return(0);
}
/**********************************************************************/
      int transpose(double a[],double b[],int n,int m,int na,int nb) {
/*    ============================================================    */
      int i,j;
      --a; a-=na;     /* dimension a(na,m) */
      --b; b-=nb;     /* dimension b(nb,n) */
/*    ============================================================    */
      for(i=1; i<=n; i++) {
        for(j=1; j<=m; j++) b[j+i*nb]=a[i+j*na];
      }
      return(0);
}
/**********************************************************************/
