#include <math.h>
/**********************************************************************/
      int luppdc(double a[],int ll[],int n,int nn) {
/*    int luppdc(a,ll,n,nn)
      double a[]; int ll[],n,nn; {                                    */
/*    ============================================================    */
      double aij,ajj;
      int    i,j,k,m,i1;
      int    *p;                     /* a[i+p[j]] = a(i,j) */
      --a; --ll;
      p=(int *)malloc(n*sizeof(int));
      --p; for(i=1; i<=n; i++) p[i]=i*nn-nn;
/*    ============================================================    */
/*    find [l] & [u] for given [a], such that  [r][a] = [l][u].       */
/*    where [r] is row_exchanges matrix indicated by ll(j)=m          */
/*    ll(j)=m : row_exchange between j_th_row & m_th_row              */
/*    ============================================================    */
      for(j=1; j<=n; j++) {
/*      +--------------------------------------------------------+    */
/*      | aij = a(i,j) - \sum_{k=1}^{min(i,j)-1} l(i,k)*u(k,j)   |    */
/*      | a(i,k)=l(i,k),    a(k,j)=u(k,j)                        |    */
/*      +--------------------------------------------------------+    */
        ajj=0.0;
        for(i=1; i<=n; i++) {
          aij=a[i+p[j]];
          i1=i-1; if(j < i) i1=j-1;
          for(k=1; k<=i1; k++) {
            aij=aij-a[i+p[k]]*a[k+p[j]];
          }
/*        +------------------------------------------------------+    */
/*        | i <  j : a(i,j)=a(i,j) --> u(i,j)=aij/l(i,i)         |    */
/*        | i >= j : a(i,j)=a(i,j) --> l(i,j)=aij                |    */
/*        +------------------------------------------------------+    */
          if(i < j) {
            a[i+p[j]]=aij/a[i+p[i]];
          } else {
            a[i+p[j]]=aij;
/*          +----------------------------------------------------+    */
/*          | find m & ajj=abs(l(m,j))=max(abs(l(i,j)), i=j,n)   |    */
/*          +----------------------------------------------------+    */
            if(ajj < fabs(aij)) {
              ajj=fabs(aij);
              m=i;
            }
          }
        }
/*      ----------------------------------------------------------    */
        if(ajj == 0.0) goto L55;
/*      +--------------------------------------------------------+    */
/*      | set ll(j)=m   &   exchange j_th_row & m_th_row         |    */
/*      +--------------------------------------------------------+    */
        ll[j]=m;
        if(m != j) {
          for(i=1; i<=n; i++) {
            aij=a[m+p[i]];
            a[m+p[i]]=a[j+p[i]];
            a[j+p[i]]=aij;
          }
        }
      }
      free(++p);
      return(0);
/*    +----------------------------------------------------------+    */
/*    | return(j) on singular matrix : l(j,j)=0                  |    */
/*    +----------------------------------------------------------+    */
  L55:printf(" Matrix is singular: a[%d,%d] = 0",j,j);
      free(++p);
      return(j);
}
/**********************************************************************/
      int luppsb(double a[],double b[],int ll[],int n,int nn) {
/*    int luppsb(a,b,ll,n,nn)
      double a[],b[]; int ll[],n,nn; {                                */
/*    ============================================================    */
      double bi;
      int    i,k,m;
      int    *p;
      --a; --b; --ll;
      p=(int *)malloc(n*sizeof(int));
      --p; for(i=1; i<=n; i++) p[i]=i*nn-nn;
/*    ============================================================    */
/*    find {x} from [a]{x}={b} for given {b} & [r][a]=[l][u].         */
/*    [l] & [u] are given & put in a(nn,n),  [r] is given by ll(n)    */
/*    [l][u]{x}=[r]{b}  ==>  [l]{y}=[r]{b},  [u]{x}={y}               */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | find {y} from [r]{b} by forward subst. of [l]{y}=[r]{b}  |    */
/*    | bi = b(i) - \sum_{k=1}^{i-1} l(i,k)*y(k)                 |    */
/*    | a(i,k)=l(i,k), b(k)=y(k), b(i)=b(i) --> y(i)=bi/l(i,i)   |    */
/*    +----------------------------------------------------------+    */
      for(i=1; i<=n; i++) {
        m=ll[i];
        bi=b[m];
        b[m]=b[i];
        for(k=1; k<=i-1; k++) {
          bi=bi-a[i+p[k]]*b[k];
        }
        b[i]=bi/a[i+p[i]];
      }
/*    +----------------------------------------------------------+    */
/*    | find {x} from {y} by backward substitution of [u]{x}={y} |    */
/*    | x(i) = bi = y(i) - \sum_{k=i+1}^{n} u(i,k)*x(k)          |    */
/*    | a(i,k)=u(i,k), b(k)=x(k), b(i)=y(i) --> x(i)=bi          |    */
/*    +----------------------------------------------------------+    */
      for(i=n-1; i>=1; i--) {
        bi=b[i];
        for(k=i+1; k<=n; k++) {
          bi=bi-a[i+p[k]]*b[k];
        }
        b[i]=bi;
      }
      free(++p);
      return(0);
}
/**********************************************************************/
