#include <stdio.h>
#include <ctype.h>
#include <math.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
/*    program for decomposition with partial pivoting                 */
/*    ============================================================    */
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double *a,*b,*x,*aa,*bb,*ax,rmax,eps;
      int    *ll;
      int    i,j,k,n,itr,nmax;
      extern int luppdc(),luppsb();
      extern double maxabs();
/*    ============================================================    */
      if(argc<3) {printf("Usage : luppmn infile outfile"); exit(-1);}

      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ============================================================    */
  L10:freeii(&n,fp_r); freeii(&itr,fp_r); freer8(&eps,fp_r); nmax=n;
      if(n==0) exit(0); if(itr==0) itr=1; if(eps==0) eps=0.00001;
      a =(double *)calloc(n*n,sizeof(double));
      b =(double *)calloc(n  ,sizeof(double));
      x =(double *)calloc(n  ,sizeof(double));
      aa=(double *)calloc(n*n,sizeof(double));
      bb=(double *)calloc(n  ,sizeof(double));
      ax=(double *)calloc(n  ,sizeof(double));
      ll=   (int *)calloc(n  ,sizeof(int));
      reada(a,n,n,nmax,fp_r);
      reada(b,1,n,1,fp_r);
/*    ------------------------------------------------------------    */
      copya(a,aa,n,n,nmax,nmax);
      copya(b,bb,n,1,nmax,nmax);
      cleara(x,n,1,nmax);
/*    ------------------------------------------------------------    */
      luppdc(a,ll,n,nmax);
      fprintf(fp_w,"\n Permutation vectors\n");
      printi(ll,1,n,1,fp_w);
      fprintf(fp_w,"\n Decomposed matrix\n");
      printa(a,n,n,nmax,fp_w);
/*    ------------------------------------------------------------    */
      for(k=1; k<=itr; k++) {
        luppsb(a,b,ll,n,nmax);
        adda(x,b,n,1,nmax,nmax);
        fprintf(fp_w,"\n Solution vector : itr = %d\n",k);
        printa(x,1,n,1,fp_w);
        cmpy(aa,x,ax,n,n,1,nmax,nmax,nmax);
        copya(bb,b,n,1,nmax,nmax);
        suba(b,ax,n,1,nmax,nmax);
        fprintf(fp_w,"\n Residual vector\n");
        printa(b,1,n,1,fp_w);
        rmax=maxabs(b,1,n,1);
        if(rmax <= eps) break;
      }
      free(a); free(b); free(x); free(aa); free(bb); free(ax); free(ll);
      goto L10;
}
/**********************************************************************/
      int printa(double a[],int n,int m,int nn,FILE *fp_w) {
/*    ============================================================    */
      int i,j,jl,jh,mm=10;
      --a; a-=nn;     /* dimension a(nn,m) */
/*    ============================================================    */
      for(jl=1; jl<=m; jl+=mm) {
        jh=jl+mm-1; if(jh > m) jh=m;
        fprintf(fp_w,"\n     ");
        for(j=jl; j<=jh; j++) fprintf(fp_w,"%10d",j);
        fprintf(fp_w,"\n");
        for(i=1; i<=n; i++) {
          fprintf(fp_w,"%5d",i);
          for(j=jl; j<=jh; j++) fprintf(fp_w,"%10.6lf",a[i+j*nn]);
          fprintf(fp_w,"\n");
        }
      }
      return(0);
}
/**********************************************************************/
      int printi(int a[],int n,int m,int nn,FILE *fp_w) {
/*    ============================================================    */
      int i,j,jl,jh,mm=10;
      --a; a-=nn;     /* dimension a(nn,m) */
/*    ============================================================    */
      for(jl=1; jl<=m; jl+=mm) {
        jh=jl+mm-1; if(jh > m) jh=m;
        fprintf(fp_w,"\n     ");
        for(j=jl; j<=jh; j++) fprintf(fp_w,"%10d",j);
        fprintf(fp_w,"\n");
        for(i=1; i<=n; i++) {
          fprintf(fp_w,"%5d",i);
          for(j=jl; j<=jh; j++) fprintf(fp_w,"%10d",a[i+j*nn]);
          fprintf(fp_w,"\n");
        }
      }
      return(0);
}
/**********************************************************************/
      int reada(double a[],int n,int m,int nn,FILE *fp_r) {
/*    ============================================================    */
      int i,j;
      --a; a-=nn;     /* dimension a(nn,m) */
/*    ============================================================    */
      for(i=1; i<=n; i++) {
        for(j=1; j<=m; j++) freer8(&a[i+j*nn],fp_r);
      }
      return(0);
}
/**********************************************************************/
      int cleara(double a[],int n,int m,int nn) {
/*    ============================================================    */
      int i,j;
      --a; a-=nn;     /* dimension a(nn,m) */
/*    ============================================================    */
      for(j=1; j<=m; j++) {
        for(i=1; i<=n; i++) a[i+j*nn]=0.0;
      }
      return(0);
}
/**********************************************************************/
      int adda(double a[],double b[],int n,int m,int na,int nb) {
/*    ============================================================    */
      int i,j;
      --a; a-=na;     /* dimension a(na,m) */
      --b; b-=nb;     /* dimension b(nb,m) */
/*    ============================================================    */
      for(j=1; j<=m; j++) {
        for(i=1; i<=n; i++) a[i+j*na]=a[i+j*na]+b[i+j*nb];
      }
      return(0);
}
/**********************************************************************/
      int suba(double a[],double b[],int n,int m,int na,int nb) {
/*    ============================================================    */
      int i,j;
      --a; a-=na;     /* dimension a(na,m) */
      --b; b-=nb;     /* dimension b(nb,m) */
/*    ============================================================    */
      for(j=1; j<=m; j++) {
        for(i=1; i<=n; i++) a[i+j*na]=a[i+j*na]-b[i+j*nb];
      }
      return(0);
}
/**********************************************************************/
      int printb(double b[],int n,FILE *fp_w) {
/*    ============================================================    */
      int j,mm=10;
      --b;            /* dimension b(n) */
/*    ============================================================    */
      for(j=1; j<=n; j++) {
        if(j%mm == 1) fprintf(fp_w,"\n     ");
        fprintf(fp_w,"%6.2lf",b[j]);
      }
      fprintf(fp_w,"\n");
      return(0);
}
/**********************************************************************/
      int copya(double a[],double b[],int n,int m,int na,int nb) {
/*    ============================================================    */
      int i,j;
      --a; a-=na;     /* dimension a(na,m) */
      --b; b-=nb;     /* dimension b(nb,m) */
/*    ============================================================    */
      for(j=1; j<=m; j++) {
        for(i=1; i<=n; i++) b[i+j*nb]=a[i+j*na];
      }
      return(0);
}
/**********************************************************************/
      int copyb(double a[],double b[],int n) {
/*    ============================================================    */
      int j;
      --a; --b;       /* dimension a(n),b(n) */
/*    ============================================================    */
      for(j=1; j<=n; j++) b[j]=a[j];
      return(0);
}
/**********************************************************************/
      double maxabs(double a[],int n,int m,int nn) {
/*    ============================================================    */
      double aa,ax;
      int    i,j;
      --a; a-=nn;     /* dimension a(nn,m) */
/*    ============================================================    */
      ax=0.0;
      for(j=1; j<=m; j++) {
        for(i=1; i<=n; i++) {
          aa=fabs(a[i+j*nn]);
          if(aa > ax) ax=aa;
        }
      }
      return(ax);
}
/**********************************************************************/
      int cmpy(double a[],double b[],double c[],int n,int m,int l
              ,int na,int nb,int nc) {
/*    ============================================================    */
      double cij;
      int    i,j,k;
      --a; a-=na;     /* dimension a(na,m) */
      --b; b-=nb;     /* dimension b(nb,l) */
      --c; c-=nc;     /* dimension c(nc,l) */
/*    ============================================================    */
      for(j=1; j<=l; j++) {
        for(i=1; i<=n; i++) {
          cij=0.0;
          for(k=1; k<=m; k++) cij=cij+a[i+k*na]*b[k+j*nb];
          c[i+j*nc]=cij;
        }
      }
      return(0);
}
/**********************************************************************/
