/**********************************************************************/
      int vbdecp(double a[],int ll[],int n) {
/*    int vbdecp(a,ll,n)
      double a[]; int ll[],n; {                                       */
/*    ============================================================    */
      double aij,ajj,akj;
      int    i,j,k,ia,ja,jb,ka,im,jm;
      --a; --ll;
/*    ============================================================    */
/*    dimension a(n+ll(n)),ll(n)                                      */
/*    ------------------------------------------------------------    */
/*    find [d] & [u] for given [a],        | a11  0  a13  0   0  |    */
/*    such that  [a] = [u]'[d] [u],        |  0  a22 a23  0  a25 |    */
/*    where [u]'= transpose of [u].  [a] = | a13 a23 a33 a34 a35 |    */
/*    for example:                         |  0   0  a34 a44 a45 |    */
/*    n=5  and  ll(5)=(0 0 2 3 6):         |  0  a25 a35 a45 a55 |    */
/*                                                                    */
/*          | d11  0   0   0   0  |        |  1   0  u13  0   0  |    */
/*          |  0  d22  0   0   0  |        |  0   1  u23  0  u25 |    */
/*    [d] = |  0   0  d33  0   0  |, [u] = |  0   0   1  u34 u35 |    */
/*          |  0   0   0  d44  0  |        |  0   0   0   1  u45 |    */
/*          |  0   0   0   0  d55 |        |  0   0   0   0   1  |    */
/*                                                                    */
/*    given ll(5) = (  0   0           2       3               6),    */
/*      i + ll(j) :  1+0 2+0 1+2 2+2 3+2 3+3 4+3 2+6 3+6 4+6 5+6      */
/*    location    :    1   2   3   4   5   6   7   8   9  10  11      */
/*    input a(11) = (a11 a22 a13 a23 a33 a34 a44 a25 a35 a45 a55);    */
/*    outpu a(11) = (d11 d22 u13 u23 d33 u34 d44 u25 u35 u45 d55).    */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | d(i,i)u(i,j)=a(i,j)-\sum_{k=im}^{i-1} d(k,k)u(k,i)u(k,j) |    */
/*    | a(k+ia)=u(k,i),     a(k+ja)=d(k,k)*u(k,j)                |    */
/*    | a(i+ja)=aij=a(i,j) --> d(i,i)*u(i,j)                     |    */
/*    +----------------------------------------------------------+    */
      jb=0;
      for(j=1; j<=n; j++) {
        ja=ll[j]-ll[1];
        jm=j-ja+jb;
        for(i=jm+1; i<=j-1; i++) {
          ia=ll[i]-ll[1];
          im=i-ll[i]+ll[i-1]; if(im < jm) im=jm;
          aij=a[i+ja];
          for(k=im; k<=i-1; k++) {
            aij=aij-a[k+ia]*a[k+ja];
          }
          a[i+ja]=aij;
        }
/*    +----------------------------------------------------------+    */
/*    | d(j,j) =a(j,j) - \sum_{k=jm}^{j-1} d(k,k)*u(k,j)*u(k,j)  |    */
/*    | a(k+ja)=d(k,k)*u(k,j) --> u(k,j),  akj=u(k,j)            |    */
/*    | a(j+ja)=ajj=a(j,j) --> d(j,j),     a(k+ka)=d(k,k)        |    */
/*    +----------------------------------------------------------+    */
        ajj=a[j+ja];
        for(k=jm; k<=j-1; k++) {
          ka=ll[k]-ll[1];
          akj=a[k+ja]/a[k+ka];
          ajj=ajj-akj*a[k+ja];
          a[k+ja]=akj;
        }
        a[j+ja]=ajj;
        if(a[j+ja] == 0.0) goto L50;
        jb=ja;
      }
      return(0);
/*    +----------------------------------------------------------+    */
/*    | return(j) with error : d(j,j)=0                          |    */
/*    +----------------------------------------------------------+    */
  L50:printf(" a[%d,%d] = 0\n",j,j);
      return(j);
}
/**********************************************************************/
      int vbsolx(double a[],double b[],int ll[],int n) {
/*    int vbsolx(a,b,ll,n)
      double a[],b[]; int ll[],n; {                                   */
/*    ============================================================    */
      double bi;
      int    i,k,ia,ib,im;
      --a; --b; --ll;
/*    ============================================================    */
/*    dimension a(n+ll(n)),b(n),ll(n)                                 */
/*    ------------------------------------------------------------    */
/*    find {x} from [a]{x}={b} for given {b} & [a]=[u]'[d][u].        */
/*    [d] & [u] are given & put in a(*) (get by subroutine vbdecp)    */
/*    [u]'[d][u]{x}={b} ===> [u]'{z}={b},  [d]{y}={z},  [u]{x}={y}    */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | find {z} from {b} by forward substitution of [u]'{z}={b} |    */
/*    | z(i) = bi = b(i) - \sum_{k=im}^{i-1} u'(i,k)*z(k)        |    */
/*    | a(k+ia)=u(k,i)=u'(i,k), b(k)=z(k), b(i)=b(i) --> z(i)    |    */
/*    +----------------------------------------------------------+    */
      ib=0;
      for(i=1; i<=n; i++) {
        ia=ll[i]-ll[1];
        im=i-ia+ib;
        bi=b[i];
        for(k=im; k<=i-1; k++) {
          bi=bi-a[k+ia]*b[k];
        }
        b[i]=bi;
        ib=ia;
      }
/*    +----------------------------------------------------------+    */
/*    | find {y} from {z} from the equation [d]{y}={z}           |    */
/*    | y(i) = z(i) / d(i,i)                                     |    */
/*    | b(i) = z(i) --> y(i),     a(i+ia)=d(i,i)                 |    */
/*    +----------------------------------------------------------+    */
      for(i=1; i<=n; i++) {
        ia=ll[i]-ll[1];
        b[i]=b[i]/a[i+ia];
      }
/*    +----------------------------------------------------------+    */
/*    | find {x} from {y} by backward substitution of [u]{x}={y} |    */
/*    | for i=n:2  compute  b(k)=b(k)-u(k,i)*x(i) for k=im:(i-1) |    */
/*    | a(k+ia)=u(k,i),     b(i)=bi=x(i),     b(k)=y(k) --> x(k) |    */
/*    +----------------------------------------------------------+    */
      for(i=n; i>=2; i--) {
        ia=ll[i]-ll[1];
        im=i-ll[i]+ll[i-1];
        bi=b[i];
        for(k=im; k<=i-1; k++) {
          b[k]=b[k]-a[k+ia]*bi;
        }
      }
      return(0);
}
/**********************************************************************/
