#include <math.h>
/**********************************************************************/
      int cvppdc(double a[],int ll[],int n,int ma,int mb,int mm) {
/*    int cvppdc(a,ll,n,ma,mb,mm)
      double a[]; int ll[],n,ma,mb,mm; {                              */
/*    ============================================================    */
      double akk,akj;
      int    i,j,k,mc,kma,kmb;
      int    *p;                     /* a[i+p[j]] = a(i,j) */
      --a; --ll; ll-=2;              /* dimension ll(2,n)  */
      p=(int *)malloc(n*sizeof(int));
      --p; for(i=1; i<=n; i++) p[i]=i*mm-mm;
/*    ============================================================    */
/*    dimension a(mm,n+(n-1)/mm) or a((n-1)*mm+n) : mm >= ma+mb+ma    */
/*    ------------------------------------------------------------    */
/*    find [l] & [u] for given [a],        | a11 a12  0   0   0  |    */
/*    such that  [r][a] = [l][u],          | a21 a22 a23  0   0  |    */
/*    [r] is row-exchanges matrix.   [a] = |  0  a32 a33 a34  0  |    */
/*    for example:                         |  0   0  a43 a44 a45 |    */
/*    n=5, ma=1, mb=1, mm=3:               |  0   0   0  a54 a55 |    */
/*                                                                    */
/*          | l11  0   0   0   0  |        |  1  u12 u13  0   0  |    */
/*          | l21 l22  0   0   0  |        |  0   1  u23 u24  0  |    */
/*    [l] = |  0  l32 l33  0   0  |, [u] = |  0   0   1  u34 u35 |    */
/*          |  0   0  l43 l44  0  |        |  0   0   0   1  u45 |    */
/*          |  0   0   0  l54 l55 |        |  0   0   0   0   1  |    */
/*                                                                    */
/*    input  data in a(3,6) =  | a11 a12  0 \a43 a44 a45 |            */
/*                             |\a21 a22 a23  0 \a54 a55 |            */
/*                             |  ? \a32 a33 a34  0 \ ?  |            */
/*    or in 1-d array:                                                */
/*    a(17) = (a11 a21 ? a12 a22 a32  0  a23 a33 a43  0               */
/*                                       a34 a44 a54  0  a45 a55);    */
/*                                                                    */
/*    output data in a(3,6) =  | l11 u12 u13\l43 l44 u45 |            */
/*                             |\l21 l22 u23 u24\l54 l55 |            */
/*                             |  ? \l32 l33 u34 u35\ ?  |            */
/*    or in 1-d array:                                                */
/*    a(17) = (l11 l21 ? u12 l22 l32 u13 u23 l33 l43 u24              */
/*                                       u34 l44 l54 u35 u45 l55).    */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | initialize ll(1,j) : top_non_zero_row_no. of j_th col.   |    */
/*    +----------------------------------------------------------+    */
      for(j=1; j<=n; j++) {
        ll[1+j*2]=j-mb; if(j-mb < 1) ll[1+j*2]=1;
      }
/*    +----------------------------------------------------------+    */
/*    | mc  : new upper_band_width = max of (kmb-k)              |    */
/*    | kmb : right_non_zero_col_no. of k_th row (pivoting_row)  |    */
/*    +----------------------------------------------------------+    */
      mc=mb;
      kmb=1;
      for(k=1; k<=n; k++) {
        kma=k+ma; if(kma > n) kma=n;
/*      +--------------------------------------------------------+    */
/*      | find pivoting element a(i,k) for i=k,kma               |    */
/*      +--------------------------------------------------------+    */
        akk=0.0;
        for(i=k; i<=kma; i++) {
          if(akk < fabs(a[i+p[k]])) akk=fabs(a[i+p[k]]);
        }
        if(akk == 0.0) break;
        akk=akk*0.25;
        for(i=k; i<=kma; i++) {
          if(akk <= fabs(a[i+p[k]])) break;
        }
/*      +--------------------------------------------------------+    */
/*      | kmb : right_non_zero_col_no of k_th row (pivoting_row) |    */
/*      | update mc=max(mc,kmb-k)                                |    */
/*      +--------------------------------------------------------+    */
        if(kmb < mb+i) kmb=mb+i; if(kmb > n) kmb=n;
        if(mc < kmb-k) mc=kmb-k;
        if(ma+mc > mm) {printf("Error : ma+mc > mm\n"); exit(-1);}
/*      +--------------------------------------------------------+    */
/*      | set ll(2,k)=i  &  exchange k_th_row & i_th_row         |    */
/*      | update ll(1,j)=min(ll(1,j),k)                          |    */
/*      +--------------------------------------------------------+    */
        ll[2+k*2]=i;
        if(k != i) {
          for(j=k; j<=kmb; j++) {
            if(ll[1+j*2] > k) ll[1+j*2]=k;
            akk=a[i+p[j]];
            a[i+p[j]]=a[k+p[j]];
            a[k+p[j]]=akk;
          }
        }
/*      +--------------------------------------------------------+    */
/*      | a(i,j)=a(i,j) - l(i,k)*u(k,j) for i=k+1,kma & j=k+1,kmb|    */
/*      | a(i,k)=l(i,k),  a(k,j)=l(k,k)*u(k,j) --> u(k,j)=akj    |    */
/*      +--------------------------------------------------------+    */
        if(k == n) {free(++p); return(0);}
        for(j=k+1; j<=kmb; j++) {
          akj=a[k+p[j]]/a[k+p[k]];
          for(i=k+1; i<=kma; i++) {
            a[i+p[j]]=a[i+p[j]]-a[i+p[k]]*akj;
          }
          a[k+p[j]]=akj;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | return(k) on singular matrix : l(k,k)=0                  |    */
/*    +----------------------------------------------------------+    */
      printf("Matrix is singular: a[%d,%d] = 0\n",k,k);
      free(++p); return(k);
}
/**********************************************************************/
      int cvppsb(double a[],double b[],int ll[]
                ,int n,int ma,int mb,int mm) {
/*    int cvppsb(a,b,ll,n,ma,mb,mm)
      double a[],b[]; int ll[],n,ma,mb,mm; {                          */
/*    ============================================================    */
      double bk;
      int    i,k,kma,kmb;
      int    *p;                     /* a[i+p[j]] = a(i,j) */
      --a; --b; --ll; ll-=2;         /* dimension ll(2,n)  */
      p=(int *)malloc(n*sizeof(int));
      --p; for(i=1; i<=n; i++) p[i]=i*mm-mm;
/*    ============================================================    */
/*    find {x} from [a]{x}={b} for given {b} & [r][a]=[l][u].         */
/*    [l] & [u] are given & put in a(nn,n), [r] is given by ll(2,n)   */
/*    [l][u]{x}=[r]{b}  ==>  [l]{y}=[r]{b}, [u]{x}={y}                */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | find {y} from [r]{b} by forward subst. of [l]{y}=[r]{b}  |    */
/*    | for k=1:n  compute b(i)=b(i)-l(i,k)*y(k) for i=(k+1):kma |    */
/*    | a(i,k)=l(i,k), b(k)=y(k), b(i)=b(i) --> y(i)=bk/l(k,k)   |    */
/*    +----------------------------------------------------------+    */
      for(k=1; k<=n; k++) {
        kma=k+ma; if(kma > n) kma=n;
        i=ll[2+k*2];
        bk=b[i]/a[k+p[k]];
        b[i]=b[k];
        for(i=k+1; i<=kma; i++) {
          b[i]=b[i]-a[i+p[k]]*bk;
        }
        b[k]=bk;
      }
/*    +----------------------------------------------------------+    */
/*    | find {x} from {y} by backward substitution of [u]{x}={y} |    */
/*    | for k=n:2  compute b(i)=b(i)-u(i,k)*x(k) for i=kmb:(k-1) |    */
/*    | a(i,k)=u(i,k), b(k)=x(k), b(i)=y(i) ==> x(k)=bk          |    */
/*    +----------------------------------------------------------+    */
      for(k=n; k>=2; k--) {
        kmb=ll[1+k*2];
        bk=b[k];
        for(i=kmb; i<=k-1; i++) {
          b[i]=b[i]-a[i+p[k]]*bk;
        }
      }
      free(++p); return(0);
}
/**********************************************************************/
