#include <math.h>
/**********************************************************************/
      int usdecp(double a[],int ll[],int not,int *pnnt,int *pnsd
                ,int maxa,int maxn) {
/*    int usdecp(a,ll,not,pnnt,pnsd,maxa,maxn)
/*    double a[]; int ll[],not,*pnnt,*pnsd,maxa,maxn; {               */
/*    ============================================================    */
      double aij,aji,ajj,add,eps=1e-7;
      int    i,j,k,ij,ia,ib,ja,jb,jc,ka;
      int    ima,imb,jma,jmb,nat,nbt,im1,jm1,jmm,nad,nnt,nsd;
      extern int lufpdc();
      --a; --ll; ll-=2;              /* dimension ll(2,n) */
/*    ============================================================    */
/*    lu decomposition [a]=[l][u]                                     */
/*    ------------------------------------------------------------    */
/*i   a(not+l*(not))  = the given original matrix a(not,not)          */
/*o   a(nnt+l*(nnt))  = decomposed matrix l+u-i : l\u(nnt,nnt)        */
/*i   ll(2,1:not)     = original storage index of a(not,not)          */
/*o   ll(2,not+1:nnt) = expanded storage index of l\u(nnt,nnt)        */
/*i   not     = the order of the original matrix a(not,not)           */
/*o   nnt     = the order of the expanded matrix a(nnt,nnt)           */
/*o   nsd     = number of singular degrees of the given matrix        */
/*i   maxa    = the maximum allowed dimension of a(maxa)              */
/*i   maxn    = the maximum allowed dimension of ll(2,maxn)           */
/*    eps     = epsilon for accuracy control                          */
/*    ------------------------------------------------------------    */
/*    find [l] & [u] for given [a], such that  [a] => [l] [u]         */
/*    for example:                                                    */
/*    input : not=3, lr(3)=(0 1 4),      ll(3)=(0 2 4)                */
/*    output: nnt=5, lr(5)=(0 1 4 7 13), ll(5)=(0 2 4 10 16)          */
/*                                                                    */
/*          | a11 a12 a13 |           | a11+p1 a12   a13 -p1  0  |    */
/*    [a] = | a21 a22 a23 |           |  a21  a22+p2 a23  0  -p2 |    */
/*          |  0   0  a33 |           |   0     0    a33  0   0  |    */
/*    if it is expanded to ---> [a] = |  -p1    0     0  +p1  0  |    */
/*    then decomposed matrices are:   |   0    -p2    0   0  +p2 |    */
/*                                                                    */
/*          | l11  0   0   0   0  |        |  1  u12 u13 u14  0  |    */
/*          | l21 l22  0   0   0  |        |  0   1  u23 u24 u25 |    */
/*    [l] = |  0   0  l33  0   0  |, [u] = |  0   0   1  u34 u35 |    */
/*          | l41 l42 l43 l44  0  |        |  0   0   0   1  u45 |    */
/*          |  0  l52 l53 l54 l55 |        |  0   0   0   0   1  |    */
/*                                                                    */
/*i    a(7):(a11 a12 a21 a22 a13 a23 a33)                             */
/*o   a(21):(l11 u12 l21 l22 u13 u23 l33 u14 u24 u34                  */
/*o                  l41 l42 l43 l44 u25 u35 u45 l52 l53 l54 d55)     */
/*    ============================================================    */
/*    ll(1,j)=storage index of upper triangular part w/o  diagonal    */
/*            a(i,j) is referred as a(i+ll(1,j))                      */
/*    ll(2,i)=storage index of lower triangular part with diagonal    */
/*            a(i,j) is referred as a(j+ll(2,i))                      */
/*    ------------------------------------------------------------    */
/*    the storage indexes/locations of the matrix elements:           */
/*    ll(1,j) 0  1  4  7 13                                           */
/*    ll(2,i)                (i) for examples:                        */
/*       0    1\ 2  5  8      1  2+ll(1,5)=15 for a(2,5) in loc.15    */
/*       2    3  4\ 6  9 15   2  3+ll(1,5)=16 for a(3,5) in loc.16    */
/*       4          7\10 16   3  4+ll(1,5)=17 for a(4,5) in loc.17    */
/*      10   11 12 13 14\17   4  2+ll(2,5)=18 for a(5,2) in loc.18    */
/*      16      18 19 20 21\  5  3+ll(2,5)=19 for a(5,3) in loc.19    */
/*                               4+ll(2,5)=20 for a(5,4) in loc.20    */
/*      (j)   1  2  3  4  5      5+ll(2,5)=21 for a(5,5) in loc.21    */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | initial set nsd=0 : this also allows matrix to expend    |    */
/*    | set to decompose the original given matrix a(not,not)    |    */
/*    +----------------------------------------------------------+    */
      nsd=0;
      nat=0;
      nbt=not;
      nnt=not;
/*    +----------------------------------------------------------+    */
/*    | decompose the sub-matrix a((nat+1):nbt,(nat+1):nbt)      |    */
/*    +----------------------------------------------------------+    */
      jc=0;
  L10:for(j=nat+1; j<=nbt; j++) {
        ja=ll[2+j*2]-ll[1+1*2];
        jb=ll[1+j*2]-ll[1+1*2];
        jma=j-ja+jb;
        jmb=j-jb+jc;
        jc=ja;
/*      +--------------------------------------------------------+    */
/*      | aij = a(i,j) - \sum_{k=ima}^{i-1} l(i,k)*u(k,j)        |    */
/*      | a(k+ia)=l(i,k),    a(k+jb)=u(k,j)                      |    */
/*      | a(i+jb)=a(i,j) --> u(i,j)=aij/l(i,i)                   |    */
/*      +--------------------------------------------------------+    */
        for(i=jmb; i<=j-1; i++) {
          ia=ll[2+i*2]-ll[1+1*2];
          ima=i-ll[2+i*2]+ll[1+i*2]; if(ima < jmb) ima=jmb;
          im1=i-1; if(im1 > not) im1=not;
          aij=a[i+jb];
          for(k=ima; k<=im1; k++) {
            aij=aij-a[k+ia]*a[k+jb];
          }
          a[i+jb]=aij;
          if(i <= not) a[i+jb]=aij/a[i+ia];
        }
/*      +--------------------------------------------------------+    */
/*      | aji = a(j,i) - \sum_{k=imb}^{i-1} l(j,k)*u(k,i)        |    */
/*      | a(k+ja)=l(j,k),    a(k+ib)=u(k,i)                      |    */
/*      | a(i+ja)=a(j,i) --> l(j,i)=aji                          |    */
/*      +--------------------------------------------------------+    */
        for(i=jma+1; i<=j-1; i++) {
          ib=ll[1+i*2]-ll[1+1*2];
          imb=i-ll[1+i*2]+ll[2+(i-1)*2]; if(imb < jma) imb=jma;
          im1=i-1; if(im1 > not) im1=not;
          aji=a[i+ja];
          for(k=imb; k<=im1; k++) {
            aji=aji-a[k+ja]*a[k+ib];
          }
          a[i+ja]=aji;
        }
/*      +--------------------------------------------------------+    */
/*      | compute l(j,j)                                         |    */
/*      | ajj = a(j,j) - \sum_{k=jm*}^{j-1} l(j,k)*u(k,j)        |    */
/*      | a(k+ja)=l(j,k),    a(k+jb)=u(k,j)                      |    */
/*      | a(j+ja)=a(j,j) --> l(j,j)=ajj                          |    */
/*      +--------------------------------------------------------+    */
        ajj=a[j+ja];
        add=fabs(ajj);
        jmm=jma; if(jmm < jmb) jmm=jmb;
        jm1=j-1; if(jm1 > not) jm1=not;
        for(k=jmm; k<=jm1; k++) {
        ajj=ajj-a[k+ja]*a[k+jb];
        if(add < fabs(ajj)) add=fabs(ajj);
        }
        a[j+ja]=ajj;
        if(j > not) continue;
/*      +--------------------------------------------------------+    */
/*      | if the pivoting element a(j,j) > add*eps ?             |    */
/*      | yes:80 : ok and continue                               |    */
/*      | no     : add pivoting by add and expand one column     |    */
/*      +--------------------------------------------------------+    */
        if(fabs(a[j+ja]) > add*eps) continue;
/*      +--------------------------------------------------------+    */
/*      | if add == 0 ?                                          |    */
/*      | yes: no reference value available, get from diagonal   |    */
/*      +--------------------------------------------------------+    */
        if(add == 0.0) {
          for(k=nat+1; k<=nbt; k++) {
            ka=ll[2+k*2]-ll[1+1*2];
            if(add < fabs(a[k+ka])) add=fabs(a[k+ka]);
          }
        }
        if(add == 0.0) add=1.0;
/*      +--------------------------------------------------------+    */
/*      | if j == nnt && nsd == 0                               |    */
/*      | then it is the only & the last zero_diagonal,          |    */
/*      | so set nsd=1 to prevent from any further expanding     |    */
/*      +--------------------------------------------------------+    */
        if(j == nnt && nsd == 0) nsd=1;
/*      +--------------------------------------------------------+    */
/*      | if nsd > 0 : no more expanding is allowed             |    */
/*      +--------------------------------------------------------+    */
        if(nsd > 0) {
          a[j+ja]=fabs(a[j+ja]);
          if(a[j+ja] < add*eps*eps) a[j+ja]=add*eps*eps;
/*      +--------------------------------------------------------+    */
/*      | if nsd == 0 : expand the matrix by                     |    */
/*      | modify the diagonal : a(j,j)=a(j,j)+add                |    */
/*      | add column : a(j,nnt)=-add, a(nnt,nnt)=add, a(*,nnt)=0 |    */
/*      +--------------------------------------------------------+    */
        } else {
          a[j+ja]=a[j+ja]+add;
          nnt=nnt+1;
          if(nnt > maxn) {
            printf("usdecp : nnt > maxn\n"); exit(-1);
          }
          ll[1+nnt*2]=ll[2+(nnt-1)*2]+nnt-j;
          ll[2+nnt*2]=ll[1+ nnt   *2]+nnt-j;
          jb=ll[1+nnt*2]-ll[1+1*2];
          ja=ll[2+nnt*2]-ll[1+1*2];
          if(nnt+ja > maxa) {
            printf("usdecp : nnt+ja > maxa\n"); exit(-1);
          }
          a[j+jb]=-add;
          a[j+ja]=-add;
          for(i=j+1; i<=nnt-1; i++) {
            a[i+jb]=0.0;
            a[i+ja]=0.0;
          }
          a[nnt+ja]=add;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | if nnt > nbt  then decompose the newly expand matrix     |    */
/*    | set nsd=nnt-nbt to prevent from further expanding        |    */
/*    +----------------------------------------------------------+    */
      if(nnt > nbt) {
        nsd=nnt-nbt;
        nat=nbt;
        nbt=nnt;
        goto L10;
      }
/*    +----------------------------------------------------------+    */
/*    | if nnt == not then return, else:                         |    */
/*    | form a sub-system [a]{x}={b} to solve by full pivoting   |    */
/*    +----------------------------------------------------------+    */
      if(nnt == not) {*pnnt=nnt; *pnsd=nsd; return(0);}
      ij=nnt+ll[2+nnt*2];
      if(nnt+nsd > maxn) {
        printf("usdecp : maxn too small\n"); exit(-1);
      }
      if(ij+nsd*nsd > maxa) {
        printf("usdecp : maxa too small\n"); exit(-1);
      }
      for(j=not+1; j<=nnt; j++) {
        for(i=not+1; i<=nnt; i++) {
          ij=ij+1;
          if(i <  j) a[ij]=a[i+ll[1+j*2]-ll[1+1*2]];
          if(i >= j) a[ij]=a[j+ll[2+i*2]-ll[1+1*2]];
        }
      }
      nad=nsd;
      lufpdc(&a[nnt+ll[2+nnt*2]+1],&ll[1+(nnt+1)*2],nad,&nsd,nad);
      *pnnt=nnt;
      *pnsd=nsd;
      return(0);
}
/**********************************************************************/
      int ussolx(double a[],double p[],int ll[],int not,int nnt
                ,double b[]) {
/*    int ussolx(a,p,ll,not,nnt,b)
/*    double a[],p[],b[]; int ll[],not,nnt; {                         */
/*    ============================================================    */
      double bi;
      int    i,k,ia,ib;
      int    ima,imb,im1,nad;
      extern int lufpsb();
      --a; --p; --b; --ll; ll-=2;    /* dimension ll(2,n) */
/*    ============================================================    */
/*    dimension a(nnt+ll(2,nnt)),p(not),ll(2,nnt),b(nnt)              */
/*    ------------------------------------------------------------    */
/*    find {x} from [a]{x}={p} for given {p} & [a]=>[l][u].           */
/*    [l] & [u] are given & put in a(*)  (expanded by sub. usdecp)    */
/*    [l][u]{x}={b} ===> [l]{y}={b},  [u]{x}={y}                      */
/*    ------------------------------------------------------------    */
/*i   p(not) = the given constant vector                              */
/*o   p(not) = the solution vector                                    */
/*w   b(nnt) = the expanded vector (form by ussolx)                   */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | expand p(not) to b(nnt)                                  |    */
/*    +----------------------------------------------------------+    */
      for(i=1; i<=not; i++) {
        b[i]=p[i];
      }
      for(i=not+1; i<=nnt; i++) {
        b[i]=0.0;
      }
/*    +----------------------------------------------------------+    */
/*    | find {y} from {b} by forward substitution of [l]{y}={b}  |    */
/*    | bi = b(i) - \sum_{k=ima}^{i-1} l(i,k)*y(k)               |    */
/*    | a(k+ia)=l(i,k), b(k)=y(k), b(i)=b(i) --> y(i)=bi/l(i,i)  |    */
/*    +----------------------------------------------------------+    */
      for(i=1; i<=nnt; i++) {
        ia=ll[2+i*2]-ll[1+1*2];
        ima=i-ll[2+i*2]+ll[1+i*2];
        im1=i-1; if(im1 > not) im1=not;
        bi=b[i];
        for(k=ima; k<=im1; k++) {
          bi=bi-a[k+ia]*b[k];
        }
        b[i]=bi;
        if(i <= not) b[i]=bi/a[i+ia];
      }
/*    ------------------------------------------------------------    */
      nad=nnt-not;
      if(nad > 0)
       lufpsb(&a[nnt+ll[2+nnt*2]+1],&b[not+1],&ll[1+(nnt+1)*2],nad,nad);
/*    +----------------------------------------------------------+    */
/*    | find {x} from {y} by backward substitution of [u]{x}={y} |    */
/*    | for i=nnt:2 compute b(k)=b(k)-u(k,i)*x(i) for k=imb:(i-1)|    */
/*    | a(k+ib)=u(k,i),     b(i)=bi=x(i),     b(k)=y(k) --> x(k) |    */
/*    +----------------------------------------------------------+    */
      for(i=nnt; i>=2; i--) {
        ib=ll[1+i*2]-ll[1+1*2];
        imb=i-ll[1+i*2]+ll[2+(i-1)*2];
        im1=i-1; if(im1 > not) im1=not;
        bi=b[i];
        for(k=imb; k<=im1; k++) {
          b[k]=b[k]-a[k+ib]*bi;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | move solution vector b(not) to p(not)                    |    */
/*    +----------------------------------------------------------+    */
      for(i=1; i<=not; i++) {
        p[i]=b[i];
      }
      return(0);
}
/**********************************************************************/
      int usbksb(double a[],double b[],int ll[],int not,int nnt) {
/*    int usbksb(a,b,ll,not,nnt)
/*    double a[],b[]; int ll[],not,nnt; {                             */
/*    ============================================================    */
      double bi;
      int    i,k,ib;
      int    imb,im1,nad;
      extern int lufpsb();
      --a; --b; --ll; ll-=2;         /* dimension ll(2,n) */
/*    ============================================================    */
/*    dimension a(nnt+ll(2,nnt)),b(nnt),ll(2,nnt)                     */
/*    ------------------------------------------------------------    */
/*    find {x} from {y} by backward substitution of [u]{x}={y}        */
/*    ------------------------------------------------------------    */
/*i   b(nnt) = the given vector {y}                                   */
/*o   b(nnt) = the solution vector {x}                                */
/*    ============================================================    */
      nad=nnt-not;
      if(nad > 0)
       lufpbs(&a[nnt+ll[2+nnt*2]+1],&b[not+1],&ll[1+(nnt+1)*2],nad,nad);
/*    +----------------------------------------------------------+    */
/*    | find {x} from {y} by backward substitution of [u]{x}={y} |    */
/*    | for i=nnt:2 compute b(k)=b(k)-u(k,i)*x(i) for k=imb:(i-1)|    */
/*    | a(k+ib)=u(k,i),     b(i)=bi=x(i),     b(k)=y(k) --> x(k) |    */
/*    +----------------------------------------------------------+    */
      for(i=nnt; i>=2; i--) {
        ib=ll[1+i*2]-ll[1+1*2];
        imb=i-ll[1+i*2]+ll[2+(i-1)*2];
        im1=i-1; if(im1 > not) im1=not;
        bi=b[i];
        for(k=imb; k<=im1; k++) {
          b[k]=b[k]-a[k+ib]*bi;
        }
      }
      return(0);
}
/**********************************************************************/
      int ussngx(double a[],double s[],int ll[],int not,int nnt,int nsd
                ,double b[]) {
/*    int ussngx(a,s,ll,not,nnt,nsd,b)
      double a[],s[],b[]; int ll[],not,nnt,nsd; {                     */
/*    ============================================================    */
      int    i,j,js;
      extern int usbksb();
      --a; --s; --b; --ll; ll-=2;    /* dimension ll(2,n) */
/*    ============================================================    */
/*    dimension a(nnt+ll(2,nnt)),s(not,nsd),ll(2,nnt),b(nnt)          */
/*    ------------------------------------------------------------    */
/*    find the solution vectors [s] of the singular matrix [a]        */
/*    ------------------------------------------------------------    */
/*i   a(nnt+l*(nnt)) = decomposed matrix l+u-i : l\u(nnt,nnt)         */
/*i   ll(2,nnt)      = expanded storage index of l\u(nnt,nnt)         */
/*o   s(not,nsd) = solution vectors of singular matrix a(not,not)     */
/*i   not     = the order of the original matrix a(not,not)           */
/*i   nnt     = the order of the expanded matrix a(nnt,nnt)           */
/*i   nsd     = number of singular degrees of the given matrix        */
/*w   b(nnt)  = the working array                                     */
/*    ============================================================    */
      for(j=nnt-nsd+1; j<=nnt; j++) {
        js=(j-nnt+nsd-1)*not;
        for(i=1; i<=nnt; i++) {
          b[i]=0.0;
        }
        b[j]=1.0;
        usbksb(&a[1],&b[1],&ll[1+1*2],not,nnt);
        for(i=1; i<=not; i++) {
          s[i+js]=b[i];
        }
      }
      return(0);
}
/**********************************************************************/
