#include <stdio.h>
/**********************************************************************/
      int input(double sm[],double pm[],int kk[],int ne,FILE *fp_r) {
/*    int input(sm,pm,kk,ne,fp_w)
      double sm[],pm[]; int kk[],ne; FILE *fp_r; {                    */
/*    ============================================================    */
      int i,j,k;
      sm-=7; pm-=3; kk-=3;   /* dimesion sm(2,2,ne),pm(2,ne),kk(2,ne) */
/*    ============================================================    */
/*    read kk(2,ne)   = unknown # of member end displacements         */
/*         sm(2,2,ne) = member stiffness matrix                       */
/*         pm(2,ne)   = member fixed end forces                       */
/*    ============================================================    */
      for(k=1; k<=ne; k++) {
        for(i=1; i<=2; i++) freeii(&kk[i+k*2],fp_r);
        for(i=1; i<=2; i++) {
          for(j=1; j<=2; j++) freer8(&sm[i+j*2+k*4],fp_r);
        }
        for(i=1; i<=2; i++) freer8(&pm[i+k*2],fp_r);
      }
      return(0);
}
/**********************************************************************/
      int formeq(double sm[],double pm[],int kk[],double s[],double p[]
                ,int l[],int ne,int n,int mm,int nn,FILE *fp_w) {
/*    int formeq(sm,pm,kk,s,p,l,ne,n,mm,nn,fp_w)
      double sm[],pm[],s[],p[]; int kk[],l,ne,n,mm,nn; FILE *fp_w; {  */
/*    ============================================================    */
      int i,j,k,ii,jj,js;
      sm-=7; pm-=3; kk-=3;  /* dimension sm(2,2,ne),pm(2,ne),kk(2,ne) */
      --s; s-=mm; --p; --l; /* dimension s(mm,nn),p(n),l(n)           */
/*    ============================================================    */
/*    form s(n,n) = structural stiffness matrix                       */
/*     and  p(n)  = loading vector for s(n,n)*d(n) = p(n)             */
/*    ------------------------------------------------------------    */
/*    for constant banded : mm = half-bandwidth; nn = n+(n-1)/mm      */
/*    for variable banded : mm = 1;              nn = l(n)+n-1        */
/*    ============================================================    */
      for(jj=1; jj<=nn; jj++) {
        for(ii=1; ii<=mm; ii++) s[ii+jj*mm]=0.0;
      }
      for(jj=1; jj<=n; jj++) p[jj]=0.0;
/*    ------------------------------------------------------------    */
      for(k=1; k<=ne; k++) {
        for(j=1; j<=2; j++) {
          jj=kk[j+k*2];
          if(jj == 0 || jj > n) continue;
/*        +------------------------------------------------------+    */
/*        | for constant banded matrix (l(n) is dummy and unused)|    */
/*        +------------------------------------------------------+    */
          if(mm != 1) js=jj*mm;
/*        +------------------------------------------------------+    */
/*        | for variable banded matrix (l(n) is location index)  |    */
/*        +------------------------------------------------------+    */
          else        js=l[jj];
          for(i=1; i<=2; i++) {
            ii=kk[i+k*2];
            if(ii == 0 || ii > jj) continue;
            s[ii+js]=s[ii+js]+sm[i+j*2+k*4];
          }
          p[jj]=p[jj]-pm[j+k*2];
        }
      }
/*    ------------------------------------------------------------    */
      fprintf(fp_w,"\nLoading vector of strucutre\n");
      for(jj=1; jj<=n; jj++) {
        if(jj%6 == 1) fprintf(fp_w,"\n");
        fprintf(fp_w,"%12.4le",p[jj]);
      }
      return(0);
}
/**********************************************************************/
      int printv(double s[],int l[],int n,int mm,int nn
                ,FILE *fp_w,char *note) {
/*    int printv(s,l,n,mm,nn,fp_w,note)
      double s[]; int l[],n,mm,nn; FILE *fp_w; char *note; {          */
/*    ============================================================    */
      int i,j,jm,js;
      --s; s-=mm; --l;               /* dimension s(mm,nn),l(n) */
/*    ============================================================    */
/*    write s(mm,nn)                                                  */
/*    ============================================================    */
      fprintf(fp_w,"\n\n%s\n",note);
      for(i=1; i<=mm; i++) {
        for(j=1; j<=nn; j++) {
          if(j%8 == 1) fprintf(fp_w,"\n");
          fprintf(fp_w,"%9.4lf",s[i+j*mm]);
        }
      }
      fprintf(fp_w,"\n");
      jm=1;
      for(j=1; j<=n; j++) {
/*      +--------------------------------------------------------+    */
/*      | for constant banded matrix (l(n) is dummy and unused)  |    */
/*      +--------------------------------------------------------+    */
        if(mm != 1) {js=j*mm; if(j > mm) jm=j-mm;}
/*      +--------------------------------------------------------+    */
/*      | for variable banded matrix (l(n) is location index)    |    */
/*      +--------------------------------------------------------+    */
        else {js=l[j]; if(j > 1) jm=j-l[j]+l[j-1];}
/*      ----------------------------------------------------------    */
        for(i=1; i<=j; i++) {
          if(i%8 == 1) fprintf(fp_w,"\n");
          if(i < jm) fprintf(fp_w,"%9.4lf",0.0);
          else       fprintf(fp_w,"%9.4lf",s[i+js]);
        }
      }
      return(0);
}
/**********************************************************************/
      int output(double sm[],double pm[],int kk[],double d[]
                ,int ne,int n,FILE *fp_w) {
/*    int output(sm,pm,kk,d,ne,n,fp_w)
      double sm[],pm[],d[]; int kk[],ne,n; FILE *fp_w; {              */
/*    ============================================================    */
      int    i,j,k,jj;
      double am[3],dm[3];
      sm-=7; pm-=3; kk-=3; --d;  /* sm(2,2,ne),pm(2,ne),kk(2,ne),d(n) */
/*    ============================================================    */
/*    write d(n)  = nodal displacements of the structure              */
/*          am(2) = member end forces = sm(2,2)*dm(2) + pm(2)         */
/*    where dm(i) = d(kk(i,k)), if kk(i,k)>0   (else dm(i)=0)         */
/*    ============================================================    */
      fprintf(fp_w,"\n\nDisplacements of structure\n");
      for(j=1; j<=n; j++) {
        if(j%6 == 1) fprintf(fp_w,"\n");
        fprintf(fp_w,"%12.4le",d[j]);
      }
      fprintf(fp_w,"\n\nMember end forces");
      fprintf(fp_w,"\n\nMember   Left-moment   Right-moment\n");
      for(k=1; k<=ne; k++) {
        for(j=1; j<=2; j++) {
          jj=kk[j+k*2];
          dm[j]=0.0;
          if(jj != 0 && jj <= n) dm[j]=d[jj];
        }
        fprintf(fp_w,"\n%5d",k);
        for(i=1; i<=2; i++) {
          am[i]=pm[i+k*2];
          for(j=1; j<=2; j++) {
            am[i]=am[i]+sm[i+j*2+k*4]*dm[j];
          }
          fprintf(fp_w,"%15.5le",am[i]);
        }
      }
      return(0);
}
/**********************************************************************/
