#include <stdio.h>
#include <ctype.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
int input(double *, double *, int *, int, FILE *);
int cband(int *, int, int, int *, int*);
int formeq(double *, double *, int *, double *, double *, int *
          ,int, int, int, int, FILE *);
int printv(double *, int *, int, int, int, FILE *, char *);
int cbdecp(double *, int, int, int);
int cbsolx(double *, double *, int, int, int);
int output(double *, double *, int *, double *, int, int, FILE *);
/**********************************************************************/
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double *a;
      int    ne,mm,nn,n;
      int    n1,n2,n3,n4,n5,n6,n7,iri;
      iri=sizeof(double)/sizeof(int);
/*    ============================================================    */
/*    program for structural analysis using constant banded matrix    */
/*    ============================================================    */
      if(argc<3) {printf("Usage : stracb infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);

  L10:freeii(&ne,fp_r); if(ne == 0) exit(0); freeii(&n,fp_r);
/*    +----------------------------------------------------------+    */
/*    | dynamic allocate the space for arrays                    |    */
/*    +----------------------------------------------------------+    */
      n1=0;
      n2=n1+2*2*ne;              /* sm(2,2,ne) */
      n3=n2+2*ne;                /* pm(2,ne) */
      n4=n3+2*ne/iri+1;          /* kk(2,ne) */
      n5=n4;                     /* dummy l(0) unused */
      a=(double *)malloc(n5*sizeof(double));
      if(a == NULL) {printf("\nDimension too large"); exit(-1);}
      input(&a[n1],&a[n2],(int *)&a[n3],ne,fp_r);
      cband((int *)&a[n3],ne,n,&mm,&nn);
/*    +----------------------------------------------------------+    */
/*    | allocate space for constant banded s(mm,nn) & p(n)       |    */
/*    +----------------------------------------------------------+    */
      n6=n5+mm*nn;               /* s(mm,nn) */
      n7=n6+n;                   /* p(n) */
      a=(double *)realloc(a,n7*sizeof(double));
      formeq(&a[n1],&a[n2],(int *)&a[n3],&a[n5],&a[n6],(int *)&a[n4]
            ,ne,n,mm,nn,fp_w);
      printv(&a[n5],(int *)&a[n4],n,mm,nn,fp_w
            ,"Stiffness con. banded matrix");
/*    ------------------------------------------------------------    */
      cbdecp(&a[n5],mm,n,mm);
      cbsolx(&a[n5],&a[n6],mm,n,mm);
/*    ------------------------------------------------------------    */
      printv(&a[n5],(int *)&a[n4],n,mm,nn,fp_w
            ,"Decomposed con. banded matrix");
      output(&a[n1],&a[n2],(int *)&a[n3],&a[n6],ne,n,fp_w);
/*    ------------------------------------------------------------    */
      free(a);
      goto L10;
}
/**********************************************************************/
      int cband(int kk[],int ne,int n,int *pmm,int *pnn) {
/*    int cband(kk,ne,n,pmm,pnn)
      int kk[],ne,n,*pmm,*pnn) {                                      */
/*    ============================================================    */
      int i,j,k,md,min,max,mm,nn;
      --kk; kk-=2;
/*    ============================================================    */
/*    compute mm = half-bandwidth of the stiffness matrix             */
/*            nn = n+(n-1)/mm = number of columns for the matrix      */
/*    ============================================================    */
      mm=2;          /* to be different to variable banded matrix */
      for(k=1; k<=ne; k++) {
/*    +----------------------------------------------------------+    */
/*    | max/min = maximum/minimum unknown # of member k          |    */
/*    | md = max-min = half-bandwidth of member stiffness matrix |    */
/*    | mm = maximum of md(1:ne)                                 |    */
/*    +----------------------------------------------------------+    */
      max=0;
      min=n;
      for(i=1; i<=2; i++) {
        j=kk[i+k*2];
        if(j == 0 || j > n) continue;
        if(max < j) max=j;
        if(min > j) min=j;
      }
      md=max-min;
      if(md > mm) mm=md;
      }
/*    ------------------------------------------------------------    */
      nn=n+(n-1)/mm;
      *pmm=mm; *pnn=nn; return(0);
}
/**********************************************************************/
