#include <stdio.h>
#include <ctype.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
int input(double *, double *, int *, int, FILE *);
int cband(int *, int, int, int *, int*);
int formeq(double *, double *, int *, double *, double *, int *
          ,int, int, int, int, FILE *);
int printv(double *, int *, int, int, int, FILE *, char *);
int cbdecp(double *, int, int, int);
int cbsolx(double *, double *, int, int, int);
int output(double *, double *, int *, double *, int, int, FILE *);
/**********************************************************************/
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double *a;
      int    ne,mm=1,nn,n;
      int    n1,n2,n3,n4,n5,n6,n7,iri;
      iri=sizeof(double)/sizeof(int);
/*    ============================================================    */
/*    program for structural analysis using variable banded matrix    */
/*    ============================================================    */
      if(argc<3) {printf("Usage : stravb infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);

  L10:freeii(&ne,fp_r); if(ne == 0) exit(0); freeii(&n,fp_r);
/*    +----------------------------------------------------------+    */
/*    | dynamic allocate the space for arrays                    |    */
/*    +----------------------------------------------------------+    */
      n1=0;
      n2=n1+2*2*ne;              /* sm(2,2,ne) */
      n3=n2+2*ne;                /* pm(2,ne) */
      n4=n3+2*ne/iri+1;          /* kk(2,ne) */
      n5=n4+n;                   /* l(n) */
      a=(double *)malloc(n5*sizeof(double));
      if(a == NULL) {printf("\nDimension too large"); exit(-1);}
      input(&a[n1],&a[n2],(int *)&a[n3],ne,fp_r);
      colid((int *)&a[n3],(int *)&a[n4],ne,n,&nn);
/*    +----------------------------------------------------------+    */
/*    | allocate space for variable banded s( 1,nn) & p(n)       |    */
/*    +----------------------------------------------------------+    */
      n6=n5+nn;                  /* s(nn) */
      n7=n6+n;                   /* p(n) */
      a=(double *)realloc(a,n7*sizeof(double));
      formeq(&a[n1],&a[n2],(int *)&a[n3],&a[n5],&a[n6],(int *)&a[n4]
            ,ne,n,1,nn,fp_w);
      printv(&a[n5],(int *)&a[n4],n,mm,nn,fp_w
            ,"Stiffness var. banded matrix");
/*    ------------------------------------------------------------    */
      vbdecp(&a[n5],(int *)&a[n4],n);
      vbsolx(&a[n5],&a[n6],(int *)&a[n4],n);
/*    ------------------------------------------------------------    */
      printv(&a[n5],(int *)&a[n4],n,mm,nn,fp_w
            ,"Decomposed var. banded matrix");
      output(&a[n1],&a[n2],(int *)&a[n3],&a[n6],ne,n,fp_w);
/*    ------------------------------------------------------------    */
      free(a);
      goto L10;
}
/**********************************************************************/
      int colid(int kk[],int l[],int ne,int n,int *pnn) {
/*    int colid(kk,l,ne,n,pnn)
      int kk[],l[],ne,n,*pnn; {                                       */
/*    ============================================================    */
      int i,j,k,min,nn;
      --kk; kk-=2; --l;
/*    ============================================================    */
/*    compute l(n) = location index for variable banded matrix        */
/*             nn  = l(n)+n-1 = total number of elements to store     */
/*    ============================================================    */
      for(j=1; j<=n; j++) l[j]=j;
/*    +----------------------------------------------------------+    */
/*    | min  = min.kk(1:2,k) = minimum unknown # of member k     |    */
/*    | l(j) = row number of top non-zero element at column j    |    */
/*    |      = minimum of min and old.l(j) for j=kk(1:2,k)       |    */
/*    +----------------------------------------------------------+    */
      for(k=1; k<=ne; k++) {
        min=n;
        for(i=1; i<=2; i++) {
          j=kk[i+k*2];
          if(j == 0 || j > n) continue;
          if(min > j) min=j;
        }
        for(i=1; i<=2; i++) {
          j=kk[i+k*2];
          if(j == 0 || j > n) continue;
          if(min < l[j]) l[j]=min;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | l(j) = location index of column j                        |    */
/*    +----------------------------------------------------------+    */
      for(j=2; j<=n; j++) l[j]=l[j-1]+(j-l[j]);
      nn=l[n]+n-1;
      *pnn=nn; return(0);
}
/**********************************************************************/
