#include <stdio.h>
#include <ctype.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
/*    program for general eigenvalue problems                         */
/*    ============================================================    */
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double *a,*b,*v,*x,eps;
      int    *ih,n,m,nmax;
/*    ============================================================    */
      if(argc<3) {printf("Usage : avbvmn infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
  L10:freeii(&n,fp_r); freer8(&eps,fp_r); nmax=n;
      if(n == 0 || n > nmax) exit(0);

      a=(double *)calloc(n*n,sizeof(double));
      b=(double *)calloc(n*n,sizeof(double));
      v=(double *)calloc(n*n,sizeof(double));
      x=(double *)calloc(n  ,sizeof(double));
      ih=  (int *)calloc(n  ,sizeof(int));

      readu(a,n,nmax,fp_r);
      readu(b,n,nmax,fp_r);
      printt(a,n,nmax,"Lower part of matrix a :",fp_w);
      printt(b,n,nmax,"Lower part of matrix b :",fp_w);
/*    ------------------------------------------------------------    */
      bvexav(a,b,v,n,x,ih,&m,eps,nmax,nmax);
/*    ------------------------------------------------------------    */
      fprintf(fp_w,"\n After %d jacobian iterations",m);
      fprintf(fp_w,"\n the eigenvalues are\n");
      printb(x,n,fp_w);
      fprintf(fp_w,"\n the eigenvector matrix is\n");
      printa(v,n,n,nmax,fp_w);
      free(a); free(b); free(v); free(x); free(ih);
      goto L10;
}
/**********************************************************************/
      int readu(double a[],int n,int nn,FILE *fp_r) {
/*    ============================================================    */
      int i,j,ja;
      --a;            /* dimension a(nn,n) ! a(n*(n+1)/2) */
/*    ============================================================    */
      for(j=1; j<=n; j++) {
        ja=(j-1)*nn;  /* ja=(j-1)*j/2 */
        for(i=1; i<=j; i++) freer8(&a[i+ja],fp_r);
      }
      return(0);
}
/**********************************************************************/
      int printa(double a[],int n,int m,int nn,FILE *fp_w) {
/*    ============================================================    */
      int i,j,jl,jh,mm=5;
      --a; a-=nn;     /* dimension a(nn,m) */
/*    ============================================================    */
      for(jl=1; jl<=m; jl+=mm) {
        jh=jl+mm-1; if(jh > m) jh=m;
        fprintf(fp_w,"\n     ");
        for(j=jl; j<=jh; j++) fprintf(fp_w,"%13d",j);
        fprintf(fp_w,"\n");
        for(i=1; i<=n; i++) {
          fprintf(fp_w,"%5d",i);
          for(j=jl; j<=jh; j++) fprintf(fp_w,"%13.4le",a[i+j*nn]);
          fprintf(fp_w,"\n");
        }
      }
      return(0);
}
/**********************************************************************/
      int printb(double b[],int n,FILE *fp_w) {
/*    ============================================================    */
      int j,mm=5;
      --b;            /* dimension b(n) */
/*    ============================================================    */
      for(j=1; j<=n; j++) {
        if(j%mm == 1) fprintf(fp_w,"\n     ");
        fprintf(fp_w,"%13.4le",b[j]);
      }
      fprintf(fp_w,"\n");
      return(0);
}
/**********************************************************************/
