#include <math.h>
/**********************************************************************/
      int bvexav(double a[],double b[],double v[],int n,double x[]
                ,int ih[],int *pm,double epsi,int nv,int na) {
/*    int bvexav(a,b,v,n,x,ih,pm,epsi,nv,na)
      double a[],b[],v[],x[],epsi; int ih[],n,*pm,nv,na; {            */
/*    ============================================================    */
      double bb;
      int    i,j,ja,jv;
      int    jacobi(),gag(),mav();
      --a; --b; --v; --x; --ih;
/*    ============================================================    */
/*    dimension a,b(na,n),v(nv,n),x(n),ih(n)  ! a,b(n*(n-1)/2)        */
/*    ------------------------------------------------------------    */
/*    [b] {x} = d [a] {x}   --->   [b] [v] = [a] [v] [d]              */
/*    normalize as : [v]'[a] [v] = [i],      [v]'[b] [v] = [d]        */
/*    ------------------------------------------------------------    */
/*    input : a,b,v,n,m,epsi,nv,na       output : a,v,x,m             */
/*    ------------------------------------------------------------    */
/*i   a(n,n) = [a] matrix required upper triangular part only         */
/*o          = [d] diagonal matrix                                    */
/*w   b(n,n) = [b] matrix required upper triangular part only         */
/*o   v(n,n) = eigen vector matrix                                    */
/*i   n      = order of matrix [a]                                    */
/*o   x(n)   = eigenvalues (also in the diagonal of [a])              */
/*w   ih(n)  = working array for row i of max.a(i,j) in col j         */
/*o   m      = iteration count                                        */
/*i   epsi   = convergence if max.|a(i,j)| < min.a(k,k)*epsi          */
/*i   nv,na  = row dimensions of array v(nv,n) and a(na,n)            */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | solve [b] {y} = e {y}  for  [v] & [e]                    |    */
/*    +----------------------------------------------------------+    */
      *pm=0;
      jacobi(&b[1],&v[1],n,&x[1],&ih[1],1,pm,epsi,nv,na);
/*    +----------------------------------------------------------+    */
/*    | compute : [v] [e]^{-1/2} ---> [v]                        |    */
/*    +----------------------------------------------------------+    */
      for(j=1; j<=n; j++) {
        jv=(j-1)*nv;
        ja=(j-1)*na;     /* ja=(j-1)*j/2 */
        if(b[j+ja] > 0.0) {
          bb=1.0/sqrt(b[j+ja]);
          for(i=1; i<=n; i++) {
            v[i+jv]=v[i+jv]*bb;
          }
        }
      }
/*    +----------------------------------------------------------+    */
/*    | compute : [v]'[a] [v] ---> [a]                           |    */
/*    +----------------------------------------------------------+    */
      mav(&a[1],&b[1],&a[1],&v[1],&x[1],n,n,nv,na);
      mav(&a[1],&b[1],&b[1],&v[1],&x[1],n,0,nv,na);
/*    +----------------------------------------------------------+    */
/*    | compute : [g]'[a] [g] ---> [a];  [v] [g] ---> [v]        |    */
/*    +----------------------------------------------------------+    */
      gag(&a[1],&b[1],&v[1],n,&x[1],epsi,nv,na);
/*    +----------------------------------------------------------+    */
/*    | solve [a] {x} = 1/d {x}  for  [v] & [d]^{-1}             |    */
/*    +----------------------------------------------------------+    */
      jacobi(&a[1],&v[1],n,&x[1],&ih[1],-1,pm,epsi,nv,na);
/*    +----------------------------------------------------------+    */
/*    | before norm. : [v]'[a] [v] = [d]^{-1}, [v]'[b] [v] = [i] |    */
/*    | normalize as : [v]'[a] [v] = [i],      [v]'[b] [v] = [d] |    */
/*    +----------------------------------------------------------+    */
      for(j=1; j<=n; j++) {
        jv=(j-1)*nv;
        ja=(j-1)*na;     /* ja=(j-1)*j/2 */
        if(a[j+ja] == 0.0) {
          x[j]=1.0e30;
        } else {
          x[j]=1.0/a[j+ja];
          bb=sqrt(fabs(x[j]));
          for(i=1; i<=n; i++) {
            v[i+jv]=v[i+jv]*bb;
          }
        }
      }
      return(0);
}
/**********************************************************************/
