#include <math.h>
/**********************************************************************/
      int mav(double a[],double b[],double c[],double v[],double x[]
             ,int n,int m,int nv,int na) {
/*    int mav(a,b,c,v,x,n,m,nv,na)
      double a[],b[],c[],v[],x[]; int n,m,nv,na; {                    */
/*    ============================================================    */
      double av;
      int    i,j,k,ia,ja,jb,jv;
      --a; --b; --c; --v; --x;
/*    ============================================================    */
/*    dimension a,b,c(na,n),v(nv,n),x(n)  ! a,b,c(n*(n-1)/2)          */
/*    ------------------------------------------------------------    */
/*    mav(a,b,a,v,x,n,n,nv); :     [a] [v] --> [a]                    */
/*    mav(a,b,b,v,x,n,0,nv); : [v]'[a]'[v] --> [a]                    */
/*    ------------------------------------------------------------    */
/*    (ct+a) *    v   --> (at+b) ; b unused if m=0                    */
/*    ------------------------------------------------------------    */
/*    a a a     v v v     a b b                                       */
/*    c a a  *  v v v  =  a a b                                       */
/*    c c a     v v v     a a a                                       */
/*    ============================================================    */
      for(i=1; i<=n; i++) {
/*      +--------------------------------------------------------+    */
/*      | set <x> = the i-th row of [a]                          |    */
/*      +--------------------------------------------------------+    */
        ia=(i-1)*na;     /* ia=(i-1)*i/2 */
        for(j=1; j<=i-1; j++) {
          x[j]=c[j+ia];
        }
        for(j=i; j<=n; j++) {
          ja=(j-1)*na;   /* ja=(j-1)*j/2 */
          x[j]=a[i+ja];
        }
/*      +--------------------------------------------------------+    */
/*      | compute left part of the i-th row of ([a][v])          |    */
/*      +--------------------------------------------------------+    */
        for(j=1; j<=i; j++) {
          jv=(j-1)*nv;
          av=0.0;
          for(k=1; k<=n; k++) {
            av=av+x[k]*v[k+jv];
          }
          a[j+ia]=av;
        }
/*      +--------------------------------------------------------+    */
/*      | compute right part of the i-th row of ([a][v])         |    */
/*      +--------------------------------------------------------+    */
        for(j=i+1; j<=m; j++) {
          jv=(j-1)*nv;
          jb=(j-1)*na;   /* jb=(j-1)*j/2 */
          av=0.0;
          for(k=1; k<=n; k++) {
            av=av+x[k]*v[k+jv];
          }
          b[i+jb]=av;
        }
      }
      return(0);
}
/**********************************************************************/
      int gag(double a[],double b[],double v[],int n,double gk[]
             ,double epsi,int nv,int na) {
/*    int gag(a,b,v,n,gk,epsi,nv,na)
      double a[],b[],v[],gk[],epsi; int n,nv,na; {                    */
/*    ============================================================    */
      double gkj;
      int    i,j,k,ja,ka,jv,kv;
      --a; --b; --v; --gk;
/*    ============================================================    */
/*    dimension a,b(na,n),v(nv,n),gk(n)  ! a,b(n*(n-1)/2)             */
/*    ------------------------------------------------------------    */
/*    static condensation : [g]'[a(n,n)] [g] --> [a(n,n)]             */
/*                              [v(n,n)] [g] --> [v(n,n)]             */
/*    ------------------------------------------------------------    */
/*    input : a,b,v,n,epsi,nv;   output : a,v;   working : gk         */
/*    ============================================================    */
      for(k=1; k<=n; k++) {
        ka=(k-1)*na;     /* ka=(k-1)*k/2 */
        if(b[k+ka] == 0.0) {
          for(i=1; i<=k; i++) {    /*     /   1                     \ */
            gk[i]=a[i+ka];         /*     |        1                | */
            a[i+ka]=0.0;           /*     |             1           | */
          }                        /* [g]=| -a41 -a42 -a43     -a45 | */
          for(j=k+1; j<=n; j++) {  /*     | ---- ---- ----  1  ---- | */
            ja=(j-1)*na; /* ja=(j-1)*j/2  |  a44  a44  a44      a44 | */
            gk[j]=a[k+ja];         /*     \                      1  / */
            a[k+ja]=0.0;
          }
          a[k+ka]=1.0e30;
/*        --------------------------------------------------------    */
          if(gk[k] != 0.0) {
            kv=(k-1)*nv;
            for(j=1; j<=n; j++) {
              if(j == k) continue;
              gkj=gk[j]/gk[k];
              jv=(j-1)*nv;                 /* / a11 a12 a13  0  a15 \ */
              ja=(j-1)*na;  /* ja=(j-1)*j/2   | a21 a22 a23  0  a25 | */
              for(i=1; i<=n; i++) {    /* [a]=| a31 a32 a33  0  a35 | */
                v[i+jv]=v[i+jv]-v[i+kv]*gkj;/*|  0   0   0   m   0  | */
                if(i>j || i==k) continue;  /* \ a51 a52 a53  0  a55 / */
                a[i+ja]=a[i+ja]-gk[i]*gkj;
              }
            }
          } else {
            for(i=1; i<=n; i++) {
              if(fabs(gk[i]) > epsi) {
                printf("\n Not a well posed problem"); return(2);
              }
            }
          }
        } else if(b[k+ka] < 0.0) {
          printf("\n [b] is not semi-positive"); return(1);
        }
      }
      return(0);
}
/**********************************************************************/
