#include <stdio.h>
#include <math.h>
/**********************************************************************/
      int subspc(int ll[],double aka[],double ama[]
                ,double av[],double w[],int n,int mt,int mw
                ,double vv[],double sks[],double sms[],double sv[]
                ,double y[],int id,int nmax,double eps,FILE *fp_w) {
/*    int subspc(ll,aka,ama,av,w,n,mt,mw
                ,vv,sks,sms,sv,y,id,nmax,eps,fp_w)
      double aka[],ama[],av[],w[],vv[],sks[],sms[],sv[],y[],eps;
      int ll[],n,mt,mw,id,nmax; FILE *fp_w; {                         */
/*    ============================================================    */
      int i,j,m,jv,kk,kkk,mmm,nnn,npt;
      int vbdecp(),vbsolx(),bvexav(),vbcmpy();
      int ampy(),cmpyat(),setmvo(),orderx(),printt();
/*    --ll; --aka; --ama; --av; --w; --vv; --sks; --sms; --sv; --y;   */
/*    ============================================================    */
/*i   ll(n)     = input variable band matrix stored index             */
/*i   aka(nn)   = input stiffness matrix [k]                          */
/*i   ama(nn)   = input mass matrix [m] (if id=1)                     */
/*i   ama(n)    = input diagonal mass matrix [m] (if id=0)            */
/*o   av(n,mt)  = output eigenvectors [v]                             */
/*o   w(mt)     = eigenvalues (omaga squares)                         */
/*w   vv(n)     = working array                                       */
/*w   sks(mt*(mt+1)/2) = working arry to store [v]'[k] [v]            */
/*w   sms(mt*(mt+1)/2) = working arry to store [v]'[m] [v]            */
/*w   sv(mt,mt) = working array                                       */
/*o   y(mt)     = working array                                       */
/*i   n         = order of aka and ama                                */
/*i   mt        = total no. of eigenvectors used in iteraton          */
/*i   mw        = reqd. no. of eigenvectors                           */
/*i   id        = 0, ama is a diagonal matrix                         */
/*i             = 1, ama is stored as aka                             */
/*i   nmax      = allowed max. no. of subspace iterations             */
/*i   eps       = tolerence of eigenvales w(mw)                       */
/*    nn        = ll(n)+n-ll(1)                                       */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | initialize                                               |    */
/*    +----------------------------------------------------------+    */
      npt=1;
      m=mt;
      mmm=nmax;
      nnn=0;
      kkk=0;
/*    +----------------------------------------------------------+    */
/*    | decompose [k]=[l]'[d] [l]; (1) av=[uo], {w}={0}          |    */
/*    +----------------------------------------------------------+    */
      vbdecp(aka,ll,n);
      setmvo(ll,aka,ama,av,n,m,id,vv);
      for(j=0; j<m; j++) {
        w[j]=0.0;
      }
/*    +----------------------------------------------------------+    */
/*    | (2) av=[v1]=inv.[k][uo]; (3) sks=[v1]'[uo]=[v1]'[k] [v1] |    */
/*    +----------------------------------------------------------+    */
  L30:nnn=nnn+1;
      for(j=0; j<m; j++) {
        y[j]=w[j];
        jv=j*n;
        for(i=0; i<n; i++) {
          vv[i]=av[i+jv];
        }
        vbsolx(aka,&av[jv],ll,n);
        cmpyat(av,vv,&sks[j*(j+1)/2],j+1,n);
      }
      if(nnn/npt*npt == nnn || nnn == mmm) {
        fprintf(fp_w,"\n Subspace iteration no. %d",nnn);
        printt(sks,m,"matrix sks",fp_w);
      }
/*    +----------------------------------------------------------+    */
/*    | (4) if nnn<mmm then av=[u1]=[m][v1] else av=[v1]         |    */
/*    | (5) sms=[u1]'[v1]=[v1]'[m] [v1]                          |    */
/*    +----------------------------------------------------------+    */
      for(j=0; j<m; j++) {
        jv=j*n;
        if(nnn < mmm) {
          for(i=0; i<n; i++) {
            vv[i]=av[i+jv];
          }
          vbcmpy(ama,vv,&av[jv],ll,n,id);
        } else {
          vbcmpy(ama,&av[jv],vv,ll,n,id);
        }
        cmpyat(av,vv,&sms[j*(j+1)/2],j+1,n);
      }
      if(nnn/npt*npt == nnn || nnn == mmm) {
        printt(sms,m,"matrix sms",fp_w);
      }
/*    +----------------------------------------------------------+    */
/*    | (6) solve [sks] [sv] = [sms] [sv] [w]                    |    */
/*    | (7) if nnn<mmm then av=[u2]=[u1][sv] else av=[v2]=[v1][sv]    */
/*    +----------------------------------------------------------+    */
      bvexav(sms,sks,sv,m,w,vv,&kk,1.0e-5,m);     kkk=kkk+kk;
      orderx(w,sv,vv,m);
      ampy(av,sv,vv,n,m);
/*    +----------------------------------------------------------+    */
/*    | (8) convergence test (if so, set mmm=0 for last iter.)   |    */
/*    +----------------------------------------------------------+    */
      if(nnn < mmm) {
        for(j=0; j<mw; j++) {
          if(fabs(y[j]-w[j]) > eps*w[j]) goto L30;
        }
        mmm=0;
        goto L30;
      }
/*    +----------------------------------------------------------+    */
/*    | (9) output the eigenvalues and return                    |    */
/*    +----------------------------------------------------------+    */
      if(nnn == mmm) fprintf(fp_w,"\n Not converged within%12.4le",eps);
      fprintf(fp_w,"\n Subspace performs %d iterations.",nnn);
      fprintf(fp_w,"\n Jacobian performs %d rotations. ",kkk);
      fprintf(fp_w,"\n Eigenvalues of the last two iterartions :\n\n");
      for(j=0; j<m; j++) fprintf(fp_w,"%13.4le",y[j]);
      fprintf(fp_w,"\n");
      for(j=0; j<m; j++) fprintf(fp_w,"%13.4le",w[j]);
      fprintf(fp_w,"\n");
      return(0);
}
/**********************************************************************/
