/**********************************************************************/
      int setmvo(int ll[],double aka[],double ama[],double av[]
                ,int n,int m,int id,double vv[]) {
/*    int setmvo(ll,aka,ama,av,n,m,id,vv)
      double aka[],ama[],av[],vv[]; int ll[],n,m,id; {                */
/*    ============================================================    */
      int    i,j,jv,ix=1;
      double random();
      --aka; --ama; --av; --vv; --ll;
/*    ============================================================    */
      for(j=1; j<=m; j++) {
        jv=(j-1)*n;
        for(i=1; i<=n; i++) {
          av[i+jv]=random(&ix);
        }
        av[j+jv]=av[j+jv]+1.0;
      }
      return(0);
}
/**********************************************************************/
      double random(int *ix) {
/*    double random(ix)
      int *ix; {                                                      */
/*    ============================================================    */
      double rand;
/*    ============================================================    */
/*    random number by linear congruential method                     */
/*    for 32 bits integer*4 51603,2147483647                          */
/*    for 16 bits integer*2 403,32767                                 */
/*    for 1's complement, cancel +1                                   */
/*    ============================================================    */
/*    *ix=*ix*403;  if(*ix < 0) *ix=(*ix+32767)+1;                    */
      *ix=(*ix*(long)403)%32768;
      rand=*ix/32767.0;
      return(rand);
}
/**********************************************************************/
      int vbcmpy(double a[],double x[],double y[],int ll[],int n,int id){
/*    int vbcmpy(a,x,y,ll,n,id)
      double a[],x[],y[]; int ll[],n,id; {                            */
/*    ============================================================    */
      double xj,yj;
      int    i,j,ja,jm;
      --a; --x; --y; --ll;
/*    ============================================================    */
/*    [a(n,n)] {x(n)} --> {y(n)}  (id=0: a[n] diagonal)               */
/*    ============================================================    */
      if(id == 0) {
        for(i=1; i<=n; i++) {
          y[i]=a[i]*x[i];
        }
        return(0);
      }
      ja=0;
      for(j=1; j<=n; j++) {
        yj=0.0;
        xj=x[j];
        jm=j-(ll[j]-ll[1]-ja);
        ja=ll[j]-ll[1];
        for(i=jm; i<=j-1; i++) {
          y[i]=y[i]+a[i+ja]*xj;
          yj=yj+a[i+ja]*x[i];
        }
        y[j]=yj+a[j+ja]*xj;
      }
      return(0);
}
/**********************************************************************/
      int cmpyat(double a[],double b[],double c[],int m,int n) {
/*    int cmpyat(a,b,c,m,n)
      double a[],b[],c[]; int m,n; {                                  */
/*    ============================================================    */
      double cj;
      int    i,j,ja;
      --a; --b; --c;
/*    ============================================================    */
/*    [a(n,m)]'[b(n)] --> [c(m)]                                      */
/*    ============================================================    */
      for(j=1; j<=m; j++) {
        ja=(j-1)*n;
        cj=0.0;
        for(i=1; i<=n; i++) {
          cj=cj+a[i+ja]*b[i];
        }
        c[j]=cj;
      }
      return(0);
}
/**********************************************************************/
      int ampy(double a[],double b[],double ai[],int n,int m) {
/*    int ampy(a,b,ai,n,m)
      double a[],b[],ai[]; int n,m; {                                 */
/*    ============================================================    */
      double aij;
      int    i,j,k,ja,jb;
      --a; --b; --ai;
/*    ============================================================    */
/*    [a(n,m)] [b(m,m)] --> [a(n,m)]                                  */
/*    ============================================================    */
      for(i=1; i<=n; i++) {
        for(k=1; k<=m; k++) {
          ai[k]=a[i+(k-1)*n];
        }
        for(j=1; j<=m; j++) {
          ja=(j-1)*n;
          jb=(j-1)*m;
          aij=0.0;
          for(k=1; k<=m; k++) {
            aij=aij+ai[k]*b[k+jb];
          }
          a[i+ja]=aij;
        }
      }
      return(0);
}
/**********************************************************************/
      int orderx(double x[],double v[],int l[],int n) {
/*    int orderx(x,v,l,n)
      double x[],v[]; int l[],n; {                                    */
/*    ============================================================    */
      double t;
      int    i,j,k,m,ne,ii,jj,kk;
      --x; --v; --l;
/*    ============================================================    */
/*    order v(n,1:n) & x(1:n) to increasing x(1:n)                    */
/*    ============================================================    */
      for(i=1; i<=n; i++) {
        l[i]=i;
      }
      m=n;
/*    ------------------------------------------------------------    */
  L20:ne=m-1;
      for(i=1; i<=ne; i++) {
        j=l[i];
        k=l[i+1];
        if(x[j] <= x[k]) continue;
        l[i]=k;
        l[i+1]=j;
        m=i;
      }
      if(m <= ne) goto L20;
/*    ------------------------------------------------------------    */
      for(j=1; j<=n-1; j++) {
        i=j;
  L70:  i=l[i]; if(i < j) goto L70;
        if(i == j) continue;
        ii=(i-1)*n;
        jj=(j-1)*n;
        t=x[i];
        x[i]=x[j];
        x[j]=t;
        for(kk=1; kk<=n; kk++) {
          t=v[kk+ii];
          v[kk+ii]=v[kk+jj];
          v[kk+jj]=t;
        }
      }
      return(0);
}
/**********************************************************************/
