#include <math.h>
/**********************************************************************/
      int auexbu(double a[],double b[],double v[],int n,double x[]
                ,double y[],int *pierr,double epsi,int nv,int na) {
/*    int auexbu(a,b,v,n,x,y,pierr,epsi,nv,na)
      double a[],b[],v[],x[],y[],epsi; int n,*pierr,nv,na; {          */
/*    ============================================================    */
      double bb;
      int    i,j,jv;
      int    tridig(),triqli(),gag(),mav();
/*    --a; a-=na; --b; b-=na; --v; v-=na; --x; --y;                   */
/*    ============================================================    */
/*    dimension a,b(na,n),v(nv,n),x(n),y(n)                           */
/*    ------------------------------------------------------------    */
/*    [a] {x} = d [b] {x}   --->   [a] [v] = [b] [v] [d]              */
/*    normalize as : [v]'[a] [v] = [d],      [v]'[b] [v] = [i]        */
/*    ------------------------------------------------------------    */
/*    input : a,b,v,n,epsi,nv,na         output : a,v,x,ierr          */
/*    ------------------------------------------------------------    */
/*i   a(n,n) = [a] matrix required upper triangular part only         */
/*o          = [d] diagonal matrix                                    */
/*w   b(n,n) = [b] matrix required upper triangular part only         */
/*o   v(n,n) = eigen vector matrix                                    */
/*i   n      = order of matrix [a]                                    */
/*o   x(n)   = eigenvalues (also in the diagonal of [a])              */
/*w   y(n)   = working array                                          */
/*o   ierr   = j: j-th eigenvalue no converge; = 0: normal return     */
/*i   epsi   = used by gag                                            */
/*i   nv     = dummy (for jacobi only)                                */
/*i   na     = row dimensions of array v(na,n) and a(na,n)            */
/*    ============================================================    */
      for(j=0; j<n; j++) {
        jv=j*na;
        for(i=0; i<n; i++) {
          v[i+jv]=0.0;
        }
        v[j+jv]=1.0;
      }
/*    +----------------------------------------------------------+    */
/*    | solve [b] {y} = e {y}  for  [v] & [e]                    |    */
/*    +----------------------------------------------------------+    */
      tridig(na,n,b,x,y,v);
      triqli(na,n,x,y,v,pierr);
/*    +----------------------------------------------------------+    */
/*    | compute : [v] [e]^{-1/2} ---> [v]                        |    */
/*    +----------------------------------------------------------+    */
      for(j=0; j<n; j++) {
        jv=j*na;
        if(x[j] > 0.0) {
          bb=1.0/sqrt(x[j]);
          for(i=0; i<n; i++) {
            v[i+jv]=v[i+jv]*bb;
          }
        }
      }
/*    +----------------------------------------------------------+    */
/*    | compute : [v]'[a] [v] ---> [a]                           |    */
/*    +----------------------------------------------------------+    */
      mav(a,b,a,v,x,n,n,na,na);
      mav(a,b,b,v,x,n,0,na,na);
/*    +----------------------------------------------------------+    */
/*    | compute : [g]'[a] [g] ---> [a];  [v] [g] ---> [v]        |    */
/*    +----------------------------------------------------------+    */
      gag(a,b,v,n,x,epsi,na,na);
/*    +----------------------------------------------------------+    */
/*    | solve [a] {x} = d {x}  for  [v] & [d]                    |    */
/*    +----------------------------------------------------------+    */
      tridig(na,n,a,x,y,v);
      triqli(na,n,x,y,v,pierr);
      return(0);
}
/**********************************************************************/
