#include <math.h>
/**********************************************************************/
      int tridig(int na,int n
                ,double a[],double d[],double e[],double z[]) {
/*    int tridig(na,n,a,d,e,z)
      double a[],d[],e[],z[]; int na,n; {                             */
/*    ============================================================    */
      double s,t,ej,amx,uau,waw,tmp;
      int    i,j,k,ja,ka;
      --a; a-=na; --d; --e; --z; z-=na;
/*    ============================================================    */
/*    simularity transform symmetric matrix to tridiagonal matrix     */
/*    by householder method :    [p]'[a][p] ==> [t]                   */
/*    ------------------------------------------------------------    */
/*i   a(n,n) = symmetric matrix given upper triangular part           */
/*o          = [t] in upper triangular part                           */
/*o   d(k)   = t(k,k)   = diagonal elements of tridiagonal matrix     */
/*o   e(k)   = t(k-1,k) = t(k,k-1) = sub-diagonal elements of [t]     */
/*i   z(n,n)  = [i] or [x] = matrix to be post-multiplied by [p]      */
/*o           = [p] or [x][p]                                         */
/*    ============================================================    */
      for(k=n; k>=1; k--) { ka=k*na;
        amx=0.0;
        for(i=1; i<=k-1; i++) {
          if((tmp=fabs(a[i+ka])) > amx) amx=tmp;
        }
/*      +--------------------------------------------------------+    */
/*      | in case of a(1:k-1,k)=0, set d(k) & e(k) (also for k=1)|    */
/*      +--------------------------------------------------------+    */
        e[k]=0.0;
        d[k]=a[k+ka];
        if(amx == 0.0) continue;
/*      +--------------------------------------------------------+    */
/*      | scale u-vector to avoid overflow, {u} ={w}sqrt(2)= {d} |    */
/*      +--------------------------------------------------------+    */
        s=0.0;
        for(i=1; i<=k-1; i++) {
          d[i]=a[i+ka]/amx;
          s=s+d[i]*d[i];
        }
        s=sqrt(s); if(d[k-1] < 0) s=-s;
        e[k]=-s*amx;
        d[k-1]=d[k-1]+s;
        t=sqrt(s*d[k-1]);
        for(i=1; i<=k-1; i++) {
          d[i]=d[i]/t;
        }
/*      +--------------------------------------------------------+    */
/*      | compute {p} = [a]{u} = [a]{w}sqrt(2) = {e}             |    */
/*      +--------------------------------------------------------+    */
        for(j=1; j<=k-1; j++) { ja=j*na;
          ej=a[j+ja]*d[j];
          for(i=1; i<=j-1; i++) {
            e[i]=e[i]+a[i+ja]*d[j];
            ej  =ej  +a[i+ja]*d[i];
          }
          e[j]=ej;
        }
/*      +--------------------------------------------------------+    */
/*      | compute {q} = {p}-k{u} ; k = <u>{p}/2 = <w>[a]{w} = waw|    */
/*      +--------------------------------------------------------+    */
        uau=0.0;
        for(i=1; i<=k-1; i++) {
          uau=uau+e[i]*d[i];
        }
        waw=uau*0.5;
        for(i=1; i<=k-1; i++) {
          e[i]=e[i]-waw*d[i];
        }
/*      +--------------------------------------------------------+    */
/*      | compute [a] = [a] - {u}<q> - {q}<u>                    |    */
/*      +--------------------------------------------------------+    */
        for(j=1; j<=k-1; j++) { ja=j*na;
          for(i=1; i<=j; i++) {
            a[i+ja]=a[i+ja]-d[i]*e[j]-e[i]*d[j];
          }
          a[j+ka]=0.0;
        }
        a[k-1+ka]=e[k];
/*      +--------------------------------------------------------+    */
/*      | compute  s(1:n) = [z]{u}  from  d(1:k-1) = <u>         |    */
/*      +--------------------------------------------------------+    */
        for(i=1; i<=n; i++) {
          s=0.0;
          for(j=1; j<=k-1; j++) { ja=j*na;
            s=s+z[i+ja]*d[j];
          }
/*        +------------------------------------------------------+    */
/*        | compute  [z] = [z][[i] - 2{w}<w>] = [z] - [z]{u}<u>  |    */
/*        +------------------------------------------------------+    */
          for(j=1; j<=k-1; j++) { ja=j*na;
            z[i+ja]=z[i+ja]-s*d[j];
          }
        }
      }
      return(0);
}
/**********************************************************************/
      int triqli(int na,int n
                ,double d[],double e[],double z[],int *pierr) {
/*    int triqli(na,n,d,e,z,pierr)
      double d[],e[],z[]; int na,n,*pierr; {
/*    ============================================================    */
      int    iter,i,j,k,l,ia,ia1;
      double p,shift,tmp,zb;
      double c0,s0,g0,p0,e0,t0,z0,d1,r1,f1,dd;
      --d; --e; --z; z-=na;
      #define c1 c0
      #define s1 s0
      #define g1 g0
      #define p1 p0
/*    ============================================================    */
/*    simularity transform tridiagonal matrix to diagonal matrix      */
/*    by ql implicit shift algorithm : [q]'[t][q] ==> [d]             */
/*    ------------------------------------------------------------    */
/*i   d(k)   = t(k,k) = diagonal element of tridiagonal matrix [t]    */
/*o          = d(k,k) = eigenvalues of [t]                            */
/*i   e(k)   = t(k-1,k) = t(k,k-1) =  sub-diagonal elements of [t]    */
/*i   z(n,n)  = [p] or [x] = matrix to be post-multiplied by [q]      */
/*o           = [p][q] or [x][q]                                      */
/*o   ierr   = j: j-th eigenvalue no converge; = 0: normal return(0)     */
/*    ============================================================    */
      *pierr=0;
      if(n == 1) return(0);
      for(i=1; i<=n-1; i++) {
        e[i]=e[i+1];
      }
      e[n]=0.0;
/*    ------------------------------------------------------------    */
      for(k=1; k<=n; k++) {
      for(iter=1; iter<=30; iter++) {
      for(l=k; l<=n-1; l++) {
        dd=fabs(d[l])+fabs(d[l+1]);
        if(dd+fabs(e[l]) == dd) goto L30;
      }
      l=n;
  L30:if(l == k) goto L80;
/*    +----------------------------------------------------------+    */
/*    | | d-x  e  | = | -y    e   |   y=x-d ; z=y/e ; p=(f-d)/2e |    */
/*    | |  e  f-x |   |  e  f-d-y |   y*y - (f-d)*y - e*e = 0    |    */
/*    | -------------------------------------------------------- |    */
/*    | z*z - 2pz - 1 = 0 ; (y/e)**2 - 2((f-d)/2e)*(y/e) - 1 = 0 |    */
/*    | large.z = p+sqrt(p*p+1) ; small.z = -1/large.z           |    */
/*    +----------------------------------------------------------+    */
      p=fabs(d[k+1]-d[k])/(e[k]+e[k]);
      tmp=sqrt(p*p+1); if(p < 0) tmp=-tmp; zb=p+tmp;
      tmp=d[k+1]; if(d[k] < tmp) tmp=d[k]; shift=tmp-e[k]/zb;
/*    shift=min(d[k],d[k+1])-e[k]/(p+sign(sqrt(p*p+1),p));            */
/*     ------------------------   -------------------------------     */
/*    |d(i-1) e(i-1)           | | d(i-1)  e(i-1)*c0 *s0         |    */
/*    |e(i-1)  d(i)  e0    f1  | |c0*e(i-1) d(i)-p0   g0         |    */
/*    |        e0    d1    g1  | |s0*e(i-1)    g0   f(i+1) g(i+1)|    */
/*    |        f1    g1  f(i+2)| |                  g(i+1) f(i+2)|    */
/*     -------< before >-------   ----------< after >------------     */
/*      c1,s1,p1,g1,d(i),e(i)  ==>   c0,s0,p0,g0,f(i+1),g(i+1)        */
/*      --------------------------------------------------------      */
/*    | f1=e(i)*s1;    r1=sqrt(f1**2+g1**2);    g(i+1)=r1        |    */
/*    | e0=e(i)*c1;    c0=g1/r1;   s0=f1/r1;                     |    */
/*    | p0=(d0-d1)*s0**2+e0*2*c0*s0      =s0*t0                  |    */
/*    | g0=(d0-d1)*c0*s0+e0*(c0**2-s0**2)=c0*t0-e0               |    */
/*    | d0=d(i);   d1=d(i+1)-p1;   f(i+1)=d(i+1)-p1+p0=d1+p0     |    */
/*      --------------------------------------------------------      */
/*    |    | c0 -s0 || d0  e0 || c0  s0 | ==> | d0-p0   g0  |    |    */
/*    |    | s0  c0 || e0  d1 ||-s0  c0 |     |  g0   d1+p0 |    |    */
/*    +----------------------------------------------------------+    */
      g1=d[l]-shift;/* d[l-2] e[l-2]               !                  */
      c1=1.0;       /* e[l-2] d[l-1] e[l-1] e[l-1] ! => force to get  */
      s1=1.0;       /*        e[l-1]  d[l]    g1   ! s0:c0=e[l-1]:g1  */
      p1=0.0;       /*        e[l-1]   g1     xx   !                  */
/*    ------------------------------------------------------------    */
      for(i=l-1; i>=k; i--) { ia=i*na; ia1=ia+na;
        e0=e[i]*c1;
        f1=e[i]*s1;
        r1=sqrt(f1*f1+g1*g1);
        e[i+1]=r1;
        if(r1 == 0.0) {
          d[i+1]=d[i+1]-p1;
          e[l]=0.0;
          goto L70;
        }
        c0=g1/r1;
        s0=f1/r1;
        d1=d[i+1]-p1;
        t0=(d[i]-d1)*s0+2*c0*e0;
        p0=s0*t0;
        g0=c0*t0-e0;
        d[i+1]=d1+p0;
/*      +--------------------------------------------------------+    */
/*      | post multiply the transformation (rotation) matrix     |    */
/*      +--------------------------------------------------------+    */
        for(j=1; j<=n; j++) {
          z0=z[j+ia];
          z[j+ia ]=z0*c0-z[j+ia1]*s0;
          z[j+ia1]=z0*s0+z[j+ia1]*c0;
        }
      }
      d[k]=d[k]-p1;
      e[k]=g0;
      e[l]=0.0;
      if(t0 == 0.0) goto L80;
  L70:;}
      printf("\n No converge in 30 iterations !");
      *pierr=k;
      return(0);
  L80:;}
      return(0);
}
/**********************************************************************/
