#include <stdio.h>
#include <ctype.h>
#include <math.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      int aitint(double x[],double y[],int n,double dx[],double ay[]
       ,int l[],double xx,double *pyy,int *pnn,double *pye,double eps) {
/*    int aitint(x,y,n,dx,ay,l,xx,pyy,pnn,pye,eps)
      double x[],y[],dx[],ay[],xx,*pyy,*pye,eps; int l[],n,*pnn; {    */
/*    ============================================================    */
      double yy,ye;
      int    i,m,nn;  int sortal();
      --x; --y; --dx; --ay; --l;
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | Aitken's iteration formula                               |    */
/*    |                                                          |    */
/*    |                      1     | y(x|x3,2) x2-x |            |    */
/*    |    y(x|x4,3,2) = --------- |                |            |    */
/*    |                   x4 - x2  | y(x|x4,3) x4-x |            |    */
/*    |                                                          |    */
/*    |                  (x2-x)y(x|x4,3) - (x4-x)y(x|x3,2)       |    */
/*    |                = ---------------------------------       |    */
/*    |                               x2 - x4                    |    */
/*    | x1 y(x|x1)                                               |    */
/*    | x2 y(x|x2)    y(x|x2,1)                                  |    */
/*    | x3 y(x|x3)(3) y(x|x3,2)(2) y(x|x3,2,1)(1)                |    */
/*    | xm y(x|x4)(4) y(x|x4,3)(3) y(x|x4,3,2)(2) y(x|x4,3,2,1)(1)    */
/*    | x3      ay(3)   \    ay(i)   \      ay(1)   \            |    */
/*    | xm      ay(m)   ->   ay(i+1) ->     ay(i)   ->       ay(1)    */
/*    |                                                          |    */
/*    | 20 ay(i)=(ay(i+1)*dx(i)-ay(i)*dx(m))/(dx(i)-dx(m))       |    */
/*    | for extrapolation from |dx(1)| > |dx(2)| > ... to 0      |    */
/*    | 20 ay(i)=ay(i+1)+(ay(i+1)-ay(i))*dx(m)/(dx(i)-dx(m))     |    */
/*    | for interpolation from |dx(1)| < |dx(2)| < |dx(3)| < ... |    */
/*    | 20 ay(i)=ay(i)+(ay(i+1)-ay(i))*dx(i)/(dx(i)-dx(m))       |    */
/*    +----------------------------------------------------------+    */
      for(i=1; i<=n; i++) {
        dx[i]=fabs(x[i]-xx);
      }
      sortal(&dx[1],&l[1],n);
/*    ------------------------------------------------------------    */
      yy=0.0;
      for(m=1; m<=n; m++) {
        nn=m;
        i=l[m];
        ay[m]=y[i];
        dx[m]=x[i]-xx;
        for(i=m-1; i>=1; i--) {
          ay[i]=ay[i]+(ay[i+1]-ay[i])*dx[i]/(dx[i]-dx[m]);
        }
/*      printf("\n %13.4le",dx[m]);                                   */
/*      for(i=m; i>=1; i--) printf("%13.4le",ay[i]);                  */
        ye=ay[1]-yy;
        yy=ay[1];
        if(fabs(ye) < eps*fabs(yy)) break;
      }
      *pyy=yy; *pye=ye; *pnn=nn;
      return(0);
}
/**********************************************************************/
      int sortal(double a[],int l[],int n) {
/*    int sortal(a,l,n) double a[]; int l[],n; {                      */
/*    ============================================================    */
      int    i,j,k,m,ne;
      --a; --l;
/*    ============================================================    */
      for(i=1; i<=n; i++) {
        l[i]=i;
      }
      m=n;
      do {
        ne=m-1;
        for(i=1; i<=ne; i++) {
          j=l[i];
          k=l[i+1];
          if(a[j] > a[k]) {
            l[i]=k;
            l[i+1]=j;
            m=i;
          }
        }
      } while(m <= ne);
      return(0);
}
/**********************************************************************/
/*    Test program for Aitken's interpolation                         */
/*    ============================================================    */
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double x[20],y[20],dx[20],dy[20],xx,yy,ye,eps;
      int    l[20],i,n,nn;  int aitint();
/*    ============================================================    */
      if(argc<3) {printf("Usage : aitint infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
  L10:freeii(&n,fp_r); if(n == 0 || n > 20) exit(0);
      for(i=0; i<n; i++) {freer8(&x[i],fp_r); freer8(&y[i],fp_r);}
      fprintf(fp_w,"\n       xx           yy           ye        nn");
  L30:freer8(&xx,fp_r); freer8(&eps,fp_r);
      if(eps == 0.0) goto L10;
      aitint(x,y,n,dx,dy,l,xx,&yy,&nn,&ye,eps);
      fprintf(fp_w,"\n %13.4le%13.4le%13.4le%5d",xx,yy,ye,nn);
      goto L30;
}
/**********************************************************************/
