#include <stdio.h>
#include <ctype.h>
#include <math.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      int difint(double x[],double y[],int n,double dx[],double dy[]
       ,int l[],double xx,double *pyy,int *pnn,double *pye,double eps) {
/*    int difint(x,y,n,dx,dy,l,xx,pyy,pnn,pye,eps)
      double x[],y[],dx[],dy[],xx,*pyy,*pye,eps; int l[],n,*pnn; {    */
/*    ============================================================    */
      double pp,yy,ye;
      int    i,m,nn;  int sortal();
      --x; --y; --dx; --dy; --l;
/*    ============================================================    */
/*    Newton's interpolation formula                                  */
/*                                                                    */
/*    f(x) = f(x1) + (x-x1)f[x1,2] + (x-x1)(x-x2)f[x1,2,3] + ...      */
/*    or (for example, n=4) :                                         */
/*    f(x) = f(x4) + (x-x4)f[x4,3] + (x-x4)(x-x3)f[x4,3,2] + ...      */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    |           f(4)-f(3)              f[x4,3]-f[x3,2]         |    */
/*    | f[x4,3] = ---------; f[x4,3,2] = ---------------         |    */
/*    |            x4 - x3                   x4 - x2             |    */
/*    |                                                          |    */
/*    |                    f[x4,3,2]-f[x3,2,1]                   |    */
/*    |      p[x4,3,2,1] = -------------------                   |    */
/*    |                          x4 - x1                         |    */
/*    |                                                          |    */
/*    | x1 f(x1)                                                 |    */
/*    | x2 f(x2)    f[x2,1]                                      |    */
/*    | x3 f(x3)(3) f[x3,2](2) f[x3,2,1](1)                      |    */
/*    | xm f(x4)(4) f[x4,3](3) f[x4,3,2](2) f[x4,3,2,1](1)       |    */
/*    | x3    dy(3)   \  dy(i)   \    dy(1)   \                  |    */
/*    | xm    dy(m)   -> dy(i+1) ->   dy(i)   ->     dy(1)       |    */
/*    +----------------------------------------------------------+    */
      for(i=1; i<=n; i++) {
        dx[i]=fabs(xx-x[i]);
      }
      sortal(&dx[1],&l[1],n);
/*    ------------------------------------------------------------    */
      yy=0.0;
      pp=1.0;
      for(m=1; m<=n; m++) {
        nn=m;
        i=l[m];
        dy[m]=y[i];
        dx[m]=xx-x[i];
        for(i=m-1; i>=1; i--) {
          dy[i]=(dy[i+1]-dy[i])/(dx[i]-dx[m]);
        }
/*      printf("\n %13.4le",dx[m]);                                   */
/*      for(i=m; i>=1; i--) printf("%13.4le",dy[i]);                  */
/*      +--------------------------------------------------------+    */
/*      | yy = f(x1) + (x-x1)f[x1,2] + (x-x1)(x-x2)f[x1,2,3] +...|    */
/*      | pp = (x-x1)(x-x2)(x-x3)...                             |    */
/*      +--------------------------------------------------------+    */
        ye=pp*dy[1];
        yy=yy+ye;
        pp=pp*dx[m];
        if(fabs(ye) < eps*fabs(yy)) break;
      }
      *pyy=yy; *pye=ye; *pnn=nn;
      return(0);
}
/**********************************************************************/
      int sortal(double a[],int l[],int n) {
/*    int sortal(a,l,n) double a[]; int l[],n; {                      */
/*    ============================================================    */
      int    i,j,k,m,ne;
      --a; --l;
/*    ============================================================    */
      for(i=1; i<=n; i++) {
        l[i]=i;
      }
      m=n;
      do {
        ne=m-1;
        for(i=1; i<=ne; i++) {
          j=l[i];
          k=l[i+1];
          if(a[j] > a[k]) {
            l[i]=k;
            l[i+1]=j;
            m=i;
          }
        }
      } while(m <= ne);
      return(0);
}
/**********************************************************************/
/*    Test program for Newton's interpolation                         */
/*    ============================================================    */
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double x[20],y[20],dx[20],dy[20],xx,yy,ye,eps;
      int    l[20],i,n,nn;  int difint();
/*    ============================================================    */
      if(argc<3) {printf("Usage : difint infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
  L10:freeii(&n,fp_r); if(n == 0 || n > 20) exit(0);
      for(i=0; i<n; i++) {freer8(&x[i],fp_r); freer8(&y[i],fp_r);}
      fprintf(fp_w,"\n       xx           yy           ye        nn");
  L30:freer8(&xx,fp_r); freer8(&eps,fp_r);
      if(eps == 0.0) goto L10;
      difint(x,y,n,dx,dy,l,xx,&yy,&nn,&ye,eps);
      fprintf(fp_w,"\n %13.4le%13.4le%13.4le%5d",xx,yy,ye,nn);
      goto L30;
}
/**********************************************************************/
