#include <stdio.h>
#include <ctype.h>
#include <math.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      int lagrag(double x[],double y[],int n
                ,double xx,double *pyy,int m) {
/*    int lagrag(x,y,n,xx,pyy,m)
      double x[],y[],xx,*pyy; int n,m; {                              */
/*    ============================================================    */
      int    i,k,ia,ib,mm;
      double pp,yy;
      --x; --y;
/*    ============================================================    */
/*    Lagrange's interpolation formula                                */
/*                                                                    */
/*    f(x) = \sum_{k=ia}^ib \prod_{i=ia}^ib (x-x(i))/(x(k)-x(i))      */
/*                                 i!=k                               */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | x(i) must be in ascending or descending order            |    */
/*    | if m >= n or m <= 1 then use all data : ia=1, ib=n       |    */
/*    +----------------------------------------------------------+    */
      mm=m/2;
      ia=1;
      ib=n;
      if(m >= n || m <= 1) goto L30;
/*    +----------------------------------------------------------+    */
/*    | find ia and ib such that: 1 <= ia and ib=ia+m-1 <= n and |    */
/*    | #{x(ia:ib) < xx} - #{x(ia:ib) > xx} as small as possible |    */
/*    +----------------------------------------------------------+    */
      pp=1.0; if(x[n] < x[1]) pp=-1.0;
      for(i=1; i<=n; i++) {
        if(xx*pp <= x[i]*pp) goto L20;
      }
      i=n;
  L20:ia=i-mm;   if(ia < 1) ia=1;
      ib=ia+m-1; if(ib > n) ib=n;
      ia=ib-m+1;
/*    ------------------------------------------------------------    */
  L30:yy=0.0;
      for(k=ia; k<=ib; k++) {
        pp=y[k];
        for(i=ia; i<=ib; i++) {
          if(i != k) pp=pp*(xx-x[i])/(x[k]-x[i]);
        }
        yy=yy+pp;
      }
      *pyy=yy;
      return(0);
}
/**********************************************************************/
/*    Test program for Lagrange's interpolation                       */
/*    ============================================================    */
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double x[20],y[20],xx,yy;
      int    i,n,m;  int lagrag();
/*    ============================================================    */
      if(argc<3) {printf("Usage : lagrag infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
  L10:freeii(&n,fp_r); if(n == 0 || n > 20) exit(0);
      for(i=0; i<n; i++) {freer8(&x[i],fp_r); freer8(&y[i],fp_r);}
      fprintf(fp_w,"\n       xx           yy         m");
  L30:freer8(&xx,fp_r); freeii(&m,fp_r);
      if(m == 0) goto L10;
      lagrag(x,y,n,xx,&yy,m);
      fprintf(fp_w,"\n %13.4le%13.4le%5d",xx,yy,m);
      goto L30;
}
/**********************************************************************/
