#include <stdio.h>
#include <ctype.h>
#include <math.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      int spline(double h[],double x[],double y[],double z[]
                ,int n,int m,int kb,int kh,double a[],int l[]) {
/*    int spline(h,x,y,z,n,m,kb,kh,a,l)
      double h[],x[],y[],z[],a[]; int n,m,kb,kh,l[]; {                */
/*    ============================================================    */
      int    i,j; int vbdecp();
      --h; --x; --y; --z; --a; --l;
/*    ============================================================    */
/*o   h(i) = parameter/length between nodes i & j=i+1 or i=n & j=1    */
/*i   x(i),y(i),z(i) = coordinates of the i-th node                   */
/*i   n    = number of nodes                                          */
/*i   kb   = index for boundary conditions at both ends               */
/*         = 0 : left_y'' given, right_y'' given                      */
/*         = 1 : left_y'' given, right_y'  given                      */
/*         = 2 : left_y'  given, right_y'' given                      */
/*         = 3 : left_y'  given, right_y'  given                      */
/*         = 4 : left_y' = right_y' for:                              */
/*               2-d and 3-d closed curve                             */
/*               1-d periodic curve : use kh = 1 or -1                */
/*i   kh   = index for h(i) values:                                   */
/*         = 0 : set h(i) = length between nodes i & j                */
/*         = 1 : set h(i) = 1                                         */
/*         = otherwise : h(i) are given                               */
/*           in any case, this subroutine set h(n)=0 for kb<4         */
/*i   m    = space dimension of the curve                             */
/*         = 1 : for 1-d curve y(x)                                   */
/*         = 2 : for 2-d curve (x(t),y(t))                            */
/*         = 3 : for 3-d curve (x(t),y(t),z(t))                       */
/*o   a(*) = a(2*n-2) for kb<4,  a(3*n-4) for kb=4.                   */
/*o   l(n) = location index for variable banded matrix a              */
/*           the coefficient matrix of the spline equation is         */
/*           (data in [] are for kb=4 only)                           */
/*        / (hn+h1)/3  h1/6                               [hn/6] \    */
/*        |       (h1+h2)/3  h2/6                         [  0 ] |    */
/*        |             (h2+h3)/3  h3/6                   [  0 ] |    */
/*    a = |                        ....                   [  0 ] |    */
/*        |                            ....    hn-2/6     [  0 ] |    */
/*        |                                (hn-2+hn-1)/3  hn-1/6 |    */
/*        \                                          (hn-1+hn)/3 /    */
/*    ============================================================    */
      if(kh == 0) {
        for(i=1; i<=n; i++) {
          j=i+1;
          if(i == n) j=1;
          if(m >= 1) h[i] =(x[j]-x[i])*(x[j]-x[i]);
          if(m >= 2) h[i]+=(y[j]-y[i])*(y[j]-y[i]);
          if(m >= 3) h[i]+=(z[j]-z[i])*(z[j]-z[i]);
          h[i]=sqrt(h[i]);
        }
      } else if(kh == 1) {
        for(i=1; i<=n; i++) {
          h[i]=1.0;
        }
      }
      if(kb < 4) h[n]=0.0;
/*    ------------------------------------------------------------    */
      l[1]=0;
      a[1]=(h[n]+h[1])/3.0;
      for(i=1; i<=n-1; i++) {
        a[2*i  ]=h[i]/6.0;
        a[2*i+1]=(h[i]+h[i+1])/3.0;
        l[i+1]=l[i]+1;
      }
/*    +----------------------------------------------------------+    */
/*    | for y'' given at  left end (kb=00xb)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb == 0 || kb == 1) a[1]=1.0e30;
/*    +----------------------------------------------------------+    */
/*    | for y'' given at right end (kb=0x0b)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb == 0 || kb == 2) a[2*n-1]=1.0e30;
/*    +----------------------------------------------------------+    */
/*    | for closed curve           (kb=1xxb)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb >= 4) {
        l[n]=l[n]+n-2;
        a[3*n-3]=a[2*n-1];
        a[3*n-4]=a[2*n-2];
        a[2*n-2]=h[n]/6.0;
        for(i=2*n-1; i<=3*n-5; i++) {
          a[i]=0.0;
        }
      }
      vbdecp(&a[1],&l[1],n);
      return(0);
}
/**********************************************************************/
      int splinf(double h[],double y[],double ypp[],int n,int kb
                ,double ypp1,double yppn,double a[],int l[]) {
/*    int splinf(h,y,ypp,n,kb,ypp1,yppn,a,l)
      double h[],y[],ypp[],a[],ypp1,yppn; int l[],n,kb; {             */
/*    ============================================================    */
      int    i; int vbsolx();
      --h; --y; --ypp; --a; --l;
/*    ============================================================    */
/*i   h,y,n,kb,a,l = should be the same as spline                     */
/*o   ypp(i) = y'' at the i-th node                                   */
/*i   ypp1   = y''  y''  y'   y'   -  at the  left end                */
/*i   yppn   = y''  y'   y''  y'   -  at the right end                */
/*    for kb = 0    1    2    3    4                                  */
/*                                                                    */
/*                  / (y2-y1)/h1 - (y1-yn)/hn     \                   */
/*                  | (y3-y2)/h2 - (y2-y1)/h1     |                   */
/*              -1  | (y4-y3)/h3 - (y3-y2)/h2     |                   */
/*    {ypp} = [a] * |          .....              |                   */
/*                  |          .....              |                   */
/*                  |          .....              |                   */
/*                  \ (y1-yn)/hn - (yn-yn-1)/hn-1 /                   */
/*    ============================================================    */
      for(i=2; i<=n-1; i++) {
        ypp[i]=(y[i+1]-y[i])/h[i]-(y[i]-y[i-1])/h[i-1];
      }
      ypp[1]=(y[2]-y[1])/h[1];
      ypp[n]=-(y[n]-y[n-1])/h[n-1];
/*    +----------------------------------------------------------+    */
/*    | for y''= ypp1 at  left end (kb=00xb)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb == 0 || kb == 1) ypp[1]=ypp1*a[1];
/*    +----------------------------------------------------------+    */
/*    | for y''= yppn at right end (kb=0x0b)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb == 0 || kb == 2) ypp[n]=yppn*a[2*n-1];
/*    +----------------------------------------------------------+    */
/*    | for y' = ypp1 at  left end (kb=01xb)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb == 2 || kb == 3) ypp[1]=ypp[1]-ypp1;
/*    +----------------------------------------------------------+    */
/*    | for y' = yppn at right end (kb=0x1b)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb == 1 || kb == 3) ypp[n]=ypp[n]+yppn;
/*    +----------------------------------------------------------+    */
/*    | for closed curve           (kb=1xxb)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb >= 4) ypp[1]=ypp[1]-(y[1]-y[n])/h[n];
      if(kb >= 4) ypp[n]=ypp[n]+(y[1]-y[n])/h[n];
      vbsolx(&a[1],&ypp[1],&l[1],n);
      return(0);
}
/**********************************************************************/
      int spling(double h[],double y[],double ypp[]
                ,int n,int i,double t,double *yt) {
/*    int spling(h,y,ypp,n,i,t,yt)
      double h[],y[],ypp[],t,*yt; int n,i; {                          */
/*    ============================================================    */
      double s;
      int    j;
      --h; --y; --ypp;
/*    ============================================================    */
/*    find yt for given h,y,ypp,n,i,t                                 */
/*    ============================================================    */
      j=i+1;
      if(i == n) j=1;
      s=1-t;
      *yt=s*y[i]+t*y[j]+((s*s*s-s)*ypp[i]+(t*t*t-t)*ypp[j])*h[i]*h[i]/6;
      return(0);
}
/**********************************************************************/
/*    Test program for spline curve fitting                           */
/*    ============================================================    */
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double h[20],x[20],y[20],z[20],xpp[20],ypp[20],zpp[20],a[60];
      double t,ho,ht,xt,yt,zt,xpp1,ypp1,zpp1,xppn,yppn,zppn;
      int    l[20],i,k,m,n,ns,kb,kh;
      int    spline(),splinf(),spling();
/*    ============================================================    */
/*    n  = number of given nodes                                      */
/*    m  = 1:3 = dimensions of the curve                              */
/*    kb = 0:4 see subroutine spline                                  */
/*    kh = 1 : set h(i) = 1 by subroutine spline                      */
/*       = 0 : set h(i) = length between nodes i & j by sub.spline    */
/*    ns = number of line segments for a curve between two nodes      */
/*    xpp1,xppn,...  = see subroutine splinf                          */
/*    x(n),y(n),z(n) = coordinates of nodes                           */
/*    ============================================================    */
      if(argc<3) {printf("Usage : spline infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
  L10:freeii(&n,fp_r); if(n < 1 || n > 20) exit(0); freeii(&m,fp_r);
      freeii(&kb,fp_r);   freeii(&kh,fp_r);   freeii(&ns,fp_r);
      freer8(&xpp1,fp_r); freer8(&xppn,fp_r); freer8(&ypp1,fp_r);
      freer8(&yppn,fp_r); freer8(&zpp1,fp_r); freer8(&zppn,fp_r);
      if(m < 1 || m > 3) m=1;
      if(ns == 0) ns=16;
      if(kh <  0) kh=0;
      for(i=0; i<n; i++) {
        freer8(&x[i],fp_r); freer8(&y[i],fp_r); freer8(&z[i],fp_r);
      }
      fprintf(fp_w,"\n%4d%5d%5d%5d%5d",n,m,kb,kh,ns);
      fprintf(fp_w,"%5.2lf%5.2lf%5.2lf",xpp1,xppn,ypp1);
      fprintf(fp_w,"%5.2lf%5.2lf%5.2lf",yppn,zpp1,zppn);
/*    ------------------------------------------------------------    */
      spline(h,x,y,z,n,m,kb,kh,a,l);
/*    ------------------------------------------------------------    */
      if(m >= 1) splinf(h,y,ypp,n,kb,ypp1,yppn,a,l);
      if(m >= 2) splinf(h,x,xpp,n,kb,xpp1,xppn,a,l);
      if(m >= 3) splinf(h,z,zpp,n,kb,zpp1,zppn,a,l);
      if(m >= 1) { fprintf(fp_w,"\nyp");
        for(i=0; i<n; i++) fprintf(fp_w,"%13.5le",ypp[i]);
      }
      if(m >= 2) { fprintf(fp_w,"\nxp");
        for(i=0; i<n; i++) fprintf(fp_w,"%13.5le",xpp[i]);
      }
      if(m >= 3) { fprintf(fp_w,"\nzp");
        for(i=0; i<n; i++) fprintf(fp_w,"%13.5le",zpp[i]);
      }
/*    ------------------------------------------------------------    */
      fprintf(fp_w,"\n   i    k  sum.h[t]    x[t]      y[t]      z[t]");
      ho=0.0;
      for(i=1; i<=n; i++) {
        if(h[i-1] == 0.0) continue;
        for(k=0; k<=ns; k++) {
          if(k == 0 && i > 1) continue;
          t=(double)k/ns;
          ht=ho+h[i-1]*t;
          if(m >= 1) spling(h,y,ypp,n,i,t,&yt);
          if(m >= 2) spling(h,x,xpp,n,i,t,&xt);
          if(m >= 3) spling(h,z,zpp,n,i,t,&zt);
                     fprintf(fp_w,"\n%4d%5d%10.5lf",i,k,ht);
          if(m == 1) fprintf(fp_w,"%10.5lf%10.5lf",ht,yt);
          if(m >= 2) fprintf(fp_w,"%10.5lf%10.5lf",xt,yt);
          if(m >= 3) fprintf(fp_w,"%10.5lf"          ,zt);
        }
        ho=ho+h[i-1];
      }
      goto L10;
}
/**********************************************************************/
