#include <stdio.h>
#include <ctype.h>
#include <math.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      int spline(double h[],double x[],double y[],double z[]
                ,int n,int m,int kb,int kh,double a[],int l[]) {
/*    int spline(h,x,y,z,n,m,kb,kh,a,l)
      double h[],x[],y[],z[],a[]; int n,m,kb,kh,l[]; {                */
/*    ============================================================    */
      int    i,j; int vbdecp();
      --h; --x; --y; --z; --a; --l;
/*    ============================================================    */
/*o   h(i) = parameter/length between nodes i & j=i+1 or i=n & j=1    */
/*i   x(i),y(i),z(i) = coordinates of the i-th node                   */
/*i   n    = number of nodes                                          */
/*i   kb   = index for boundary conditions at both ends               */
/*         = 0 : left_y'' given, right_y'' given                      */
/*         = 1 : left_y'' given, right_y'  given                      */
/*         = 2 : left_y'  given, right_y'' given                      */
/*         = 3 : left_y'  given, right_y'  given                      */
/*         = 4 : left_y' = right_y' for:                              */
/*               2-d and 3-d closed curve                             */
/*               1-d periodic curve : use kh = 1 or -1                */
/*i   kh   = index for h(i) values:                                   */
/*         = 0 : set h(i) = length between nodes i & j                */
/*         = 1 : set h(i) = 1                                         */
/*         = otherwise : h(i) are given                               */
/*           in any case, this subroutine set h(n)=0 for kb<4         */
/*i   m    = space dimension of the curve                             */
/*         = 1 : for 1-d curve y(x)                                   */
/*         = 2 : for 2-d curve (x(t),y(t))                            */
/*         = 3 : for 3-d curve (x(t),y(t),z(t))                       */
/*o   a(*) = a(2*n-2) for kb<4,  a(3*n-4) for kb=4.                   */
/*o   l(n) = location index for variable banded matrix a              */
/*           the coefficient matrix of the spline equation is         */
/*           (data in [] are for kb=4 only)                           */
/*        / (hn+h1)/3  h1/6                               [hn/6] \    */
/*        |       (h1+h2)/3  h2/6                         [  0 ] |    */
/*        |             (h2+h3)/3  h3/6                   [  0 ] |    */
/*    a = |                        ....                   [  0 ] |    */
/*        |                            ....    hn-2/6     [  0 ] |    */
/*        |                                (hn-2+hn-1)/3  hn-1/6 |    */
/*        \                                          (hn-1+hn)/3 /    */
/*    ============================================================    */
      if(kh == 0) {
        for(i=1; i<=n; i++) {
          j=i+1;
          if(i == n) j=1;
          if(m >= 1) h[i] =(x[j]-x[i])*(x[j]-x[i]);
          if(m >= 2) h[i]+=(y[j]-y[i])*(y[j]-y[i]);
          if(m >= 3) h[i]+=(z[j]-z[i])*(z[j]-z[i]);
          h[i]=sqrt(h[i]);
        }
      } else if(kh == 1) {
        for(i=1; i<=n; i++) {
          h[i]=1.0;
        }
      }
      if(kb < 4) h[n]=0.0;
/*    ------------------------------------------------------------    */
      l[1]=0;
      a[1]=(h[n]+h[1])/3.0;
      for(i=1; i<=n-1; i++) {
        a[2*i  ]=h[i]/6.0;
        a[2*i+1]=(h[i]+h[i+1])/3.0;
        l[i+1]=l[i]+1;
      }
/*    +----------------------------------------------------------+    */
/*    | for y'' given at  left end (kb=00xb)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb == 0 || kb == 1) a[1]=1.0e30;
/*    +----------------------------------------------------------+    */
/*    | for y'' given at right end (kb=0x0b)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb == 0 || kb == 2) a[2*n-1]=1.0e30;
/*    +----------------------------------------------------------+    */
/*    | for closed curve           (kb=1xxb)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb >= 4) {
        l[n]=l[n]+n-2;
        a[3*n-3]=a[2*n-1];
        a[3*n-4]=a[2*n-2];
        a[2*n-2]=h[n]/6.0;
        for(i=2*n-1; i<=3*n-5; i++) {
          a[i]=0.0;
        }
      }
      vbdecp(&a[1],&l[1],n);
      return(0);
}
/**********************************************************************/
      int splino(double x[],double y[],double dyx[],int n,int kb
                ,double dyx1,double dyxn,double a[],int l[]) {
/*    int splino(h,y,ypp,n,kb,ypp1,yppn,a,l)
      double x[],y[],dyx[],a[],dyx1,dyxn; int l[],n,kb; {             */
/*    ============================================================    */
      int    i; int vbsolx();
      --x; --y; --dyx; --a; --l;
/*    ============================================================    */
/*i   x,y,n,kb,a,l = should be the same as spline                     */
/*o   dyx(i) = k at the i-th point (k=curvature, a=rotation angle)    */
/*i   dyx1   = k    k    a    a    -  at the  left end                */
/*i   dyxn   = k    a    k    a    -  at the right end                */
/*    for kb = 0    1    2    3    4                                  */
/*                                                                    */
/*                  / atan(y2-y1)/(x2-x1) - atan(y1-yn)/(x1-xn)  \    */
/*                  | atan(y3-y2)/(x3-x2) - atan(y2-y1)/(x2-x1)  |    */
/*              -1  | atan(y4-y3)/(x4-x3) - atan(y3-y2)/(x3-x2)  |    */
/*    {dyx} = [a] * |                   .....                    |    */
/*                  |                   .....                    |    */
/*                  |                   .....                    |    */
/*                  \ atan(y1-yn)/(x1-xn)-atan(yn-yn-1)/(xn-xn-1)/    */
/*    ============================================================    */
      for(i=2; i<=n-1; i++) {
        dyx[i]=atan2(y[i+1]-y[i],x[i+1]-x[i])
              -atan2(y[i]-y[i-1],x[i]-x[i-1]);
        if(dyx[i] > 3.14159) dyx[i]=dyx[i]-6.28318;
        if(dyx[i] <-3.14159) dyx[i]=dyx[i]+6.28318;
      }
      dyx[1]= atan2(y[2]-y[1],x[2]-x[1]);
      dyx[n]=-atan2(y[n]-y[n-1],x[n]-x[n-1]);
/*    +----------------------------------------------------------+    */
/*    | for k  = dyx1 at  left end (kb=00xb)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb == 0 || kb == 1) dyx[1]=dyx1*a[1];
/*    +----------------------------------------------------------+    */
/*    | for k  = dyxn at right end (kb=0x0b)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb == 0 || kb == 2) dyx[n]=dyxn*a[2*n-1];
/*    +----------------------------------------------------------+    */
/*    | for a  = dyx1 at  left end (kb=01xb)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb == 2 || kb == 3) dyx[1]=dyx[1]-dyx1;
/*    +----------------------------------------------------------+    */
/*    | for a  = dyxn at right end (kb=0x1b)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb == 1 || kb == 3) dyx[n]=dyx[n]+dyxn;
/*    +----------------------------------------------------------+    */
/*    | for closed curve           (kb=1xxb)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb >= 4) {
        dyx[1]=dyx[1]-atan2(y[1]-y[n],x[1]-x[n]);
        dyx[n]=dyx[n]+atan2(y[1]-y[n],x[1]-x[n]);
        if(dyx[1] > 3.14159) dyx[1]=dyx[1]-6.28318;
        if(dyx[1] <-3.14159) dyx[1]=dyx[1]+6.28318;
        if(dyx[n] > 3.14159) dyx[n]=dyx[n]-6.28318;
        if(dyx[n] <-3.14159) dyx[n]=dyx[n]+6.28318;
      }
      vbsolx(&a[1],&dyx[1],&l[1],n);
      return(0);
}
/**********************************************************************/
      int splin2(double h[],double x[],double y[],double dyx[]
                ,int n,int i,int ns,double xt[],double yt[]) {
/*    int splin2(h,x,y,dyx,n,i,ns,xt,yt)
      double h[],x[],y[],dyx[],xt[],yt[]; int n,i,ns; {               */
/*    ============================================================    */
      double sa[130],sb[130];
      int    j,ia,ib,ic,ix;
      int    splinp();
      --h; --x; --y; --dyx; --xt; --yt;
/*    ============================================================    */
/*    find xt(ns+1),yt(ns+1) for given h,x,y,dyx,n,i,ns=2**k          */
/*    ============================================================    */
      j=i+1;
      if(i == n) j=1;
      xt[   1]=x[i];
      yt[   1]=y[i];
      xt[ns+1]=x[j];
      yt[ns+1]=y[j];
      sa[   1]=-(2*dyx[i]+dyx[j])*h[i]/6;
      sb[ns+1]=-(dyx[i]+2*dyx[j])*h[i]/6;
      if(ns > 128) {printf("\n ns > 128"); exit(-1);}
      ix=ns;
      do {
        for(ia=1; ia<=ns; ia=ia+ix) {
          ib=ia+ix;
          ic=(ia+ib)/2;
          splinp(xt[ia],yt[ia],xt[ib],yt[ib],&xt[ic],&yt[ic]
                            ,&sa[ia],&sb[ib],&sa[ic],&sb[ic]);
        }
        ix=ix/2;
      } while(ix > 1);
      return(0);
}
/**********************************************************************/
      int splin3(double h[],double x[],double y[],double z[]
                ,double dzy[],double dxz[],double dyx[],int n
                ,int i,int ns,double xt[],double yt[],double zt[]) {
/*    int splin3(h,x,y,z,dzy,dxz,dyx,n,i,ns,xt,yt,zt) int n,i,ns;
      double h[],x[],y[],z[],dzy[],dxz[],dyx[],xt[],yt[],zt[]; {      */
/*    ============================================================    */
      double cx[130],cy[130],cz[130];
      int    j,ia,ib,ic,ix;
      int    abcxyz(),splinq();
      --h; --x; --y; --z; --dzy; --dxz; --dyx; --xt; --yt; --zt;
/*    ============================================================    */
/*    find xt,yt,zt(ns+1) for given h,x,y,z,dzy,dxz,dyx,n,i,ns=2**k   */
/*    ============================================================    */
      j=i+1;
      if(i == n) j=1;
      xt[   1]=x[i];
      yt[   1]=y[i];
      zt[   1]=z[i];
      xt[ns+1]=x[j];
      yt[ns+1]=y[j];
      zt[ns+1]=z[j];
      cx[   1]=-(2*dzy[i]+dzy[j])*h[i]/6;
      cy[   1]=-(2*dxz[i]+dxz[j])*h[i]/6;
      cz[   1]=-(2*dyx[i]+dyx[j])*h[i]/6;
      cx[ns+1]=-(dzy[i]+2*dzy[j])*h[i]/6;
      cy[ns+1]=-(dxz[i]+2*dxz[j])*h[i]/6;
      cz[ns+1]=-(dyx[i]+2*dyx[j])*h[i]/6;
      abcxyz(xt[1], yt[1], zt[1], xt[ns+1], yt[ns+1], zt[ns+1]
           ,&cx[1],&cy[1],&cz[1],&cx[ns+1],&cy[ns+1],&cz[ns+1]);
      if(ns > 128) {printf("\n ns > 128"); exit(-1);}
      ix=ns;
      do {
        for(ia=1; ia<=ns; ia=ia+ix) {
          ib=ia+ix;
          ic=(ia+ib)/2;
          splinq(xt[ia],yt[ia],zt[ia],xt[ib],yt[ib],zt[ib]
                                  ,&xt[ic],&yt[ic],&zt[ic]
                ,cx[ia],cy[ia],cz[ia],cx[ib],cy[ib],cz[ib]
                                  ,&cx[ic],&cy[ic],&cz[ic]);
        }
        ix=ix/2;
      } while(ix > 1);
      return(0);
}
/**********************************************************************/
      int splinp(double xa,double ya,double xb,double yb
                ,double *xc,double *yc
                ,double *xya,double *yxb,double *xyc,double *yxc) {
/*    int splinp(xa,ya,xb,yb,xc,yc,xya,yxb,xyc,yxc)
      double xa,ya,xb,yb,*xc,*yc,*xya,*yxb,*xyc,*yxc; {               */
/*    ============================================================    */
      double cxy,dxy,syx;
/*    ============================================================    */
/*    find xc,yc,xya,yxb,xyc,yxc from xa,ya,xb,yb,xya,yxb             */
/*    ------------------------------------------------------------    */
/*i   xa,ya = coordinates of left  end point a                        */
/*i   xb,yb = coordinates of right end point b                        */
/*o   xc,yc = coordinates of middle point c                           */
/*i   xya   = angle from line ab to tangent of curve ab at a          */
/*i   yxb   = angle from line ba to tangent of curve ba at b          */
/*o   xya   = angle from line ac to tangent of curve ac at a          */
/*o   yxc   = angle from line ca to tangent of curve ca at c          */
/*o   xyc   = angle from line cb to tangent of curve cb at c          */
/*o   yxb   = angle from line bc to tangent of curve bc at b          */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | cxy = angle from line ab to line ac or from ba to bc     |    */
/*    +----------------------------------------------------------+    */
      cxy=(*yxb+*xya)*0.25;
      syx=(*yxb-*xya)*0.25;
      *yxc= cxy-syx;
      *xyc= cxy+syx;
      *xya=*yxc-syx;
      *yxb=*xyc+syx;
      dxy=sin(cxy)/cos(cxy);
      *xc=0.5*((xb+xa)-(yb-ya)*dxy);
      *yc=0.5*((yb+ya)+(xb-xa)*dxy);
      return(0);
}
/**********************************************************************/
      int splinq(double   xa,double   ya,double   za
                ,double   xb,double   yb,double   zb
                ,double  *xc,double  *yc,double  *zc
                ,double  txa,double  tya,double  tza
                ,double  txb,double  tyb,double  tzb
                ,double *txc,double *tyc,double *tzc) {
/*    int splinq(xa,ya,za,xb,yb,zb,xc,yc,zc
                ,txa,tya,tza,txb,tyb,tzb,txc,tyc,tzc)
      double xa,ya,za,xb,yb,zb,*xc,*yc,*zc
            ,txa,tya,tza,txb,tyb,tzb,*txc,*tyc,*tzc; {                */
/*    ============================================================    */
      double ca,cb,cc,cd,sa,sb,sc,sd,al,bl,cl,dl,a;
      double ax,ay,az,bx,by,bz,cx,cy,cz,dx,dy,dz,b;
      double tx,ty,tz,vx,vy,vz,px,py,pz,pc,pd,vl,h;
      int    vcross();
/*    ============================================================    */
/*    find (xc,yc,zc),(txc,tyc,tzc)                                   */
/*    from (xa,ya,za),(xb,yb,zb),(txa,tya,tza),(txb,tyb,tzb)          */
/*    ------------------------------------------------------------    */
/*i   xa,ya,za    = coordinates of left  end point a                  */
/*i   xb,yb,zb    = coordinates of right end point b                  */
/*o   xc,yc,zc    = coordinates of middle point c                     */
/*i   txa,tya,tza = unit vector of tangent of curve acb at a          */
/*i   txb,tyb,tzb = unit vector of tangent of curve acb at c          */
/*o   txc,tyc,tzc = unit vector of tangent of curve acb at b          */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | tx,ty,tz = unit vector of line ab                        |    */
/*    +----------------------------------------------------------+    */
      tx=xb-xa;
      ty=yb-ya;
      tz=zb-za;
      h=sqrt(tx*tx+ty*ty+tz*tz);
      tx=tx/h;
      ty=ty/h;
      tz=tz/h;
/*    ------------------------------------------------------------    */
      vcross(tx, ty, tz, txa,tya,tza,&ax,&ay,&az,&al);
      vcross(txb,tyb,tzb,tx, ty, tz, &bx,&by,&bz,&bl);
      vcross(bx, by, bz, ax, ay, az, &vx,&vy,&vz,&vl);
      ca=tx*txa+ty*tya+tz*tza;
      cb=tx*txb+ty*tyb+tz*tzb;
      sa=sqrt(1-ca*ca);
      sb=sqrt(1-cb*cb);
      a=atan2(sa,ca);
      b=atan2(sb,cb);
/*    +----------------------------------------------------------+    */
/*    | cx,cy,cz = unit vector normal to plane abc               |    */
/*    | dx,dy,dz = unit vector normal to line ab and vector c    |    */
/*    | cl = angle from line ab to line ac                       |    */
/*    | dl = distance from center of line ab to point c          |    */
/*    +----------------------------------------------------------+    */
      cx=ax*a+bx*b;
      cy=ay*a+by*b;
      cz=az*a+bz*b;
      cl=sqrt(cx*cx+cy*cy+cz*cz);
      if(cl != 0) {
        cx=cx/cl;
        cy=cy/cl;
        cz=cz/cl;
      }
      vcross(cx,cy,cz,tx,ty,tz,&dx,&dy,&dz,&dl);
      dl=0.5*h*tan(0.25*cl);
      *xc=0.5*(xa+xb)+dx*dl;
      *yc=0.5*(ya+yb)+dy*dl;
      *zc=0.5*(za+zb)+dz*dl;
/*    +----------------------------------------------------------+    */
/*    | px,py,pz = vector difference of vector a and vector b    |    */
/*    | pc/4 = -rotation angle about (cx,cy,cz) at point c       |    */
/*    | pd/4 =  rotation angle about (dx,dy,dz) at point c       |    */
/*    +----------------------------------------------------------+    */
      px=ax*a-bx*b;
      py=ay*a-by*b;
      pz=az*a-bz*b;
      pc=px*cx+py*cy+pz*cz;
      pd=sqrt(px*px+py*py+pz*pz-pc*pc);
      if(tx*vx+ty*vy+tz*vz < 0) pd=-pd;
      sc=sin(0.25*pc);
      cc=sqrt(1-sc*sc);
      sd=sin(0.25*pd);
      cd=sqrt(1-sd*sd);
      *txc=(tx*cd-cx*sd)*cc-dx*sc;
      *tyc=(ty*cd-cy*sd)*cc-dy*sc;
      *tzc=(tz*cd-cz*sd)*cc-dz*sc;
      return(0);
}
/**********************************************************************/
      int vcross(double  ax,double  ay,double  az
                ,double  bx,double  by,double  bz
                ,double *cx,double *cy,double *cz,double *cl) {
/*    int vcross(ax,ay,az,bx,by,bz,cx,cy,cz,cl)
      double ax,ay,az,bx,by,bz,*cx,*cy,*cz,*cl; {                     */
/*    ============================================================    */
/*    cross product of two vectors:                                   */
/*    / cx \     / ax \   / bx \     / 0  -az  ay \ / bx \            */
/*    | cy |  =  | ay | x | by |  =  | az  0  -ax | | by |            */
/*    \ cz /     \ az /   \ bz /     \-ay  ax  0  / \ bz /            */
/*    and normalize to unit vector                                    */
/*    ============================================================    */
      *cx=      -az*by+ay*bz;
      *cy= az*bx      -ax*bz;
      *cz=-ay*bx+ax*by;
      *cl=sqrt(*cx**cx+*cy**cy+*cz**cz);
      if(*cl == 0) return(0);
      *cx=*cx / *cl;
      *cy=*cy / *cl;
      *cz=*cz / *cl;
      return(0);
}
/**********************************************************************/
      int abcxyz(double  xa,double  ya,double  za
                ,double  xb,double  yb,double  zb
                ,double *ax,double *ay,double *az
                ,double *bx,double *by,double *bz) {
/*    int abcxyz(xa,ya,za,xb,yb,zb,ax,ay,az,bx,by,bz)
      double xa,ya,za,xb,yb,zb,*ax,*ay,*az,*bx,*by,*bz; {             */
/*    ============================================================    */
      double pp,px,py,pz,qq,qx,qy,qz,rx,ry,rz;
      double rax,ray,raz,rbx,rby,rbz;
/*    ============================================================    */
/*i   xa,ya,za = coordinates of node a                                */
/*i   xb,yb,zb = coordinates of node b                                */
/*i   ax,ay,az = angles from vector ab to tangent of curve ab at a    */
/*i   bx,by,bz = angles from vector ba to tangent of curve ba at b    */
/*o   ax,ay,az = unit vector of tangent of curve ab at a              */
/*o   bx,by,bz = unit vector of tangent of curve ab at b              */
/*    ============================================================    */
      rx=atan2(zb-za,yb-ya);
      ry=atan2(xb-xa,zb-za);
      rz=atan2(yb-ya,xb-xa);
/*    ------------------------------------------------------------    */
      rax=rx+*ax;
      ray=ry+*ay;
      raz=rz+*az;
      if(rax > 3.14159) rax=rax-6.28318;
      if(rax <-3.14159) rax=rax+6.28318;
      if(ray > 3.14159) ray=ray-6.28318;
      if(ray <-3.14159) ray=ray+6.28318;
      if(raz > 3.14159) raz=raz-6.28318;
      if(raz <-3.14159) raz=raz+6.28318;
      px=tan(rax);
      py=tan(ray);
      pz=tan(raz);
      pp=pow(fabs(px*py*pz),1.0/3.0);
      px=px*px/(pp*pp);
      py=py*py/(pp*pp);
      pz=pz*pz/(pp*pp);
      *ax=1.0/sqrt(1+pz+pz*px); if(ray < 0) *ax=-*ax;
      *ay=1.0/sqrt(1+px+px*py); if(raz < 0) *ay=-*ay;
      *az=1.0/sqrt(1+py+py*pz); if(rax < 0) *az=-*az;
/*    ------------------------------------------------------------    */
      rbx=rx-*bx;
      rby=ry-*by;
      rbz=rz-*bz;
      if(rbx > 3.14159) rbx=rbx-6.28318;
      if(rbx <-3.14159) rbx=rbx+6.28318;
      if(rby > 3.14159) rby=rby-6.28318;
      if(rby <-3.14159) rby=rby+6.28318;
      if(rbz > 3.14159) rbz=rbz-6.28318;
      if(rbz <-3.14159) rbz=rbz+6.28318;
      qx=tan(rbx);
      qy=tan(rby);
      qz=tan(rbz);
      qq=pow(fabs(qx*qy*qz),1.0/3.0);
      qx=qx*qx/(qq*qq);
      qy=qy*qy/(qq*qq);
      qz=qz*qz/(qq*qq);
      *bx=1.0/sqrt(1+qz+qz*qx); if(rby < 0) *bx=-*bx;
      *by=1.0/sqrt(1+qx+qx*qy); if(rbz < 0) *by=-*by;
      *bz=1.0/sqrt(1+qy+qy*qz); if(rbx < 0) *bz=-*bz;
      return(0);
}
/**********************************************************************/
      int splinl(double *h,double xt[],double yt[],double zt[]
                ,int ns,int m) {
/*    int splinl(h,xt,yt,zt,ns,m)
      double *h,xt[],yt[],zt[]; int ns,m; {                           */
/*    ============================================================    */
      int    k;
      --xt; --yt; --zt;
/*    ============================================================    */
/*    h = curve length of xt(ns+1),yt(ns+1),zt(ns+1)                  */
/*    ============================================================    */
      *h=0.0;
      if(m != 3) {
        for(k=1; k<=ns; k++) {
          *h=*h+sqrt((xt[k+1]-xt[k])*(xt[k+1]-xt[k])
                    +(yt[k+1]-yt[k])*(yt[k+1]-yt[k]));
        }
      } else {
        for(k=1; k<=ns; k++) {
          *h=*h+sqrt((xt[k+1]-xt[k])*(xt[k+1]-xt[k])
                    +(yt[k+1]-yt[k])*(yt[k+1]-yt[k])
                    +(zt[k+1]-zt[k])*(zt[k+1]-zt[k]));
        }
      }
      return(0);
}
/**********************************************************************/
/*    Test program for spline curve fitting                           */
/*    ============================================================    */
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double h[20],x[20],y[20],z[20],dzy[20],dxz[20],dyx[20];
      double a[60],xt[129],yt[129],zt[129];
      double dyx1,dxz1,dzy1,dyxn,dxzn,dzyn;
      int    l[20],i,k,m,n,kb,kh,kl,nl,nn,ns,n1;
      int    spline(),splinl(),splino(),splin2(),splin3();
/*    ============================================================    */
/*    n  = number of given nodes                                      */
/*    m  = 2 or 3 = dimensions of the curve                           */
/*    kb = 0:4 see subroutine spline                                  */
/*    kl = 1 : set h(i) = 1 by subroutine spline                      */
/*       = 0 : set h(i) = length between nodes i & j by sub.spline    */
/*       < 0 : use h(i) = length of the curve ij get by sub.splinl    */
/*             -kl = number of iterations to get h(i)   (2 is ok)     */
/*    nl = number of line segments for a curve between two nodes      */
/*    dzy1,dzyn,...  = see subroutine splino                          */
/*    x(n),y(n),z(n) = coordinates of nodes                           */
/*    ============================================================    */
      if(argc<3) {printf("Usage : splino infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
  L10:freeii(&n,fp_r); if(n < 1 || n > 20) exit(0); freeii(&m,fp_r);
      freeii(&kb,fp_r);   freeii(&kl,fp_r);   freeii(&nl,fp_r);
      freer8(&dzy1,fp_r); freer8(&dzyn,fp_r); freer8(&dxz1,fp_r);
      freer8(&dxzn,fp_r); freer8(&dyx1,fp_r); freer8(&dyxn,fp_r);
      if(m != 3) m=2;
      kh=kl; if(kh < 0) kh=0;
      ns=8;
      for(nn=1; nn<=4; nn++) {
        if(ns < nl) ns=2*ns;
      }
      for(i=0; i<n; i++) {
        freer8(&x[i],fp_r); freer8(&y[i],fp_r); freer8(&z[i],fp_r);
      }
      fprintf(fp_w,"\n%4d%5d%5d%5d%5d",n,m,kb,kl,ns);
      fprintf(fp_w,"%5.2lf%5.2lf%5.2lf",dzy1,dzyn,dxz1);
      fprintf(fp_w,"%5.2lf%5.2lf%5.2lf",dxzn,dyx1,dyxn);
/*    ------------------------------------------------------------    */
  L20:spline(h,x,y,z,n,m,kb,kh,a,l);
/*    ------------------------------------------------------------    */
      splino(x,y,dyx,n,kb,dyx1,dyxn,a,l);
      fprintf(fp_w,"\nxy");
      for(i=0; i<n; i++) fprintf(fp_w,"%13.5le",dyx[i]);
      if(m == 3) {
        splino(y,z,dzy,n,kb,dzy1,dzyn,a,l);
        splino(z,x,dxz,n,kb,dxz1,dxzn,a,l);
        fprintf(fp_w,"\nyz");
        for(i=0; i<n; i++) fprintf(fp_w,"%13.5le",dzy[i]);
        fprintf(fp_w,"\nzx");
        for(i=0; i<n; i++) fprintf(fp_w,"%13.5le",dxz[i]);
      }
/*    ------------------------------------------------------------    */
      fprintf(fp_w,"\n   i    k      x[t]      y[t]      z[t]");
      for(i=1; i<=n; i++) {
        if(h[i-1] == 0.0) continue;
        n1=i; if(n1 > 2) n1=2;
        if(m != 3) {
          splin2(h,x,y,dyx,n,i,ns,xt,yt);
          if(kh > kl) {
            splinl(&h[i-1],xt,yt,zt,ns,m);
          } else {
            for(k=n1; k<=ns+1; k++)
              fprintf(fp_w,"\n%4d%5d%10.5lf%10.5lf"
                          ,i,k-1,xt[k-1],yt[k-1]);
          }
        } else {
          splin3(h,x,y,z,dzy,dxz,dyx,n,i,ns,xt,yt,zt);
          if(kh > kl) {
            splinl(&h[i-1],xt,yt,zt,ns,m);
          } else {
            for(k=n1; k<=ns+1; k++)
              fprintf(fp_w,"\n%4d%5d%10.5lf%10.5lf%10.5lf"
                          ,i,k-1,xt[k-1],yt[k-1],zt[k-1]);
          }
        }
      }
      kh=kh-1;
      if(kh >= kl) goto L20;
      goto L10;
}
/**********************************************************************/
