#include <stdio.h>
#include <ctype.h>
#include <math.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      int splins(double h[],double x[],double y[],double z[]
                ,int n,int m,int kb,int kh,double a[],int l[]) {
/*    int splins(h,x,y,z,n,m,kb,kh,a,l)
      double h[],x[],y[],z[],a[]; int n,m,kb,kh,l[]; {                */
/*    ============================================================    */
      int    i,j; int vbdecp();
      --h; --x; --y; --z; --a; --l;
/*    ============================================================    */
/*o   h(i) = parameter/length between nodes i & j=i+1 or i=n & j=1    */
/*i   x(i),y(i),z(i) = coordinates of the i-th node                   */
/*i   n    = number of nodes                                          */
/*i   kb   = index for boundary conditions at both ends               */
/*         = 0 : left_y'' given, right_y'' given                      */
/*         = 1 : left_y'' given, right_y'  given                      */
/*         = 2 : left_y'  given, right_y'' given                      */
/*         = 3 : left_y'  given, right_y'  given                      */
/*         = 4 : left_y' = right_y' for:                              */
/*               2-d and 3-d closed curve                             */
/*               1-d periodic curve : use kh = 1 or -1                */
/*i   kh   = index for h(i) values:                                   */
/*         = 0 : set h(i) = length between nodes i & j                */
/*         = 1 : set h(i) = 1                                         */
/*         = otherwise : h(i) are given                               */
/*           in any case, this subroutine set h(n)=1d30 for kb<4      */
/*i   m    = space dimension of the curve                             */
/*         = 1 : for 1-d curve y(x)                                   */
/*         = 2 : for 2-d curve (x(t),y(t))                            */
/*         = 3 : for 3-d curve (x(t),y(t),z(t))                       */
/*o   a(*) = a(2*n-2) for kb<4,  a(3*n-4) for kb=4.                   */
/*o   l(n) = location index for variable banded matrix a              */
/*           the coefficient matrix of the spline equation is         */
/*           (data in [] are for kb=4 only)                           */
/*        / 4/hn+4/h1  2/h1                               [2/hn] \    */
/*        |        4/h1+4/h2  2/h2                        [  0 ] |    */
/*        |               4/h2+4/h3 2/h3                  [  0 ] |    */
/*    a = |                         ....                  [  0 ] |    */
/*        |                            ....   2/hn-2      [  0 ] |    */
/*        |                                4/hn-2+4/hn-1  2/hn-1 |    */
/*        \                                          4/hn-1+4/hn /    */
/*    ============================================================    */
      if(kh == 0) {
        for(i=1; i<=n; i++) {
          j=i+1;
          if(i == n) j=1;
          if(m >= 1) h[i] =(x[j]-x[i])*(x[j]-x[i]);
          if(m >= 2) h[i]+=(y[j]-y[i])*(y[j]-y[i]);
          if(m >= 3) h[i]+=(z[j]-z[i])*(z[j]-z[i]);
          h[i]=sqrt(h[i]);
        }
      } else if(kh == 1) {
        for(i=1; i<=n; i++) {
          h[i]=1.0;
        }
      }
      if(kb < 4) h[n]=1.0e30;
/*    ------------------------------------------------------------    */
      l[1]=0;
      a[1]=4.0/h[1]+4.0/h[n];
      for(i=1; i<=n-1; i++) {
        a[2*i  ]=2.0/h[i];
        a[2*i+1]=4.0/h[i]+4.0/h[i+1];
        l[i+1]=l[i]+1;
      }
/*    +----------------------------------------------------------+    */
/*    | for y'  given at  left end (kb=01xb)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb == 2 || kb == 3) a[1]=1.0e30;
/*    +----------------------------------------------------------+    */
/*    | for y'  given at right end (kb=0x1b)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb == 1 || kb == 3) a[2*n-1]=1.0e30;
/*    +----------------------------------------------------------+    */
/*    | for closed curve           (kb=1xxb)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb >= 4) {
        l[n]=l[n]+n-2;
        a[3*n-3]=a[2*n-1];
        a[3*n-4]=a[2*n-2];
        a[2*n-2]=2.0/h[n];
        for(i=2*n-1; i<=3*n-5; i++) {
          a[i]=0.0;
        }
      }
      vbdecp(&a[1],&l[1],n);
      return(0);
}
/**********************************************************************/
      int splinr(double h[],double y[],double yp[],int n,int kb
                ,double yp1,double ypn,double a[],int l[]) {
/*    int splinr(h,y,yp,n,kb,yp1,ypn,a,l)
      double h[],y[],yp[],a[],yp1,ypn; int l[],n,kb; {                */
/*    ============================================================    */
      int    i; int vbsolx();
      --h; --y; --yp; --a; --l;
/*    ============================================================    */
/*i   h,y,n,kb,a,l = should be the same as splins                     */
/*o   yp(i)  = y'  at the i-th node                                   */
/*i   yp1    = y''  y''  y'   y'   -  at the  left end                */
/*i   ypn    = y''  y'   y''  y'   -  at the right end                */
/*    for kb = 0    1    2    3    4                                  */
/*                                                                    */
/*                  / 6(y2-y1)/h1**2 + 6(y1-yn)/hn**2     \           */
/*                  | 6(y3-y2)/h2**2 + 6(y2-y1)/h1**2     |           */
/*              -1  | 6(y4-y3)/h3**2 + 6(y3-y2)/h2**2     |           */
/*    {yp}  = [a] * |              .....                  |           */
/*                  |              .....                  |           */
/*                  |              .....                  |           */
/*                  \ 6(y1-yn)/hn**2 + 6(yn-yn-1)/hn-1**2 /           */
/*    ============================================================    */
      for(i=2; i<=n-1; i++) {
        yp[i]=6*(y[i+1]-y[i])/h[i]/h[i]+6*(y[i]-y[i-1])/h[i-1]/h[i-1];
      }
      yp[1]=6*(y[2]-y[1])/h[1]/h[1];
      yp[n]=6*(y[n]-y[n-1])/h[n-1]/h[n-1];
/*    +----------------------------------------------------------+    */
/*    | for y' = yp1  at  left end (kb=01xb)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb == 2 || kb == 3) yp[1]=yp1*a[1];
/*    +----------------------------------------------------------+    */
/*    | for y' = ypn  at right end (kb=0x1b)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb == 1 || kb == 3) yp[n]=ypn*a[2*n-1];
/*    +----------------------------------------------------------+    */
/*    | for y''= yp1  at  left end (kb=00xb)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb == 0 || kb == 1) yp[1]=yp[1]-yp1;
/*    +----------------------------------------------------------+    */
/*    | for y''= ypn  at right end (kb=0x0b)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb == 0 || kb == 2) yp[n]=yp[n]+ypn;
/*    +----------------------------------------------------------+    */
/*    | for closed curve           (kb=1xxb)                     |    */
/*    +----------------------------------------------------------+    */
      if(kb >= 4) yp[1]=yp[1]+6*(y[1]-y[n])/h[n]/h[n];
      if(kb >= 4) yp[n]=yp[n]+6*(y[1]-y[n])/h[n]/h[n];
      vbsolx(&a[1],&yp[1],&l[1],n);
      return(0);
}
/**********************************************************************/
      int splint(double h[],double y[],double yp[]
                ,int n,int i,double t,double *yt) {
/*    int splint(h,y,yp,n,i,t,yt)
      double h[],y[],yp[],t,*yt; int n,i; {                           */
/*    ============================================================    */
      double s;
      int    j;
      --h; --y; --yp;
/*    ============================================================    */
/*    find yt for given h,y,yp,n,i,t                                  */
/*    ============================================================    */
      j=i+1;
      if(i == n) j=1;
      s=1-t;
      *yt=s*s*((3-2*s)*y[i]+t*yp[i]*h[i])
         +t*t*((3-2*t)*y[j]-s*yp[j]*h[i]);
      return(0);
}
/**********************************************************************/
/*    Test program for spline curve fitting                           */
/*    ============================================================    */
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double h[20],x[20],y[20],z[20],xp[20],yp[20],zp[20],a[60];
      double t,ho,ht,xt,yt,zt,xp1,yp1,zp1,xpn,ypn,zpn;
      int    l[20],i,k,m,n,ns,kb,kh;
      int    splins(),splinr(),splint();
/*    ============================================================    */
/*    n  = number of given nodes                                      */
/*    m  = 1:3 = dimensions of the curve                              */
/*    kb = 0:4 see subroutine splins                                  */
/*    kh = 1 : set h(i) = 1 by subroutine splins                      */
/*       = 0 : set h(i) = length between nodes i & j by sub.splins    */
/*    ns = number of line segments for a curve between two nodes      */
/*    xp1, xpn, ...  = see subroutine splinr                          */
/*    x(n),y(n),z(n) = coordinates of nodes                           */
/*    ============================================================    */
      if(argc<3) {printf("Usage : splins infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
  L10:freeii(&n,fp_r); if(n < 1 || n > 20) exit(0); freeii(&m,fp_r);
      freeii(&kb,fp_r);  freeii(&kh,fp_r);  freeii(&ns,fp_r);
      freer8(&xp1,fp_r); freer8(&xpn,fp_r); freer8(&yp1,fp_r);
      freer8(&ypn,fp_r); freer8(&zp1,fp_r); freer8(&zpn,fp_r);
      if(m < 1 || m > 3) m=1;
      if(ns == 0) ns=16;
      if(kh <  0) kh=0;
      for(i=0; i<n; i++) {
        freer8(&x[i],fp_r); freer8(&y[i],fp_r); freer8(&z[i],fp_r);
      }
      fprintf(fp_w,"\n%4d%5d%5d%5d%5d",n,m,kb,kh,ns);
      fprintf(fp_w,"%5.2lf%5.2lf%5.2lf",xp1,xpn,yp1);
      fprintf(fp_w,"%5.2lf%5.2lf%5.2lf",ypn,zp1,zpn);
/*    ------------------------------------------------------------    */
      splins(h,x,y,z,n,m,kb,kh,a,l);
/*    ------------------------------------------------------------    */
      if(m >= 1) splinr(h,y,yp,n,kb,yp1,ypn,a,l);
      if(m >= 2) splinr(h,x,xp,n,kb,xp1,xpn,a,l);
      if(m >= 3) splinr(h,z,zp,n,kb,zp1,zpn,a,l);
      if(m >= 1) { fprintf(fp_w,"\nyp");
        for(i=0; i<n; i++) fprintf(fp_w,"%13.5le",yp[i]);
      }
      if(m >= 2) { fprintf(fp_w,"\nxp");
        for(i=0; i<n; i++) fprintf(fp_w,"%13.5le",xp[i]);
      }
      if(m >= 3) { fprintf(fp_w,"\nzp");
        for(i=0; i<n; i++) fprintf(fp_w,"%13.5le",zp[i]);
      }
/*    ------------------------------------------------------------    */
      fprintf(fp_w,"\n   i    k  sum.h[t]    x[t]      y[t]      z[t]");
      ho=0.0;
      for(i=1; i<=n; i++) {
        if(h[i-1] >= 0.9e30) continue;
        for(k=0; k<=ns; k++) {
          if(k == 0 && i > 1) continue;
          t=(double)k/ns;
          ht=ho+h[i-1]*t;
          if(m >= 1) splint(h,y,yp,n,i,t,&yt);
          if(m >= 2) splint(h,x,xp,n,i,t,&xt);
          if(m >= 3) splint(h,z,zp,n,i,t,&zt);
                     fprintf(fp_w,"\n%4d%5d%10.5lf",i,k,ht);
          if(m == 1) fprintf(fp_w,"%10.5lf%10.5lf",ht,yt);
          if(m >= 2) fprintf(fp_w,"%10.5lf%10.5lf",xt,yt);
          if(m >= 3) fprintf(fp_w,"%10.5lf"          ,zt);
        }
        ho=ho+h[i-1];
      }
      goto L10;
}
/**********************************************************************/
