#include <stdio.h>
#include <ctype.h>
#include <math.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      int thiele(double x[],double y[],int n,double c[],double p[]) {
/*    int thiele(x,y,n,c,p) double x[],y[],c[],p[]; int n; {          */
/**********************************************************************/
      double dp,pi,pi1,eps=1.0e-15;
      int    i,m;
      --x; --y; --c; --p;
/*    ============================================================    */
/*    Thiele's interpolation formula                                  */
/*                                                                    */
/*    f(x(i)) = y(i), for i=1,2,...,n;  n=1,3,...,2*m+1;              */
/*                                                                    */
/*           c(1)*x**m + c(3)*x**(m-1) + ... + c(n-2)*x + c(2*m+1)    */
/*    f(x) = -----------------------------------------------------    */
/*                x**m + c(2)*x**(m-1) + ... + c(n-3)*x + c(2*m  )    */
/*                                                                    */
/*    f(x(i)) = y(i), for i=1,2,...,n;  n=2,4,...,2*m;                */
/*                                                                    */
/*                x**m + c(2)*x**(m-1) + ... + c(n-2)*x + c(2*m  )    */
/*    f(x) = -----------------------------------------------------    */
/*                       c(1)*x**(m-1) + ... + c(n-3)*x + c(2*m-1)    */
/*                                                                    */
/*    f(x) = y(x4)+(x-x4)   (x-x3)           (x-x2)                   */
/*                 -------- ---------------- --------------------     */
/*                 p(x4,3)+ p(x4,3,2)-y(x4)+ p(x4,3,2,1)-p(x4,3)+     */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    |            x4 - x3                   x4 - x2             |    */
/*    | p(x4,3) = ---------; p(x4,3,2) = --------------- + f(x3) |    */
/*    |           f(4)-f(3)              p(x4,3)-p(x3,2)         |    */
/*    |                                                          |    */
/*    |                          x4 - x1                         |    */
/*    |      p(x4,3,2,1) = ------------------- + p(x3,2)         |    */
/*    |                    p(x4,3,2)-p(x3,2,1)                   |    */
/*    |                                                          |    */
/*    | x1 f(x1)                                                 |    */
/*    | x2 f(x2)    p(x2,1)                                      |    */
/*    | x3 f(x3)(3) p(x3,2)(2) p(x3,2,1)(1)                      |    */
/*    | xm f(x4)(4) p(x4,3)(3) p(x4,3,2)(2) p(x4,3,2,1)(1)       |    */
/*    | x3     p(3)   \   p(i)   \     p(1)   \                  |    */
/*    | xm     p(m)   ->  p(i+1) ->    p(i)   ->      p(1)       |    */
/*    +----------------------------------------------------------+    */
      for(m=1; m<=n; m++) {
        p[m]=y[m];
        pi1=0.0;
        for(i=m-1; i>=1; i--) {
          pi=p[i];
          dp=p[i+1]-p[i];
          if(dp == 0.0)  { dp=eps*fabs(p[i]);
          if(dp < eps*eps) dp=eps*eps; }
          p[i]=(x[m]-x[i])/dp+pi1;
          pi1=pi;
        }
/*      printf("\n %13.4le",x[m]);                                    */
/*      for(i=m; i>=1; i--) printf("%13.4le",p[i]);                   */
      }
/*    +----------------------------------------------------------+    */
/*    | p(4),p(3); p(2)=p(x4,3,2)-f(x4);p(1)=p(x4,3,2,1)-p(x4,3) |    */
/*    +----------------------------------------------------------+    */
      for(i=1; i<=n-2; i++) {
        p[i]=p[i]-p[i+2];
      }
/*    +----------------------------------------------------------+    */
/*    | f(x)=f(x4)+(x-x4)   (x-x3)           (x-x2)              |    */
/*    |            -------- ---------------- --------------------|    */
/*    |            p(x4,3)+ p(x4,3,2)-f(x4)+ p(x4,3,2,1)-p(x4,3)+|    */
/*    +----------------------------------------------------------+    */
      for(m=1; m<=n; m++) {
        c[m]=0.0;
        for(i=m; i>=3; i=i-2) {
          c[i]=c[i]-c[i-2]*x[m]+c[i-1]*p[m];
        }
        if((m & 1) == 0) c[2]=c[2]-x[m]+c[1]*p[m];
        else             c[1]=c[1]+p[m];
      }
      return(0);
}
/**********************************************************************/
      double ratfun(double c[],int n,double x) {
/*    double ratfun(c,n,x) double c[],x; int n; {                     */
/*    ============================================================    */
      double d[2],dk,fun,eps=1.0e-15;
      int    i,k;
      --c;
/*    ============================================================    */
/*    n = 1,3,...,2*m+1                                               */
/*                                                                    */
/*           c(1)*x**m + c(3)*x**(m-1) + ... + c(2*m+1)    d(2)       */
/*    f(x) = ------------------------------------------ = ------      */
/*                x**m + c(2)*x**(m-1) + ... + c(2*m  )    d(1)       */
/*                                                                    */
/*    n = 2,4,...,2*m                                                 */
/*                                                                    */
/*                x**m + c(2)*x**(m-1) + ... + c(2*m  )    d(1)       */
/*    f(x) = ------------------------------------------ = ------      */
/*                       c(1)*x**(m-1) + ... + c(2*m-1)    d(2)       */
/*    ============================================================    */
      d[1]=1.0;
      d[2]=c[1];
      k=1;
      for(i=2; i<=n; i++) {
        d[k]=d[k]*x+c[i];
        k=3-k;
      }
      dk=d[k];
      if(dk == 0.0) dk=eps;
      fun=d[3-k]/dk;
      return(fun);
}
/**********************************************************************/
/*    Test program for Thiele's interpolation formula                 */
/*    ============================================================    */
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double x[20],y[20],c[20],p[20],yy;
      int    i,n;
      double ratfun(); int thiele();
/*    ============================================================    */
      if(argc<3) {printf("Usage : thiele infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
  L10:freeii(&n,fp_r); if(n == 0 || n > 20) exit(0);
      for(i=0; i<n; i++) {freer8(&x[i],fp_r); freer8(&y[i],fp_r);}
      fprintf(fp_w,"\n         c            p");
      fprintf(fp_w,"            x            y");
      thiele(x,y,n,c,p);
      for(i=0; i<n; i++) {
        fprintf(fp_w,"\n%2d%13.4le%13.4le%13.4le%13.4le"
                                  ,i,c[i],p[i],x[i],y[i]);
      }
      for(i=0; i<n; i++) {
        yy=ratfun(c,n,x[i]);
        fprintf(fp_w,"\n%2d%13.4le%13.4le",i,x[i],yy);
      }
      goto L10;
}
/**********************************************************************/
