#include <stdio.h>
#include <ctype.h>
#include <math.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      int thiint(double x[],double y[],int n,double dx[],double py[]
       ,int l[],double xx,double *pyy,int *pnn,double *pye,double eps) {
/*    int thiint(x,y,n,dx,py,l,xx,pyy,pnn,pye,eps)
      double x[],y[],dx[],py[],xx,*pyy,*pye,eps; int l[],n,*pnn; {    */
/*    ============================================================    */
      double yy,ye,difpy,dd,yo,pyi,pyip1;
      int    i,m,nn;  int sortal();
      --x; --y; --dx; --py; --l;
/*    ============================================================    */
/*    Thiele's interpolation formula                                  */
/*                                                                    */
/*    f(x) = f(x4)+(x-x4)   (x-x3)           (x-x2)                   */
/*                 -------- ---------------- --------------------     */
/*                 p(x4,3)+ p(x4,3,2)-f(x4)+ p(x4,3,2,1)-p(x4,3)+     */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    |            x4 - x3                   x4 - x2             |    */
/*    | p(x4,3) = ---------; p(x4,3,2) = --------------- + f(x3) |    */
/*    |           f(4)-f(3)              p(x4,3)-p(x3,2)         |    */
/*    |                                                          |    */
/*    |                          x4 - x1                         |    */
/*    |      p(x4,3,2,1) = ------------------- + p(x3,2)         |    */
/*    |                    p(x4,3,2)-p(x3,2,1)                   |    */
/*    |                                                          |    */
/*    | x1 f(x1)                                                 |    */
/*    | x2 f(x2)    p(x2,1)                                      |    */
/*    | x3 f(x3)(3) p(x3,2)(2) p(x3,2,1)(1)                      |    */
/*    | xm f(x4)(4) p(x4,3)(3) p(x4,3,2)(2) p(x4,3,2,1)(1)       |    */
/*    | x3    py(3)   \  py(i)   \    py(1)   \                  |    */
/*    | xm    py(m)   -> py(i+1) ->   py(i)   ->     py(1)       |    */
/*    +----------------------------------------------------------+    */
      for(i=1; i<=n; i++) {
        dx[i]=fabs(xx-x[i]);
      }
      sortal(&dx[1],&l[1],n);
/*    ------------------------------------------------------------    */
      yy=0.0;
      for(m=1; m<=n; m++) {
        yo=yy;
        nn=m;
        i=l[m];
        py[m]=y[i];
        dx[m]=xx-x[i];
        pyip1=0.0;
        for(i=m-1; i>=1; i--) {
          pyi=py[i];
          difpy=py[i+1]-py[i];
          if(difpy == 0.0)  { difpy=eps*fabs(py[i]);
          if(difpy < eps*eps) difpy=eps*eps; }
          py[i]=(dx[i]-dx[m])/difpy+pyip1;
          pyip1=pyi;
        }
/*      printf("\n %13.4le",dx[m]);                                   */
/*      for(i=m; i>=1; i--) printf("%13.4le",py[i]);                  */
/*    +----------------------------------------------------------+    */
/*    | yy = f(x4)+(x-x4)   (x-x3)           (x-x2)              |    */
/*    |            -------- ---------------- --------------------|    */
/*    |            p(x4,3)+ p(x4,3,2)-f(x4)+ p(x4,3,2,1)-p(x4,3)+|    */
/*    +----------------------------------------------------------+    */
        dd=0.0;
        for(i=1; i<=m-2; i++) {
          dd=dx[i+1]/(py[i]-py[i+2]+dd);
        }
        if(m > 1) dd=dx[m]/(py[m-1]+dd);
        yy=py[m]+dd;
        ye=yy-yo;
        if(fabs(ye) < eps*fabs(yy)) break;
      }
      *pyy=yy; *pye=ye; *pnn=nn;
      return(0);
}
/**********************************************************************/
      int sortal(double a[],int l[],int n) {
/*    int sortal(a,l,n) double a[]; int l[],n; {                      */
/*    ============================================================    */
      int    i,j,k,m,ne;
      --a; --l;
/*    ============================================================    */
      for(i=1; i<=n; i++) {
        l[i]=i;
      }
      m=n;
      do {
        ne=m-1;
        for(i=1; i<=ne; i++) {
          j=l[i];
          k=l[i+1];
          if(a[j] > a[k]) {
            l[i]=k;
            l[i+1]=j;
            m=i;
          }
        }
      } while(m <= ne);
      return(0);
}
/**********************************************************************/
/*    Test program for Thiele's interpolation                         */
/*    ============================================================    */
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double x[20],y[20],dx[20],dy[20],xx,yy,ye,eps;
      int    l[20],i,n,nn;  int thiint();
/*    ============================================================    */
      if(argc<3) {printf("Usage : thiint infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
  L10:freeii(&n,fp_r); if(n == 0 || n > 20) exit(0);
      for(i=0; i<n; i++) {freer8(&x[i],fp_r); freer8(&y[i],fp_r);}
      fprintf(fp_w,"\n       xx           yy           ye        nn");
  L30:freer8(&xx,fp_r); freer8(&eps,fp_r);
      if(eps == 0.0) goto L10;
      thiint(x,y,n,dx,dy,l,xx,&yy,&nn,&ye,eps);
      fprintf(fp_w,"\n %13.4le%13.4le%13.4le%5d",xx,yy,ye,nn);
      goto L30;
}
/**********************************************************************/
