#include <stdio.h>
#include <ctype.h>
#include <math.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
/*    program for curve fitting by least squares method               */
/*    ============================================================    */
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double x[101],y[101],w[101];       /* dim u(10,10),q(100,10)    */
      double a[1111],b[101],q[1111],u[121],c[11]; /* dim a(100,10)    */
      double ri,xi,yi,xsum,xmean;
      int    i,j,n,m,ja,nmax=100,mmax=10;
      int    qusol();
/*    ============================================================    */
      if(argc<3) {printf("Usage : lsqmn infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
  L10:freeii(&n,fp_r); freeii(&m,fp_r);
      if(n == 0 || m == 0 || n > nmax || m > mmax) exit(0);
      xsum=0.0;
      for(i=1; i<=n; i++) {
        freer8(&x[i],fp_r); freer8(&y[i],fp_r); freer8(&w[i],NULL);
        if(w[i] <= 0.0) w[i]=1.0;
        xsum+=x[i];
        b[i]=sqrt(w[i])*y[i];
        a[i+m*nmax]=sqrt(w[i]);
      }
      xmean=xsum/n;
      for(i=1; i<=n; i++) {
        for(j=m-1; j>=1; j--) {
          a[i+j*nmax]=a[i+(j+1)*nmax]*(x[i]-xmean);
        }
      }
/*    ------------------------------------------------------------    */
      qusol(&a[1+nmax],&b[1],&q[1+nmax],&u[1+mmax],&c[1],n,m,nmax,mmax);
/*    ------------------------------------------------------------    */
      fprintf(fp_w
         ,"\n\nCoefficients c(m) for c(j)*(x(i)-x_mean)^(m-j)\n\n    ");
      for(j=1; j<=m; j++) fprintf(fp_w,"%13.4le",c[j]);
      fprintf(fp_w
      ,"\n\n   i       {x}          {y}          {Y}        {Y}-{y}\n");
      for(i=1; i<=n; i++) {
        xi=x[i]-xmean;
        yi=0.0;
        for(j=1; j<=m; j++) {
          yi=yi*xi+c[j];
        }
        ri=yi-y[i];
        fprintf(fp_w
                ,"\n%4d%13.4le%13.4le%13.4le%13.4le",i,x[i],y[i],yi,ri);
      }
      goto L10;
}
/**********************************************************************/
