#include <stdio.h>
#include <ctype.h>
#include <math.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
/*    program for solving [a]{x}={b} by least squares method          */
/*    where [a] is a n x m matrix, and n > m                          */
/*    ============================================================    */
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double a[1111],b[101],w[101];         /* dim a(100,10)          */
      double q[1111],c[101],u[121],x[11];   /* dim q(100,10),u(10,10) */
      double ri,yi,wsq;
      int    i,j,n,m,ja,nmax=100,mmax=10;
      int    qusol();
/*    ============================================================    */
      if(argc<3) {printf("Usage : lsqmn infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
  L10:freeii(&n,fp_r); freeii(&m,fp_r);
      if(n == 0 || m == 0 || n > nmax || m > mmax) exit(0);
      for(i=1; i<=n; i++) {
        for(j=1; j<=m; j++) freer8(&a[i+j*nmax],fp_r);
        freer8(&b[i],fp_r); freer8(&w[i],NULL);
        if(w[i] <= 0.0) w[i]=1.0;
        wsq=sqrt(w[i]);
        c[i]=b[i]*wsq;
        for(j=1; j<=m; j++) { ja=j*nmax;
          q[i+ja]=a[i+ja]*wsq;
        }
      }
/*    ------------------------------------------------------------    */
      qusol(&q[1+nmax],&c[1],&q[1+nmax],&u[1+mmax],&x[1],n,m,nmax,mmax);
/*    ------------------------------------------------------------    */
      fprintf(fp_w,"\n\nvariables x(m) :\n\n    ");
      for(j=1; j<=m; j++) fprintf(fp_w,"%13.4le",x[j]);
      fprintf(fp_w,"\n\n   i       {b}       [a]{x}  {r}=[a]{x}-{b}\n");
      for(i=1; i<=n; i++) {
        yi=0.0;
        for(j=1; j<=m; j++) { ja=j*nmax;
          yi+=a[i+ja]*x[j];
        }
        ri=yi-b[i];
        fprintf(fp_w,"\n%4d%13.4le%13.4le%13.4le",i,b[i],yi,ri);
      }
      goto L10;
}
/**********************************************************************/
