#include <math.h>
/**********************************************************************/
      int qusol(double a[],double b[],double q[],double u[],double x[]
               ,int n,int m,int nn,int mm) {
/*    int qusol(a,b,q,u,x,n,m,nn,mm)
      double a[],b[],q[],u[],x[]; int n,m,nn,mm; {                    */
/*    ============================================================    */
      double uij,ujj,xsqs,eps=1.0e-10;
      int    i,j,k,ia,ja,ju;
      --a; a-=nn; --b; --q; q-=nn; --u; u-=mm; --x;
/*    ============================================================    */
/*i   a(n,m),b(n),n,m,nn                                              */
/*o   q(n,m),u(m,m),x(m) (q(n,m) & a(n,m) can be the same matrix)     */
/*    ------------------------------------------------------------    */
/*    solve a'(m,n)*a(n,m)*x(m) = a'(m,n)*b(n)                        */
/*    by orthogonal decomposition a(n,m) = q(n,m)*u(m,m)              */
/*    where q(n,m) is an orthogonal matrix q'(m,n)*q(n,m) = i(m,m)    */
/*     and  u(m,m) is an upper-triangular matrix                      */
/*    get x(m) by backward substitution u(m,m)*x(m) = q'(m,n)*b(n)    */
/*    ============================================================    */
      for(j=1; j<=m; j++) { ja=j*nn; ju=j*mm;
        xsqs=0.0;
        for(i=1; i<=n; i++) {
          xsqs+=a[i+ja]*a[i+ja];
          q[i+ja]=a[i+ja];
        }
/*      +--------------------------------------------------------+    */
/*      | compute q(i,j) & u(j,j)                                |    */
/*      +--------------------------------------------------------+    */
        for(i=1; i<=j-1; i++) { ia=i*nn;
          uij=0.0;
          for(k=1; k<=n; k++) {
            uij+=q[k+ia]*q[k+ja];
          }
          u[i+ju]=uij;
          for(k=1; k<=n; k++) {
            q[k+ja]-=q[k+ia]*uij;
          }
        }
/*      ---------------------------------------------------------     */
        ujj=0.0;
        for(k=1; k<=n; k++) {
          ujj+=q[k+ja]*q[k+ja];
        }
        if(ujj > xsqs*eps) {
          ujj=sqrt(ujj);
          u[j+ju]=ujj;
          for(k=1; k<=n; k++) {
            q[k+ja]/=ujj;
          }
        } else {
          u[j+ju]=1.0;
          for(k=1; k<=n; k++) {
            q[k+ja]=0.0;
          }
          printf("\n %d-th vector is not independent, set x[%d]=0",j,j);
        }
/*      +--------------------------------------------------------+    */
/*      | compute q(1:n,j)*b(1:n) --> x(j)  :  [q]'{b}           |    */
/*      +--------------------------------------------------------+    */
        x[j]=0.0;
        for(k=1; k<=n; k++) {
          x[j]+=q[k+ja]*b[k];
        }
      }
/*    +----------------------------------------------------------+    */
/*    | solve u(m,m)*x(m) = q(n,m)*b(n)  :  [u]{x}=[q]'{b}       |    */
/*    +----------------------------------------------------------+    */
      for(j=m; j>=1; j--) { ju=j*mm;
        x[j]/=u[j+ju];
        for(i=1; i<=j-1; i++) {
          x[i]-=u[i+ju]*x[j];
        }
      }
/*    ------------------------------------------------------------    */
/*    for(j=m; j>=1; j--) { printf("\n u(*,%d):",j); ju=j*mm;         */
/*      for(i=1; i<=j; i++) printf("%12.4le",u[i+ju]);                */
/*    }                                                               */
/*    printf("\n x(*)  :");                                           */
/*    for(j=1; j<=m; j++) printf("%12.4le",x[j]);                     */
      return(0);
}
/**********************************************************************/
