#include <math.h>
/**********************************************************************/
      int ffta(double f[],double a[],int n,int inv) {
/*    int ffta(f,a,n,inv) double f[],a[]; int n,inv; {                */
/*====================================================================*/
/*    complex fi(n),fo(n)                                             */
      int     nbf,now,naf,ifa,i;
/*======================================================================
  f(n) = input (fi) and output (fo) data array of arbitrary n
  a(n) = working array (f1,f2,f3,...) reqd for n != 2**integer only
  ----------------------------------------------------------------------
  fo(k5,k4,k3,k2,k1)=fi(l1,l2,l3,l4,l5)w^(l1,l2,l3,l4,l5)(k5,k4,k3,k2,k1)
        where     w = exp(i*(-2*pi*inv/n))
  ======================================================================
  for now = 2  (n5=n4=n3=2)  :  by do 290
  ----------------------------------------------------------------------
  f1(l1,l2,l3,l4,j5)=fi(l1,l2,l3,l4,i5)w^(0, 0, 0, 0,i5)(j5, 0, 0, 0, 0)
  f2(l1,l2,l3,j4,k5)=f1(l1,l2,l3,i4,k5)w^(0, 0, 0,i4, 0)(k5,j4, 0, 0, 0)
  f3(l1,l2,j3,k4,k5)=f2(l1,l2,i3,k4,k5)w^(0, 0,i3, 0, 0)(k5,k4,j3, 0, 0)
  ----------------------------------------------------------------------
  bit-reversal       fr(l1,l2,k5,k4,k3)=f3(l1,l2,k3,k4,k5) : by do 590
  ----------------------------------------------------------------------
  for now > 2  (n2>2, n1>2)  :  by do 90
  ----------------------------------------------------------------------
  f4(l1,k5,k4,k3,j2)=fr(l1,i2,k5,k4,k3)w^(0,i2, 0, 0, 0)(k5,k4,k3,j2,j1)
  fo(k5,k4,k3,k2,j1)=f4(i1,k5,k4,k3,k2)w^(i1,0, 0, 0, 0)(k5,k4,k3,k2,k1)
  ======================================================================
  w^(0,0,i3,0,0)(k5,k4,j3,0,0) = w^(0,0,1,0,0)(k5,k4,j3,0,0)i3 = ar1^i3
  omg = w^(0,0,1,0,0) = exp(i*(-2*pi*inv/n)*nbf)
  ar1 = w^(0,0,1,0,0)(k5,k4,j3,0,0) = 1*omg*omg*omg*...
  ----------------------------------------------------------------------
  nbfore =  n1*n2*n3*n4   n1*n2*n3    n1*n2       n1           1
  now    =       n5          n4         n3        n2           n1
  nafter =       1           n5       n5*n4    n5*n4*n3   n5*n4*n3*n2
  ----------------------------------------------------------------------
  ib     = (l1,l2,l3,l4) (l1,l2,l3)  (l1,l2)     (l1)          0
  in     =      (i5)        (i4)       (i3)      (i2)         (i1)
  ia     =       0          (k5)     (k5,k4)  (k5,k4,k3) (k5,k4,k3,k2)
  ir     =       0          (k5)     (k4,k5)  (k3,k4,k5) (k2,k3,k4,k5)
  im     =      (j5)        (j4)       (j3)      (j2)         (j1)
  < for now=n2=5 > : ---------------------------------------------------
        / fo(ib,ia,0) \   / w00 w01 w02 w03 w04 \ / fi(ib,0,ia) \
        | fo(ib,ia,1) |   | w10 w11 w12 w13 w14 | | fi(ib,1,ia) |
        | fo(ib,ia,2) | = | w20 w21 w22 w23 w24 | | fi(ib,2,ia) |
        | fo(ib,ia,3) |   | w30 w31 w32 w33 w34 | | fi(ib,3,ia) |
        \ fo(ib,ia,4) /   \ w40 w41 w42 w43 w44 / \ fi(ib,4,ia) /
  ----------------------------------------------------------------------
        where : wij = w^ij,   w1j = w^j,   w1j = ar1 = omg^(ia,j)
  ----------------------------------------------------------------------
  fo($#j)=fi($0#)+(fi($1#)+(fi($2#)+(fi($3#)+fi($4#)*w1j)*w1j)*w1j)*w1j
  ====================================================================*/
      ifa=1;
      nbf=n;
      naf=1;
      now=2;
/*    +----------------------------------------------------------+    */
/*    | now = 2,..,3,..,5,..,7,..,11,..,13,..,17,..              |    */
/*    +----------------------------------------------------------+    */
      while(nbf > 1) {
        while(nbf%now != 0) now=now+1;
        nbf=nbf/now;
        if(ifa > 0) fftbna(f,a,nbf,now,naf,inv);
        else        fftbna(a,f,nbf,now,naf,inv);
        if(now != 2) ifa=-ifa;
        naf=naf*now;
      }
/*    +----------------------------------------------------------+    */
/*    | return transformed values in f(0:n-1)                    |    */
/*    +----------------------------------------------------------+    */
      if(ifa > 0) return(0);
      for(i=0; i<2*n; i++) f[i]=a[i];
      return(0);
}
/**********************************************************************/
      int fftbna(double fi[],double fo[]
                ,int nbf,int now,int naf,int inv) {
/*    int fftbna(fi,fo,nbf,now,naf,inv)
      double fi[,fo[]; int nbf,now,naf,inv; {                         */
/*    ============================================================    */
/*    complex fi(nbf,now,naf),fo(nbf,naf,now)                         */
      double  ang,omg0,omg1,ar10,ar11,ff0,ff1,tt0,tt10;
      int     ia,ib,ir,is,in,im,iri,iai,iao,ini_iai,imo;
      int     ib0,ib1,ir0,ir1,nowi,nbf2;
/*    ============================================================    */
      ang=-6.2831853071795864/(now*naf); if(inv < 0) ang=-ang;
      omg0=cos(ang); omg1=sin(ang); nbf2=2*nbf;
/*    ------------------------------------------------------------    */
      if(now == 2) goto L200;
/*    ------------------------------------------------------------    */
      ar10=1.0; ar11=0.0;     nowi=(now-1)*nbf2;
      for(im=0; im<now; im++) { imo=im*naf*nbf2;
        for(ia=0; ia<naf; ia++) { iao=ia*nbf2; iai=iao*now;
          for(ib=0; ib<nbf; ib++) { ib0=ib+ib; ib1=ib0+1;
            ff0=fi[ib0+nowi+iai];
            ff1=fi[ib1+nowi+iai];
            for(in=now-2; in>=0; in--) { ini_iai=in*nbf2+iai;
              tt0=ff0;
              ff0=tt0*ar10-ff1*ar11+fi[ib0+ini_iai];
              ff1=tt0*ar11+ff1*ar10+fi[ib1+ini_iai];
            }
            fo[ib0+iao+imo]=ff0;
            fo[ib1+iao+imo]=ff1;
          }
          tt10=ar10;
          ar10=tt10*omg0-ar11*omg1;
          ar11=tt10*omg1+ar11*omg0;
        }
      }
      return(0);
/*    +----------------------------------------------------------+    */
/*    | now=2 : use dual nodes and in-place computation          |    */
/*    +----------------------------------------------------------+    */
 L200:ir=0;
      ar10=1.0; ar11=0.0;
      for(ia=0; ia<naf; ia++) { ir0=ir*now*nbf2; ir1=ir0+nbf2;
/*      +--------------------------------------------------------+    */
/*      | / fi(ib,0,ir) \   / 1  ar1 \ / fi(ib,0,ir) \           |    */
/*      | \ fi(ib,1,ir) / = \ 1 -ar1 / \ fi(ib,1,ir) /           |    */
/*      +--------------------------------------------------------+    */
        for(ib=0; ib<nbf; ib++) { ib0=ib+ib; ib1=ib0+1;
          ff0=fi[ib0+ir1]*ar10-fi[ib1+ir1]*ar11;
          ff1=fi[ib0+ir1]*ar11+fi[ib1+ir1]*ar10;
          fi[ib0+ir1]=fi[ib0+ir0]-ff0; fi[ib0+ir0]+=ff0;
          fi[ib1+ir1]=fi[ib1+ir0]-ff1; fi[ib1+ir0]+=ff1;
        }
        if(ia == naf-1) continue;
        is=naf/2;
        while(is <= ir) {
          ir=ir-is;
          is=is/2;
        }
        ir=ir+is;
        tt10=ar10;
        ar10=tt10*omg0-ar11*omg1;
        ar11=tt10*omg1+ar11*omg0;
      }
      if(nbf%2 == 0) return(0);
/*    +----------------------------------------------------------+    */
/*    | bit-reversal operation after all base 2 transformations  |    */
/*    +----------------------------------------------------------+    */
      ir=0;
      for(ia=0; ia<2*naf-1; ia++) { iai=ia*nbf2;
        if(ia < ir) {               iri=ir*nbf2;
          for(ib=0; ib<nbf; ib++) { ib0=ib+ib; ib1=ib0+1;
            ff0=fi[ib0+iri]; fi[ib0+iri]=fi[ib0+iai]; fi[ib0+iai]=ff0;
            ff1=fi[ib1+iri]; fi[ib1+iri]=fi[ib1+iai]; fi[ib1+iai]=ff1;
          }
        }
        is=naf;
        while(is <= ir) {
          ir=ir-is;
          is=is/2;
        }
        ir=ir+is;
      }
      return(0);
}
/**********************************************************************/
