#include <stdio.h>
#include <ctype.h>
#include <math.h>
double powdl(double,long);
double xmin(double,double,double,int,int *,double []);
/**********************************************************************/
      main() {
/*    ============================================================    */
      static double a[5100];  /* permanent var --> initialized to 0's */
      double epsx=1.0e-15,epsf=1.0e-5;
      long   m,nm,no,nr,nx,ny;
      long   itm=15,its=4,ip=21,nf=0,ndm=5100;
      int    inpequ(),polyct(),polyft(),polyrt();
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | input coefficients in a(1:m) --> a(i) * x**(m-i)         |    */
/*    | m     = number of real coefficients = poly. order + 1    |    */
/*    |       = 2 * number of complex coefficients               |    */
/*    | itm   = maximum numbers of iterations allowed            |    */
/*    | its   = max. # of iterations for no additional # of rr=1 |    */
/*    | ip    = debug output control (1+2+4+8+16+32+64+128)      |    */
/*    | nf    > 0 : by fft method (nf=data points used in fft)   |    */
/*    |       = 0 : by root shift (itersections of circles)      |    */
/*    |       < 0 : for complex coefficients                     |    */
/*    +----------------------------------------------------------+    */
  L10:inpequ(a,&m,&nf,&epsx,&epsf,&itm,&its,&ip);
      no=0;
      nx=no+m;               /* a[no] for ao(m) */
      ny=nx+m;               /* a[nx] for ax(m) */
      nr=ny+m;               /* a[ny] for ay(m) */
/*    +----------------------------------------------------------+    */
/*    | by fft method                                            |    */
/*    +----------------------------------------------------------+    */
      if(nf <= 0) goto L30;
      nm=nr+m*4+nf+2;        /* a[nr] for working array ar(4*m+nf+2) */
      if(nm > ndm) exit(0);
      polyft(&a[no],&a[nx],&a[ny],&a[nr],m,epsx,epsf,itm,its,ip,nf);
      goto L10;
/*    +----------------------------------------------------------+    */
/*    | by root shift (intersections of circles)                 |    */
/*    +----------------------------------------------------------+    */
  L30:if(nf < 0) goto L50;
      nm=nr+m*13;            /* a[nr] for working array ar(13*m) */
      if(nm > ndm) exit(0);
      polyrt(&a[no],&a[nx],&a[ny],&a[nr],m,epsx,epsf,itm,its,ip);
      goto L10;
/*    +----------------------------------------------------------+    */
/*    | for complex coefficients                                 |    */
/*    +----------------------------------------------------------+    */
  L50:nm=nr+m*14;            /* a[nr] for working array ar(14*m) */
      if(nm > ndm) exit(0);
      polyct(&a[no],&a[nx],&a[ny],&a[nr],m,epsx,epsf,itm,its,ip);
      goto L10;
}
/**********************************************************************/
      int inpequ(double ao[],long *m,long *nf,double *epsx,double *epsf
                ,long *itm,long *its,long *ip) {
/*    int inpequ(ao,m,nf,epsx,epsf,itm,its,ip)
      double ao[],*epsx,*epsf; long *m,*nf,*itm,*its,*ip; {           */
/*    ============================================================    */
      long  i;
      int   termd(),termi(),answer();
      --ao;
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | input data from terminal                                 |    */
/*    +----------------------------------------------------------+    */
  L10:termr8(" epsx  :",epsx);
      termr8(" epsf  :",epsf);
      termi4(" itm   :",itm);
      termi4(" its   :",its);
      termi4(" idebug:",ip);
      termi4(" nf-fft:",nf);
      termi4(" m     :",m);
/*    +----------------------------------------------------------+    */
/*    | input coefficients of the polynomial                     |    */
/*    +----------------------------------------------------------+    */
      i=0;
  L20:i=i+1;
      termi4(" i     :",&i);
      if(i > *m) goto L30;
      termr8(" ao[i] :",&ao[i]);
      goto L20;
/*    ------------------------------------------------------------    */
  L30:if(answer(" Want to retype (y/n) ? ","?")) goto L10;
      if(*m <= 0) exit(0);
      return(0);
}
/**********************************************************************/
      int graeff(double aa[],long ka[],double bb[],long kb[]
                ,double rr[],long kr[],double ao[],long mo
                ,double eps,long itm,long its,long ip) {
/*    int graeff(aa,ka,bb,kb,rr,kr,ao,mo,eps,itm,its,ip)
      double aa[],bb[],rr[],ao[],eps;
      long   ka[],kb[],kr[]; int mo,itm,its,ip; {                     */
/*    ============================================================    */
      double s,sa,ai,am,ak,base=1024.0;
      long   ii,il,ir,it,ki,kk,km,m,mm,mq,mr,ms,mx,i1n,i1o,ito;
      long   kpos=7,kneg=-8,kmax=1073741822;
      int    normal(),rsqrt();
      --aa; --ka; --bb; --kb; --rr; --kr; --ao;
/*    ============================================================    */
/*    base**( kpos-1)  >  2**bitr8       (10*(7-1) > 56)              */
/*    base**(-kneg-2)  >  2**bitr8       (10*(8-2) > 56)              */
/*    kmax*2+3  <=  2**min(biti4,2*biti4)-1    (2**30-2)              */
/*    ------------------------------------------------------------    */
/*    input   : ao(mo),mo,eps,itm,its,ip                              */
/*    output  : rr(mo),kr(mo)                                         */
/*    working : aa(mo),ka(mo),bb(mo),kb(mo)                           */
/*    ------------------------------------------------------------    */
/*i   ao(i) = coefficient of x**(m-i)                                 */
/*i   mo    = number of coefficients = polynormial order + 1          */
/*i   eps   = error tolerance for rr=1 as |rr-1| <= eps               */
/*i   itm   = maximum numbers of iterations allowed                   */
/*i   its   = max. # of iterations for no additional # of rr=1        */
/*i   ip    = debug output control (1+2+4+8+16+32+64+128)             */
/*    ------------------------------------------------------------    */
/*o   if kr(i) > 0  then rr(i) is the magnitude of the roots          */
/*                       kr(i) is the multiplicity                    */
/*    ------------------------------------------------------------    */
/*    by Graeffe's root squaring method                               */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | adjust m such that a(m) != 0 and ao(m+1:mo)=0            |    */
/*    +----------------------------------------------------------+    */
      m=mo;
  L10:if(m <= 1) goto L90;
      if(fabs(ao[m]) < 1000.0*eps) {
        m=m-1;
        goto L10;
      }
/*    +----------------------------------------------------------+    */
/*    | normalize : ao(1)=|ao(m)|=1, ao(ii)=aa(ii)*base**ka(ii)  |    */
/*    +----------------------------------------------------------+    */
      ai=ao[1];
      am=exp(log(fabs(ao[m]/ai))/(m-1));
      for(ii=1; ii<=m; ii++) {
        aa[ii]=ao[ii]/ai;
        ka[ii]=0;
        normal(&aa[ii],&ka[ii]);
        ak=ka[ii];
        if(ip/4*2 != ip/2)
          printf("\n%8ld%16.7le%20.0lf%24.15le",ii,aa[ii],ak,ao[ii]);
        ai=ai*am;
      }
      aa[m]=aa[m]/fabs(aa[m]);
      ka[m]=0;
      if(ip/4*2 != ip/2) printf("\n%4ld%4ld",itm,its);
/*    +----------------------------------------------------------+    */
/*    | root squaring                                            |    */
/*    +----------------------------------------------------------+    */
      km=0;
      i1o=0;
      for(it=1; it<=itm+its*2; it++) {
        for(ii=1; ii<=m; ii++) {
          il=ii;
          ir=ii;
          s=2.0;
          bb[ii]=aa[ii]*aa[ii];
          kb[ii]=ka[ii]+ka[ii];
          normal(&bb[ii],&kb[ii]);
          while(il > 1 && ir < m) {
            il=il-1;
            ir=ir+1;
            s=-s;
            sa=s*aa[il]*aa[ir];
            if(sa != 0.0) {
              ki=ka[il]+ka[ir]-kb[ii];
              if(ki >= kpos || bb[ii] == 0.0) {
                bb[ii]=sa;
                kb[ii]=ka[il]+ka[ir];
                normal(&bb[ii],&kb[ii]);
              } else if(ki > kneg) {
                bb[ii]=bb[ii]+sa*powdl(base,ki);
                normal(&bb[ii],&kb[ii]);
              }
            }
          }
        }
/*      +--------------------------------------------------------+    */
/*      | move bb(m),kb(m) --> aa(m),ka(m)                       |    */
/*      | count i1n = number of ii with aa(ii)**2/bb(ii)=1       |    */
/*      +--------------------------------------------------------+    */
        i1n=0;
        for(ii=1; ii<=m; ii++) {
          if(bb[ii] != 0.0 && aa[ii] != 0.0) {
           rr[ii]=aa[ii]*aa[ii]/bb[ii]*powdl(base,ka[ii]+ka[ii]-kb[ii]);
          } else {
           rr[ii]=0.0;
          }
          aa[ii]=bb[ii];
          ka[ii]=kb[ii];
          if(fabs(rr[ii]-1.0) <= eps) i1n=i1n+1;
          if(ka[ii] > km) km=ka[ii];
          if(ip/4*2 != ip/2)
            printf("\n%8ld%16.7le%8ld%24.15le",ii,aa[ii],ka[ii],rr[ii]);
        }
/*      +--------------------------------------------------------+    */
/*      | set  ms  = number of squaring has been performed       |    */
/*      | i1n/i1o  = number of rr(*)=1 at this/last cycle        |    */
/*      | it-ito+1 = number of cycles which have the same i1n    |    */
/*      +--------------------------------------------------------+    */
        if(i1n != i1o) ito=it;
        i1o=i1n;
        ms=it;
        if(ip/4*2 != ip/2) printf("\n%4ld%4ld%4ld%4ld",it,i1n,i1o,ito);
/*      +--------------------------------------------------------+    */
/*      | convergence test                                       |    */
/*      +--------------------------------------------------------+    */
        if(km > kmax) break;
        if(it >= itm && it-ito >= its) break;
      }
/*    +----------------------------------------------------------+    */
/*    | find mm = ii-il = multiplicity of root s, where rr(ii)=1 |    */
/*    +----------------------------------------------------------+    */
      il=1;
      for(ii=2; ii<=m; ii++) {
        if(fabs(rr[ii]-1.0) > eps) continue;
        s=aa[ii]/aa[il];
        kk=ka[ii]-ka[il];
        rsqrt(&s,&kk,ms);
        mm=ii-il;
        mq=kk/mm;
        mr=kk-mq*mm;
        if(mm > 1) s=exp(log(s*powdl(base,mr))/mm);
        s=s*powdl(base,mq)*am;
/*      +--------------------------------------------------------+    */
/*      | set rr(il:il+mm-1)=s, kr(il)=mm, kr(il+1:il+mm-1)=-mm  |    */
/*      +--------------------------------------------------------+    */
        mx=mm;
        for(ir=1; ir<=mm; ir++) {
          rr[il]=s;
          kr[il]=mx;
          if(ip/2*2 != ip)
            printf("\n%8ld%24.15le%8ld%24.15le"
                   ,il,rr[il],kr[il],rr[il+1]);
          mx=-mm;
          il=il+1;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | return rr(m),kr(m) (rr(m+1:mo)=0, kr(m+1)=mo-m, if m<mo) |    */
/*    +----------------------------------------------------------+    */
  L90:kr[mo]=-mo;
      if(m == mo) return(0);
      for(ii=m; ii<mo; ii++) {
        rr[ii]=0.0;
        kr[ii]=m-mo;
      }
      kr[m]=mo-m;
      return(0);
}
/**********************************************************************/
      int normal(double *a,long *k) {
/*    int normal(a,k) double *a; long *k; {                           */
/*    ============================================================    */
      double x,base=1024.0;
/*    ============================================================    */
/*    normalize : a*base**k such that base > |a| >= 1                 */
/*    ============================================================    */
      x=fabs(*a);
      if(x <= 0.0) {
        *k=0;
        return(0);
      }
      while(x >= base) {
        x/=base;
        ++(*k);
      }
      while(x < 1.0) {
        x*=base;
        --(*k);
      }
      if(*a < 0) x=-x;;
      *a=x;
      return(0);
}
/**********************************************************************/
      int rsqrt(double *a,long *k,long mm) {
/*    int rsqrt(a,k,mm) double *a; long *k,mm; {                      */
/*    ============================================================    */
      double base=1024.0;
      long   i;
/*    ============================================================    */
/*    square root of a*base**k  mm times  (a is positive)             */
/*    ============================================================    */
      for(i=1; i<=mm; i++) {
        if(*k%2 != 0) {
          *a=sqrt(*a*base);
          *k=(*k-1)/2;
        } else {
          *a=sqrt(*a);
          *k=*k/2;
        }
      }
      return(0);
}
/**********************************************************************/
      int polyrt(double ao[],double rr[],long kr[],double a[],long m
                ,double epsx,double epsf,long itm,long its,long ip) {
/*    int polyrt(ao,rr,kr,a,m,epsx,epsf,itm,its,ip)
      double ao[],rr[],a[],epsx,epsf; long kr[],m,itm,its,ip; {       */
/*    ============================================================    */
/*    dimension ao(m),rr(m),kr(m),a(m,13)                             */
      double *a1,*a2,*a3,*a4,*a5,*a6,*a7,*a8,*a9,*a10,*a11,*a12,*a13;
      int polynm();
      a1=a; a2=a1+m; a3=a2+m; a4=a3+m; a5=a4+m; a6=a5+m; a7=a6+m;
      a8=a7+m; a9=a8+m; a10=a9+m; a11=a10+m; a12=a11+m; a13=a12+m;
/*    ============================================================    */
      polynm(ao,rr,kr,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13
            ,m,epsx,epsf,itm,its,ip);
      return(0);
}
/**********************************************************************/
      int polynm(double ao[],double rr[],long   kr[]
                ,double aa[],long   ka[],double bb[],long kb[]
                ,double ar[],double al[],double ac[]
                ,double pr[],double pl[],double pc[]
                ,long   nr[],long   nl[],long   nc[],long m
                ,double epsx,double epsf,long itm,long its,long ip) {
/*    int polynm(ao,rr,kr,aa,ka,bb,kb,ar,al,ac,pr,pl,pc,nr,nl,nc
                ,m,epsx,epsf,itm,its,ip)
      double ao[],rr[],aa[],bb[],epsx,epsf;
      double ar[],al[],ac[],pr[],pl[],pc[];
      long   kr[],ka[],kb[],nr[],nl[],nc[],m,itm,its,ip;              */
/*    ============================================================    */
      double p,q,s,sa,x,xx,fx,po;
      double eps,ers,efm,ffm,buf[14];
      double base=1024.0,zero=0.0;
      long   ir,il,ix,iy,ii,ki,kx,mb,mr,mc,ml,iv;
      long   i,k,kk,kkk,kfm,im=2;
      int    istep,ivy;
      int graeff(),synth2(),bairst(),normal(),check2(),pqerr(),putx();
      --ao; --rr; --kr; --aa; --ka; --bb; --kb;
      --ar; --al; --ac; --pr; --pl; --pc; --nr; --nl; --nc;
/*    ============================================================    */
/*    input   : ao(m),m,epsx,epsf,itm,its,ip                          */
/*    output  : rr(m),kr(m)                                           */
/*    working : aa(m),ka(m),bb(m),kb(m)                               */
/*              ar(m),al(m),ac(m),pr(m),pl(m),pc(m),nr(m),nl(m),nc(m) */
/*    ------------------------------------------------------------    */
/*    ao(i) = coefficient of x**(m-i)                                 */
/*    ------------------------------------------------------------    */
/*    if kr(i) > 0 and kr(i+1) < 0 then                               */
/*         rr(i) = real root                                          */
/*         kr(i) = its multiplicity                                   */
/*    ------------------------------------------------------------    */
/*    if kr(i) > 0 and kr(i+1) == 0 then                              */
/*         (rr(i),+-rr(i+1)) = complex roots                          */
/*         kr(i) = its multiplicity (always even)                     */
/*    ------------------------------------------------------------    */
/*    by Graeffe's method and root shift and Bairstow's method        */
/*    ============================================================    */
      graeff(&aa[1],&ka[1],&bb[1],&kb[1],&rr[1],&kr[1],&ao[1]
            ,m,epsx,itm,its,ip);
/*    ------------------------------------------------------------    */
      ii=1;
      for(il=1; il<=m-1; il++) {
        if(kr[il] <= 0 || il < ii) continue;
        ir=il+kr[il]-1;
/*      ----------------------------------------------------------    */
        ii=il;
        x=rr[ii];
        if(x == 0.0) continue;
/*      +--------------------------------------------------------+    */
/*      | scale the ii-th root to unit magnitude                 |    */
/*      +--------------------------------------------------------+    */
        kfm=0;
        xx=1.0;
        kx=0;
        for(i=m; i>=1; i--) {
          aa[i]=ao[i]*xx;
          ka[i]=kx;
          normal(&aa[i],&ka[i]);
          if(ka[i] > kfm && aa[i] != 0.0) kfm=ka[i];
          xx=xx*x;
          normal(&xx,&kx);
        }
/*      +--------------------------------------------------------+    */
/*      | ffm = sum of the fabs of the coefficients              |    */
/*      +--------------------------------------------------------+    */
        ffm=0.0;
        for(i=1; i<=m; i++) {
          ki=ka[i]-kfm;
          if(ki != 0 && aa[i] != 0.0) aa[i]=aa[i]*powdl(base,ki);
          ffm=ffm+fabs(aa[i]);
        }
        efm=epsf*ffm;
        eps=epsx*100.0;
/*      +--------------------------------------------------------+    */
/*      | square the roots for pure imag roots                   |    */
/*      +--------------------------------------------------------+    */
        for(i=1; i<=m; i++) {
          al[i]=aa[i];
          ar[i]=aa[i];
          ix=i;
          iy=i;
          s=2.0;
          sa=0.0;
          while(ix > 1 && iy < m) {
            ix=ix-1;
            iy=iy+1;
            s=-s;
            sa=aa[ix]*aa[iy]-sa;
          }
          ac[i]=aa[i]*aa[i]+s*sa;
        }
/*      +--------------------------------------------------------+    */
/*      | shift the roots                                        |    */
/*      +--------------------------------------------------------+    */
        for(k=m; k>=2; k--) {
          for(i=2; i<=k; i++) {
            ar[i]=ar[i]+ar[i-1];
            al[i]=al[i]-al[i-1];
            ac[i]=ac[i]+ac[i-1];
          }
        }
/*      +--------------------------------------------------------+    */
/*      | find  m-mr = # of real roots (+x,0)                    |    */
/*      | find  m-ml = # of real roots (-x,0)                    |    */
/*      | find  m-mc = # of imag roots (0,+x) or (0,-x)          |    */
/*      +--------------------------------------------------------+    */
        for(k=m-kr[il]; k<=m; k++) {
          if(fabs(ar[k]) > efm) mr=k;
          if(fabs(al[k]) > efm) ml=k;
          if(fabs(ac[k]) > efm) mc=k;
        }
/*      ----------------------------------------------------------    */
        putx( x,zero,m-mr,&rr[1],&kr[1],&ii,eps);
        if(ii > ir) continue;
        putx(-x,zero,m-ml,&rr[1],&kr[1],&ii,eps);
        if(ii > ir) continue;
        putx( zero,x,m-mc,&rr[1],&kr[1],&ii,eps);
        if(ii > ir) continue;
/*      +--------------------------------------------------------+    */
/*      | check complex root for err<efm (efm increase with kkk) |    */
/*      +--------------------------------------------------------+    */
        for(kkk=1; kkk<=3; kkk++) {
/*        +------------------------------------------------------+    */
/*        | find complex roots : real part between +x/2 and +x   |    */
/*        +------------------------------------------------------+    */
          if(kkk == 1)
            graeff(&ar[1],&ka[1],&bb[1],&kb[1],&pr[1],&nr[1],&ar[1]
                  ,mr,epsx,itm,its/2,ip);
          for(iv=mr-1; iv>=1; iv--) {
            if(nr[iv] <= 0 || pr[iv] > 2.005) continue;
            p=2.0-pr[iv]*pr[iv];
            q=1.0;
            for(istep=1; istep<=20; istep++) {
              synth2(&aa[1],&bb[1],m,p,q,im);
              pqerr(&bb[1],m,p,q,im,&ers,&fx);
              po=p;
              p=xmin(p,fx,0.001,istep,&ivy,buf);
              if(fabs(p-po) <= epsx) break;
            }
            bairst(&aa[1],&bb[1],m,&p,&q,im,epsx,efm,ip);
            if(fabs(q-1.0) > 0.125 || fabs(p) > 2.25) continue;
            check2(&aa[1],&bb[1],m,&mb,p,q,im,efm,ip);
            if(m == mb) continue;
            putx(0.5*p*x,sqrt(q-0.25*p*p)*x,m-mb,&rr[1],&kr[1],&ii,eps);
            nr[iv]=0;
            if(ii > ir) goto L500;
          }
/*        +------------------------------------------------------+    */
/*        | find complex roots : real part between -x and -x/2   |    */
/*        +------------------------------------------------------+    */
          if(kkk == 1)
            graeff(&al[1],&ka[1],&bb[1],&kb[1],&pl[1],&nl[1],&al[1]
                  ,ml,epsx,itm,its/2,ip);
          for(iv=ml-1; iv>=1; iv--) {
            if(nl[iv] <= 0 || pl[iv] >= 2.005) continue;
            p=pl[iv]*pl[iv]-2.0;
            q=1.0;
            for(istep=1; istep<=20; istep++) {
              synth2(&aa[1],&bb[1],m,p,q,im);
              pqerr(&bb[1],m,p,q,im,&ers,&fx);
              po=p;
              p=xmin(p,fx,0.001,istep,&ivy,buf);
              if(fabs(p-po) <= epsx) break;
            }
            bairst(&aa[1],&bb[1],m,&p,&q,im,epsx,efm,ip);
            if(fabs(q-1.0) > 0.125 || fabs(p) > 2.25) continue;
            check2(&aa[1],&bb[1],m,&mb,p,q,im,efm,ip);
            if(m == mb) continue;
            putx(0.5*p*x,sqrt(q-0.25*p*p)*x,m-mb,&rr[1],&kr[1],&ii,eps);
            nl[iv]=0;
            if(ii > ir) goto L500;
          }
/*        +------------------------------------------------------+    */
/*        | find complex roots : real part between -x/2 and +x/2 |    */
/*        +------------------------------------------------------+    */
          efm=efm*4.0;
          if(kkk == 1)
            graeff(&ac[1],&ka[1],&bb[1],&kb[1],&pc[1],&nc[1],&ac[1]
                  ,mc,epsx,itm,its/2,ip);
          for(iv=mc-1; iv>=1; iv--) {
            if(nc[iv] <= 0 || pc[iv] > 2.010) continue;
            p=pc[iv];
            q=1.0;
            for(istep=1; istep<=20; istep++) {
              synth2(&aa[1],&bb[1],m,p,q,im);
              pqerr(&bb[1],m,p,q,im,&ers,&fx);
              po=p;
              p=xmin(p,fx,0.001,istep,&ivy,buf);
              if(fabs(p-po) <= epsx) break;
            }
            for(kk=1; kk<=2; kk++) { if(kk == 2) p=-p;
              bairst(&aa[1],&bb[1],m,&p,&q,im,epsx,efm,ip);
              if(fabs(q-1.) > 0.125 || fabs(p) > 2.25) continue;
              check2(&aa[1],&bb[1],m,&mb,p,q,im,efm,ip);
              if(m == mb) continue;
              putx(.5*p*x,sqrt(q-.25*p*p)*x,m-mb,&rr[1],&kr[1],&ii,eps);
              nc[iv]=0;
              if(ii > ir) goto L500;
            }
          }
/*        +------------------------------------------------------+    */
/*        | increase the error tolerance efm                     |    */
/*        +------------------------------------------------------+    */
          efm=efm*2.5;
          if(ii > ir) goto L500;
        }
        printf("\nNo enough accurate roots found for %16.8lf",x);
 L500:;}
/*    +----------------------------------------------------------+    */
/*    | output the answers                                       |    */
/*    +----------------------------------------------------------+    */
      printf("\n       i               real.x(i)");
      printf("               imag.x(i)      no\n");
      for(ii=1; ii<=m-1; ii++) {
        if(kr[ii] <= 0) continue;
        if(kr[ii+1] != 0) {
         printf("\n%8ld%24.15le%32ld",ii,rr[ii],kr[ii]);
        } else {
         printf("\n%8ld%24.15le%24.15le%8ld",ii,rr[ii],rr[ii+1],kr[ii]);
        }
      }
      return(0);
}
/**********************************************************************/
      int bairst(double aa[],double bb[],long m,double *pp,double *pq
                ,long im,double eps,double efm,long ip) {
/*    int bairst(aa,bb,m,pp,pq,im,eps,efm,ip)
      double aa[],bb[],*pp,*pq,eps,efm; long m,im,ip; {               */
/*    ============================================================    */
      double p,q,dp,dq,d,ee,b0,b1;
      long   i;
      int    synth2();
      --aa; --bb;
      p=*pp; q=*pq;
/*    ============================================================    */
/*    input   : aa(m),m,p,q,im,eps,efm,ip                             */
/*    output  : p,q in the factor (x*x-p*x+q)                         */
/*    working : bb(m)                                                 */
/*    ------------------------------------------------------------    */
/*    by Bairstow's method                                            */
/*    ============================================================    */
      if(m <= 3) return(0);
      for(i=1; i<=20; i++) {
/*      +--------------------------------------------------------+    */
/*      | [x*x-p*x+q][b(1)*x**(m-3)+..+b(m-2)]+b(m-1)*(x-p)+b(m) |    */
/*      +--------------------------------------------------------+    */
        synth2(&aa[1],&bb[1],m,p,q,2L);
/*      ----------------------------------------------------------    */
        b0=bb[m];
        b1=bb[m-1];
        ee=sqrt(fabs(b0*b0-p*b0*b1+q*b1*b1));
/*      +--------------------------------------------------------+    */
/*      | [x*x-p*x+q][c(1)*x**(m-4)+..+c(m-3)]+c(m-2)*(x-p)+c(m-1)    */
/*      +--------------------------------------------------------+    */
        synth2(&bb[1],&bb[1],m-1,p,q,2L);
/*      +--------------------------------------------------------+    */
/*      | / c(m-1)  c(m-2) \ / -dp \   / b( m ) \                |    */
/*      | |                | |     | = |        |                |    */
/*      | \ c(m-2)  c(m-3) / \ +dq /   \ b(m-1) /                |    */
/*      +--------------------------------------------------------+    */
        d=bb[m-1]*bb[m-3]-bb[m-2]*bb[m-2];
        if(fabs(d) < eps) printf("\nBairst : |d| < eps");
        dp=(bb[m-2]*b1-bb[m-3]*b0)/d;
        dq=(bb[m-1]*b1-bb[m-2]*b0)/d;
        p=p+dp;
        q=q+dq;
        if(ip/32*2 != ip/16) {
          printf("\n Bairst %24.15le%14.5le%14.5le%14.5le",p,q,dp,dq);
          printf("\n Bairst %24.15le%14.5le%14.5le%14.5le",d,ee,b1,b0);
        }
        if(fabs(dp)+fabs(dq) <= eps) {*pp=p; *pq=q; return(0);}
/*      +--------------------------------------------------------+    */
/*      | for general use following statement should be deleted  |    */
/*      +--------------------------------------------------------+    */
        if(fabs(q-1.0) > 0.125 || fabs(p) > 2.25) {
          *pp=p; *pq=q; return(0);
        }
      }
      printf("\nBairst : not converge in 20 iteration");
      *pp=p; *pq=q; return(0);
}
/**********************************************************************/
      int putx(double xr,double xi,long n
              ,double rr[],long kr[],long *pii,double eps) {
/*    int putx(xr,xi,n,rr,kr,pii,eps)
      double xr,xi,rr[],eps; long kr[],n,*pii; {                      */
/*    ============================================================    */
      long  i,ii;
      --rr; --kr;
      ii=*pii;
/*    ============================================================    */
/*    test if (xr,xi) already exist in  rr(1:ii-1)                    */
/*    ============================================================    */
      if(n <= 0) return(0);
      for(i=1; i<=ii-1; i++) {
        if(kr[i] <= 0) continue;
        if(kr[i+1] != 0) {
           if(fabs(xr-rr[i])+fabs(xi-rr[i+1]) <= eps) return(0);
        } else {
           if(fabs(xr-rr[i]) <= eps) return(0);
        }
      }
/*    ------------------------------------------------------------    */
      rr[ii]=xr;
      kr[ii]=n;
      if(xi != 0.0) {
        rr[ii+1]=xi;
        kr[ii+1]=0;
      }
      ii=ii+n;
      printf("\nputx %8ld%24.15le%24.15le",ii,xr,xi);
      *pii=ii; return(0);
}
/**********************************************************************/
      int check2(double aa[],double bb[],long ma,long *mb
                ,double p,double q,long im,double efm,long ip) {
/*    int check2(aa,bb,ma,mb,p,q,im,efm,ip)
      double aa[],bb[],p,q,efm; long ma,*mb,im,ip; {                  */
/*    ============================================================    */
      double err,ers;
      long   i,m;
      int    synth2(),pqerr();
      --aa; --bb;
/*    ============================================================    */
/*    check # of the factor (x*x - p*x + q)   --->  (mb-ma)/2         */
/*            or the factor (x - p)           --->  (mb-ma)           */
/*    ------------------------------------------------------------    */
/*    input   : aa(ma),ma,p,q,im,efm,ip                               */
/*    output  : mb                                                    */
/*    working : bb(ma)                                                */
/*    ============================================================    */
      *mb=ma;
      for(m=ma; m>=im+1; m=m-im) {
        if(m == ma) {
          synth2(&aa[1],&bb[1],*mb,p,q,im);
        } else {
          synth2(&bb[1],&bb[1],*mb,p,q,im);
        }
        pqerr(&bb[1],*mb,p,q,im,&ers,&err);
        if(ip/64*2 != ip/32) {
          for(i=1; i<=*mb; i++)
            printf("\n%8ld%16.7le%16.7le",i,aa[i],bb[i]);
        }
        if(ip/32*2 != ip/16) {
          printf("\ncheck %5ld%24.15le%12.3le%12.3le%12.3le"
                                          ,*mb,p,q,err,efm);
        }
        if(err > efm) return(0);
        *mb=*mb-im;
      }
      return(0);
}
/**********************************************************************/
      int synth2(double aa[],double bb[],long m
                ,double p,double q,long im) {
/*    int synth2(aa,bb,m,p,q,im) double aa[],bb[],p,q; long m,im; {   */
/*    ============================================================    */
      long   i;
      --aa; --bb;
/*    ============================================================    */
/*i   a(1)*x**(m-1)+..+a(m)                                           */
/*o   =  (x-p)  *  (b(1)*x**(m-2)+..+b(m-1)) + b(m)                   */
/*o   =(x*x-p*x+q)*(b(1)*x**(m-3)+..+b(m-2)) + b(m-1)*(x-p) + b(m)    */
/*    ------------------------------------------------------------    */
/*    input   : aa(m),m,p,q,im  (im=1 or 2)                           */
/*    output  : bb(m)                                                 */
/*    ============================================================    */
      bb[1]=aa[1];
      if(im == 1) {
        for(i=2; i<=m; i++) {
          bb[i]=aa[i]+bb[i-1]*p;
        }
      } else {
        bb[2]=aa[2]+p*bb[1];
        for(i=3; i<=m; i++) {
          bb[i]=aa[i]+bb[i-1]*p-bb[i-2]*q;
        }
      }
      return(0);
}
/**********************************************************************/
      int pqerr(double bb[],long m,double p,double q,long im
               ,double *es,double *er) {
/*    int pqerr(bb,m,p,q,im,es,er)
      double bb[],p,q,*es,*er; long m,im;                             */
/*    ============================================================    */
      --bb;
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | |(x-p)*b1+b0)|**2=((x-p)*b1+b0)*((conj.x-p)*b1+b0)       |    */
/*    | =(b0-p*b1)**2+(x+conj.x)*(b0-p*b1)*b1+|x|**2*b1**2       |    */
/*    | =(b0-p*b1)**2+    p     *(b0-p*b1)*b1+ q    *b1**2       |    */
/*    | =b0**2-p*b0*b1+q*b1**2                                   |    */
/*    +----------------------------------------------------------+    */
      if(im == 1) {
        *es=bb[m];
      } else {
        *es=bb[m]*bb[m]-p*bb[m]*bb[m-1]+q*bb[m-1]*bb[m-1];
      }
      *er=fabs(*es);
      return(0);
}
/**********************************************************************/
      int polyft(double ao[],double rr[],long kr[],double a[],long m
         ,double epsx,double epsf,long itm,long its,long ip,long nf) {
/*    int polyft(ao,rr,kr,a,m,epsx,epsf,itm,its,ip,nf)
      double ao[],rr[],a[],epsx,epsf; long kr[],m,itm,its,ip,nf; {    */
/*    ============================================================    */
/*    dimension ao(m),rr(m),kr(m),a(m,10)                             */
      double *a1,*a2,*a3,*a4,*a5,*a6; int fftang();
      a1=a; a2=a1+m; a3=a2+m; a4=a3+m; a5=a4+m; a6=a5+nf/2+1;
/*    ============================================================    */
      fftang(ao,rr,kr,a1,a2,a3,a4,a5,a6,m,epsx,epsf,itm,its,ip,nf);
      return(0);
}
/**********************************************************************/
      int fftang(double ao[],double rr[],long kr[],double aa[],long ka[]
                            ,double bb[],long kb[],double ff[],long ll[]
                            ,long m,double epsx,double epsf
                            ,long itm,long its,long ip,long nf) {
/*    int fftang(ao,rr,kr,aa,ka,bb,kb,ff,ll,m,epsx,epsf,itm,its,ip,nf)
      double ao[],rr[],aa[],bb[],ff[],epsx,epsf;
      long   kr[],ka[],kb[],ll[],m,itm,its,ip,nf; {                   */
/*    ============================================================    */
      double p,q,x,dx,dl,dr,am,xo,xx,fx,efm,ffm,eps,ers;
      double buf[14],base=1024.0;
      long   i,k,ii,il,im,in,ki,ie,ir,is,iu,iv,kx,kfm,mb;
      int    istep,ivy,inv=-2;
      double xmin(); int fftr(),graeff(),bairst();
      int    normal(),synth2(),check2(),pqerr(),putx();
      --ao; --rr; --kr; --aa; --ka; --bb; --kb; --ff; --ll;
/*    ============================================================    */
/*    input   : ao(m),m,epsx,epsf,itm,its,ip,nf                       */
/*    output  : rr(m),kr(m)                                           */
/*    working : aa(m),ka(m),bb(m),kb(m),ff(nf+2),ll(nf/2+1)           */
/*    ------------------------------------------------------------    */
/*    ao(i) = coefficient of x**(m-i)                                 */
/*    ------------------------------------------------------------    */
/*    if kr(i) > 0 and kr(i+1) != 0 then                              */
/*         rr(i) = real root                                          */
/*         kr(i) = its multiplicity                                   */
/*    ------------------------------------------------------------    */
/*    if kr(i) > 0 and kr(i+1) == 0 then                              */
/*         (rr(i),+-rr(i+1)) = complex roots                          */
/*         kr(i) = its multiplicity (always even)                     */
/*    ------------------------------------------------------------    */
/*    by Graeffe's method and FFT and Bairstow's method               */
/*    ============================================================    */
      graeff(&aa[1],&ka[1],&bb[1],&kb[1],&rr[1],&kr[1],&ao[1]
            ,m,epsx,itm,its,ip);
/*    ------------------------------------------------------------    */
      ii=1;
      for(il=1; il<=m-1; il++) {
        if(kr[il] <= 0 || il < ii) continue;
        ir=il+kr[il]-1;
/*      ----------------------------------------------------------    */
        ii=il;
        x=rr[ii];
        if(x == 0.0) continue;
/*      ----------------------------------------------------------    */
        for(i=1; i<=nf+2; i++) {
          ff[i]=0.0;
        }
/*      +--------------------------------------------------------+    */
/*      | scale the ii-th root to unit magnitude                 |    */
/*      +--------------------------------------------------------+    */
        kfm=0;
        xx=1.0;
        kx=0;
        for(i=m; i>=1; i--) {
          aa[i]=ao[i]*xx;
          ka[i]=kx;
          normal(&aa[i],&ka[i]);
          if(ka[i] > kfm && aa[i] != 0.0) kfm=ka[i];
          xx=xx*x;
          normal(&xx,&kx);
        }
/*      +--------------------------------------------------------+    */
/*      | ffm = sum of the abs of the coefficients               |    */
/*      +--------------------------------------------------------+    */
        ffm=0.0;
        for(i=1; i<=m; i++) {
          ki=ka[i]-kfm;
          if(ki != 0 && aa[i] != 0.0) aa[i]=aa[i]*powdl(base,ki);
          ffm=ffm+fabs(aa[i]);
          ff[i]=aa[i];
        }
        efm=epsf*ffm;
        eps=epsx*100.0;
/*      +--------------------------------------------------------+    */
/*      | find real roots +x or -x                               |    */
/*      +--------------------------------------------------------+    */
        im=1;
        p=1.0;
        q=0.0;
        for(k=1; k<=2; k++) {
          check2(&aa[1],&bb[1],m,&mb,p,q,im,efm,ip);
          putx(p*x,q,m-mb,&rr[1],&kr[1],&ii,eps);
          if(ii > ir) goto L85;
          p=-p;
        }
/*      +--------------------------------------------------------+    */
/*      | compute function values along the unit circle by fft   |    */
/*      +--------------------------------------------------------+    */
        fftr(&ff[1],&ff[1],(int)nf,inv);
        for(i=1; i<=nf/2+1; i++) {
          am=sqrt(ff[2*i-1]*ff[2*i-1]+ff[2*i]*ff[2*i]);
          if(ip/256*2 != ip/128) printf("\n%8ld%16.7le%16.7le%16.7le"
                                            ,i,am,ff[2*i-1],ff[2*i]);
          ff[i]=am;
        }
/*      +--------------------------------------------------------+    */
/*      | find locations with local minimum errors               |    */
/*      +--------------------------------------------------------+    */
        in=0;
        dr=ff[2]-ff[1];
        for(i=2; i<=nf/2; i++) {
          dl=dr;
          dr=ff[i+1]-ff[i];
          if(dl > 0.0 || dr < 0.0) continue;
          in=in+1;
          ll[in]=i;
          if(ip/128*2 != ip/64) printf("\n%8ld%16.7le%16.7le%16.7le"
                                          ,i,ff[i-1],ff[i],ff[i+1]);
        }
/*      +--------------------------------------------------------+    */
/*      | index sort according to errors                         |    */
/*      +--------------------------------------------------------+    */
        is=in;
        do {
          ie=is-1;
          for(i=1; i<=ie; i++) {
            iu=ll[i];
            iv=ll[i+1];
            if(ff[iu] <= ff[iv]) continue;
            ll[i]=iv;
            ll[i+1]=iu;
            is=i;
          }
        } while(is <= ie);
/*      +--------------------------------------------------------+    */
/*      | refine the complex roots by minimizing the errors      |    */
/*      | then by Bairstow's method                              |    */
/*      +--------------------------------------------------------+    */
        im=2;
        dx=2.0/nf;
        for(iv=1; iv<=in; iv++) {
          xx=dx*(ll[iv]-1);
          for(istep=1; istep<=12; istep++) {
            p=2.0*cos(xx*3.1415926535897932);
            q=1.0;
            synth2(&aa[1],&bb[1],m,p,q,im);
            pqerr(&bb[1],m,p,q,im,&ers,&fx);
            xo=xx;
            xx=xmin(xx,fx,0.5*dx,istep,&ivy,buf);
            if(fabs(xx-xo) <= epsx) break;
          }
/*        --------------------------------------------------------    */
          bairst(&aa[1],&bb[1],m,&p,&q,im,epsx,efm,ip);
          if(fabs(q-1.0) > 0.125 || fabs(p) > 2.25) continue;
          check2(&aa[1],&bb[1],m,&mb,p,q,im,efm,ip);
          if(m == mb) continue;
          putx(0.5*p*x,sqrt(q-0.25*p*p)*x,m-mb,&rr[1],&kr[1],&ii,eps);
          if(ii > ir) break;
        }
 L85:;}
/*    +----------------------------------------------------------+    */
/*    | output the answers                                       |    */
/*    +----------------------------------------------------------+    */
      printf("\n       i               real.x(i)");
      printf("               imag.x(i)      no\n");
      for(ii=1; ii<=m-1; ii++) {
        if(kr[ii] <= 0) continue;
        if(kr[ii+1] != 0) {
         printf("\n%8ld%24.15le%32ld",ii,rr[ii],kr[ii]);
        } else {
         printf("\n%8ld%24.15le%24.15le%8ld",ii,rr[ii],rr[ii+1],kr[ii]);
        }
      }
      return(0);
}
/**********************************************************************/
      int polyct(double ao[],double rr[],long kr[],double a[],long m2
                ,double epsx,double epsf,long itm,long its,long ip) {
/*    int polyct(ao,rr,kr,a,m2,epsx,epsf,itm,its,ip)
      double ao[],rr[],a[],epsx,epsf; long kr[],m2,itm,its,ip; {      *
/*    ============================================================    */
      double xr,xi,sr,si;
      long   i,k,n,m,ii,ix,iy,ir,mm; int polyrt();
      --ao; --rr; --kr; --a;
/*    ============================================================    */
/*    input   : ao(m2),m2,epsx,epsf,itm,its,ip                        */
/*    output  : rr(m2),kr(m2)                                         */
/*    working : a(mm*14)         (mm=m2-1, m=m2/2, m2 is even)        */
/*    ------------------------------------------------------------    */
/*    (ao(2*i-1),ao(2*i)) = complex coefficient of x**(m-i)           */
/*    ------------------------------------------------------------    */
/*    a(i) = coefficient of y**(mm-i)                                 */
/*         half # of roots y = roots x                                */
/*         half # of roots y = conjugate of roots x                   */
/*    ------------------------------------------------------------    */
/*    if kr(i) > 0 and kr(i+1) < 0 then                               */
/*         rr(i) = real root                                          */
/*         kr(i) = its multiplicity                                   */
/*    ------------------------------------------------------------    */
/*    if kr(i) > 0 and kr(i+1) == 0 then                              */
/*         (rr(i),+-rr(i+1)) = complex roots                          */
/*         kr(i) = its multiplicity (always even)                     */
/*    ------------------------------------------------------------    */
/*    double the degree of the polynomial such that                   */
/*    the roots include the original roots and their conjugates       */
/*    so the coefficients are all real                                */
/*    ============================================================    */
/*    m=m2/2;                                                         */
      mm=m2-1;
      for(i=1; i<=mm; i=i+2) {
        ix=i;
        iy=i;
        sr=0.0;
        si=0.0;
        while(ix > 0 && iy < mm) {
          iy=iy+2;
          si=si+ao[ix]*ao[iy]+ao[ix+1]*ao[iy+1];
          ix=ix-2;
          if(ix > 0) {
            sr=sr+ao[ix]*ao[iy]+ao[ix+1]*ao[iy+1];
          }
        }
        a[i  ]=2.0*sr+ao[i]*ao[i]+ao[i+1]*ao[i+1];
        a[i+1]=2.0*si;
      }
/*    ------------------------------------------------------------    */
      polyrt(&a[1],&rr[1],&kr[1],&a[mm+1],mm,epsx,epsf,itm,its,ip);
/*    ------------------------------------------------------------    */
      printf("\n       i               real.x(i)");
      printf("               imag.x(i)      no\n");
      for(ii=1; ii<=mm-1; ii++) {
        if(kr[ii] <= 0) continue;
        xr=rr[ii];
        if(kr[ii+1] == 0) {
          xi=rr[ii+1];
          ix=2;
        } else {
          xi=0.0;
          ix=1;
        }
/*      ----------------------------------------------------------    */
        for(ir=1; ir<=ix; ir++) {
          for(i=1; i<=m2; i++) {
            a[i]=ao[i];
          }
          for(k=mm; k>=3; k=k-2) {
            for(i=3; i<=k; i=i+2) {
              a[i  ]=a[i  ]+a[i-2]*xr-a[i-1]*xi;
              a[i+1]=a[i+1]+a[i-2]*xi+a[i-1]*xr;
            }
            if(sqrt(a[k]*a[k]+a[k+1]*a[k+1]) > epsf) break;
          }
/*        --------------------------------------------------------    */
          n=(mm-k)/2;
          printf("\n%8ld%24.15le%24.15le%8ld",ii,xr,xi,n);
          xi=-xi;
        }
      }
      return(0);
}
/**********************************************************************/
      double powdl(double b,long i) {
/*    double powdl(b,i) double b; long i; {                           */
/*    ============================================================    */
      double p;
/*    ============================================================    */
/*    return b**i                                                     */
/*    ============================================================    */
      if(i < 0) {i=-i; b=1.0/b;}
      if((i & 1) != 0) p=b; else p=1.0;
      while ((i >>= 1) != 0) {
        b=b*b;
        if((i & 1) != 0) p=p*b;
      }
      return(p);
}
/**********************************************************************/
      int printv(double b[],long n) {
/*    int printv(b,n) double b[]; long n; {                           */
/*    ============================================================    */
      int i;
/*    ============================================================    */
      for(i=0; i<n; i++) {
        if(i%5 == 0) printf("\n");
        printf("%15.6le",b[i]);
      }
      return(0);
}
/**********************************************************************/
      int printk(long b[],long n) {
/*    int printk(b,n) long b[]; long n; {                             */
/*    ============================================================    */
      int i;
/*    ============================================================    */
      for(i=0; i<n; i++) {
        if(i%5 == 0) printf("\n");
        printf("%15ld",b[i]);
      }
      return(0);
}
/**********************************************************************/
