#include <math.h>
/**********************************************************************/
      int adamsc(int n,int (*ff)(),double dt,double *pt
                ,double yi[],double yo[],double x[],int mmax,int *muse
                ,double epsreq,double *epsold,int id[]) {
/*    int adamsc(n,ff,dt,pt,yi,yo,x,mmax,muse,epsreq,epsold,id)
      double dt,*pt,yi[],yo[],x[],epsreq,*epsold;
      int    n,(*ff)(),mmax,*muse,id[]; {                             */
/*    ============================================================    */
/*    dimension yi[n],yo[n],x[n,16],id[3]                             */
      double t,t1,t2,t4,ht;
      double *x1,*x2,*x3,*x4,*x5,*x6,*x7,*x8,*x9,*x10;
      double *x11,*x12,*x13,*x14,*x15,*x16;
      int    i,istep,musc,maxc=0;  int adams(),rungec();
      --id;
      x1=x; x2=x1+n; x3=x2+n; x4=x3+n; x5=x4+n; x6=x5+n; x7=x6+n;
      x8=x7+n; x9=x8+n; x10=x9+n; x11=x10+n; x12=x11+n; x13=x12+n;
      x14=x13+n; x15=x14+n; x16=x15+n;
      t=*pt;
/*    ============================================================    */
/*    input t,yi(n) at t=ti;          output t,yo(n) at t=to=ti+dt    */
/*    input id(3)=-3 for the first step, then don't change id(1:3)    */
/*    yi(n) & yo(n) can be the same location : loc.yo(n)=loc.yi(n)    */
/*    ------------------------------------------------------------    */
/*i   n      = number of dependent variables                          */
/*s   ff     = subroutine to compute f(n) for given t & y(n)          */
/*i   dt     = time_step = final_time - initial_time                  */
/*o   t      = initial time ti & final time to=ti+dt                  */
/*i   yi(n)  = y_i(ti)                                                */
/*o   yo(n)  = y_i(to)                                                */
/*i   x(n,1:3) = f3(y3,t3),f2(y2,t2),f1(y1,t1) : tk=ti-k*dt           */
/*o   x(n,1:3) = f2(y2,t2),f1(y1,t1),fi(yi,ti) : yk=y_i(tk)           */
/*w   x(n,16)  = buffers x(9*n),x(12*n),x(16*n) for mmax=(0,1,2)      */
/*w            : x(n,6:8) for subroutine adams(...,fp,yc,yp)          */
/*w            : x(n,9:9) for yi(n) in case of loc.yo(n)=loc.yi(n)    */
/*    -----------------------------------------------------------     */
/*    x1            x2           x3             x4             x5     */
/*      id() = 1:         x10    x3     x11     x4     x12     x5     */
/*      id() = 2:                   x13 x11 x14 x4 x15 x12 x16 x5     */
/*              :     ------------- -------------- --------------     */
/*    id(3)  = 0:2  ===>  id(1)         id(2)          id(3)          */
/*    -----------------------------------------------------------     */
/*    maxc   = additional corrector cycles allowed = 0                */
/*    musc   = actual corrector cycles used                           */
/*i   mmax   = allowed max_steps = 2**mmax                            */
/*o   muse   = actual used_steps = 2**muse                            */
/*i   epsreq = req. epsilon such that max.|dyc/yc(i)| < epsreq        */
/*o   epsold = max. epsilon = max_{i=1}^n |1-yp(i)/yc(i)|*19/270      */
/*    to adjust dt : dt_new = (epsreq/epsold)**(1/4) * dt / 2**muse   */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | for the initial 3-steps by rungec, also set id(1:3)=0    |    */
/*    +----------------------------------------------------------+    */
      if(id[3] < 0) {
        id[3]=id[3]+1;
        istep=id[3]+3;
        if(istep <= 0) {printf("\n adamsc: id[3] < -3"); exit(1);}
        id[istep]=0;
        rungec(n,ff,dt,pt,yi,yo,&x[istep*n-n],mmax,muse,epsreq,epsold);
        return(0);
      }
/*    +----------------------------------------------------------+    */
/*    | find fi(n) = x(n,4)                                      |    */
/*    | save yi(n) in x(n,9) in case of loc.yo(n)=loc.yi(n)      |    */
/*    +----------------------------------------------------------+    */
      ff(t,yi,x4,n);
      for(i=0; i<n; i++) {
        x9[i]=yi[i];
      }
/*    +----------------------------------------------------------+    */
/*    | perform 1_step at dt_step_size                           |    */
/*    +----------------------------------------------------------+    */
 L100:if(id[3] > 0) goto L200;
      t1=t;
      adams(n,ff,dt,&t1,yi,yo,x1,x2,x3,x4,x5,x6,x7,x8
                             ,maxc,&musc,epsreq,epsold);
      if(*epsold <= epsreq || mmax <= 0) goto L500;
      id[3]=1;
      for(i=0; i<n; i++) {
        yi[i]=x9[i];
      }
/*    +----------------------------------------------------------+    */
/*    | perform 2_steps at dt/2_step_size                        |    */
/*    +----------------------------------------------------------+    */
 L200:if(id[3] > 1) goto L400;
      if(id[1] < 1) {
        id[1]=1;
        for(i=0; i<n; i++) {
          x10[i]=(-x1[i]+9*(x2[i]+x3[i])-x4[i])/16;
        }
      }
      if(id[2] < 1) {
        id[2]=1;
        for(i=0; i<n; i++) {
          x11[i]=(x2[i]-4*x10[i]+6*x3[i]+x4[i])/4;
        }
      }
      t2=t;
      ht=dt*0.5;
      adams(n,ff,ht,&t2,yi,yo,x10,x3,x11,x4,x12,x6,x7,x8
                             ,maxc,&musc,epsreq,epsold);
      ff(t2,yo,x12,n);
      adams(n,ff,ht,&t2,yo,yo,x3,x11,x4,x12,x5,x6,x7,x8
                             ,maxc,&musc,epsreq,epsold);
      if(*epsold <= epsreq || mmax <= 1) goto L500;
      id[3]=2;
      for(i=0; i<n; i++) {
        yi[i]=x9[i];
      }
/*    +----------------------------------------------------------+    */
/*    | perform 4_steps at dt/4_step_size                        |    */
/*    +----------------------------------------------------------+    */
 L400:if(id[3] > 2) goto L500;
      if(id[2] < 1) {printf("\n adamsc: internal error !"); exit(1);}
      if(id[2] < 2) {
        id[2]=2;
        for(i=0; i<n; i++) {
          x13[i]=(-x10[i]+9*(x3[i]+x11[i])-x4[i])/16;
          x14[i]=( x10[i]-5*(x3[i]-x4[i])+15*x11[i])/16;
        }
      }
      t4=t;
      ht=dt*0.25;
      adams(n,ff,ht,&t4,yi,yo,x13,x11,x14,x4,x15,x6,x7,x8
                             ,maxc,&musc,epsreq,epsold);
      ff(t4,yo,x15,n);
      adams(n,ff,ht,&t4,yo,yo,x11,x14,x4,x15,x12,x6,x7,x8
                             ,maxc,&musc,epsreq,epsold);
      ff(t4,yo,x12,n);
      adams(n,ff,ht,&t4,yo,yo,x14,x4,x15,x12,x16,x6,x7,x8
                             ,maxc,&musc,epsreq,epsold);
      ff(t4,yo,x16,n);
      adams(n,ff,ht,&t4,yo,yo,x4,x15,x12,x16,x5,x6,x7,x8
                             ,maxc,&musc,epsreq,epsold);
      if(*epsold <= epsreq) goto L500;
      id[3]=3;
/*    +----------------------------------------------------------+    */
/*    | shift one step                                           |    */
/*    +----------------------------------------------------------+    */
 L500:*muse=id[3]; if(*muse > 2) *muse=2;
      id[1]=id[2];
      id[2]=id[3];
      id[3]=id[3]-1; if(id[3] < 0) id[3]=0;
      t=t+dt;
/*    +----------------------------------------------------------+    */
/*    | shift f_values for dt_step_size                          |    */
/*    +----------------------------------------------------------+    */
      for(i=0; i<n; i++) {
        x1[i]=x2[i];
        x2[i]=x3[i];
        x3[i]=x4[i];
      }
/*    +----------------------------------------------------------+    */
/*    | shift f_values for dt/2_step_size & dt/4_step_size       |    */
/*    +----------------------------------------------------------+    */
      if(id[1] >= 1) {
        for(i=0; i<n; i++) {
          x10[i]=x11[i];
        }
      }
      if(id[2] == 1) {
        for(i=0; i<n; i++) {
          x11[i]=x12[i];
        }
      } else if(id[2] >= 2) {
        for(i=0; i<n; i++) {
          x11[i]=x12[i];
          x13[i]=x15[i];
          x14[i]=x16[i];
        }
      }
      *pt=t; return(0);
}
/**********************************************************************/
      int adams(int n,int (*ff)(),double dt,double *pt
         ,double yi[],double yo[],double f3[],double f2[],double f1[]
         ,double fi[],double fc[],double fp[],double yc[],double yp[]
         ,int maxc,int *musc,double epsreq,double *epsold) {
/*    int adams(n,ff,dt,pt,yi,yo,f3,f2,f1,fi,fc,fp,yc,yp
                          ,maxc,musc,epsreq,epsold)
      double yi[],yo[],f3[],f2[],f1[],fi[],fc[],fp[],yc[],yp[];
      double dt,*pt,epsreq,*epsold; int (*ff)(),maxc,*musc; {         */
/*    ============================================================    */
      double dy,dt24,dt924,f19270,t,tmp;
      int    i;
      t=*pt;
/*    ------------------------------------------------------------    */
/*    input  t,yi(n),fi(n) at t=ti & f3(n),f2(n),f1(n) at t-3dt,...   */
/*    output t,yo(n)       at t=to=ti+dt                              */
/*    yi(n) & yo(n) can be the same location : loc.yo(n)=loc.yi(n)    */
/*    ------------------------------------------------------------    */
/*i   n      = number of dependent variables                          */
/*s   ff     = subroutine to compute f(n) for given t & y(n)          */
/*i   dt     = time_step = final_time - initial_time                  */
/*o   t      = initial time ti & final time to=ti+dt                  */
/*i   yi(n)  = y_i(ti)                                                */
/*o   yo(n)  = y_i(to)                                                */
/*i   f3(n),f2(n),f1(n),fi(n) = f_i(y3,t3),..,f_i(y1,t1),f_i(yi,ti)   */
/*w   fc(n),yc(n) = f_i(yc,to),y_i(to) corrector                      */
/*w   fp(n),yp(n) = f_i(yp,to),y_i(to) predictor                      */
/*i   maxc   = additional corrector cycles allowed                    */
/*o   musc   = actual corrector cycles used                           */
/*i   epsreq = req. epsilon such that max.|dyc/yc(i)| < epsreq        */
/*o   epsold = max. epsilon = max_{i=1}^n |1-yp(i)/yc(i)|*19/270      */
/*    ============================================================    */
      dt24=dt/24;
      dt924=9*dt24;
      f19270=19/270.0;
      t=t+dt;
/*    +----------------------------------------------------------+    */
/*    | find the predictor yp(n) & fp(n)                         |    */
/*    +----------------------------------------------------------+    */
      for(i=0; i<n; i++) {
        yp[i]=yi[i]+(55*fi[i]-59*f1[i]+37*f2[i]-9*f3[i])*dt24;
      }
      ff(t,yp,fp,n);
/*    +----------------------------------------------------------+    */
/*    | find the corrector yc(n)                                 |    */
/*    +----------------------------------------------------------+    */
      for(i=0; i<n; i++) {
        yc[i]=yi[i]+(9*fp[i]+19*fi[i]-5*f1[i]+f2[i])*dt24;
      }
/*    +----------------------------------------------------------+    */
/*    | find the convergent corrector                            |    */
/*    +----------------------------------------------------------+    */
      for(*musc=1; *musc<=maxc; (*musc)++) {
        ff(t,yc,fc,n);
        *epsold=0.0;
        for(i=0; i<n; i++) {
          dy=(fc[i]-fp[i])*dt924;
          fp[i]=fc[i];
          yc[i]=yc[i]+dy;
          if(yc[i]!=0) {if((tmp=fabs(dy/yc[i])) > *epsold) *epsold=tmp;}
        }
        if(*epsold <= epsreq) break;
      }
/*    +----------------------------------------------------------+    */
/*    | find accepted yo from yc and yp                          |    */
/*    +----------------------------------------------------------+    */
      *epsold=0.0;
      for(i=0; i<n; i++) {
        dy=(yc[i]-yp[i])*f19270;
        yo[i]=yc[i]-dy;
        if(yo[i] != 0) {if((tmp=fabs(dy/yo[i])) > *epsold) *epsold=tmp;}
      }
/*    ff(t,yo,fc,n);                                                  */
      *pt=t; return(0);
}
/**********************************************************************/
