/* #define ADAMS */
/* #define SAVEn */
#include <stdio.h>
#include <ctype.h>
#include <math.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
#ifdef SAVEn
      double y[100][2];
#else
      double y[2];
#endif
#ifdef ADAMS
      double x[16][2]; int id[3]; int adamsc();
#else
      double x[7][2];             int rungec();
#endif
      double o,d,dt,yt,wd,edt,ewdt,epsreq,epsold=0.0;
      int    istep,nstep,mmax,muse=0; int fun();
      double t=0.0,u0=1.0,v0=2.0,w=3.0,xi=0.05; int n=2;
/*    ============================================================    */
/*    y''(t) + 2*xi*w*y'(t) + w*w*y(t) = 0 with y(0)=u0, y'(0)=v0     */
/*    ============================================================    */
      if(argc<3) {printf("Usage : ratt infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
      freeii(&mmax,fp_r); freer8(&dt,fp_r); freer8(&epsreq,fp_r);
      if(epsreq == 0.0) epsreq=0.0001;
      if(dt == 0.0) dt=0.2;
      nstep=3.01/dt+1;
/*    ------------------------------------------------------------    */
#ifdef SAVEn
      y[0][0]=u0;
      y[0][1]=v0;
#else
      y[0]=u0;
      y[1]=v0;
#endif
#ifdef ADAMS
      id[2]=-3;
#endif
/*    ------------------------------------------------------------    */
      fprintf(fp_w,"\n    t        v            y           yt");
      fprintf(fp_w,"           y-yt       epsold*yt  muse");
/*    +----------------------------------------------------------+    */
/*    | yt = exact solution of y(1)                              |    */
/*    +----------------------------------------------------------+    */
      d=sqrt(1.0-xi*xi);
      o=atan(xi/d);
      wd=w*d;
      edt=1.0/d;
      ewdt=exp(-xi*w*dt);
      for(istep=0; istep<nstep; istep++) {
        yt=edt*(u0*cos(wd*t-o)+v0*sin(wd*t)/w);
        edt=edt*ewdt;
/*      ----------------------------------------------------------    */
#ifdef SAVEn
        fprintf(fp_w,"\n%6.3lf%13.4le%13.4le%13.4le%13.4le%13.4le%4d"
        ,t,y[istep][1],y[istep][0],yt,y[istep][0]-yt,epsold*yt,muse);
#else
        fprintf(fp_w,"\n%6.3lf%13.4le%13.4le%13.4le%13.4le%13.4le%4d"
                             ,t,y[1],y[0],yt,y[0]-yt,epsold*yt,muse);
#endif
/*      ----------------------------------------------------------    */
#ifdef ADAMS
#ifdef SAVEn
        adamsc(n,fun,dt,&t,y[istep],y[istep+1]
                              ,x,mmax,&muse,epsreq,&epsold,id);
#else
        adamsc(n,fun,dt,&t,y,y,x,mmax,&muse,epsreq,&epsold,id);
#endif
#else
#ifdef SAVEn
        rungec(n,fun,dt,&t,y[istep],y[istep+1]
                              ,x,mmax,&muse,epsreq,&epsold);
#else
        rungec(n,fun,dt,&t,y,y,x,mmax,&muse,epsreq,&epsold);
#endif
#endif
/*      ----------------------------------------------------------    */
      }
      exit(0);
}
/**********************************************************************/
      int fun(double t,double y[],double f[],int n) {
/*    int fun(t,y,f,n) double t,y[],f[]; int n; {                     */
/*    ============================================================    */
/*    double y[n],f[n];                                               */
      double ww=9.0,w=3.0,xi=0.05;
      --f; --y;
/*    ============================================================    */
/*    y''(t) + 2*xi*w*y'(t) + w*w*y(t) = 0 with y(0)=u0, y'(0)=v0     */
/*    ============================================================    */
      f[1]=y[2];
      f[2]=-2.0*xi*w*y[2]-ww*y[1];
      return(0);
}
/**********************************************************************/
