/* #define ADAMS */
/* #define SAVEn */
#include <stdio.h>
#include <ctype.h>
#include <math.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
#ifdef SAVEn
      double y[100][2];
#else
      double y[2];
#endif
#ifdef ADAMS
      double x[16][2]; int id[3]; int adamsc();
#else
      double x[7][2];             int rungec();
#endif
      double dt,yt,epsreq,epsold=0.0;
      int    istep,nstep,mmax,muse=0; int fun();
      double t=0.0,u0=1.0,v0=-0.568646969; int n=2;
/*    ============================================================    */
/*    y''(t) - 4*t*y'(t) + (4*t**2-1)*y(t) = exp(t**2)                */
/*    with initial condition y(0)=u0, y'(0)=v0                        */
/*    ============================================================    */
      if(argc<3) {printf("Usage : ratt infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
      freeii(&mmax,fp_r); freer8(&dt,fp_r); freer8(&epsreq,fp_r);
      freer8(&v0,fp_r);
      if(v0 == 0.0) v0=-0.568646969;
      if(epsreq == 0.0) epsreq=0.0001;
      if(dt == 0.0) dt=0.1;
      nstep=1.21/dt+1;
/*    ------------------------------------------------------------    */
#ifdef SAVEn
      y[0][0]=u0;
      y[0][1]=v0;
#else
      y[0]=u0;
      y[1]=v0;
#endif
#ifdef ADAMS
      id[2]=-3;
#endif
/*    ------------------------------------------------------------    */
      fprintf(fp_w,"\n    t        v            y           yt");
      fprintf(fp_w,"           y-yt       epsold*yt  muse");
/*    +----------------------------------------------------------+    */
/*    | yt = exact solution of y(1)                              |    */
/*    +----------------------------------------------------------+    */
      for(istep=0; istep<nstep; istep++) {
        yt=exp(t*t)*(1.0+(1.0-u0)*cos(t)+v0*sin(t));
/*      ----------------------------------------------------------    */
#ifdef SAVEn
        fprintf(fp_w,"\n%6.3lf%13.4le%13.4le%13.4le%13.4le%13.4le%4d"
        ,t,y[istep][1],y[istep][0],yt,y[istep][0]-yt,epsold*yt,muse);
#else
        fprintf(fp_w,"\n%6.3lf%13.4le%13.4le%13.4le%13.4le%13.4le%4d"
                             ,t,y[1],y[0],yt,y[0]-yt,epsold*yt,muse);
#endif
/*      ----------------------------------------------------------    */
#ifdef ADAMS
#ifdef SAVEn
        adamsc(n,fun,dt,&t,y[istep],y[istep+1]
                              ,x,mmax,&muse,epsreq,&epsold,id);
#else
        adamsc(n,fun,dt,&t,y,y,x,mmax,&muse,epsreq,&epsold,id);
#endif
#else
#ifdef SAVEn
        rungec(n,fun,dt,&t,y[istep],y[istep+1]
                              ,x,mmax,&muse,epsreq,&epsold);
#else
        rungec(n,fun,dt,&t,y,y,x,mmax,&muse,epsreq,&epsold);
#endif
#endif
/*      ----------------------------------------------------------    */
      }
      exit(0);
}
/**********************************************************************/
      int fun(double t,double y[],double f[],int n) {
/*    int fun(t,y,f,n) double t,y[],f[]; int n; {                     */
/*    ============================================================    */
/*    double y[n],f[n];                                               */
      --f; --y;
/*    ============================================================    */
/*    y''(t) - 4*t*y'(t) + (4*t**2-1)*y(t) = exp(t**2)                */
/*    ============================================================    */
      f[1]=y[2];
      f[2]=4.0*t*y[2]-(4.0*t*t-1.0)*y[1]+exp(t*t);
      return(0);
}
/**********************************************************************/
