#include <stdio.h>
#include <ctype.h>
#include <math.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double u[441],p[441],bl[21],bd[21],br[21],bu[21]; int ip[441];
      double r,p0,b,h,w,eps,phh,x,y,theta,tmp; int ellips(),ellipt();
      int    i,j,n,mi,mj,ia,ib,jd,ju,jc,niter,ndim=21;
/*    ============================================================    */
/*    this program setup the data for calling ellip* to solve         */
/*    poisson equation : d^2u/dx^2 + d^2u/dy^2 = p, x^2+y^2 < r^2     */
/*    with boundary condition :     u(x,y) = b  on  x^2+y^2 = r^2     */
/*    ============================================================    */
      if(argc<3) {printf("Usage : partst infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
      freeii(&n,fp_r);   freer8(&r,fp_r);
      freer8(&p0,fp_r);  freer8(&b,fp_r);  freer8(&w,fp_r);
      freer8(&eps,fp_r); freeii(&niter,fp_r);
      if(n/2*2 == n || n > ndim) {
        fprintf(fp_w,"\n n is even or n > ndim"); exit(0);
      }
      h=2*r/(n-1);
      phh=p0*h*h;
/*    +----------------------------------------------------------+    */
/*    | initialize                                               |    */
/*    +----------------------------------------------------------+    */
      for(j=0; j<n; j++) { jc=j*ndim;
        for(i=0; i<n; i++) {
          u[i+jc]=0;
          ip[i+jc]=-3;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | boundary pt on horizontal line, set theta, u()=b, ip()=-2|    */
/*    +----------------------------------------------------------+    */
      for(j=0; j<n; j++) { jc=j*ndim;
        y=(j-n/2)*h;
        x=sqrt(r*r-y*y);
        mi=x/h;
        theta=fabs(x-mi*h)/h;
        if(theta < 0.333333) {
          theta=1+theta;
          mi=mi-1;
        }
        ia=-mi-1+n/2; ib= mi+1+n/2;
        bl[j]=theta;
        br[j]=theta;
        u[ ia+jc]=b;           /* u(-mi-1+n/2+1,j)=b(-x,y) */
        u[ ib+jc]=b;           /* u( mi+1+n/2+1,j)=b(+x,y) */
        ip[ia+jc]=-2;
        ip[ib+jc]=-2;
/*      +--------------------------------------------------------+    */
/*      | for interior points, set  p()=p(x,y)*h*h and ip()=0    |    */
/*      +--------------------------------------------------------+    */
        for(i=-mi; i<=mi; i++) {
          p[ i+n/2+jc]=phh;    /* p(i+n/2+1,j)=p(x,y)*h*h ; x=i*h */
          ip[i+n/2+jc]=0;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | boundary pt on vertical line, set theta, u()=b, ip()=-2  |    */
/*    +----------------------------------------------------------+    */
      for(i=0; i<n; i++) {
        x=(i-n/2)*h;
        y=sqrt(r*r-x*x);
        mj=y/h;
        theta=fabs(y-mj*h)/h;
        if(theta < 0.333333) {
          theta=1+theta;
          mj=mj-1;
        }
        jd=(-mj-1+n/2)*ndim; ju=( mj+1+n/2)*ndim;
        bd[i]=theta;
        bu[i]=theta;
        u[ i+jd]=b;            /* u(i,-mj-1+n/2+1)=b(x,-y) */
        u[ i+ju]=b;            /* u(i, mj+1+n/2+1)=b(x,+y) */
        ip[i+jd]=-2;
        ip[i+ju]=-2;
      }
/*    +----------------------------------------------------------+    */
/*    | calculate acceleration factor w for subroutine ellipt    |    */
/*    +----------------------------------------------------------+    */
      if(w == 0.0) {tmp=cos(3.14159/(n-1)); w=2/(1+sqrt(1-tmp*tmp));}
/*    +----------------------------------------------------------+    */
/*    | compute u(i,j) and output results                        |    */
/*    +----------------------------------------------------------+    */
      if(niter != 0) {
        ellipt(u,p,ip,bl,bd,br,bu,w,eps,niter,n,n,ndim);
      } else {
        ellips(u,p,ip,bl,bd,br,bu,n,n,ndim);
      }
      for(j=n-1; j>=0; j--) { jc=j*ndim;
        for(i=0; i<n; i++) {
          if(i%25 == 0) fprintf(fp_w,"\n");
          fprintf(fp_w,"%3d",ip[i+jc]);
        }
      }
      for(j=n-1; j>=0; j--) { jc=j*ndim;
        for(i=0; i<n; i++) {
          if(i%10 == 0) fprintf(fp_w,"\n");
          fprintf(fp_w,"%8.4lf",u[i+jc]);
        }
      }
      exit(0);
}
/**********************************************************************/
      int ellipt(double u[],double p[],int ip[]
                ,double bl[],double bd[],double br[],double bu[]
                ,double w,double eps,int niter,int n,int m,int ndim) {
/*    int ellipt(u,p,ip,bl,bd,br,bu,w,eps,niter,n,m,ndim)
      double u[],p[],bl[],bd[],br[],bu[],w,eps;
      int    ip[],niter,n,m,ndim; {                                   */
/*    ============================================================    */
/*    dimen  u(ndim,m),p(ndim,m),ip(ndim,m),bl(m),bd(m),br(n),bu(n)   */
      double fl,fd,fr,fu,uold,unew;
      int    i,j,k,jl,jd,jr,ju,jc,iter,nerr;
      --u; u-=ndim; --p; p-=ndim; --ip; ip-=ndim;
      --bl; --bd; --br; --bu;
/*    ============================================================    */
/*    use gauss-seidel iterations to solve poisson or laplace eq.     */
/*    ------------------------------------------------------------    */
/*             output : ip(i,j)        -3 : outside point             */
/*    m  -3 -3 -2 -2 -2 -2 -2 -3 -3    -2 : boundary point            */
/*   (u) -3 -2  9  8  8  8 10 -2 -3     0 : inside point              */
/*       -2  9  0  0  0  0  0 10 -2     1 : boundary on left  side    */
/*       -2  1  0  0  0  0  0  2 -2     2 : boundary on right side    */
/*    j  -2  1  0  0  0  0  0  2 -2     4 : boundary on down  side    */
/*       -2  1  0  0  0  0  0  2 -2     8 : boundary on up    side    */
/*       -2  5  0  0  0  0  0  6 -2     5 = 1+4 : bou. on l+d side    */
/*   (d) -3 -2  5  4  4  4  6 -2 -3     6 = 2+4 : bou. on r+d side    */
/*    1  -3 -3 -2 -2 -2 -2 -2 -3 -3     9 = 1+8 : bou. on l+u side    */
/*        1(l)        i        (r)n    10 = 2+8 : bou. on r+u side    */
/*    ------------------------------------------------------------    */
/*i   u(i,j) = assumed initial function values for ip=0,-2            */
/*o          = computed function values for ip=0                      */
/*i   p(i,j) = p(x,y)*h*h (h=grid spacing) for ip=0                   */
/*i   bl(j)  = distance_to_boundary_point / h for ip=-2               */
/*i   w      = acceleration factor (1 <= w <= 2)                      */
/*i   eps    = convergence if |unew-uold| < |uold|*eps                */
/*i   niter  = maximum number of iterations allowed                   */
/*i   n,m    = grid points in x/y-dirctions                           */
/*i   ndim   = dimension of u(ndim,m),p(ndim,m),ip(ndim,m)            */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | for points near boundary : set ip()=(1+2+4+8)            |    */
/*    +----------------------------------------------------------+    */
      for(j=1; j<=m; j++) { jc=j*ndim; jd=jc-ndim; ju=jc+ndim;
                                       jl=jc-1;    jr=jc+1;
        for(i=1; i<=n; i++) {
          if(ip[i+jc] != 0) continue;
          if(ip[i+jl] == -2) ip[i+jc]=ip[i+jc]+1;
          if(ip[i+jd] == -2) ip[i+jc]=ip[i+jc]+4;
          if(ip[i+jr] == -2) ip[i+jc]=ip[i+jc]+2;
          if(ip[i+ju] == -2) ip[i+jc]=ip[i+jc]+8;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | use gauss-seidel iterations to solve u(i,j)              |    */
/*    +----------------------------------------------------------+    */
      for(iter=1; iter<=niter; iter++) {
        nerr=0;
        for(j=1; j<=m; j++) { jc=j*ndim; jd=jc-ndim; ju=jc+ndim;
                                         jl=jc-1;    jr=jc+1;
          for(i=1; i<=n; i++) {
            uold=u[i+jc];
            k=ip[i+jc];
            if(k <= -2) continue;
            if(k == 0) {
              unew=(u[i+jl]+u[i+jd]+u[i+jr]+u[i+ju]-p[i+jc])*0.25;
            } else if(k > 0) {
              if((k & 1) != 0) fl=bl[j]; else fl=1;
              if((k & 4) != 0) fd=bd[i]; else fd=1;
              if((k & 2) != 0) fr=br[j]; else fr=1;
              if((k & 8) != 0) fu=bu[i]; else fu=1;
              unew=(u[i+jl]/(fl*(fl+fr))+u[i+jd]/(fd*(fd+fu))
                   +u[i+jr]/(fr*(fl+fr))+u[i+ju]/(fu*(fd+fu))
                   -p[i+jc]*0.5)*fl*fr*fd*fu/(fl*fr+fd*fu);
            }
/*          +----------------------------------------------------+    */
/*          | convergence control                                |    */
/*          +----------------------------------------------------+    */
            u[i+jc]=(1-w)*uold+w*unew;
            if(fabs(u[i+jc]-uold) > fabs(uold)*eps) nerr=nerr+1;
          }
        }
/*      +--------------------------------------------------------+    */
/*      | debug output and convergence test                      |    */
/*      +--------------------------------------------------------+    */
        if(iter%10 == 1 || niter-iter <= 10 || nerr == 0) {
          printf("\n iter : %d",iter);
          for(j=n; j>=1; j--) { jc=j*ndim;
            for(i=1; i<=n; i++) {
              if(i%10 == 1) printf("\n"); printf("%8.4lf",u[i+jc]);
            }
          }
        }
        if(nerr == 0) return(0);
      }
      return(0);
}
/**********************************************************************/
      int ellips(double u[],double p[],int ip[],double bl[],double bd[]
                ,double br[],double bu[],int n,int m,int ndim) {
/*    int ellips(u,p,ip,bl,bd,br,bu,n,m,ndim)
      double u[],p[],bl[],bd[],br[],bu[]; int ip[],n,m,ndim; {        */
/*    ============================================================    */
/*    dimen  u(ndim,m),p(ndim,m),ip(ndim,m),bl(m),bd(m),br(n),bu(n)   */
      double fl,fd,fr,fu,*s,*t; int *l; int usdecp(),ussolx();
      int    i,j,k,jl,jd,jr,ju,jc,neq,nsd,nnt,kmin,maxa,maxn;
      --u; u-=ndim; --p; p-=ndim; --ip; ip-=ndim;
      --bl; --bd; --br; --bu;
/*    ============================================================    */
/*    use direct method to solve poisson or laplace equation          */
/*    ------------------------------------------------------------    */
/*              input : ip(i,j)               output : ip(i,j)        */
/*    m  -3 -3 -2 -2 -2 -2 -2 -3 -3     -3 -3 -2 -2 -2 -2 -2 -3 -3    */
/*   (u) -3 -2  0  0  0  0  0 -2 -3     -3 -2 41 42 43 44 45 -2 -3    */
/*       -2  0  0  0  0  0  0  0 -2     -2 34 35 36 37 38 39 40 -2    */
/*       -2  0  0  0  0  0  0  0 -2     -2 27 28 29 30 31 32 33 -2    */
/*    j  -2  0  0  0  0  0  0  0 -2     -2 20 21 22 23 24 25 26 -2    */
/*       -2  0  0  0  0  0  0  0 -2     -2 13 14 15 16 17 18 19 -2    */
/*       -2  0  0  0  0  0  0  0 -2     -2  6  7  8  9 10 11 12 -2    */
/*   (d) -3 -2  0  0  0  0  0 -2 -3     -3 -2  1  2  3  4  5 -2 -3    */
/*    1  -3 -3 -2 -2 -2 -2 -2 -3 -3     -3 -3 -2 -2 -2 -2 -2 -3 -3    */
/*        1(l)        i        (r)n      1(l)        i        (r)n    */
/*    ------------------------------------------------------------    */
/*i   u(i,j) = assumed initial function values for ip=0,-2            */
/*o          = computed function values for ip=0                      */
/*i   p(i,j) = p(x,y)*h*h (h=grid spacing) for ip=0                   */
/*i   bl(j)  = distance_to_boundary_point / h for ip=-2               */
/*i   n,m    = grid points in x/y-dirctions                           */
/*i   ndim   = dimension of u(ndim,m),p(ndim,m),ip(ndim,m)            */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | for interior points : set ip() = neq = equation number   |    */
/*    +----------------------------------------------------------+    */
      neq=0;
      for(j=1; j<=m; j++) { jc=j*ndim;
        for(i=1; i<=n; i++) {
          if(ip[i+jc] <= -2) continue;
          neq=neq+1;
          ip[i+jc]=neq;
        }
      }
/*    ------------------------------------------------------------    */
      maxn=2*neq+100;
      l=(int    *)calloc(maxn,sizeof(int   ));
      t=(double *)calloc(maxn,sizeof(double));
      if(l == NULL) {printf("\n neq = %d is too large",neq); exit(1);}
      if(t == NULL) {printf("\n neq = %d is too large",neq); exit(1);}
      --l; l-=2; --t;
/*    +----------------------------------------------------------+    */
/*    | find l(1,k) = top  non-zero row_number                   |    */
/*    |  and l(2,k) = left non-zero col_number                   |    */
/*    +----------------------------------------------------------+    */
      for(k=1; k<=neq; k++) {
        l[1+k*2]=k;
      }
      for(j=1; j<=m; j++) { jc=j*ndim; jd=jc-ndim; ju=jc+ndim;
                                       jl=jc-1;    jr=jc+1;
        for(i=1; i<=n; i++) {
          k=ip[i+jc];
          if(k < 0) continue;
          kmin=k;
          if(ip[i+jl] > 0 && ip[i+jl] < kmin)    kmin=ip[i+jl];
          if(ip[i+jd] > 0 && ip[i+jd] < kmin)    kmin=ip[i+jd];
          if(ip[i+jr] > k && k < l[1+ip[i+jr]*2]) l[1+ip[i+jr]*2]=k;
          if(ip[i+ju] > k && k < l[1+ip[i+ju]*2]) l[1+ip[i+ju]*2]=k;
          l[2+k*2]=kmin;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | find l(1,k)/l(2,k) = k_col/k_row location index          |    */
/*    +----------------------------------------------------------+    */
      l[1+1*2]=0;
      l[2+1*2]=0;
      for(k=2; k<=neq; k++) {
        l[1+k*2]=l[  k*2]+(k-l[1+k*2]);
        l[2+k*2]=l[1+k*2]+(k-l[2+k*2]);
      }
      maxa=l[2+neq*2]+neq;  maxa=maxa+1000;
      s=(double *)calloc(maxa,sizeof(double));
      if(s == NULL) {printf("\n maxa = %d is too large",maxa); exit(1);}
      --s;
/*    +----------------------------------------------------------+    */
/*    | initialize and form s(neq,neq) & t(neq)                  |    */
/*    +----------------------------------------------------------+    */
/*    for(k=1; k<=maxa; k++) s[k]=0.0;                                */
      for(j=1; j<=m; j++) { jc=j*ndim; jd=jc-ndim; ju=jc+ndim;
                                       jl=jc-1;    jr=jc+1;
        for(i=1; i<=n; i++) {
          k=ip[i+jc];
          if(k < 0) continue;
          if(ip[i+jl] != -2 && ip[i+jd] != -2 &&
             ip[i+jr] != -2 && ip[i+ju] != -2) {
/*          +----------------------------------------------------+    */
/*          | all 5-points inside the boundary                   |    */
/*          +----------------------------------------------------+    */
            t[k]=-p[i+jc];
            s[l[2+k*2]+k]=4.0;
            s[l[2+k*2]+ip[i+jl]]=-1;
            s[l[2+k*2]+ip[i+jd]]=-1;
            s[l[1+ip[i+jr]*2]+k]=-1;
            s[l[1+ip[i+ju]*2]+k]=-1;
          } else {
/*          +----------------------------------------------------+    */
/*          | some given points on the boundary                  |    */
/*          +----------------------------------------------------+    */
            if(ip[i+jl] == -2) fl=bl[j]; else fl=1;
            if(ip[i+jd] == -2) fd=bd[i]; else fd=1;
            if(ip[i+jr] == -2) fr=br[j]; else fr=1;
            if(ip[i+ju] == -2) fu=bu[i]; else fu=1;
            t[k]=-p[i+jc];
            s[l[2+k*2]+k]=2/(fl*fr)+2/(fd*fu);
            if(ip[i+jl] == -2) t[k] = t[k]+u[i+jl]*2.0/(fl*(fl+fr));
            if(ip[i+jl] != -2) s[l[2+k*2]+ip[i+jl]]=-2/(fl*(fl+fr));
            if(ip[i+jd] == -2) t[k] = t[k]+u[i+jd]*2.0/(fd*(fd+fu));
            if(ip[i+jd] != -2) s[l[2+k*2]+ip[i+jd]]=-2/(fd*(fd+fu));
            if(ip[i+jr] == -2) t[k] = t[k]+u[i+jr]*2.0/(fr*(fl+fr));
            if(ip[i+jr] != -2) s[l[1+ip[i+jr]*2]+k]=-2/(fr*(fl+fr));
            if(ip[i+ju] == -2) t[k] = t[k]+u[i+ju]*2.0/(fu*(fd+fu));
            if(ip[i+ju] != -2) s[l[1+ip[i+ju]*2]+k]=-2/(fu*(fd+fu));
          }
        }
      }
/*    +----------------------------------------------------------+    */
/*    | solve linear equation : s(neq,neq) * u(neq) = t(neq)     |    */
/*    +----------------------------------------------------------+    */
      usdecp(&s[1],&l[3],neq,&nnt,&nsd,maxa,maxn);
      ussolx(&s[1],&t[1],&l[3],neq,nnt,&t[1]);
/*    +----------------------------------------------------------+    */
/*    | get function values u(i,j) from t(ip(i,j))               |    */
/*    +----------------------------------------------------------+    */
      for(j=m; j>=1; j--) { jc=j*ndim;
        for(i=1; i<=n; i++) {
          if(ip[i+jc] > 0) u[i+jc]=t[ip[i+jc]];
          if(i%10 == 1) printf("\n"); printf("%8.4lf",u[i+jc]);
        }
      }
      free(++s); free(++t); free(l+3); return(0);
}
/**********************************************************************/
