#include <stdio.h>
#include <ctype.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double u[420],d[420];          /* u(nxmax,ntmax),d(nxmax,ntmax) */
      double bl[20],br[20];          /* bl(ntmax),br(ntmax)           */
      double c[41],b[21];            /* c[2*nxmax-1],b[nxmax];        */
      double a,dx,dt,axt,dxt,g0,g1,u0;
      int    i,j,jj,nx,nt,ibc,nxmax=21,ntmax=20; int parabe();
/*    ============================================================    */
      if(argc<3) {printf("Usage : partst infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
      freeii(&nx,fp_r);  freeii(&nt,fp_r);
      freer8(&dx,fp_r);  freer8(&dt,fp_r);
      freer8(&axt,fp_r); freer8(&dxt,fp_r); freeii(&ibc,fp_r);
      freer8(&g0,fp_r);  freer8(&g1,fp_r);  freer8(&u0,fp_r);
      if(nx > nxmax || nt > ntmax) {
        fprintf(fp_w,"\n nx > nxmax || nt > ntmax"); exit(0);
      }
      for(i=0; i<nx; i++) {
        u[i]=u0;  /* freer8(fp_r,&u[i]); */
      }
      a=axt*axt*dt/(dx*dx);
      if(ibc == 1 || ibc == 3) g0=g0*dx;
      if(ibc == 2 || ibc == 3) g1=g1*dx;
      for(j=0; j<nt; j++) { jj=j*nxmax;
        for(i=0; i<nx; i++) {
          d[i+jj]=dxt*dt;
        }
        bl[j]=g0;
        br[j]=g1;
      }
      parabe(u,bl,br,d,a,ibc,c,b,nx,nt,nxmax);
      for(j=0; j<nt; j++) { jj=j*nxmax;
        for(i=0; i<nx; i++) {
          if(i%10 == 0) fprintf(fp_w,"\n");
          fprintf(fp_w,"%8.3lf",u[i+jj]);
        }
      }
      exit(0);
}
/**********************************************************************/
      int parabe(double u[],double bl[],double br[],double d[],double a
         ,int ibc,double c[],double b[],int nx,int nt,int nxmax) {
/*    int parabe(u,bl,br,d,a,ibc,c,b,nx,nt,nxmax)
      double u[],bl[],br[],d[],c[],b[],a; int ibc,nx,nt,nxmax; {      */
/*    ============================================================    */
/*    dimension u(nxmax,nt),bl(nt),br(nt),d(nxmax,nt),c(nx),b(nx)     */
      int n,i,j,ja,jb; int cbdecp(),cbsolx();
      --u; u-=nxmax; --bl; --br; --d; d-=nxmax; --c; --b;
/*    ============================================================    */
/*    use crank-nicolson method to solve parabolic equation :         */
/*     du/dt - a**2 * d2u/dt2 = d(x,t) ; a=constant                   */
/*     u(x,0) = given (initial condition)                             */
/*     u(0,t) = g0(t)  or  du/dx(0,t) = g0'(t)                        */
/*     u(l,t) = g1(t)  or  du/dt(l,t) = g1'(t)                        */
/*    +-------------------+--------------------------------------+    */
/*      1---2---3---4--nx   h=dx=l/(nx-1); k=dt; a=a**2*k/h**2        */
/*                          -------------------------------------     */
/*        2+2a -a           a(u1+u3)+(2-2a)u2 + 2k*d2 + a*u1          */
/*         -a 2+2a -a       a(u2+u4)+(2-2a)u3 + 2k*d3                 */
/*             -a 2+2a      a(u3+u5)+(2-2a)u4 + 2k*d4 + a*u5          */
/*    +----< c[n,n] >-----+----------< b{n} >--------------------+    */
/*     1+a -a               a(   u2)+(1- a)u1 +  k*d1 - a*h*du/dx     */
/*     -a 2+2a -a           a(u1+u3)+(2-2a)u2 + 2k*d2                 */
/*         -a 2+2a -a       a(u2+u4)+(2-2a)u3 + 2k*d3                 */
/*             -a 2+2a -a   a(u3+u5)+(2-2a)u4 + 2k*d4                 */
/*                 -a 1+a   a(u4   )+(1- a)u5 +  k*d5 + a*h*du/dx     */
/*                          -------------------------------------     */
/*      1---2---3---4--nx    u0=u2-2*h*du/dx  ;  u6=u4+2*h*du/dx      */
/*    +-------------------+--------------------------------------+    */
/*i   u(i,1)  = u(x,0)       ;   t=(j-1)*dt                           */
/*o   u(i,j)  = u(x,t)                                                */
/*i   bl(j)   = g0(t) or g0'(t)*dx                                    */
/*i   br(j)   = g1(t) or g1'(t)*dx                                    */
/*i   d(i,j)  = d(x,t)*dt                                             */
/*i   a       = a(x,t)*dt/dx**2 (assume a=constant)                   */
/*i   ibc     = 0+1+2 : boundary conditions on left/right ends        */
/*i           = 1 : given du/dx = g0'(t) else given u=g0(t)           */
/*i           = 2 : given du/dx = g1'(t) else given u=g1(t)           */
/*w   c(2*nx-1) = working array for coefficient matrix                */
/*w   b(nx)   = working array for rhs constant vector                 */
/*i   nx      = number of grid points in x (h=dx=grid spacing)        */
/*i   nt      = number of grid points in t (k=dt=grid spacing)        */
/*i   nxmax   = dimension of u(nxmax,nt),d(nxmax,nt)                  */
/*    ============================================================    */
      n=nx-2;
      if(ibc == 1 || ibc == 3) n=n+1;
      if(ibc == 2 || ibc == 3) n=n+1;
/*    +----------------------------------------------------------+    */
/*    | setup coefficient matrix (upper triangular of symmetric) |    */
/*    +----------------------------------------------------------+    */
      c[1]=2+a+a;
      for(i=2; i<=n; i++) {
        c[2*i-2]=-a;
        c[2*i-1]=2+a+a;
      }
/*    +----------------------------------------------------------+    */
/*    | modify 1st and/or n-th equation to make matrix symmetric |    */
/*    +----------------------------------------------------------+    */
      if(ibc == 1 || ibc == 3) c[1]    =c[1]    *0.5;
      if(ibc == 2 || ibc == 3) c[2*n-1]=c[2*n-1]*0.5;
/*    +----------------------------------------------------------+    */
/*    | decompose the coefficient matrix c(n,n)                  |    */
/*    +----------------------------------------------------------+    */
      cbdecp(&c[1],1,n,1);
/*    +----------------------------------------------------------+    */
/*    | setup rhs constant vector b(n)                           |    */
/*    +----------------------------------------------------------+    */
/*    for(i=1; i<=nx; i++)                                            */
/*      {if(i%10 == 1) printf("\n"); printf("%8.3lf",u[i+nxmax]);}    */
      for(j=1; j<=nt-1; j++) { ja=j*nxmax; jb=ja+nxmax;
        for(i=2; i<=nx-1; i++) {
          b[i]=a*(u[i-1+ja]+u[i+1+ja])+(2-a-a)*u[i+ja]
              +(d[i+ja]+d[i+jb]);          /* d(i,j+1) = d(x,j*dt)*dt */
        }
/*      +--------------------------------------------------------+    */
/*      | modify last equation                                   |    */
/*      +--------------------------------------------------------+    */
        if(ibc == 2 || ibc == 3) {
          b[nx]=a*u[nx-1+ja]+(1-a)*u[nx+ja]+0.5*(d[nx+ja]+d[nx+jb])
               +a*(br[j]+br[j+1]);         /* br(j+1) = g1'(j*dt)*dx  */
        } else {
          b[nx]=br[j+1];                   /* br(j+1) = g1(j*dt)      */
          b[nx-1]=b[nx-1]+a*b[nx];
        }
/*      +--------------------------------------------------------+    */
/*      | modify 1st eq and solve to get u(*,j+1) in b(1:nx)     |    */
/*      +--------------------------------------------------------+    */
        if(ibc == 1 || ibc == 3) {
          b[1]=a*u[2+ja]+(1-a)*u[1+ja]+0.5*(d[1+ja]+d[1+jb])
              -a*(bl[j]+bl[j+1]);          /* bl(j+1) = g0'(j*dt)*dx  */
          cbsolx(&c[1],&b[1],1,n,1);
        } else {
          b[1]=bl[j+1];                    /* bl(j+1) = g0(j*dt)      */
          b[2]=b[2]+a*b[1];
          cbsolx(&c[1],&b[2],1,n,1);
        }
/*      +--------------------------------------------------------+    */
/*      | move b(1:nx) to u(1:nx,j+1) (include boundary)         |    */
/*      +--------------------------------------------------------+    */
        for(i=1; i<=nx; i++) {
          u[i+jb]=b[i];
/*        if(i%10 == 1) printf("\n"); printf("%8.3lf",u[i+jb]);       */
        }
      }
      return(0);
}
/**********************************************************************/
