#include <stdio.h>
#include <math.h>
/**********************************************************************/
      int linear(double a[],int li[],int lj[],double d[],double x[]
                ,int ii,int jj,int nx,int *icase,int *kkk
                ,int nia,int nja,double t[],int mi[],int mj[]
                ,int is,int ic,FILE *fp_s,FILE *fp_w) {
/*    int linear(a,li,lj,d,x,ii,jj,nx,icase,kkk
                ,nia,nja,t,mi,mj,is,ic,fp_s,fp_w)
      double a[],d[],x[],t[]; FILE *fp_s,*fp_w;
      int li[],lj[],mi[],mj[],ii,jj,nx,*icase,*kkk,nia,nja,is,ic; {   */
/*    ============================================================    */
/*    double a(nia,nja),li(nia),lj(nja),d(nx),x(nx)                   */
/*    double t(nia,nja),mi(nia),mj(nja)                               */
      double xi,dj,bkk,xmin,tmp,eps=1.0e-6,big=1.0e10;
      int    i,j,ki,kj,kk,lii,ljj,ljk,lik,lki,ny,kkkk,kkko,*o;
      int    gauss(),recomp(),chkout();
      o=(int *)malloc(nja*sizeof(int));
      --o; for(j=1; j<=nja; j++) o[j]=j*nia-nia;
      --a; --li; --lj; --d; --x; --t; --mi; --mj;
/*    ============================================================    */
/*    linear programming with upper bound by simplex method           */
/*    ------------------------------------------------------------    */
/*               1                        jj-1   jj                   */
/*              +-----------------------------+------+                */
/*           1  |                             |      |                */
/*              |                             >=     | l(i)<0         */
/*              |              a              =   b  | l(i)=0         */
/*              |                             <=     | l(i)>0         */
/*         ii-1 |                             |      |                */
/*              +-----------------------------+------+                */
/*          ii  |              c              |  -z  |                */
/*              +-----------------------------+------+                */
/*         ii+1 |              c'             |  -z' |  *  m          */
/*              +-----------------------------+------+                */
/*    ------------------------------------------------------------    */
/*    minimize: z = \sum c(j)*x(lj(j))                                */
/*    subject to: \sum a(i,j)*x(lj(j)) [-|+] x([-|+]li(i)) = b(i)     */
/*        and   :     d(k) >= x(k) >= 0                               */
/*      where:  i = 1 to ii-1;    j = 1 to jj-1;    k = 1 to nx       */
/*    ------------------------------------------------------------    */
/*    input  : a(ii  ,jj),li(ii-1),lj(jj-1),d(nx),ii,jj,nx,nia,nja,is,*/
/*    output : a(ii+1,jj),li(ii-1),lj(jj-1),d(nx),x(nx),icase,kkk     */
/*    working: t(ii  ,jj),mi(ii-1),mj(jj-1)                           */
/*             nia >= ii+1;    nja >= jj                              */
/*    ------------------------------------------------------------    */
/*    if is  > 0 then t unused & is=file # to save a                  */
/*    if is == 0 then t,mi,mj unused                                  */
/*    if is  < 0 then t is a working array to save a                  */
/*    ============================================================    */
/*1   +----------------------------------------------------------+    */
/*    | call chkout is for print out only, it can be deleted     |    */
/*    +----------------------------------------------------------+    */
      chkout(&a[1],&li[1],&lj[1],&d[1],&li[1],&lj[1]
                  ,ii,jj,nx,nia,nja,ic,0,1,1,&o[1],fp_w);
/*    +----------------------------------------------------------+    */
/*    | kkkk,kkko = re-perform control variables                 |    */
/*    | kkk       = number of simplex pivot                      |    */
/*    +----------------------------------------------------------+    */
      kkkk=0;
      kkko=0;
      *kkk=0;
/*2   +----------------------------------------------------------+    */
/*    | re-set l(i) from the input values of (-s,0,+s)           |    */
/*    | (1) change all constraints to <= b(i), such that:        |    */
/*    |     l(i) > 0 : for slack variable x(i),      i<=nx       |    */
/*    |     l(i) < 0 : for artificial variable x(i), i> nx       |    */
/*    | (2) make sure that d(i) >= 0 for non-artificial variable |    */
/*    +----------------------------------------------------------+    */
      ny=nx;
      for(i=1; i<=ii-1; i++) {
        if(li[i] < 0) {
          for(j=1; j<=jj; j++) {
            a[i+o[j]]=-a[i+o[j]];
          }
          li[i]=-li[i];
        } else if(li[i] == 0) {
          ny=ny+1;
          li[i]=-ny;
        }
      }
/*    ------------------------------------------------------------    */
      for(j=1; j<=nx; j++) {
        if(d[j] < 0.0) {printf("\n lp : d[j] < 0"); exit(1);}
      }
/*3   +----------------------------------------------------------+    */
/*    | save a(ii,jj) on (1) file# is>0 or (2) t(ii,jj) if is<0  |    */
/*    | for is=0, a(ii,jj) will not be saved and no re-perform   |    */
/*    +----------------------------------------------------------+    */
      if(is > 0) {
        rewind(fp_s); fwrite(&a[1],sizeof(double),nia*nja,fp_s);
      } else if(is < 0) {
        for(j=1; j<=jj; j++) { for(i=1; i<=ii; i++) {
          t[i+o[j]]=a[i+o[j]];
        } }
      }
/*4   +----------------------------------------------------------+    */
/*    | save |li(i)| & |lj(j)| on mi(i) & mj(j) for re-perform   |    */
/*    +----------------------------------------------------------+    */
      if(is != 0) {
        for(i=1; i<=ii-1; i++) {
          mi[i]=abs(li[i]);
        }
        for(j=1; j<=jj-1; j++) {
          mj[j]=abs(lj[j]);
        }
      }
/*5   +----------------------------------------------------------+    */
/*    | set up simplex tableau :                                 |    */
/*    | (1) reset a(ii+1,*)=0 : objective fun. for artifical var.|    */
/*    | (2) set lj(j)<0 : to disqualify j as basic variable, if  |    */
/*    |     (2a) artificial variables  (j>nx)                    |    */
/*    |     (2b) non-artificial variables (j<=nx) but d(j) = 0   |    */
/*    | kk=ii+1 : phase 1 objective function at row ii+1         |    */
/*    | kk=ii   : phase 2 objective function at row ii           |    */
/*    +----------------------------------------------------------+    */
 L200:kk=ii+1;
      a[kk+o[jj]]=0.0;
      for(j=1; j<=jj-1; j++) {
        a[kk+o[j]]=0.0;
        ljj=abs(lj[j]);
        if(ljj > nx) {
          ljj=-ljj;
        } else if(d[ljj] == 0.0) {
          ljj=-ljj;
        }
        lj[j]=ljj;
      }
/*6   +----------------------------------------------------------+    */
/*    | (3) change b(i)=a(i,jj) to >= 0     (for i=1 to ii-1)    |    */
/*    +----------------------------------------------------------+    */
      for(i=1; i<=ii-1; i++) {
        if(a[i+o[jj]] < 0.0) {
          for(j=1; j<=jj; j++) {
            a[i+o[j]]=-a[i+o[j]];
          }
          li[i]=-li[i];
        }
/*7     +--------------------------------------------------------+    */
/*      | (4) for artificial var (i>nx) : li(i) must be < 0      |    */
/*      +--------------------------------------------------------+    */
        if(li[i] > nx) li[i]=-li[i];
/*8     +--------------------------------------------------------+    */
/*      | (5) basic var x(l(i))=a(i,jj) must be <= d(li(i))      |    */
/*      |     otherwise change basic var s to d-s': i.e. change :|    */
/*      |     (5a) a(i,jj)  to a(i,jj)-d(li(i))                  |    */
/*      |     (5b) d(li(i)) to -d(li(i)) to indicate bounded var |    */
/*      |     (5c) li(i)    to -li(i)  to indicate non-basic var |    */
/*      +--------------------------------------------------------+    */
        lii=li[i];
        if(lii > 0) {
          if(a[i+o[jj]] > d[lii]) {
            a[i+o[jj]]=a[i+o[jj]]-d[lii];
            d[lii]=-d[lii];
            li[i]=-lii;
          }
        }
/*9     +--------------------------------------------------------+    */
/*      | (6) for any constraint not satisfied (li(i) <= 0)      |    */
/*      |     substract from a(ii+1,j) by a(i,j)                 |    */
/*      +--------------------------------------------------------+    */
        if(li[i] <= 0) {
          for(j=1; j<=jj; j++) {
            a[kk+o[j]]=a[kk+o[j]]-a[i+o[j]];
          }
        }
      }
/*0   +----------------------------------------------------------+    */
/*    | feasibility check                                        |    */
/*    +----------------------------------------------------------+    */
      *icase=0;
      for(j=1; j<=jj-1; j++) {
/*      +--------------------------------------------------------+    */
/*      | lj(j)<0 indicate x(j) must be 0 & can not be basic var |    */
/*      | so, test only for j<jj and lj(j)>0                     |    */
/*      | (0) stay at phase 1 (goto L300) :   if any a(ii+1,j)<0 |    */
/*      | (1) feasible (icase=0, phase 2) :   if all a(ii+1,j)=0 |    */
/*      | (2) may be infeasible : if not (0) and any a(ii+1,j)>0 |    */
/*      +--------------------------------------------------------+    */
        if(lj[j] <= 0) continue;
        if(fabs(a[kk+o[j]]) <= eps) continue;
        if(a[kk+o[j]] < 0.0) goto L300;
        *icase=-1;
      }
/*    +----------------------------------------------------------+    */
/*    | (2a) a(ii+1,jj)< 0 : infeasible (icase=-1 & goto L710)   |    */
/*    | (2b) a(ii+1,jj)>=0 : feasible, set lj(j)<0 if a(ii+1,j)>0|    */
/*    +----------------------------------------------------------+    */
      if(*icase < 0) {
        if(a[kk+o[jj]] < -eps) goto L710;
        for(j=1; j<=jj-1; j++) {
          if(a[kk+o[j]] > 0.0) lj[j]=-abs(lj[j]);
        }
      }
/*    +----------------------------------------------------------+    */
/*    | feasible case : get into phase 2 to find the optimal sol |    */
/*    +----------------------------------------------------------+    */
      *icase=0;
      kk=ii;
/*1   +----------------------------------------------------------+    */
/*    | begin simplex pivot  (kk=ii+1:phase 1) (kk=ii:phase 2)   |    */
/*    +----------------------------------------------------------+    */
/*    | find xmin=a(kk,kj)=min.a(kk,1:jj-1) -> xmin<0 & lj(kj)>0 |    */
/*    | case 1:  p(lj(kj)) = +1   (p(lj(kj))=sign(1,d(lj(kj))))  |    */
/*    | case 2:  p(lj(kj)) = -1                                  |    */
/*    | if all a(kk,1:jj-1) >= 0 : end of phase 1/2 -> goto L700 |    */
/*    +----------------------------------------------------------+    */
 L300:if(*kkk == 0) chkout(&a[1],&li[1],&lj[1],&d[1],&li[1],&lj[1]
                                ,ii,jj,nx,nia,nja,ic,0,1,1,&o[1],fp_w);
      xmin=-eps;
      kj=0;
      for(j=1; j<=jj-1; j++) {
        if(a[kk+o[j]] >= xmin || lj[j] <= 0) continue;
        xmin=a[kk+o[j]];
        kj=j;
      }
      if(kj <= 0) goto L700;
/*2   +----------------------------------------------------------+    */
/*    | find xmin=min.xi      (for ki=1 to ii-1)                 |    */
/*    | case a: a(ki,kj)>0 -> xi=a(ki,jj)/a(ki,kj)               |    */
/*    | case b: a(ki,kj)<0 -> xi=(a(ki,jj)-d(li(i)))/a(ki,kj)    |    */
/*    | case c: (ki=0)     -> xi=d(lj(kj))                       |    */
/*    +----------------------------------------------------------+    */
      ljk=lj[kj];
      xmin=fabs(d[ljk]);
      ki=0;
      for(i=1; i<=ii-1; i++) {
      if(fabs(a[i+o[kj]]) <= eps) continue;
        if(a[i+o[kj]] > 0.0) {
          xi=a[i+o[jj]]/a[i+o[kj]];
        } else {
/*        +------------------------------------------------------+    */
/*        | case b:  for slack var li(i)>0 and bounded var only  |    */
/*        +------------------------------------------------------+    */
          lii=li[i];
          if(lii <= 0) continue;
          if(d[lii] >= big) continue;
          xi=(a[i+o[jj]]-d[lii])/a[i+o[kj]];
        }
/*      ----------------------------------------------------------    */
        if(xi > xmin) continue;
        if(xi == xmin && ki != 0) {
          if(li[i] > li[ki]) continue;
        }
        xmin=xi;
        ki=i;
      }
/*3   +----------------------------------------------------------+    */
/*    | if xmin >= big : un-bounded for new basic var (goto L740)|    */
/*    +----------------------------------------------------------+    */
      if(xmin >= big) goto L740;
/*4   +----------------------------------------------------------+    */
/*    | cases 1a,2a,1b,2b (ki>0)                                 |    */
/*    +----------------------------------------------------------+    */
      if(ki > 0) {
        lki=li[ki];
        lik=abs(lki);
        bkk=1.0; if(lki < 0) bkk=-1.0;
/*      +--------------------------------------------------------+    */
/*      | sweep li(ki),lj(kj) and set lj(kj) to <0 for artif. var|    */
/*      +--------------------------------------------------------+    */
        li[ki]=ljk;
        lj[kj]=lik;
        if(lik > nx) lj[kj]=-lik;
/*5     +--------------------------------------------------------+    */
/*      | cases 1b,2b : change basic var to non-bas var x -> d-x'|    */
/*      | (a(ki,kj)<0)  x(lik)'= d(lik)-x(lik) = 0, p(lik) = -1  |    */
/*      +--------------------------------------------------------+    */
        if(a[ki+o[kj]] < 0.0) {
          a[ki+o[jj]]=a[ki+o[jj]]-d[lik];
          d[lik]=-d[lik];
          bkk=-1.0;
        }
      }
/*6   +----------------------------------------------------------+    */
/*    | case 2a,2b (ki>0) : x(ljk) < d(ljk), p(ljk) = -1 --> +1  |    */
/*    | case 1c    (ki=0) : x(ljk)'= 0,      p(ljk) = +1 --> -1  |    */
/*    | case 2c    (ki=0) : x(ljk) = 0,      p(ljk) = -1 --> +1  |    */
/*    +----------------------------------------------------------+    */
      if(d[ljk] < 0.0 || ki == 0) {
        dj=fabs(d[ljk]);
        for(i=1; i<=kk; i++) {
          a[i+o[jj]]= a[i+o[jj]]-a[i+o[kj]]*dj;
          a[i+o[kj]]=-a[i+o[kj]];
        }
        d[ljk]=-d[ljk];
      }
/*7   +----------------------------------------------------------+    */
/*    | cases 1a,2a,1b,2b (ki>0) : perform gauss elimination     |    */
/*    +----------------------------------------------------------+    */
      if(ki > 0) gauss(&a[1],ii,jj,ki,kj,bkk,kk,lki,nia,nja,&o[1]);
/*8   +----------------------------------------------------------+    */
/*    | end of simplex loop : goto begin of loop (L300)          |    */
/*    +----------------------------------------------------------+    */
      *kkk=*kkk+1;
      chkout(&a[1],&li[1],&lj[1],&d[1],&mi[1],&mj[1]
                  ,ii,jj,nx,nia,nja,ic,*kkk,ki,kj,&o[1],fp_w);
      goto L300;
/*9   +----------------------------------------------------------+    */
/*    | re-perform phase 1 simplex 5-times maximum               |    */
/*    +----------------------------------------------------------+    */
 L700:if(kk == ii) goto L710;
      if(kkkk >= 5 || kkko == *kkk) goto L750;
      kkkk=kkkk+1;
      kkko=*kkk;
      if(is != 0) {
      recomp(&a[1],&li[1],&lj[1],&d[1],ii,jj,nx,nia,nja
            ,&t[1],&mi[1],&mj[1],is,&o[1],fp_s);
      chkout(&a[1],&li[1],&lj[1],&d[1],&mi[1],&mj[1]
                  ,ii,jj,nx,nia,nja,ic,0,1,1,&o[1],fp_w);
      }
      goto L200;
/*0   +----------------------------------------------------------+    */
/*    | feasible solution in x(*) (also for unbounded/infeasible)|    */
/*    +----------------------------------------------------------+    */
 L710:for(j=1; j<=nx; j++) {
        x[j]=-d[j];
        if(x[j] < 0) x[j]=0.0;
      }
      for(i=1; i<=ii-1; i++) {
        if(li[i] > 0) x[li[i]]=a[i+o[jj]];
      }
      for(j=1; j<=nx; j++) {
        if((tmp=fabs(d[j])) < x[j]) x[j]=tmp;
      }
      free(++o); return(0);
/*1   +----------------------------------------------------------+    */
/*    | unbounded solution                                       |    */
/*    +----------------------------------------------------------+    */
 L740:*icase=1;
      goto L710;
/*2   +----------------------------------------------------------+    */
/*    | infeasible solution                                      |    */
/*    +----------------------------------------------------------+    */
 L750:*icase=-2;
      goto L710;
}
/**********************************************************************/
      int gauss(double a[],int ii,int jj,int ki,int kj
               ,double bkk,int kk,int lki,int nia,int nja,int o[]) {
/*    int gauss(a,ii,jj,ki,kj,bkk,kk,lki,nia,nja,o)
      double a[],bkk; int ii,jj,ki,kj,kk,lki,nia,nja,o[]; {           */
/*    ============================================================    */
      double aik,akk;
      int    i,j;
      --a; --o;
/*    ============================================================    */
/*    perform gauss elimination pivot at a(ki,kj)                     */
/*    a(*,kj) will be used by new non-basic var   (bkk = -1 or +1)    */
/*    lki=li(ki) < 0 : new non-bas var is art var (has 1*m in obj)    */
/*    ============================================================    */
      akk=a[ki+o[kj]];
      a[ki+o[kj]]=bkk;
      for(j=1; j<=jj; j++) {
        a[ki+o[j]]/=akk;
      }
      for(i=1; i<=kk; i++) {
        if(i == ki) continue;
        aik=a[i+o[kj]];
        a[i+o[kj]]=0.0;
        if(i == ii+1 && lki < 0) a[i+o[kj]]=1.0;
        for(j=1; j<=jj; j++) {
          a[i+o[j]]-=aik*a[ki+o[j]];
        }
      }
      return(0);
}
/**********************************************************************/
      int recomp(double a[],int li[],int lj[],double d[]
                ,int ii,int jj,int nx,int nia,int nja
                ,double t[],int mi[],int mj[]
                ,int is,int o[],FILE *fp_s) {
/*    int recomp(a,li,lj,d,ii,jj,nx,nia,nja,t,mi,mj,is,o,fp_s)
      double a[],d[],t[]; FILE *fp_s;
      int    li[],lj[],ii,jj,nx,nia,nja,mi[],mj[],is,o[]; {           */
/*    ============================================================    */
      double dj,aik,akk,eps=1.0e-6;
      int    i,j,k,ni,nj,ki,kj,lii,ljj,lik;
      --a; --li; --lj; --d; --t; --mi; --mj; --o;
/*    ============================================================    */
/*    perform gauss elimination from the original matrix              */
/*    for phase 1 only : to reduce roundoff error                     */
/*    ============================================================    */
 L800:if(is > 0) {
        rewind(fp_s); fread(&a[1],sizeof(double),nia*nja,fp_s);
      } else if(is < 0) {
        for(j=1; j<=jj; j++) { for(i=1; i<=ii; i++) {
          a[i+o[j]]=t[i+o[j]];
        } }
      }
/*    +----------------------------------------------------------+    */
/*    | li(i) = basic variables;   lj(j) = non-basic variables   |    */
/*    +----------------------------------------------------------+    */
      for(i=1; i<=ii-1; i++) {
        li[i]=abs(li[i]);
      }
      for(j=1; j<=jj-1; j++) {
        lj[j]=abs(lj[j]);
      }
/*    +----------------------------------------------------------+    */
/*    | set mi(i) = -mi(i) < 0  if mi(i) not in li(1:ii-1)       |    */
/*    +----------------------------------------------------------+    */
      ni=0;
      for(i=1; i<=ii-1; i++) {
        for(ki=1; ki<=ii-1; ki++) {
          if(mi[i] == li[ki]) goto L850;
        }
        mi[i]=-mi[i];
        ni=ni+1;
 L850:;}
/*    +----------------------------------------------------------+    */
/*    | set mj(j) = -mj(j) < 0  if mj(j) not in lj(1:jj-1)       |    */
/*    +----------------------------------------------------------+    */
      nj=0;
      for(j=1; j<=jj-1; j++) {
        for(kj=1; kj<=jj-1; kj++) {
          if(mj[j] == lj[kj]) goto L860;
        }
        mj[j]=-mj[j];
        nj=nj+1;
 L860:;}
/*    +----------------------------------------------------------+    */
/*    | move signed mi(i) & mj(j) to li(i) & lj(j)               |    */
/*    | reset mi(i) & mj(j) to original positive values          |    */
/*    +----------------------------------------------------------+    */
      for(i=1; i<=ii-1; i++) {
        li[i]=mi[i];
        mi[i]=abs(mi[i]);
      }
      for(j=1; j<=jj-1; j++) {
        lj[j]=mj[j];
        mj[j]=abs(mj[j]);
      }
/*    +----------------------------------------------------------+    */
/*    | find pivot element a(ki,kj) : li(ki) < 0 and lj(kj) < 0  |    */
/*    +----------------------------------------------------------+    */
      if(ni != nj) {printf("\n recomp : ni != nj"); exit(1);}
      if(ni == 0) goto L960;
      for(k=1; k<=ni; k++) {
        akk=0.0;
        for(j=1; j<=jj-1; j++) {
          if(lj[j] >= 0) continue;
          for(i=1; i<=ii-1; i++) {
            if(li[i] >= 0) continue;
            if(akk >= fabs(a[i+o[j]])) continue;
            akk=fabs(a[i+o[j]]);
            ki=i;
            kj=j;
          }
        }
        if(akk <= eps) goto L960;
/*      +--------------------------------------------------------+    */
/*      | elimination by pivot row : sweep -li(ki) <--> -lj(kj)  |    */
/*      +--------------------------------------------------------+    */
        lik=-li[ki];
        li[ki]=-lj[kj];
        lj[kj]=lik;
/*      ----------------------------------------------------------    */
/*      gauss(&a[1],ii,jj,ki,kj,1.0,ii,1,nia,nja,&o[1]);   /* also ok */
/*      ----------------------------------------------------------    */
        akk=a[ki+o[kj]];
        a[ki+o[kj]]=1.0;
        for(j=1; j<=jj; j++) {
          a[ki+o[j]]/=akk;
        }
        for(i=1; i<=ii; i++) {
          if(i == ki) continue;
          aik=a[i+o[kj]];
          a[i+o[kj]]=0.0;
          for(j=1; j<=jj; j++) {
            a[i+o[j]]-=aik*a[ki+o[j]];
          }
        }
      }
/*    +----------------------------------------------------------+    */
/*    | reform simplex tableau                                   |    */
/*    | (1) reset p(li(i)) = +1                                  |    */
/*    | (2) change var x --> d-x'  if p(lj(j)) = -1              |    */
/*    +----------------------------------------------------------+    */
 L960:for(i=1; i<=ii-1; i++) {
        lii=li[i];
        if(lii > nx) continue;
        d[lii]=fabs(d[lii]);
      }
      for(j=1; j<=jj-1; j++) {
        ljj=lj[j];
        if(ljj > nx) continue;
        if(d[ljj] >= 0.0) continue;
        dj=-d[ljj];
        for(i=1; i<=ii; i++) {
          a[i+o[jj]]-=a[i+o[j]]*dj;
          a[i+o[ j]]=-a[i+o[j]];
        }
      }
      return(0);
}
/**********************************************************************/
