#include <stdio.h>
#include <ctype.h>
#include <math.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w,*fp_s;
      double *a,*d,*x,*t; int *li,*lj,*mi,*mj; int linear();
      int    i,j,ii,jj,nx,ny,icase,kkk,nia,nja,is,ic;
/*    ============================================================    */
/*    input data -----+------+--------------------+----------         */
/*                seq | sets | variables          |  format           */
/*               -----+------+--------------------+----------         */
/*                 1  |  1   | is,ic              |  2i5              */
/*                 2  |  1   | ii,jj,ny           |  3i5              */
/*                 3  |  ii  | (a(i,j),j=1,jj)    |  8f10.0           */
/*                 4  |  1   | (d(j),j=1,ny)      |  8f10.0           */
/*                 5  |  1   | (li(i),i=1,ii-1)   |  16i5             */
/*                 6  |  1   | (lj(j),j=1,jj-1)   |  16i5             */
/*               -----+------+--------------------+----------         */
/*    is    = file# to save origi. tableau (no re-perform if is=0)    */
/*    ic    = file# to save debug output (no debug output if ic=0)    */
/*    ii,jj = numbers of rows and columns of simplex tableau          */
/*    ny    = maximum variable # which have upper bound to input      */
/*            (may include slack var but not artificial var)          */
/*    ------------------------------------------------------------    */
/*    a(i,j)            = simplex tableau                             */
/*    i=1,ii-1;j=1,jj-1 : for coeff. of variables : a(i,j)            */
/*    i=1,ii-1;j=jj     : for rhs constants       : b(i) = a(i,jj)    */
/*    i=ii    ;j=1,jj-1 : for objective function  : c(j) = a(ii,j)    */
/*    ------------------------------------------------------------    */
/*    d(j)  = upper bound value for variable i                        */
/*    ------------------------------------------------------------    */
/*    li(i) = constaint equation type                                 */
/*          = +1  for lesser  or equal constraint                     */
/*          = -1  for greater or equal constraint                     */
/*          =  0  for equal constarint                                */
/*    lj(j) = variable # for column j of the table                    */
/*          = 0  will be reset to j by this program                   */
/*    ============================================================    */
      if(argc<3) {printf("Usage : lptst infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
  L10:freeii(&is,fp_r); freeii(&ic,fp_r);
      freeii(&ii,fp_r); freeii(&jj,fp_r); freeii(&ny,NULL);
      if(ii <= 0 || jj <= 0) exit(0);
/*    ------------------------------------------------------------    */
      nia=ii+1; nja=jj;
      a=(double *)calloc(nia*nja,sizeof(double));
      d=(double *)calloc(nia+nja,sizeof(double));
      x=(double *)calloc(nia+nja,sizeof(double));
      li=(int   *)calloc(ii     ,sizeof(int   ));
      lj=(int   *)calloc(jj     ,sizeof(int   ));
      if(lj == NULL) {
        printf("\n ii,jj = %d,%d are too large",ii,jj); exit(1);
      }
      --a; a-=nia; --li; --lj; --d; --x;
/*    ------------------------------------------------------------    */
      if(is < 0) {
        t=(double *)calloc(nia*nja,sizeof(double));
        mi=(int   *)calloc(ii     ,sizeof(int   ));
        mj=(int   *)calloc(jj     ,sizeof(int   ));
        if(mj == NULL) is=abs(is);
      }
      if(is > 0) {if((fp_s=fopen("lp.tmp","w+b"))==NULL) exit(-1);}
/*    --t; t-=nia; --mi; --mj;                                        */
/*    ------------------------------------------------------------    */
      for(i=1; i<=ii; i++) { for(j=1; j<=jj; j++) {
          freer8(&a[i+j*nia],fp_r);
      } }
      for(j=1; j<=ny;   j++) freer8(&d[j] ,fp_r);
      for(i=1; i<=ii-1; i++) freeii(&li[i],fp_r);
      for(j=1; j<=jj-1; j++) freeii(&lj[j],NULL);
/*    +----------------------------------------------------------+    */
/*    | comput nx and fill d(ny+1:nx)=0                          |    */
/*    | setup li(ii-1),lj(jj-1),d(nx) for simplex tableau        |    */
/*    +----------------------------------------------------------+    */
      for(j=1; j<=jj-1; j++) {
        if(lj[j] == 0) lj[j]=j;
      }
      nx=jj-1;
      for(i=1; i<=ii-1; i++) {
        if(li[i] == 0) continue;
        nx=nx+1;
        if(abs(li[i]) == 1) li[i]=li[i]*nx;
      }
      for(j=1; j<=nx; j++) {
        if(j > ny) d[j]=0.0;
        if(d[j] <= 0.0) d[j]=1.0e30;
      }
/*    +----------------------------------------------------------+    */
/*    | write data before calling lp                             |    */
/*    +----------------------------------------------------------+    */
      fprintf(fp_w,"\n ********** data before call linear **********");
      for(i=1; i<=ii; i++) { for(j=1; j<=jj; j++) {
        if(j%10 == 1) fprintf(fp_w,"\n");
        fprintf(fp_w,"%10.3lf",a[i+j*nia]);
      } }
      for(j=1; j<=nx; j++) {
        if(j%10 == 1) fprintf(fp_w,"\n"); fprintf(fp_w,"%10.2le",d[j]);
      }
      for(i=1; i<=ii-1; i++) {
        if(i%10 == 1) fprintf(fp_w,"\n"); fprintf(fp_w,"%5d",li[i]);
      }
      for(j=1; j<=jj-1; j++) {
        if(j%10 == 1) fprintf(fp_w,"\n"); fprintf(fp_w,"%5d",lj[j]);
      }
/*    +----------------------------------------------------------+    */
      linear(&a[1+nia],&li[1],&lj[1],&d[1],&x[1],ii,jj,nx
            ,&icase,&kkk,nia,nja,t,mi,mj,is,ic,fp_s,fp_w);
/*    +----------------------------------------------------------+    */
/*    | write data after calling linear                          |    */
/*    +----------------------------------------------------------+    */
      fprintf(fp_w,"\n ========== data after call linear ==========");
      for(i=1; i<=ii; i++) { for(j=1; j<=jj; j++) {
        if(j%10 == 1) fprintf(fp_w,"\n");
        fprintf(fp_w,"%10.3lf",a[i+j*nia]);
      } }
      for(j=1; j<=nx; j++) {
        if(j%10 == 1) fprintf(fp_w,"\n"); fprintf(fp_w,"%10.2le",d[j]);
      }
      for(i=1; i<=ii-1; i++) {
        if(i%10 == 1) fprintf(fp_w,"\n"); fprintf(fp_w,"%5d",li[i]);
      }
      for(j=1; j<=jj-1; j++) {
        if(j%10 == 1) fprintf(fp_w,"\n"); fprintf(fp_w,"%5d",lj[j]);
      }
/*    +----------------------------------------------------------+    */
/*    | output feasible optimal solution                         |    */
/*    +----------------------------------------------------------+    */
      if(icase == 0) {
        fprintf(fp_w,"\n values of variables =");
        for(j=1; j<=nx; j++) {
          if(j%10 == 1)fprintf(fp_w,"\n"); fprintf(fp_w,"%10.2le",x[j]);
        }
        fprintf(fp_w,"\n objective function  =%15.6le",-a[ii+jj*nia]);
      }
      free(a+1+nia); free(++li); free(++lj); free(++d); free(++x);
      if(is < 0) {free(t); free(mi); free(mj);}
      goto L10;
}
/**********************************************************************/
