#include <stdio.h>
#include <math.h>
/**********************************************************************/
      int dlp(double aa[],int lli[],int llj[],double d[],double x[]
         ,int ii,int jj,int nia,int nja
         ,double a[],int li[],int lj[],double t[],int mi[],int mj[]
         ,int is,int ic,int *picase
         ,double dlu[],int ityp[],double val[],double znod[],int mvx[]
         ,int nvar,int nx,FILE *fp_s,FILE *fp_w) {
/*    int dlp(aa,lli,llj,d,x,ii,jj,nia,nja,a,li,lj,t,mi,mj
             ,is,ic,picase,dlu,ityp,val,znod,mvx,nvar,nx,fp_s,fp_w)
      double aa[],d[],x[],a[],t[],dlu[],val[],znod[];
      int    lli[],llj[],ii,jj,nia,nja,li[],lj[],mi[],mj[];
      int    is,ic,*picase,ityp[],mvx[],nvar,nx; FILE *fp_s,*fp_w;    */
/*    ============================================================    */
      double zmin,zopt,z;
      int    iv,ix,jv,jx,node,nmin,nopt,kkk,icase;
      int    linear(),setlij(),setblu(),setsmp();
      int    intchk(),addnod(),savnod(),nxtnod(),getxvl();
      icase=*picase;
/*    ============================================================    */
/*    dimension aa(nia,nja),lli(nia),llj(nja),d(nx),x(nx)             */
/*    dimension a(nia,nja),li(nia),lj(nja)                            */
/*    dimension t(nia,nja),mi(nia),mj(nja)                            */
/*    dimension dlu(3,nvar),ityp(3,nvar),val(1),znod(node),mvx(node)  */
/*    ------------------------------------------------------------    */
/*i   aa(ii,jj)   = simplex tableau                                   */
/*i   lli(ii-1)   = -1/0/1 : constraint type ge/eq/le                 */
/*o               = -s/0/s : s/a = slack/artificail variable          */
/*i   llj(jj-1)   = 0/v : variable for columns                        */
/*o               = v   : set by this subroutine when input is 0      */
/*o   d(nx)       = upper bound for each variable in simplex          */
/*o   x(nx)       = solution vector                                   */
/*i   ii,jj       = number of rows and columns in simplex tableau     */
/*i   nia,nja     = dimensions of a(nia,nja)                          */
/*w   a,li,lj     = computing array for simplex method                */
/*w   t,mi,mj     = working array for simplex method                  */
/*    ------------------------------------------------------------    */
/*w   dlu(3  ,iv) = given upper bound = d(iv) for iv <= nvar          */
/*w   dlu(1:2,iv) = lower:upper bound of variables(integer bound)     */
/*i   ityp(1, iv) = variable type :                                   */
/*i               = 0 : real                                          */
/*i               = 1 : integer 0 or 1                                */
/*i               = 2 : integer 0, 1, 2, ...                          */
/*i               =-m : discrete value in table val(1:m,*)            */
/*i   ityp(2, iv) = pointer to the table val(*) for ityp(1,iv)=-m     */
/*i   ityp(3, iv) = lower integer value of non-integer variable       */
/*i   val(*)      = discrete values for discrete variables            */
/*w   znod(node)  = objective value at node                           */
/*w   mvx(3,node) = mother/jv/jx                                      */
/*w   nvar        = jj - 1 = number of variables (no slack var)       */
/*w   nx          = number of variables include slack variables       */
/*    ------------------------------------------------------------    */
/*w   zopt        = z_optimal so far                                  */
/*w   nopt        = node of the zopt                                  */
/*w   zmin        = minimum z from all active node                    */
/*w   nmin        = node of the zmin                                  */
/*w   node        = number of nodes have been done                    */
/*w   iv/ix       = integer variable/value for current node           */
/*w   jv/jx       = integer variable/value for the left node          */
/*i   is,ic       = file#/0/-1,file#/0 for subroutine linear          */
/*    ============================================================    */
      iv=0;
      ix=0;
      node=0;
      nmin=0;
      nopt=0;
      zmin=1.0e29;
      zopt=1.0e30;
      setlij(lli,llj,d,dlu,ii,jj,&nx,nia,nja,&nvar);
/*    +----------------------------------------------------------+    */
/*    | set dlu(1:2,nvar) = lower:upper bound of all variables   |    */
/*    | set dlu(1:2,iv) for integer variable at left/right node  |    */
/*    | set a(nia,nja),li(nia),lj(nja),d(nx)                     |    */
/*    | perform linear programming computation                   |    */
/*    +----------------------------------------------------------+    */
  L20:setblu(nmin,mvx,dlu,ityp,val,nvar);
      addnod(node,iv,&ix,dlu,ityp,val,nvar);
      setsmp(a,li,lj,d,nx,ii,jj,nia,nja,aa,lli,llj,dlu,nvar,&icase);
      if(icase >= 0) linear(a,li,lj,d,x,ii,jj,nx,&icase,&kkk,nia,nja
                           ,t,mi,mj,is,ic,fp_s,fp_w);
      z=-a[ii-1+(jj-1)*nia];
      if(icase < 0) z= 1.0e30;
      if(icase > 0) z=-1.0e30;
      printf("\n dlp    %12.3le%12.3le%12.3le%5d",zmin,zopt,z,icase);
/*    +----------------------------------------------------------+    */
/*    | reset x(1:nvar) : from discrete values to real vaules    |    */
/*    +----------------------------------------------------------+    */
      getxvl(x,dlu,nvar,icase);
/*    +----------------------------------------------------------+    */
/*    | zmin = zopt : return after re-compute optimal solution   |    */
/*    +----------------------------------------------------------+    */
      if(zmin >= zopt) {*picase=icase; return(0);}
/*    +----------------------------------------------------------+    */
/*    | integer check and get next integer var/val jv/jx         |    */
/*    | save result of new node at mvx(3,++node)                 |    */
/*    +----------------------------------------------------------+    */
      intchk(x,ityp,val,nvar,&jv,&jx,icase);
      savnod(&node,znod,mvx,z,nmin,jv,jx);
/*    +----------------------------------------------------------+    */
/*    | jv = 0 : all integer solution                            |    */
/*    +----------------------------------------------------------+    */
      if(jv == 0) {
        if(z < zopt) {
          zopt=z;
          nopt=node;
        }
      }
      if(node/2*2 == node) goto L20;
/*    +----------------------------------------------------------+    */
/*    | after analyze left and right nodes                       |    */
/*    | find next node with minimum z : nmin,zmin,iv,ix          |    */
/*    +----------------------------------------------------------+    */
      nxtnod(node,znod,mvx,nopt,&nmin,&zmin,&iv,&ix);
      goto L20;
}
/**********************************************************************/
      int setblu(int nmin,int mvx[],double dlu[],int ityp[]
                ,double val[],int nvar) {
/*    int setblu(nmin,mvx,dlu,ityp,val,nvar)
      double dlu[],val[]; int nmin,mvx[],ityp[],nvar; {               */
/*    ============================================================    */
/*    dimension mvx(3,nvar),dlu(3,nvar),ityp(3,nvar),val[1]           */
      double xval; int node,mo,iv,ix; int intval();
      mvx-=4; dlu-=4; ityp-=4; --val;
/*    ============================================================    */
/*    set dlu(1:2,iv) = lower:upper bound of variable iv              */
/*    ------------------------------------------------------------    */
/*    mvx(1,node) = node number of mother node                        */
/*    mvx(2,node) = jv : next integer variable (active if jv>=0)      */
/*    mvx(3,node) = jx : next integer value                           */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | reset lower/upper bound of all variable                  |    */
/*    +----------------------------------------------------------+    */
      for(iv=1; iv<=nvar; iv++) {
        dlu[1+iv*3]=0.0;
        dlu[2+iv*3]=dlu[3+iv*3];
      }
      if(nmin <= 1) return(0);
/*    +----------------------------------------------------------+    */
/*    | tracking back to set lower/upper bound by mother nodes   |    */
/*    +----------------------------------------------------------+    */
      node=nmin;
  L50:mo=mvx[1+node*3];
      if(mo == 0) return(0);
      iv=abs(mvx[2+mo*3]);
      ix=mvx[3+mo*3];
      if(node/2*2 != node) ix=ix+1;
/*    +----------------------------------------------------------+    */
/*    | get xval = true value of variable iv at integer ix       |    */
/*    +----------------------------------------------------------+    */
      intval(iv,ix,&xval,&dlu[4],&ityp[4],&val[1],nvar);
/*    +----------------------------------------------------------+    */
/*    | node = 2, 4, 6, ...  for left node : x(iv) <= xval       |    */
/*    +----------------------------------------------------------+    */
      if(node/2*2 == node) {
        if(xval < dlu[2+iv*3]) dlu[2+iv*3]=xval;
      } else {
        if(xval > dlu[1+iv*3]) dlu[1+iv*3]=xval;
      }
/*    +----------------------------------------------------------+    */
/*    | back to mother node at upper level                       |    */
/*    +----------------------------------------------------------+    */
      node=mo;
      goto L50;
}
/**********************************************************************/
      int addnod(int node,int jv,int *jx
                ,double dlu[],int ityp[],double val[],int nvar) {
/*    int addnod(node,jv,jx,dlu,ityp,val,nvar)
      double dlu[],val[]; int node,jv,*jx,ityp,nvar: {                */
/*    ============================================================    */
/*    dimension dlu(3,nvar),ityp(3,nvar),val(1)                       */
      double xval; int iv; int intval();
      dlu-=4; ityp-=4; --val;
/*    ============================================================    */
/*    set upper/lower bound for left/right node                       */
/*    ============================================================    */
      if(jv <= 0) return(0);
      if(node/2*2 == node) *jx=*jx+1;
      intval(jv,*jx,&xval,&dlu[4],&ityp[4],&val[1],nvar);
      if(node/2*2 != node) {
        if(xval < dlu[2+jv*3]) dlu[2+jv*3]=xval;
      } else {
        if(xval > dlu[1+jv*3]) dlu[1+jv*3]=xval;
      }
      for(iv=1; iv<=nvar; iv++) {
        printf("\n addnod %12.3le%12.3le%12.3le"
                  ,dlu[1+iv*3],dlu[2+iv*3],dlu[3+iv*3]);
      }
      return(0);
}
/**********************************************************************/
      int nxtnod(int node,double znod[],int mvx[],int nopt
                ,int *pnmin,double *pzmin,int *jv,int *jx) {
/*    int nxtnod(node,znod,mvx,nopt,*pnmin,*pzmin,*jv,*jx)
      double znod[],*pzmin; int node,mvx[],nopt,*pnmin,*jv,*jx; {     */
/*    ============================================================    */
/*    dimension znod(node),mvx(3,node)                                */
      double zmin; int n,nmin;
      --znod; mvx-=4;
      nmin=*pnmin; zmin=*pzmin;
/*    ============================================================    */
/*    find node nmin with minimum znod(nmin) from active node         */
/*    ------------------------------------------------------------    */
/*o   nmin  = node number for next starting node                      */
/*o   zmin  = objective value z of the node nmin                      */
/*o   jv,jx = next integer variable/value (jv<0 : infeasible)         */
/*    ============================================================    */
      nmin=node;
      if(nopt != 0) nmin=nopt;
      zmin=znod[nmin];
      for(n=1; n<=node; n++) {
        if(mvx[2+n*3] < 0) continue;
        if(znod[n] >= zmin) continue;
        nmin=n;
        zmin=znod[n];
      }
      *jv=mvx[2+nmin*3];
      *jx=mvx[3+nmin*3];
      for(n=1; n<=node; n++) {
        printf("\n nxtnod %12.3le%5d%5d%5d%5d",znod[n],n
                     ,mvx[1+n*3],mvx[2+n*3],mvx[3+n*3]);
      }
      printf("\n nxtnod %12.3le     %5d%5d%5d",zmin,nmin,*jv,*jx);
      *pnmin=nmin; *pzmin=zmin; return(0);
}
/**********************************************************************/
      int savnod(int *pnode,double znod[],int mvx[]
                ,double z,int nmin,int jv,int jx) {
/*    int savnod(pnode,znod,mvx,z,nmin,jv,jx)
      double znod[],z; int *pnode,mvx[],nmin,jv,jx; {                 */
/*    ============================================================    */
/*    dimension znod(node),mvx(3,nvar)                                */
      int node;
      --znod; mvx-=4;
      node=*pnode;
/*    ============================================================    */
/*    at node=node+1 : save node data : znod(node) & mvx(3,node)      */
/*    ============================================================    */
      node=node+1;
      znod[node]=z;
      mvx[1+node*3]=nmin;
      mvx[2+node*3]=jv;
      mvx[3+node*3]=jx;
/*    +----------------------------------------------------------+    */
/*    | set mother node to non-active (negative mvx(2,nmin))     |    */
/*    +----------------------------------------------------------+    */
      if(nmin > 0) mvx[2+nmin*3]=-abs(mvx[2+nmin*3]);
      printf("\n savnod %12.3le%5d%5d%5d%5d",znod[node],node
                ,mvx[1+node*3],mvx[2+node*3],mvx[3+node*3]);
      *pnode=node; return(0);
}
/**********************************************************************/
      int intval(int iv,int ix,double *xval
                ,double dlu[],int ityp[],double val[],int nvar) {
/*    int intval(iv,ix,xval,dlu,ityp,val,nvar)
      double *xval,dlu[],val[]; int iv,ix,ityp[],nvar; {              */
/*    ============================================================    */
/*    dimension dlu(3,nvar),itype(3,nvar),val(1)                      */
      int iv1,iv2,iv3,id;
      dlu-=4; ityp-=4; --val;
/*    ============================================================    */
/*i   iv   = integer variable                                         */
/*i   ix   = integer value of the var iv                              */
/*o   xval = real value of the var iv = ix or val(ix+ityp(2,iv)-1)    */
/*i   ityp(1,iv) = 0 : real value                                     */
/*               = 1 : 0 or 1                                         */
/*               = 2 : integer value : 0, 1, 2, ...                   */
/*               =-m : use discrete values for intermidiate values    */
/*                     in val(iype(2,iv):ityp(2,iv)+m-1)              */
/*    ============================================================    */
      iv1=1+iv*3; iv2=iv1+1; iv3=iv2+1;
      if(ityp[iv1]== 0) {
        printf("\n error !"); exit(1);
      } else if(ityp[iv1] > 0) {
        *xval=ix;
      } else if(ityp[iv1] < 0) {
        id=ityp[iv2]+ix-1;
        if(ix <= 0) {
          *xval=0.0;
        } else if(ix <= abs(ityp[iv1])) {
          *xval=val[id];
        } else {
          *xval=dlu[iv3];
        }
      }
      return(0);
}
/**********************************************************************/
      int intchk(double x[],int ityp[],double val[]
                ,int nvar,int *jv,int *jx,int icase) {
/*    int intchk(x,ityp,val,nvar,jv,jx,icase)
      double x[],val[]; int ityp[],nvar,*jv,*jx,icase; {              */
/*    ============================================================    */
/*    dimension x(nvar),itype(3,nvar),val(1)                          */
      double vals,xi,eps=1.0e-6;
      int    ix,id,iv,iv1,iv2,iv3,istrt,istop;
      --x; ityp-=4; --val;
/*    ============================================================    */
/*i   icase      = -1/0/1 : infeasible/feasible/unbounded             */
/*o   ityp(3,iv) = -1 : variable is integer/discrete                  */
/*o              >= 0 : variable is not integer/discrete              */
/*o   jv,jx      =  next integer variable/value (jv=-1:infeasible)    */
/*    ============================================================    */
      *jv=-1;
      *jx=0;
      if(icase < 0) return(0);
      for(iv=1; iv<=nvar; iv++) { iv1=1+iv*3; iv2=iv1+1; iv3=iv2+1;
        ityp[iv3]=-1;
        if(ityp[iv1] == 0) {
          ityp[iv3]=-1;
        } else if(ityp[iv1] > 0) {
          ix=x[iv]+eps;
          if(fabs(ix-x[iv]) > eps) ityp[iv3]=x[iv];
        } else if(ityp[iv1] < 0) {
          vals=0.0;
          istrt=ityp[iv2];
          istop=istrt-ityp[iv1]-1;
          for(id=istrt; id<=istop; id++) {
            if(x[iv] <= val[id]) {
              xi=(x[iv]-vals)/(val[id]-vals);
              ix=xi+eps;
              if(fabs(ix-xi) > eps) ityp[iv3]=id-istrt;
              goto L50;
            }
            vals=val[id];
          }
        }
  L50:;}
/*    +----------------------------------------------------------+    */
/*    | find jv/jx : non-integer variable/value for left node    |    */
/*    +----------------------------------------------------------+    */
      for(iv=1; iv<=nvar; iv++) {
        if(iv%10 == 1) printf("\n intchk "); printf("%5d",ityp[1+iv*3]);
      }
      for(iv=1; iv<=nvar; iv++) {
        if(iv%10 == 1) printf("\n intchk "); printf("%5d",ityp[2+iv*3]);
      }
      for(iv=1; iv<=nvar; iv++) {
        if(iv%10 == 1) printf("\n intchk "); printf("%5d",ityp[3+iv*3]);
      }
      *jv=0;
      for(iv=1; iv<=nvar; iv++) { iv3=3+iv*3;
        if(ityp[iv3] < 0) continue;
        *jv=iv;
        *jx=ityp[iv3];
        printf("\n intchk %5d%5d",*jv,*jx);
        return(0);
      }
      return(0);
}
/**********************************************************************/
      int setsmp(double a[],int li[],int lj[],double d[]
                ,int nx,int ii,int jj,int nia,int nja
                ,double aa[],int lli[],int llj[]
                ,double dlu[],int nvar,int *icase) {
/*    int setsmp(a,li,lj,d,nx,ii,jj,nia,nja,aa,lli,llj,dlu,nvar,icase)
      double a[],d[],aa[],dlu[];
      int li[],lj[],nx,ii,jj,nia,nja,lli[],llj[],nvar,*icase; {       */
/*    ============================================================    */
/*    dimension aa(nia,nja),lli(nia),llj(nja)                         */
/*    dimension a(nia,nja),li(nia),lj(nja),d(nx),dlu(3,nvar)          */
      int i,j,ja,jja,j3;
      --a; a-=nia; --li; --lj; --d; --aa; aa-=nia; --lli; --llj; dlu-=4;
/*    ============================================================    */
/*    input : aa,lli,llj;  output : a,li,lj,d of simplex tableau      */
/*    ------------------------------------------------------------    */
/*o   icase = -1 : for infeasible case due to xl > xu (= 0 else)      */
/*    ============================================================    */
      for(j=1; j<=jj; j++) { ja=j*nia;
        lj[j]=llj[j];
        for(i=1; i<=ii; i++) {
          a[i+ja]=aa[i+ja];
        }
      }
      for(i=1; i<=ii; i++) {
        li[i]=lli[i];
      }
      *icase=0; jja=jj*nia;
      for(j=1; j<=jj-1; j++) { ja=j*nia; j3=j*3;
        d[j]=dlu[2+j3]-dlu[1+j3];
        if(d[j] < 0.0) *icase=-1;
        if(dlu[1+j3] == 0.0) continue;
        for(i=1; i<=ii; i++) {
          a[i+jja]=a[i+jja]-a[i+ja]*dlu[1+j3];
        }
      }
      return(0);
}
/**********************************************************************/
      int getxvl(double x[],double dlu[],int nvar,int icase) {
/*    int getxvl(x,dlu,nvar,icase)
      double x[],dlu[]; int nvar,icase; {                             */
/*    ============================================================    */
/*    dimension x(nvar),dlu(3,nvar)                                   */
      int iv;
      --x; dlu-=4;
/*    ============================================================    */
/*    transform solution of simplex tableau to original equation      */
/*    ============================================================    */
      if(icase < 0) return(0);
      for(iv=1; iv<=nvar; iv++) {
        x[iv]=x[iv]+dlu[1+iv*3];
        printf("\n getxvl %12.3le%12.3le%12.3le%12.3le"
                  ,x[iv],dlu[1+iv*3],dlu[2+iv*3],dlu[3+iv*3]);
      }
      return(0);
}
/**********************************************************************/
      int setlij(int li[],int lj[],double d[],double dlu[]
                ,int ii,int jj,int *nx,int nia,int nja,int *nvar) {
/*    int setlij(li,lj,d,dlu,ii,jj,nx,nia,nja,nvar)
      double d[],dlu[]; int li[],lj[],ii,jj,*nx,nia,nja,*nvar; {      */
/*    ============================================================    */
/*    dimension li(nia),lj(nja),d(nja),dlu(3,1)                       */
      int i,j;
      --li; --lj; --d; dlu-=4;
/*    ============================================================    */
/*i   li(i)    =-1/0/1 : ge/eq/le constraint for row i                */
/*o            =-s/0/s : s = slack variable number > nvar             */
/*i   lj(j)    =  0/k  : k = variable number for column j             */
/*o            =  j/k  : j = variable number for column j             */
/*i   d(k)     =  0/u  : u = upper bound for variable k               */
/*o            =  m/u  : m = 1.0d30 for no-upper-bound variable k     */
/*o   dlu(3,k) =  d(k) : for k <= nvar                                */
/*i   ii       =  number of total rows in a(ii,jj) <= nia             */
/*i   jj       =  number of total cols in a(ii,jj) <= nja             */
/*o   nvar     =  jj - 1                                              */
/*o   nx       =  nvar + slack variables                              */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | set nvar,nx,li(ii-1),lj(jj-1),d(nx) for simplex tableau  |    */
/*    | save d(1:nvar) in dlu(3:3,1:nvar)  for int bounds setup  |    */
/*    +----------------------------------------------------------+    */
      for(j=1; j<=jj-1; j++) {
        if(lj[j] == 0) lj[j]=j;
      }
      *nvar=jj-1;
      *nx=jj-1;
      for(i=1; i<=ii-1; i++) {
        if(li[i] == 0) continue;
        *nx=*nx+1;
        if(abs(li[i]) == 1) li[i]=*nx*li[i];
      }
      for(j=1; j<=*nx; j++) {
        if(d[j] <= 0.0) d[j]=1.0e30;
        if(j <= *nvar) dlu[3+j*3]=d[j];
      }
      return(0);
}
/**********************************************************************/
