#include <stdio.h>
#include <ctype.h>
#include <math.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w,*fp_s;
      double *aa,*d,*x,*a,*t,*dlu,*val,*znod;
      int    *lli,*llj,*li,*lj,*mi,*mj,*ityp,*mvx; int dlp();
      int    i,j,k,ii,jj,nx,ny,icase,nia,nja,is,ic,nvar,kstrt,knext;
      int    nval=1000,nnode=300;
/*    ============================================================    */
/*    input data -----+------+--------------------+----------         */
/*                seq | sets | variables          |  format           */
/*               -----+------+--------------------+----------         */
/*                 1  |  1   | is,ic              |  2i5              */
/*                 2  |  1   | ii,jj,ny           |  3i5              */
/*                 3  |  ii  | (a(i,j),j=1,jj)    |  8f10.0           */
/*                 4  |  1   | (d(j),j=1,ny)      |  8f10.0           */
/*                 5  |  1   | (li(i),i=1,ii-1)   |  16i5             */
/*                 6  |  1   | (lj(j),j=1,jj-1)   |  16i5             */
/*                 7  |  1   | (ityp(j),j=1,jj-1) |  16i5             */
/*                 8  |  *   | (val(k,*),k=1,m)   |  8f10.0           */
/*               -----+------+--------------------+----------         */
/*    is    = file# to save origi. tableau (no re-perform if is=0)    */
/*    ic    = file# to save debug output (no debug output if ic=0)    */
/*    ii,jj = numbers of rows and columns of simplex tableau          */
/*    ny    = maximum variable # which have upper bound to input      */
/*            (may include slack var but not artificial var)          */
/*    ------------------------------------------------------------    */
/*    a(i,j)            = simplex tableau                             */
/*    i=1,ii-1;j=1,jj-1 : for coeff. of variables : a(i,j)            */
/*    i=1,ii-1;j=jj     : for rhs constants       : b(i) = a(i,jj)    */
/*    i=ii    ;j=1,jj-1 : for objective function  : c(j) = a(ii,j)    */
/*    ------------------------------------------------------------    */
/*    d(j)  = upper bound value for variable i                        */
/*    ------------------------------------------------------------    */
/*    li(i) = constaint equation type                                 */
/*          = +1  for lesser  or equal constraint                     */
/*          = -1  for greater or equal constraint                     */
/*          =  0  for equal constarint                                */
/*    lj(j) = variable # for column j of the table                    */
/*          = 0  will be reset to j by this program                   */
/*    ityp(j) = 0 : real variable                                     */
/*            = 1 : 0/1 integer var (d(j)=1 set by this program)      */
/*            = 2 : integer  var -> 0,1,2,...,d(j)                    */
/*            =-m : discrete var -> 0,val(1),val(2),..,val(m),d(j)    */
/*    val(1:m,*) =  discrete values for discrete variable             */
/*    ============================================================    */
      if(argc<3) {printf("Usage : dlp infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
  L10:freeii(&is,fp_r); freeii(&ic,fp_r);
      freeii(&ii,fp_r); freeii(&jj,fp_r); freeii(&ny,fp_r);
      if(ii <= 0 || jj <= 0) exit(0);
/*    ------------------------------------------------------------    */
      nia=ii+1; nja=jj;
      a =(double *)calloc(nia*nja,sizeof(double));
      d =(double *)calloc(nia+nja,sizeof(double));
      x =(double *)calloc(nia+nja,sizeof(double));
      li=(int    *)calloc(ii     ,sizeof(int   ));
      lj=(int    *)calloc(jj     ,sizeof(int   ));
      aa =(double *)calloc(nia*nja,sizeof(double));
      lli=(int    *)calloc(ii     ,sizeof(int   ));
      llj=(int    *)calloc(jj     ,sizeof(int   ));
      ityp=(int    *)calloc(3*jj   ,sizeof(int   ));
      dlu =(double *)calloc(3*jj   ,sizeof(double));
      mvx =(int    *)calloc(3*nnode,sizeof(int   ));
      znod=(double *)calloc(nnode  ,sizeof(double));
      val =(double *)calloc(nval   ,sizeof(double));
      if(val == NULL) {
        printf("\n ii,jj = %d,%d are too large",ii,jj); exit(1);
      }
      --a; a-=nia; --li; --lj; --d; --x; --aa; aa-=nia; --lli; --llj;
      ityp-=4; dlu-=4; /* mvx-=4; --znod; */ --val;
/*    ------------------------------------------------------------    */
      if(is < 0) {
        t=(double *)calloc(nia*nja,sizeof(double));   /* --t; t-=nia; */
        mi=(int   *)calloc(ii     ,sizeof(int   ));   /* --mi;        */
        mj=(int   *)calloc(jj     ,sizeof(int   ));   /* --mj;        */
        if(mj == NULL) is=abs(is);
      }
      if(is > 0) {if((fp_s=fopen("lp.tmp","w+b"))==NULL) exit(-1);}
/*    --t; t-=nia; --mi; --mj;                                        */
/*    ------------------------------------------------------------    */
      for(i=1; i<=ii; i++) { for(j=1; j<=jj; j++) {
          freer8(&a[i+j*nia],fp_r);
      } }
      for(j=1; j<=ny;   j++) freer8(&d[j] ,fp_r);
      for(i=1; i<=ii-1; i++) freeii(&li[i],fp_r);
      for(j=1; j<=jj-1; j++) freeii(&lj[j],fp_r);
      for(j=1; j<=jj-1; j++) freeii(&ityp[1+j*3],fp_r);
/*    +----------------------------------------------------------+    */
/*    | comput nx and fill d(ny+1:nx)=0                          |    */
/*    | setup li(ii-1),lj(jj-1),d(nx) for simplex tableau        |    */
/*    +----------------------------------------------------------+    */
      for(j=1; j<=jj-1; j++) {
        if(lj[j] == 0) lj[j]=j;
      }
      nx=jj-1; nvar=jj-1;
      for(i=1; i<=ii-1; i++) {
        if(li[i] == 0) continue;
        nx=nx+1;
        if(abs(li[i]) == 1) li[i]=li[i]*nx;
      }
      for(j=1; j<=nx; j++) {
        if(j > ny) d[j]=0.0;
        if(d[j] <= 0.0) d[j]=1.0e30;
      }
/*    +----------------------------------------------------------+    */
/*    | read discrete values val(1:m,*) for ityp=-m              |    */
/*    +----------------------------------------------------------+    */
      knext=1;
      for(j=1; j<=jj-1; j++) {
        if(ityp[1+j*3] == 1) d[j]=1.0;
        if(ityp[1+j*3] < 0) {
          kstrt=knext;
          knext=kstrt-ityp[1+j*3];
          if(knext > nval) {printf("\n dim nval too small"); exit(1);}
          ityp[2+j*3]=kstrt;
          for(k=kstrt; k<=knext-1; k++) freer8(&val[k],fp_r);
        }
      }
/*    +----------------------------------------------------------+    */
/*    | write data before calling lp                             |    */
/*    +----------------------------------------------------------+    */
      fprintf(fp_w,"\n ********** data before calling dlp **********");
      for(i=1; i<=ii; i++) { for(j=1; j<=jj; j++) {
        if(j%10 == 1) fprintf(fp_w,"\n");
        fprintf(fp_w,"%10.3lf",a[i+j*nia]);
      } }
      for(j=1; j<=nx; j++) {
        if(j%10 == 1) fprintf(fp_w,"\n"); fprintf(fp_w,"%10.2le",d[j]);
      }
      for(i=1; i<=ii-1; i++) {
        if(i%10 == 1) fprintf(fp_w,"\n"); fprintf(fp_w,"%5d",li[i]);
      }
      for(j=1; j<=jj-1; j++) {
        if(j%10 == 1) fprintf(fp_w,"\n"); fprintf(fp_w,"%5d",lj[j]);
      }
      for(j=1; j<=jj-1; j++) {
        if(j%10 == 1) fprintf(fp_w,"\n");
        fprintf(fp_w,"%5d",ityp[1+j*3]);
      }
/*    +----------------------------------------------------------+    */
      dlp(&a[1+nia],&li[1],&lj[1],&d[1],&x[1],ii,jj,nia,nja
         ,&aa[1+nia],&lli[1],&llj[1],t,mi,mj,is,ic
         ,&icase,&dlu[4],&ityp[4],&val[1],znod,mvx,nvar,nx,fp_s,fp_w);
/*    +----------------------------------------------------------+    */
/*    | write data after calling linear                          |    */
/*    +----------------------------------------------------------+    */
      fprintf(fp_w,"\n ========== data after calling dlp ==========");
      for(i=1; i<=ii; i++) { for(j=1; j<=jj; j++) {
        if(j%10 == 1) fprintf(fp_w,"\n");
        fprintf(fp_w,"%10.3lf",aa[i+j*nia]);
      } }
      for(j=1; j<=nx; j++) {
        if(j%10 == 1) fprintf(fp_w,"\n"); fprintf(fp_w,"%10.2le",d[j]);
      }
      for(i=1; i<=ii-1; i++) {
        if(i%10 == 1) fprintf(fp_w,"\n"); fprintf(fp_w,"%5d",lli[i]);
      }
      for(j=1; j<=jj-1; j++) {
        if(j%10 == 1) fprintf(fp_w,"\n"); fprintf(fp_w,"%5d",llj[j]);
      }
      for(j=1; j<=jj-1; j++) {
        if(j%10 == 1) fprintf(fp_w,"\n");
        fprintf(fp_w,"%5d",ityp[1+j*3]);
      }
/*    +----------------------------------------------------------+    */
/*    | output feasible optimal solution                         |    */
/*    +----------------------------------------------------------+    */
      if(icase == 0) {
        fprintf(fp_w,"\n values of variables =");
        for(j=1; j<=nx; j++) {
          if(j%10 == 1)fprintf(fp_w,"\n"); fprintf(fp_w,"%10.2le",x[j]);
        }
        fprintf(fp_w,"\n objective function  =%15.6le",-aa[ii+jj*nia]);
      }
      free(a+1+nia); free(++li); free(++lj); free(++d); free(++x);
      free(aa+1+nia); free(++lli); free(++llj);
      free(ityp+4); free(dlu+4); free(mvx); free(znod); free(++val);
      if(is < 0) {free(t); free(mi); free(mj);}
      goto L10;
}
/**********************************************************************/
