#include <stdio.h>
#include <ctype.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double *a,*b,*c,*g; int *ix,*id,*im,*is;
      double zopt; int i,j,nc,nv,nra; int zerone();
/*    ============================================================    */
      if(argc<3) {printf("Usage : zerone infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
  L10:freeii(&nc,fp_r); freeii(&nv,fp_r); nra=nc;
      if(nc <= 0 || nv <= 0) exit(0);
      a=(double *)calloc(nc*nv,sizeof(double));
      b=(double *)calloc(nc   ,sizeof(double));
      c=(double *)calloc(nv   ,sizeof(double));
      g=(double *)calloc(nc   ,sizeof(double));
      ix=(int   *)calloc(nv   ,sizeof(int   ));
      id=(int   *)calloc(nv   ,sizeof(int   ));
      im=(int   *)calloc(nv   ,sizeof(int   ));
      is=(int   *)calloc(nv   ,sizeof(int   ));
      if(is == NULL) {
        printf("\n nc,nv = %d,%d are too large",nc,nv); exit(1);
      }
      for(j=0; j<nv; j++) freer8(&c[j],fp_r);
      for(i=0; i<nc; i++) {
        for(j=0; j<nv; j++) freer8(&a[i+j*nra],fp_r);
        freer8(&b[i],fp_r);
      }
/*    ------------------------------------------------------------    */
      zerone(a,b,c,g,ix,id,im,is,&zopt,nc,nv,nra,fp_w); /* fp_w|NULL  */
/*    ------------------------------------------------------------    */
      fprintf(fp_w,"\n\n objective c(nv) :\n");
      for(j=0; j<nv; j++) {
        if(j%11 == 0) fprintf(fp_w,"\n"); fprintf(fp_w,"%7.0lf",c[j]);
      }
      fprintf(fp_w,"\n\n constraints a(nc,nv) :\n");
      for(i=0; i<nc; i++) {
        for(j=0; j<nv; j++) {
          if(j%11 == 0) fprintf(fp_w,"\n");
          fprintf(fp_w,"%7.0lf",a[i+j*nra]);
        }
        fprintf(fp_w,"%7.0lf",b[i]);
      }
      fprintf(fp_w,"\n\n constraint values g(nc) :\n");
      for(i=0; i<nc; i++) {
        if(i%11 == 0) fprintf(fp_w,"\n");
        fprintf(fp_w,"%7.0lf",g[i]);
      }
/*    ------------------------------------------------------------    */
      fprintf(fp_w,"\n\n solution vector :\n");
      for(j=0; j<nv; j++) {
        if(j%11 == 0) fprintf(fp_w,"\n"); fprintf(fp_w,"%7d",ix[j]);
      }
      fprintf(fp_w,"\n\n optimal function :  %7.0lf\n",zopt);
      free(a);  free(b);  free(c);  free(g);
      free(ix); free(id); free(im); free(is);
      goto L10;
}
/**********************************************************************/
      int zerone(double a[],double b[],double c[],double g[]
                ,int ix[],int id[],int im[],int is[]
                ,double *pzopt,int nc,int nv,int nra,FILE *fp_w) {
/*    int zerone(a,b,c,g,ix,id,im,is,pzopt,nc,nv,nra,fp_w)
      double a[],b[],c[],g[],*pzopt;
      int    ix[],id[],im[],is[],nc,nv,nra; FILE *fp_w; {             */
/*    ============================================================    */
/*    dim a(nra,nv),b(nc),c(nv),g(nc),ix(nv),id(nv),im(nv),is(nv)     */
      double z,zopt;
      int    i,j,k,jj,ns,kv; int findkv(),compgz();
      --a; a-=nra; --b; --c; --g; --ix; --id; --im; --is;
/*    zopt=*pzopt;                                                    */
/*    ============================================================    */
/*    minimize z = c(j)*ix(j)                                         */
/*    subject to : a(i,j)*ix(j) + b(i) >= 0                           */
/*               : ix(j) = 0 or 1                                     */
/*    ============================================================    */
/*o   g(i)  = a(i,j)*ix(j) + b(i)                                     */
/*o   ix(j) = 0 or 1 : the solution vector                            */
/*w         = 1 : indicate the input c(j) is negative                 */
/*w   id(j) = 0 : variable j is a free variable                       */
/*w         = 1 : variable j is fixed at 1                            */
/*w         =-1 : variable j is fixed at 0                            */
/*w   im(j) = id(j) corresponding to zopt                             */
/*w   is(*) = fixed variables stack                                   */
/*w   ns    = number of fixed variables in the stack                  */
/*w   z     = objective function under consideration                  */
/*o   zopt  = the best objective function found so far                */
/*i   nc    = number of constraints                                   */
/*i   nv    = number of variables                                     */
/*i   nra   = row dimension of matrix a(nra,nv)                       */
/*w   kv    = the last fixed variable to be put or get from stack     */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | initialize : set id(*)=0 : i.e. all variables are free   |    */
/*    |              change variable x(j) to 1-x(j) if c(j) < 0  |    */
/*    |                 and set ix(j)=1 to indicate this change  |    */
/*    |              set ns=0 : i.e. no fixed variable in stack  |    */
/*    |              set g(i)=b(i) & z=0 and zopt=0 or infinity  |    */
/*    +----------------------------------------------------------+    */
      for(j=1; j<=nv; j++) { jj=j*nra;
        im[j]=0;
        is[j]=j;
        ix[j]=0;
        if(c[j] < 0.0) {
          ix[j]=1;
          c[j]=-c[j];
          for(i=1; i<=nc; i++) {
            b[i]=b[i]+a[i+jj];
            a[i+jj]=-a[i+jj];
          }
        }
      }
/*    ------------------------------------------------------------    */
      ns=0;
      z=0.0;
      zopt=0.0;
      for(i=1; i<=nc; i++) {
        g[i]=b[i];
        if(g[i] < 0.0) zopt=1.0e30;
      }
/*    +----------------------------------------------------------+    */
/*    | find variable kv (if any) to be fixed at 1 or 0          |    */
/*    +----------------------------------------------------------+    */
  L50:findkv(&a[1+nra],&c[1],&g[1],&is[1],nc,nv,nra,z,zopt,ns,&k);
/*    +----------------------------------------------------------+    */
/*    | if kv > 0 : go down one level & fix variable kv at 1     |    */
/*    +----------------------------------------------------------+    */
      if(k > ns) {
        ns=ns+1;
        kv=is[k];
        is[k]=is[ns];
        is[ns]=kv;
        if(fp_w!=NULL) fprintf(fp_w,"\n kv,id[kv] : %7d%7d",kv,1);
/*    +----------------------------------------------------------+    */
/*    | if kv < 0 : stay at this level & fix variable kv at 0    |    */
/*    +----------------------------------------------------------+    */
      } else if(k < 0) {
        ns=ns+1;
        k=-k;
        kv=is[k];
        is[k]=is[ns];
        is[ns]=-kv;
        id[kv]=-1;
        if(fp_w!=NULL) fprintf(fp_w,"\n kv,id[kv] : %7d%7d",kv,-1);
        goto L50;
/*    +----------------------------------------------------------+    */
/*    | if kv = 0 : free variables in stack & go back one level  |    */
/*    +----------------------------------------------------------+    */
      } else {
/*      +--------------------------------------------------------+    */
/*      | return if no fixed variable in stack                   |    */
/*      +--------------------------------------------------------+    */
  L70:  if(ns == 0) goto L100;
/*      +--------------------------------------------------------+    */
/*      | get from stack : variable kv to be free or fixed at 0  |    */
/*      +--------------------------------------------------------+    */
        kv=is[ns];
        if(fp_w!=NULL)
          fprintf(fp_w,"\n kv,id[kv] : %7d%7d",-abs(kv),kv/abs(kv));
/*      +--------------------------------------------------------+    */
/*      | if variable kv fixed at 0 : free variable kv           |    */
/*      +--------------------------------------------------------+    */
        if(kv < 0) {
          is[ns]=-kv;
          ns=ns-1;
          goto L70;
        }
/*      +--------------------------------------------------------+    */
/*      | else : go back one level & fix variable kv at 0        |    */
/*      +--------------------------------------------------------+    */
        is[ns]=-kv;
        if(fp_w!=NULL) fprintf(fp_w,"\n kv,id[kv] : %7d%7d",abs(kv),-1);
      }
/*    +----------------------------------------------------------+    */
/*    | update g(i), z & zopt : base on status of fixed var kv   |    */
/*    +----------------------------------------------------------+    */
      compgz(&a[1+nra],&c[1],&g[1],&is[1],nc,nv,nra
                            ,&z,&zopt,&im[1],ns,fp_w);
      goto L50;
/*    +----------------------------------------------------------+    */
/*    | return : if no fixed variable in stack                   |    */
/*    +----------------------------------------------------------+    */
 L100:if(zopt < 1.0e30) zopt=0.0;
/*    +----------------------------------------------------------+    */
/*    | compute g(nc) : base on im(nv)                           |    */
/*    +----------------------------------------------------------+    */
      for(i=1; i<=nc; i++) {
        g[i]=b[i];
      }
      for(j=1; j<=nv; j++) { jj=j*nra;
        if(im[j] > 0) {
          for(i=1; i<=nc; i++) {
            g[i]=g[i]+a[i+jj];
          }
        }
/*      +--------------------------------------------------------+    */
/*      | reset a,b,c to original input values : base on ix(nv)  |    */
/*      +--------------------------------------------------------+    */
        if(ix[j] > 0) {
          c[j]=-c[j];
          for(i=1; i<=nc; i++) {
            b[i]=b[i]+a[i+jj];
            a[i+jj]=-a[i+jj];
          }
        }
/*      +--------------------------------------------------------+    */
/*      | compute ix(nv) & zopt : base on im(nv) & ix(nv)        |    */
/*      +--------------------------------------------------------+    */
        if(im[j] > 0) ix[j]=1-ix[j];
        if(ix[j] > 0) zopt=zopt+c[j];
      }
      *pzopt=zopt; return(0);
}
/**********************************************************************/
      int findkv(double a[],double c[],double g[],int is[],int nc,int nv
                ,int nra,double z,double zopt,int ns,int *k) {
/*    int findkv(a,c,g,is,nc,nv,nra,z,zopt,ns,k)
      double a[],c[],g[],z,zopt; int is[],nc,nv,nra,ns,*k; {          */
/*    ============================================================    */
/*    dimension a(nra,nv),g(nc),c(nv),is(nv)                          */
      double gjmax,gi,gj,tmp;
      int    i,j,jj,kj;
      --a; a-=nra; --c; --g; --is;
/*    ============================================================    */
/*    input : a,c,g,id,nc,nv,nra,z,zopt;        output : kv           */
/*    ------------------------------------------------------------    */
/*o   (1) kv = 0 : if  z >= zopt (true for feasible solution)         */
/*o   (4)          or  z >= zopt (no more improvement)                */
/*o   (2)          or  no feasible solutions at all nodes             */
/*o   (u)          or  no free variable (no id(*) = 0)                */
/*o   (3) kv < 0 : the variable to be fixed at 0 in this level        */
/*o   (d) kv > 0 : the variable to be fixed at 1 in next level        */
/*    ============================================================    */
      *k=0;
/*    +----------------------------------------------------------+    */
/*    | return kv=0 by case (1) or (4) : z >= zopt               |    */
/*    +----------------------------------------------------------+    */
      if(z >= zopt) return(0);
/*    +----------------------------------------------------------+    */
/*    | return kv=-j by case (3) : any z+c(j) >= zopt            |    */
/*    +----------------------------------------------------------+    */
      if(zopt < 1.0e30) {
        for(kj=ns+1; kj<=nv; kj++) {
          j=is[kj];
          if(z+c[j] < zopt) continue;
          *k=-kj;
          return(0);
        }
      }
/*    +----------------------------------------------------------+    */
/*    | return kv=0 by case (2) : any g(i)+sum.pos.a(i,j) < 0    |    */
/*    +----------------------------------------------------------+    */
      for(i=1; i<=nc; i++) {
        gi=g[i];
        if(gi < 0.0) {
          for(kj=ns+1; kj<=nv; kj++) {
            j=is[kj];  jj=j*nra;
            if(a[i+jj] > 0.0) gi=gi+a[i+jj];
          }
          if(gi < 0.0) return(0);
        }
      }
/*    +----------------------------------------------------------+    */
/*    | compute infeasiblity value = gj = sum.neg.(g(i)+a(i,j))  |    */
/*    +----------------------------------------------------------+    */
      gjmax=-1.0e30;
      for(kj=ns+1; kj<=nv; kj++) {
        j=is[kj];  jj=j*nra;
        gj=0.0;
        for(i=1; i<=nc; i++) {
          if((tmp=g[i]+a[i+jj]) < 0) gj=gj+tmp;
        }
/*      +--------------------------------------------------------+    */
/*      | select kv by max.gj : if gj<0 : next node is infeasible|    */
/*      +--------------------------------------------------------+    */
        if(gj > gjmax) {
          gjmax=gj;
          *k=kj;
/*      +--------------------------------------------------------+    */
/*      | select kv by min.c(j) : if gj=0 : next node is feasible|    */
/*      | next 2 lines are not reqd if c(j) is in incr. order    |    */
/*      +--------------------------------------------------------+    */
        } else if(gj == 0) {
          if(c[j] < c[is[*k]]) *k=kj;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | return kv>0 by case (d) : kv = variable to be fixed at 1 |    */
/*    | return kv=0 by case (u) : no free variable               |    */
/*    +----------------------------------------------------------+    */
      return(0);
}
/**********************************************************************/
      int compgz(double a[],double c[],double g[],int is[],int nc,int nv
         ,int nra,double *z,double *zopt,int im[],int ns,FILE *fp_w) {
/*    int compgz(a,c,g,is,nc,nv,nra,z,zopt,im,ns,fp_w) FILE *fp_w;
      double a[],c[],g[],*z,*zopt; int is[],im[],nc,nv,nra,ns; {      */
/*    ============================================================    */
/*    dimension a(nra,nv),g(nc),c(nv),is(nv),im(nv)                   */
      int    i,j,isf,kj,kv,kk;
      --a; a-=nra; --c; --g; --is; --im;
/*    ============================================================    */
/*    explicit enumerate the node by computing g(nc) & z              */
/*    ------------------------------------------------------------    */
/*    input  : a,c,g,id,nc,nv,nra,z,zopt,im,kv                        */
/*    output : g,z,zopt,im                                            */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | update g(i) & z and set isf=1 if all g(i) >= 0 ?         |    */
/*    +----------------------------------------------------------+    */
      isf=1;
      if(is[ns] > 0) {
        kv=is[ns]; kk=kv*nra;
        *z=*z+c[kv];
        for(i=1; i<=nc; i++) {
          g[i]=g[i]+a[i+kk];
          if(g[i] < 0.0) isf=0;
        }
      } else {
        kv=-is[ns]; kk=kv*nra;
        *z=*z-c[kv];
        for(i=1; i<=nc; i++) {
          g[i]=g[i]-a[i+kk];
          if(g[i] < 0.0) isf=0;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | for feasible solution : save best one in zopt & im(nv)   |    */
/*    +----------------------------------------------------------+    */
      if(isf != 0 && *z < *zopt) {
        *zopt=*z;
        for(j=1; j<=nv; j++) {
          im[j]=0;
        }
        for(kj=1; kj<=ns; kj++) {
          j=is[kj];
          if(j > 0) im[j]=1;
        }
        if(fp_w != NULL) fprintf(fp_w,"\n zopt follows : ");
      }
      if(fp_w == NULL) return(0);
/*    ------------------------------------------------------------    */
      for(j=1; j<=nv; j++) {
        if(j%10 == 1) fprintf(fp_w,"\n is(*) :");
        fprintf(fp_w,"%7d",is[j]);
      }
      for(i=1; i<=nc; i++) {
        if(i%10 == 1) fprintf(fp_w,"\n g(*)  :");
        fprintf(fp_w,"%7.0lf",g[i]);
      }
      fprintf(fp_w,"\n z,ns  :%7.0lf%7d",*z,ns);
      return(0);
}
/**********************************************************************/
