/* FFTA.F -- translated by f2c (version 19971204).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include <math.h>
#define integer int
#define doublereal double
typedef struct { doublereal r, i; } doublecomplex;

/* ************************************************************************ */
/* Subroutine */ int ffta_(f, a, n, inv)
doublecomplex *f, *a;
integer *n, *inv;
{
    /* System generated locals */
    integer i__1, i__2, i__3;

    /* Local variables */
    static integer i__;
    extern /* Subroutine */ int fftbna_();
    static integer ifa, naf, nbf, now;

/* ===================================================================== * */
/* ===================================================================== * */
/* F(N) = Input (FI) and Output (FO) data array of arbitrary N           * */
/* A(N) = Working array (F1,F2,F3,...) reqd for N .NE. 2**Integer only   * */
/* --------------------------------------------------------------------- * */
/* FO(K5,K4,K3,K2,K1)=FI(L1,L2,L3,L4,L5)W^(L1,L2,L3,L4,L5)(K5,K4,K3,K2,K1) */
/*       where     W = EXP(i*(-2*PI*INV/N))                              * */
/* ===================================================================== * */
/* For NOW = 2  (N5=N4=N3=2)  :  by DO 290                               * */
/* --------------------------------------------------------------------- * */
/* F1(L1,L2,L3,L4,J5)=FI(L1,L2,L3,L4,I5)W^( 0, 0, 0, 0,I5)(J5, 0, 0, 0, 0) */
/* F2(L1,L2,L3,J4,K5)=F1(L1,L2,L3,I4,K5)W^( 0, 0, 0,I4, 0)(K5,J4, 0, 0, 0) */
/* F3(L1,L2,J3,K4,K5)=F2(L1,L2,I3,K4,K5)W^( 0, 0,I3, 0, 0)(K5,K4,J3, 0, 0) */
/* --------------------------------------------------------------------- * */
/* Bit-reversal       FR(L1,L2,K5,K4,K3)=F3(L1,L2,K3,K4,K5) : by DO 590  * */
/* --------------------------------------------------------------------- * */
/* For NOW > 2  (N2>2, N1>2)  :  by DO 90                                * */
/* --------------------------------------------------------------------- * */
/* F4(L1,K5,K4,K3,J2)=FR(L1,I2,K5,K4,K3)W^( 0,I2, 0, 0, 0)(K5,K4,K3,J2, 0) */
/* FO(K5,K4,K3,K2,J1)=F4(I1,K5,K4,K3,K2)W^(I1, 0, 0, 0, 0)(K5,K4,K3,K2,J1) */
/* ===================================================================== * */
/* W^(0,0,I3,0,0)(K5,K4,J3,0,0) = W^(0,0,1,0,0)(K5,K4,J3,0,0)I3 = AR1^I3 * */
/* OMG = W^(0,0,1,0,0) = EXP(i*(-2*PI*INV/N)*NBF)                        * */
/* AR1 = W^(0,0,1,0,0)(K5,K4,J3,0,0) = 1*OMG*OMG*OMG*...                 * */
/* --------------------------------------------------------------------- * */
/* NBFore =  N1*N2*N3*N4   N1*N2*N3    N1*N2       N1           1        * */
/* NOW    =       N5          N4         N3        N2           N1       * */
/* NAFter =       1           N5       N5*N4    N5*N4*N3   N5*N4*N3*N2   * */
/* --------------------------------------------------------------------- * */
/* IB     = (L1,L2,L3,L4) (L1,L2,L3)  (L1,L2)     (L1)          0        * */
/* IN     =      (I5)        (I4)       (I3)      (I2)         (I1)      * */
/* IA     =       0          (K5)     (K5,K4)  (K5,K4,K3) (K5,K4,K3,K2)  * */
/* IR     =       0          (K5)     (K4,K5)  (K3,K4,K5) (K2,K3,K4,K5)  * */
/* IM     =      (J5)        (J4)       (J3)      (J2)         (J1)      * */
/* < for NOW=N2=5 > : -------------------------------------------------- * */
/*       / FO(IB,IA,0) \   / W00 W01 W02 W03 W04 \ / FI(IB,0,IA) \       * */
/*       | FO(IB,IA,1) |   | W10 W11 W12 W13 W14 | | FI(IB,1,IA) |       * */
/*       | FO(IB,IA,2) | = | W20 W21 W22 W23 W24 | | FI(IB,2,IA) |       * */
/*       | FO(IB,IA,3) |   | W30 W31 W32 W33 W34 | | FI(IB,3,IA) |       * */
/*       \ FO(IB,IA,4) /   \ W40 W41 W42 W43 W44 / \ FI(IB,4,IA) /       * */
/* --------------------------------------------------------------------- * */
/*       where : Wij = W^ij,   W1j = W^j,   W1j = AR1 = OMG^(IA,j)       * */
/* --------------------------------------------------------------------- * */
/* FO($#j)=FI($0#)+(FI($1#)+(FI($2#)+(FI($3#)+FI($4#)*W1j)*W1j)*W1j)*W1j * */
/* ===================================================================== * */
    if (*n <= 1) {
        return 0;
    }
    ifa = 1;
    nbf = *n;
    naf = 1;
/* **   +----------------------------------------------------------+    ** */
/* **   | NOW = 2,..,3,..,5,..,7,..,11,..,13,..,17,..              |    ** */
/* **   +----------------------------------------------------------+    ** */
    now = 2;
L20:
    if (nbf / now * now != nbf) {
        ++now;
        goto L20;
    }
    nbf /= now;
    if (ifa > 0) {
        fftbna_(f, a, &nbf, &now, &naf, inv);
    }
    if (ifa < 0) {
        fftbna_(a, f, &nbf, &now, &naf, inv);
    }
    if (now != 2) {
        ifa = -ifa;
    }
    naf *= now;
    if (nbf > 1) {
        goto L20;
    }
/* **   +----------------------------------------------------------+    ** */
/* **   | Return transformed values in F(0:N-1)                    |    ** */
/* **   +----------------------------------------------------------+    ** */
    if (ifa > 0) {
        return 0;
    }
    i__1 = *n - 1;
    for (i__ = 0; i__ <= i__1; ++i__) {
/* L50: */
        i__2 = i__;
        i__3 = i__;
        f[i__2].r = a[i__3].r, f[i__2].i = a[i__3].i;
    }
    return 0;
} /* ffta_ */

/* *********************************************************************** */
/* Subroutine */ int fftbna_(fi, fo, nbf, now, naf, inv)
doublecomplex *fi, *fo;
integer *nbf, *now, *naf, *inv;
{
    /* System generated locals */
    integer fi_dim1, fi_dim2, fo_dim1, fo_dim2, i__1, i__2, i__3, i__4;
    doublereal d__1, d__2;
    doublecomplex z__1, z__2;

    /* Builtin functions */
    integer i_sign();
    double cos(), sin();

    /* Local variables */
    static integer ia, ib;
    static doublecomplex ff;
    static integer im, in, ir, is;
    static doublecomplex ar1;
    static doublereal ang;
    static doublecomplex omg;

/* **   ============================================================    ** */
/* **   ============================================================    ** */
    /* Parameter adjustments */
    fo_dim1 = *nbf - 1 + 1;
    fo_dim2 = *naf - 1 + 1;
    fi_dim1 = *nbf - 1 + 1;
    fi_dim2 = *now - 1 + 1;

    /* Function Body */
    i__1 = *now * *naf;
    ang = -6.2831853071795864 / i_sign(&i__1, inv);
    d__1 = cos(ang);
    d__2 = sin(ang);
    z__1.r = d__1, z__1.i = d__2;
    omg.r = z__1.r, omg.i = z__1.i;
/* **   ------------------------------------------------------------    ** */
    if (*now == 2) {
        goto L200;
    }
/* **   ------------------------------------------------------------    ** */
    ar1.r = 1., ar1.i = 0.;
    i__1 = *now - 1;
    for (im = 0; im <= i__1; ++im) {
        i__2 = *naf - 1;
        for (ia = 0; ia <= i__2; ++ia) {
            i__3 = *nbf - 1;
            for (ib = 0; ib <= i__3; ++ib) {
                i__4 = ib + (*now - 1 + ia * fi_dim2) * fi_dim1;
                ff.r = fi[i__4].r, ff.i = fi[i__4].i;
                for (in = *now - 2; in >= 0; --in) {
/* L60: */
                    z__2.r = ff.r * ar1.r - ff.i * ar1.i, z__2.i = ff.r *
                            ar1.i + ff.i * ar1.r;
                    i__4 = ib + (in + ia * fi_dim2) * fi_dim1;
                    z__1.r = z__2.r + fi[i__4].r, z__1.i = z__2.i + fi[i__4]
                            .i;
                    ff.r = z__1.r, ff.i = z__1.i;
                }
/* L70: */
                i__4 = ib + (ia + im * fo_dim2) * fo_dim1;
                fo[i__4].r = ff.r, fo[i__4].i = ff.i;
            }
/* L80: */
            z__1.r = ar1.r * omg.r - ar1.i * omg.i, z__1.i = ar1.r * omg.i +
                    ar1.i * omg.r;
            ar1.r = z__1.r, ar1.i = z__1.i;
        }
/* L90: */
    }
    return 0;
/* **   +----------------------------------------------------------+    ** */
/* **   | NOW=2 : Use dual nodes and in-place computation          |    ** */
/* **   +----------------------------------------------------------+    ** */
L200:
    ir = 0;
    ar1.r = 1., ar1.i = 0.;
    i__1 = *naf - 1;
    for (ia = 0; ia <= i__1; ++ia) {
/* **     +--------------------------------------------------------+    ** */
/* **     | / FI(IB,0,IR) \   / 1  AR1 \ / FI(IB,0,IR) \           |    ** */
/* **     | \ FI(IB,1,IR) / = \ 1 -AR1 / \ FI(IB,1,IR) /           |    ** */
/* **     +--------------------------------------------------------+    ** */
        i__2 = *nbf - 1;
        for (ib = 0; ib <= i__2; ++ib) {
            i__4 = ib + (ir * fi_dim2 + 1) * fi_dim1;
            z__1.r = fi[i__4].r * ar1.r - fi[i__4].i * ar1.i, z__1.i = fi[
                    i__4].r * ar1.i + fi[i__4].i * ar1.r;
            ff.r = z__1.r, ff.i = z__1.i;
            i__4 = ib + (ir * fi_dim2 + 1) * fi_dim1;
            i__3 = ib + ir * fi_dim2 * fi_dim1;
            z__1.r = fi[i__3].r - ff.r, z__1.i = fi[i__3].i - ff.i;
            fi[i__4].r = z__1.r, fi[i__4].i = z__1.i;
            i__4 = ib + ir * fi_dim2 * fi_dim1;
            i__3 = ib + ir * fi_dim2 * fi_dim1;
            z__1.r = fi[i__3].r + ff.r, z__1.i = fi[i__3].i + ff.i;
            fi[i__4].r = z__1.r, fi[i__4].i = z__1.i;
/* L280: */
        }
        if (ia == *naf - 1) {
            goto L290;
        }
        is = *naf / 2;
L285:
        if (is <= ir) {
            ir -= is;
            is /= 2;
            goto L285;
        }
        ir += is;
        z__1.r = ar1.r * omg.r - ar1.i * omg.i, z__1.i = ar1.r * omg.i +
                ar1.i * omg.r;
        ar1.r = z__1.r, ar1.i = z__1.i;
L290:
        ;
    }
    if (*nbf / 2 << 1 == *nbf) {
        return 0;
    }
/* **   +----------------------------------------------------------+    ** */
/* **   | Bit-reversal operation after all base 2 transformations  |    ** */
/* **   +----------------------------------------------------------+    ** */
    ir = 0;
    i__1 = (*naf << 1) - 2;
    for (ia = 0; ia <= i__1; ++ia) {
        if (ia < ir) {
            i__2 = *nbf - 1;
            for (ib = 0; ib <= i__2; ++ib) {
                i__4 = ib + ir * fi_dim1;
                ff.r = fi[i__4].r, ff.i = fi[i__4].i;
                i__4 = ib + ir * fi_dim1;
                i__3 = ib + ia * fi_dim1;
                fi[i__4].r = fi[i__3].r, fi[i__4].i = fi[i__3].i;
                i__4 = ib + ia * fi_dim1;
                fi[i__4].r = ff.r, fi[i__4].i = ff.i;
/* L540: */
            }
        }
        is = *naf;
L550:
        if (is <= ir) {
            ir -= is;
            is /= 2;
            goto L550;
        }
        ir += is;
/* L590: */
    }
    return 0;
} /* fftbna_ */

int i_sign(int *i,int *j) {
      if(*j > 0) return(*i);
      else       return(-*i);
}

int ffta(double f[],double a[],int n,int inv) {
      ffta_(f,a,&n,&inv);
      return(0);
}
