#include <math.h>
/**********************************************************************/
      int fft2d(double a[],int n1,int n2
               ,int inv1,int inv2,double w[],int nra) {
/*    int fft2d(a,n1,n2,inv1,inv2,w,nra)
      double a[],w[]; int n1,n2,inv1,inv2,nra; {
/*    ============================================================    */
      int    i,j; int ffta();
/*    ============================================================    */
/*    inv1,inv2 = +1 : fourior transform                              */
/*    inv1,inv2 = -1 : inverse transform                              */
/*    ------------------------------------------------------------    */
/*    input & output : a(0:n1-1,0:n2-1) = complex data                */
/*    ------------------------------------------------------------    */
/*    w(0:n-1) : working array                                        */
/*           n  >=  max(n1,n2+n2) for any n1  and any n2              */
/*           n  >=  max(n1,   n2) for any n1  and n2=2**k             */
/*           n  >=         n2+n2  for n1=2**m and any n2              */
/*           n  >=            n2  for n1=2**m and n2=2**k             */
/*    ------------------------------------------------------------    */
      if(n2 > 1) {
        for(i=0; i<n1; i++) {
          for(j=0; j<n2; j++) {
            w[j]=a[i+j*nra];
          }
          ffta(w,&w[n2],n2,inv2);
          for(j=0; j<n2; j++) {
            a[i+j*nra]=w[j];
          }
        }
      }
/*    ------------------------------------------------------------    */
      if(n1 > 1) {
        for(j=0; j<n2; j++) {
          ffta(&a[j*nra],w,n1,inv1);
        }
      }
/*    ------------------------------------------------------------    */
      return(0);
}
/**********************************************************************/
      int fft2sc(double a[],int n1,int n2
                ,int ics1,int ics2,double w[],int nra) {
/*    int fft2sc(a,n1,n2,ics1,ics2,w,nra)
      double a[],w[]; int n1,n2,ics1,ics2,nra; {                      */
/*    ============================================================    */
      int    i,j,nr,nc; int fftsc();
/*    ============================================================    */
/*    2-d half-sin/cos transform                                      */
/*    ------------------------------------------------------------    */
/*    ics1=+-1  half-sin transform for any n1 (nr=n1  )               */
/*    ics1=+-2  half-cos transform for any n1 (nr=n1+1)               */
/*    ics1=+-3  half-cos trans/inv for any n1 (nr=n1  )               */
/*    ics2=+-1  half-sin transform for any n2 (nc=n2  )               */
/*    ics2=+-2  half-cos transform for any n2 (nc=n2+1)               */
/*    ics2=+-3  half-cos trans/inv for any n2 (nc=n2  )               */
/*    ------------------------------------------------------------    */
/*    input & output : a(0:nr-1,0:nc-1) = real data                   */
/*    ------------------------------------------------------------    */
/*    w(0:n-1) : working array                                        */
/*           n  >=  max(n1,n2+nc) for any n1  and any n2              */
/*           n  >=  max(n1,   nc) for any n1  and n2=2**j             */
/*           n  >=         n2+nc  for n1=2**i and any n2              */
/*           n  >=            nc  for n1=2**i and n2=2**j             */
/*    ============================================================    */
      nr=n1;
      nc=n2;
      if(abs(ics1) == 2 && n1 > 1) nr=n1+1;
      if(abs(ics2) == 2 && n2 > 1) nc=n2+1;
/*    ------------------------------------------------------------    */
      if(n2 > 1) {
        for(i=0; i<nr; i++) {
          for(j=0; j<nc; j++) {
            w[j]=a[i+j*nra];
          }
          fftsc(w,&w[nc],n2,ics2);
          for(j=0; j<nc; j++) {
            a[i+j*nra]=w[j];
          }
        }
      }
/*    ------------------------------------------------------------    */
      if(n1 > 1) {
        for(j=0; j<nc; j++) {
          fftsc(&a[j*nra],w,n1,ics1);
        }
      }
/*    ------------------------------------------------------------    */
      return(0);
}
/**********************************************************************/
      int fft2cs(double a[],int n1,int n2
                ,int ics1,int ics2,double w[],int nra) {
/*    int fft2cs(a,n1,n2,ics1,ics2,w,nra)
      double a[],w[]; int n1,n2,ics1,ics2,nra; {                      */
/*    ============================================================    */
      int    i,j; int fftcs();
/*    ============================================================    */
/*    ics1,ics2 = +-1 : sin transform                                 */
/*    ics1,ics2 = +-2 : cos transform                                 */
/*    ------------------------------------------------------------    */
/*    input & output : a(0:n1-1,0:n2-1) = real data                   */
/*    ------------------------------------------------------------    */
/*    w(0:n-1) : working array                                        */
/*           n  >=  max(n1/2,n2/2+n2) for even n1 and even n2         */
/*           n  >=  max(n1/2,     n2) for even n1 and n2=2**j         */
/*           n  >=           n2/2+n2  for n1=2**i and even n2         */
/*           n  >=                n2  for n1=2**i and n2=2**j         */
/*    ============================================================    */
      if(n2 > 1) {
        for(i=0; i<n1; i++) {
          for(j=0; j<n2; j++) {
            w[j]=a[i+j*nra];
          }
          fftcs(w,&w[n2],n2,ics2);
          for(j=0; j<n2; j++) {
            a[i+j*nra]=w[j];
          }
        }
      }
/*    ------------------------------------------------------------    */
      if(n1 > 1) {
        for(j=0; j<n2; j++) {
          fftcs(&a[j*nra],w,n1,ics1);
        }
      }
/*    ------------------------------------------------------------    */
      return(0);
}
/**********************************************************************/
      int fft2h(double a[],int n1,int n2
               ,int ics1,int ics2,double w[],int nra) {
/*    int fft2h(a,n1,n2,ics1,ics2,w,nra)
      double a[],w[]; int n1,n2,ics1,ics2,nra; {                      */
/*    ============================================================    */
      int    i,j,nr,nc; int fftsc(),fftcs();
/*    ============================================================    */
/*    2-d half-sin/cos transform                                      */
/*    ------------------------------------------------------------    */
/*    ics1=+-1  half-sin transform for any n1 (nr=n1  )               */
/*    ics1=+-2  half-cos transform for any n1 (nr=n1+1)               */
/*    ics1=+-3  half-cos trans/inv for any n1 (nr=n1  )               */
/*    ics2=+-1  half-sin transform for any n2 (nc=n2  )               */
/*    ics2=+-2  half-cos transform for any n2 (nc=n2+1)               */
/*    ics2=+-3  half-cos trans/inv for any n2 (nc=n2  )               */
/*    ------------------------------------------------------------    */
/*    input & output : a(0:nr-1,0:nc-1) = real data                   */
/*    ------------------------------------------------------------    */
/*    working array  : w(0:n-1)                                       */
/*    n  >=  max(n1,n2)*4  for any n1  and any n2                     */
/*    n  >=  max(n1,n2)*2  for n1=2**m and n2=2**k                    */
/*    ============================================================    */
      nr=n1;
      nc=n2;
      if(abs(ics1) == 2 && n1 > 1) nr=n1+1;
      if(abs(ics2) == 2 && n2 > 1) nc=n2+1;
/*    ------------------------------------------------------------    */
      if(n2 > 1) {
        for(i=0; i<nr; i++) {
          for(j=0; j<n2; j++) {
            w[n2+j]=0.0;
            w[j]=a[i+j*nra];
          }
          if(abs(ics2) == 2) {
            w[0]   =0.5*w[0];
            w[nc-1]=0.5*a[i+(nc-1)*nra];
            fftcs(w,&w[2*n2],2*n2,ics2);
          } else if(abs(ics2) >= 3) {
            fftsc(w,&w[n2],n2,ics2);
          } else {
            fftcs(w,&w[2*n2],2*n2,ics2);
          }
          for(j=0; j<nc; j++) {
            a[i+j*nra]=w[j];
          }
        }
      }
/*    ------------------------------------------------------------    */
      if(n1 > 1) {
        for(j=0; j<nc; j++) {
          if(abs(ics1) >= 3) {
            fftsc(&a[j*nra],w,n1,ics1);
          } else {
            for(i=0; i<n1; i++) {
              w[n1+i]=0.0;
              w[i]=a[i+j*nra];
            }
            if(abs(ics1) == 2) {
              w[0]   =0.5*w[0];
              w[nr-1]=0.5*a[nr-1+j*nra];
            }
            fftcs(w,&w[2*n1],2*n1,ics1);
            for(i=0; i<nr; i++) {
              a[i+j*nra]=w[i];
            }
          }
        }
      }
/*    ------------------------------------------------------------    */
      return(0);
}
/**********************************************************************/
