#include <math.h>
/**********************************************************************/
      int ffta(double f[],double a[],int n,int inv) {
/*    int ffta(f,a,n,inv) double f[],a[]; int n,inv; {                */
/*====================================================================*/
/*    complex fi(n),fo(n)                                             */
      int     nbf,now,naf,ifa,i;
/*    ============================================================    */
/*    f(n) = input (fi) and output (fo) data array of arbitrary n     */
/*    a(n) = working array (f1,f2,f3,...)  for n != 2**m only         */
/*    ============================================================    */
      ifa=1;
      nbf=n;
      naf=1;
      now=4;
/*    +----------------------------------------------------------+    */
/*    | now = 4,..,2,3,..,5,..,7,..,11,..,13,..,17,..            |    */
/*    +----------------------------------------------------------+    */
      while(nbf > 1) {
        while(nbf%now != 0) {now++; if(now==5) now=2; if(now==4) now=5;}
        nbf=nbf/now;
        if(ifa > 0) fftbna(f,a,nbf,now,naf,inv);
        else        fftbna(a,f,nbf,now,naf,inv);
        if(now%2 != 0) ifa=-ifa;
        naf=naf*now;
      }
/*    +----------------------------------------------------------+    */
/*    | return transformed values in f(0:n-1)                    |    */
/*    +----------------------------------------------------------+    */
      if(ifa > 0) return(0);
      for(i=0; i<2*n; i++) f[i]=a[i];
      return(0);
}
/**********************************************************************/
      int fftbna(double fi[],double fo[]
                ,int nbf,int now,int naf,int inv) {
/*    int fftbna(fi,fo,nbf,now,naf,inv)
      double fi[,fo[]; int nbf,now,naf,inv; {                         */
/*    ============================================================    */
/*    complex fi(nbf,now,naf),fo(nbf,naf,now)                         */
      double  ang,tt10,ttn0,ttm0;
      double  omg0,ar10,arn0,ff0,v00,v10,v20,v30;
      double  omg1,ar11,arn1,ff1,v01,v11,v21,v31;
      double  xt0,yt0,xi0,yi0,unm0,un10,u110;
      double  xt1,yt1,xi1,yi1,unm1,un11,u111;
      int     ia,ib,ir,is,in,im,jn,jm,iri,iai,iao,ini,ino,ini_iri,nbf2;
      int     ib0,ib1,ir0,ir1,ir2,ir3,ini_iai,jni_iai,iao_imo,iao_jmo;
/*    ============================================================    */
      ang=-6.2831853071795864/(now*naf); if(inv < 0) ang=-ang;
      omg0=cos(ang); omg1=sin(ang); nbf2=2*nbf;
/*    +----------------------------------------------------------+    */
/*    | multiplicate twiddle factors                             |    */
/*    +----------------------------------------------------------+    */
      ir=naf/2;
      ar10=omg0; ar11=omg1;
      for(ia=1; ia<naf; ia++) {
        if(now != 2 && now != 4) ir=ia;
        arn0=ar10; arn1=ar11;    iri=ir*now*nbf2;
        for(in=1; in<now; in++) { ini_iri=in*nbf2+iri;
          if(in != 1) {
            ttn0=arn0;
            arn0=ttn0*ar10-arn1*ar11;
            arn1=ttn0*ar11+arn1*ar10;
          }
          for(ib=0; ib<nbf; ib++) { ib0=ib+ib; ib1=ib0+1;
            ff0=fi[ib0+ini_iri];
            fi[ib0+ini_iri]=ff0*arn0-fi[ib1+ini_iri]*arn1;
            fi[ib1+ini_iri]=ff0*arn1+fi[ib1+ini_iri]*arn0;
          }
        }
        if(ia == naf-1) continue;
        if(now == 2 || now == 4) {
          is=naf/2;
          while(is <= ir) {
            ir=ir-is;
            is=is/2;
          }
          ir=ir+is;
        }
        tt10=ar10;
        ar10=tt10*omg0-ar11*omg1;
        ar11=tt10*omg1+ar11*omg0;
      }
/*    ------------------------------------------------------------    */
      if(now == 4) goto L400;
      if(now == 2) goto L200;
/*    ------------------------------------------------------------    */
      ang=-6.283185307179586/now; if(inv < 0) ang=-ang;
      u110=cos(ang); u111=sin(ang);
      for(ia=0; ia<naf; ia++) { iao=ia*nbf2; iai=iao*now;
/*      +-------------------------------------------------------+     */
/*      / fo(ib,ia,0) \   / u00 u01 u02 u03 u04 \ / fi(ib,0,ia) \     */
/*      | fo(ib,ia,1) |   | u10                 | | fi(ib,1,ia) |     */
/*      | fo(ib,ia,2) | = | u20                 | | fi(ib,2,ia) |     */
/*      | fo(ib,ia,3) |   | u30                 | | fi(ib,3,ia) |     */
/*      \ fo(ib,ia,4) /   \ u40                 / \ fi(ib,4,ia) /     */
/*      +-------------------------------------------------------+     */
        for(ib=0; ib<nbf; ib++) { ib0=ib+ib; ib1=ib0+1;
          fo[ib0+iao    ]=fi[ib0+    iai];
          fo[ib1+iao    ]=fi[ib1+    iai];
          for(in=1; in<now; in++) { ini=in*nbf2; ino=ini*naf;
            fo[ib0+iao    ]=fo[ib0+iao    ]+fi[ib0+ini+iai];
            fo[ib1+iao    ]=fo[ib1+iao    ]+fi[ib1+ini+iai];
            fo[ib0+iao+ino]=fi[ib0+    iai];
            fo[ib1+iao+ino]=fi[ib1+    iai];
          }
        }
/*      +-------------------------------------------------------+     */
/*      / fo(ib,ia,0) \   /                     \ / fi(ib,0,ia) \     */
/*   xo | fo(ib,ia,1) |   |     u11 u12 u13 u14 | | fi(ib,1,ia) |     */
/*      | fo(ib,ia,2) | = |     u21 u22 u23 u24 | | fi(ib,2,ia) | xi  */
/*      | fo(ib,ia,3) |   |     u31 u32 u33 u34 | | fi(ib,3,ia) | yi  */
/*   yo \ fo(ib,ia,4) /   \     u41 u42 u43 u44 / \ fi(ib,4,ia) /     */
/*      +-------------------------------------------------------+     */
        un10=1.0; un11=0.0;
        for(in=1; in<=now/2; in++) { ini_iai=in*nbf2+iai;
        jn=now-in;                   jni_iai=jn*nbf2+iai;
        tt10=un10;
        un10=tt10*u110-un11*u111;
        un11=tt10*u111+un11*u110;
        unm0=1.0; unm1=0.0;
        for(im=1; im<=now/2; im++) { iao_imo=iao+im*naf*nbf2;
        jm=now-im;                   iao_jmo=iao+jm*naf*nbf2;
        ttm0=unm0;
        unm0=ttm0*un10-unm1*un11;
        unm1=ttm0*un11+unm1*un10;
/*      +--------------------------------------------------------+    */
/*      | xxo =  xxt+yyt = (u(0)+i*u(1))*xxi + (u(0)-i*u(1))*yyi |    */
/*      | yyo =  xxt-yyt = (u(0)-i*u(1))*xxi + (u(0)+i*u(1))*yyi |    */
/*      | xxt = (xxo+yyo)/2 =   u(0) * (xxi+yyi)                 |    */
/*      | yyt = (xxo-yyo)/2 = i*u(1) * (xxi-yyi)                 |    */
/*      +--------------------------------------------------------+    */
        for(ib=0; ib<nbf; ib++) { ib0=ib+ib; ib1=ib0+1;
          xi0=fi[ib0+ini_iai]; xi1=fi[ib1+ini_iai];
          yi0=fi[ib0+jni_iai]; yi1=fi[ib1+jni_iai];
          xt0=(xi0+yi0)*unm0;
          xt1=(xi1+yi1)*unm0;
          yt0=(yi1-xi1)*unm1;
          yt1=(xi0-yi0)*unm1;
          fo[ib0+iao_imo]=fo[ib0+iao_imo]+xt0+yt0;
          fo[ib1+iao_imo]=fo[ib1+iao_imo]+xt1+yt1;
          fo[ib0+iao_jmo]=fo[ib0+iao_jmo]+xt0-yt0;
          fo[ib1+iao_jmo]=fo[ib1+iao_jmo]+xt1-yt1;
        }
        }
        }
      }
      return(0);
/*    +----------------------------------------------------------+    */
/*    | now=2 : use in-place computation                         |    */
/*    +----------------------------------------------------------+    */
 L200:ir=0;
      for(ia=0; ia<naf; ia++) { ir0=ir*now*nbf2; ir1=ir0+nbf2;
/*      +--------------------------------------------------------+    */
/*      | / fi(ib,0,ir) \   / 1    1 \ / fi(ib,0,ir) \           |    */
/*      | \ fi(ib,1,ir) / = \ 1   -1 / \ fi(ib,1,ir) /           |    */
/*      +--------------------------------------------------------+    */
        for(ib=0; ib<nbf; ib++) { ib0=ib+ib; ib1=ib0+1;
          ff0=fi[ib0+ir1];
          ff1=fi[ib1+ir1];
          fi[ib0+ir1]=fi[ib0+ir0]-ff0; fi[ib0+ir0]+=ff0;
          fi[ib1+ir1]=fi[ib1+ir0]-ff1; fi[ib1+ir0]+=ff1;
        }
        if(ia == naf-1) continue;
        is=naf/2;
        while(is <= ir) {
          ir=ir-is;
          is=is/2;
        }
        ir=ir+is;
      }
      goto L500;
/*    +----------------------------------------------------------+    */
/*    | now=4 : use in-place computation                         |    */
/*    +----------------------------------------------------------+    */
 L400:ir=0;
      for(ia=0; ia<naf; ia++) { ir0=ir*now*nbf2; ir1=ir0+nbf2;
                                ir2=ir1+nbf2;    ir3=ir2+nbf2;
/*      +---------------------< for inv>=1 >--------------------+     */
/*      | / fo(ib,0,0,ir) \   / 1  1  1  1 \ / fi(ib,0,0,ir) \  |     */
/*      | | fo(ib,0,1,ir) |   | 1 -i -1  i | | fi(ib,1,0,ir) |  |     */
/*      | | fo(ib,1,0,ir) | = | 1 -1  1 -1 | | fi(ib,0,1,ir) |  |     */
/*      | \ fo(ib,1,1,ir) /   \ 1  i -1 -i / \ fi(ib,1,1,ir) /  |     */
/*      +-------------------------------------------------------+     */
        for(ib=0; ib<nbf; ib++) { ib0=ib+ib; ib1=ib0+1;
          v00=fi[ib0+ir0]+fi[ib0+ir2]; v01=fi[ib1+ir0]+fi[ib1+ir2];
          v10=fi[ib0+ir1]+fi[ib0+ir3]; v11=fi[ib1+ir1]+fi[ib1+ir3];
          v20=fi[ib0+ir0]-fi[ib0+ir2]; v21=fi[ib1+ir0]-fi[ib1+ir2];
          v31=fi[ib0+ir1]-fi[ib0+ir3]; v30=fi[ib1+ir1]-fi[ib1+ir3];
          if(inv > 0) {
            v31=-v31;
          } else {
            v30=-v30;
          }
          fi[ib0+ir0]=v00+v10; fi[ib1+ir0]=v01+v11;
          fi[ib0+ir2]=v20+v30; fi[ib1+ir2]=v21+v31;
          fi[ib0+ir1]=v00-v10; fi[ib1+ir1]=v01-v11;
          fi[ib0+ir3]=v20-v30; fi[ib1+ir3]=v21-v31;
        }
        if(ia == naf-1) continue;
        is=naf/2;
        while(is <= ir) {
          ir=ir-is;
          is=is/2;
        }
        ir=ir+is;
      }
 L500:if(nbf%2 == 0) return(0);
/*    +----------------------------------------------------------+    */
/*    | bit-reversal operation after all base 4 + 2 transforms   |    */
/*    +----------------------------------------------------------+    */
      ir=0;
      for(ia=0; ia<now*naf-1; ia++) { iai=ia*nbf2;
        if(ia < ir) {                 iri=ir*nbf2;
          for(ib=0; ib<nbf; ib++) { ib0=ib+ib; ib1=ib0+1;
            ff0=fi[ib0+iri]; fi[ib0+iri]=fi[ib0+iai]; fi[ib0+iai]=ff0;
            ff1=fi[ib1+iri]; fi[ib1+iri]=fi[ib1+iai]; fi[ib1+iai]=ff1;
          }
        }
        is=now*naf/2;
        while(is <= ir) {
          ir=ir-is;
          is=is/2;
        }
        ir=ir+is;
      }
      return(0);
}
/**********************************************************************/
