#include <math.h>
/**********************************************************************/
      int ffta(double f[],double a[],int n,int inv) {
/*    int ffta(f,a,n,inv) double f[],a[]; int n,inv; {                */
/*====================================================================*/
/*    complex fi(n),fo(n)                                             */
      int     nbf,now,naf,ifa,i;
/*    ============================================================    */
/*    f(n) = input (fi) and output (fo) data array of arbitrary n     */
/*    a(n) = working array (f1,f2,f3,...)                             */
/*    ============================================================    */
      ifa=1;
      nbf=n;
      naf=1;
      now=2;
/*    +----------------------------------------------------------+    */
/*    | now = 2,..,3,..,5,..,7,..,11,..,13,..,17,..              |    */
/*    +----------------------------------------------------------+    */
      while(nbf > 1) {
        while(nbf%now != 0) now=now+1;
        nbf=nbf/now;
        if(ifa > 0) fftbna(f,a,nbf,now,naf,inv);
        else        fftbna(a,f,nbf,now,naf,inv);
        ifa=-ifa;
        naf=naf*now;
      }
/*    +----------------------------------------------------------+    */
/*    | return transformed values in f(0:n-1)                    |    */
/*    +----------------------------------------------------------+    */
      if(ifa > 0) return(0);
      for(i=0; i<2*n; i++) f[i]=a[i];
      return(0);
}
/**********************************************************************/
      int fftbna(double fi[],double fo[]
                ,int nbf,int now,int naf,int inv) {
/*    int fftbna(fi,fo,nbf,now,naf,inv)
      double fi[,fo[]; int nbf,now,naf,inv; {                         */
/*    ============================================================    */
/*    complex fi(nbf,now,naf),fo(nbf,naf,now)                         */
      double  ang,omg0,omg1,ar10,ar11,ff0,ff1,tt0,tt10;
      int     ia,ib,in,im,iai,iao,ini_iai,imo;
      int     ib0,ib1,nowi,nbf2;
/*    ============================================================    */
      ang=-6.2831853071795864/(now*naf); if(inv < 0) ang=-ang;
      omg0=cos(ang); omg1=sin(ang); nbf2=2*nbf;
/*    ------------------------------------------------------------    */
      ar10=1.0; ar11=0.0;     nowi=(now-1)*nbf2;
      for(im=0; im<now; im++) { imo=im*naf*nbf2;
        for(ia=0; ia<naf; ia++) { iao=ia*nbf2; iai=iao*now;
          for(ib=0; ib<nbf; ib++) { ib0=ib+ib; ib1=ib0+1;
            ff0=fi[ib0+nowi+iai];
            ff1=fi[ib1+nowi+iai];
            for(in=now-2; in>=0; in--) { ini_iai=in*nbf2+iai;
              tt0=ff0;
              ff0=tt0*ar10-ff1*ar11+fi[ib0+ini_iai];
              ff1=tt0*ar11+ff1*ar10+fi[ib1+ini_iai];
            }
            fo[ib0+iao+imo]=ff0;
            fo[ib1+iao+imo]=ff1;
          }
          tt10=ar10;
          ar10=tt10*omg0-ar11*omg1;
          ar11=tt10*omg1+ar11*omg0;
        }
      }
      return(0);
}
/***********************************************************************/
