#include <stdio.h>
#include <ctype.h>
#include <math.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double a[4224];
      int    n1,n2,na,nw,nt,ndm=4224;
/*    ============================================================    */
      if(argc<3) {printf("Usage : plated infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    +----------------------------------------------------------+    */
/*    | n1 x n2 = sub-sections in 2-directions                   |    */
/*    +----------------------------------------------------------+    */
  L50:freeii(&n1,fp_r); freeii(&n2,fp_r); if(n1 == 0) exit(0);
      na=0;
      nw=na+n1*n2;
      nt=nw+n1; if(n1 < n2+n2) nt=nw+n2+n2;
      if(nt > ndm) {printf("\n dimension %d > %d",nt,ndm); exit(-1);}
      plats(&a[na],&a[nw],n1,n2,n1,fp_r,fp_w);
      goto L50;
}
/**********************************************************************/
      int plats(double a[],double w[],int n1,int n2,int nra
               ,FILE *fp_r,FILE *fp_w) {
/*    int plats(a,w,n1,n2,nra,fp_r,fp_w)
      double a[],w[]; int n1,n2,nra; FILE *fp_r,*fp_w; {              */
/*    ============================================================    */
/*    dimension a(0:nra-1,0:n2-1),w(0:n2-1)                           */
      double dmin,dmax,xl,yl,d,f0,f1,dx,dy,pi=3.1415926535897932;
      int    i,j,np,ip; int plate(); double powdi();
/*    ============================================================    */
/*    analysis of simply supported rectangular plate : xl * yl        */
/*    ------------------------------------------------------------    */
/*    xl,yl    = x/y-length of the rectangular plate                  */
/*    d        = rigidity of the plate                                */
/*    f0,f1,np = factors for distributed loading                      */
/*    a(i,j)   = loading per unit area at point (i,j)                 */
/*             = (f0 + f1*((i-n1/2)*dx+(j-n2/2)*dy))*pi**np           */
/*    ip       = 0:15 = index for intermediate output                 */
/*    ============================================================    */
/*    printf("\n xl,yl,d,f0,f1,np,ip ?");                             */
      freer8(&xl,fp_r); freer8(&yl,fp_r); freer8(&d,fp_r);
      freer8(&f0,fp_r); freer8(&f1,fp_r);
      freeii(&np,fp_r); freeii(&ip,fp_r);
      if(xl == 0.0) xl=1.0;
      if(yl == 0.0) yl=xl;
      if(d == 0.0) d=1.0;
      if(f0 == 0.0 && f1 == 0.0) f0=1.0;
/*    ------------------------------------------------------------    */
      dx=xl/n1;
      dy=yl/n2;
/*    +----------------------------------------------------------+    */
/*    | set a(i,j) = loading per unit area                       |    */
/*    | at point (i,j) for i=1:n1-1, j=1:n2-1                    |    */
/*    +----------------------------------------------------------+    */
      for(j=1; j<n2; j++) {
        for(i=1; i<n1; i++) {
          a[i+j*nra]=(f0+f1*((i-n1/2)*dx+(j-n2/2)*dy))*powdi(pi,np);
        }
      }
/*    +----------------------------------------------------------+    */
/*    | call plate to compute a(i,j) = deflection at (i,j)       |    */
/*    +----------------------------------------------------------+    */
      plate(a,n1,n2,d,xl,yl,w,ip,nra,fp_w);
      dmax=a[0];
      dmin=a[0];
      for(j=0; j<n2; j++) {
        for(i=0; i<n1; i++) {
          if(a[i+j*nra] > dmax) dmax=a[i+j*nra];
          if(a[i+j*nra] < dmin) dmin=a[i+j*nra];
        }
      }
      fprintf(fp_w,"\nmax. & min.deflection :%15.6le%15.6le",dmax,dmin);
      fprintf(fp_w,"\nxl,yl,d,f0,f1,np,n1,n2:");
      fprintf(fp_w,"%7.1lf%7.1lf%7.1lf%7.1lf%7.1lf",xl,yl,d,f0,f1);
      fprintf(fp_w,"%5d%5d%5d",np,n1,n2);
      return(0);
}
/**********************************************************************/
      int plate(double a[],int n1,int n2,double d,double xl
               ,double yl,double w[],int ip,int nra,FILE *fp_w) {
/*    int plate(a,n1,n2,d,xl,yl,w,ip,nra,fp_w)
      double a[],d,xl,yl,w[]; int n1,n2,nra; FILE *fp_w; {            */
/*    ============================================================    */
/*    dimension a(0:nra-1,0:n2-1),w(0:n2-1)                           */
      double ppaa,tmp,pi=3.1415926535897932;
      int    i,j; int fft2sc();
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | b.c. for simply supported rectangular plate xl * yl      |    */
/*    +----------------------------------------------------------+    */
      for(i=0; i<n1; i++) {
        a[i]=0.0;
      }
      for(j=0; j<n2; j++) {
        a[j*nra]=0.0;
      }
      if(ip/2*2 != ip) {   /* if((ip&1) != 0) */
        for(j=0; j<n2; j++) {
          fprintf(fp_w,"\n loading = a1(i,%d) :",j);
          for(i=0; i<n1; i++) {
            fprintf(fp_w,"\n i =%4d%15.6le",i,a[i+j*nra]);
          }
        }
      }
/*    +----------------------------------------------------------+    */
/*    | amplitute of the sine-loading                            |    */
/*    +----------------------------------------------------------+    */
      fft2sc(a,n1,n2,1,1,w,nra);
      if(ip/4*2 != ip/2) {   /* if((ip&2) != 0) */
        for(j=0; j<n2; j++) {
          fprintf(fp_w,"\n sin-transform of a1 = a2(i,%d) :",j);
          for(i=0; i<n1; i++) {
            fprintf(fp_w,"\n i =%4d%15.6le",i,a[i+j*nra]);
          }
        }
      }
/*    +----------------------------------------------------------+    */
/*    | amplitute of the sine-deflection due to the sine-loading |    */
/*    +----------------------------------------------------------+    */
      ppaa=n1*n2*d*pi*pi*pi*pi/4;
      for(j=1; j<n2; j++) {
        for(i=1; i<n1; i++) {
          tmp=(i/xl)*(i/xl)+(j/yl)*(j/yl);
          a[i+j*nra]/=(ppaa*tmp*tmp);
        }
      }
      if(ip/8*2 != ip/4) {   /* if((ip&4) != 0) */
        for(j=0; j<n2; j++) {
          fprintf(fp_w,"\n a2*h = a3(i,%d) :",j);
          for(i=0; i<n1; i++) {
            fprintf(fp_w,"\n i= %4d%15.6le",i,a[i+j*nra]);
          }
        }
      }
/*    +----------------------------------------------------------+    */
/*    | deflection at point (i,j)                                |    */
/*    +----------------------------------------------------------+    */
      fft2sc(a,n1,n2,-1,-1,w,nra);
      if(ip/16*2 != ip/8) {   /* if((ip&8) != 0) */
        for(j=0; j<n2; j++) {
          fprintf(fp_w,"\n deflection = a4(i,%d) :",j);
          for(i=0; i<n1; i++) {
            fprintf(fp_w,"\n i =%4d%15.6le",i,a[i+j*nra]);
          }
        }
      }
      return(0);
}
/**********************************************************************/
      double powdi(double b,int i) {
/*    double powdi(b,i) double b; int i; {                            */
/*    ============================================================    */
      double p;
/*    ============================================================    */
/*    return b**i                                                     */
/*    ============================================================    */
      if(i < 0) {i=-i; b=1.0/b;}
      if((i & 1) != 0) p=b; else p=1.0;
      while ((i >>= 1) != 0) {
        b=b*b;
        if((i & 1) != 0) p=p*b;
      }
      return(p);
}
/**********************************************************************/
