/**********************************************************************/
      int heapg(int n) {
/*    int heapg(n) int n; {                                           */
/*    ============================================================    */
/*    logical icmpij,icmpix,icmpxj                                    */
      int k,m; int moveij(),movexj(),shiftg(),initil();
/*    ============================================================    */
/*    heap  ascending  sort (for decending : change  <=  to  >= )     */
/*    =================< key sorting >==+===< index sorting >=====    */
/*    dimension             a(n)        |       a(n),l(n)             */
/*    after sorting a : a(i) <= a(i+1)  |  a(l(i)) <= a(l(i+1))       */
/*                  d : a(i) >= a(i+1)  |  a(l(i)) >= a(l(i+1))       */
/*    ----------------------------------+-------------------------    */
/*    icmpij(i,j) = a : a(i) <= a(j)    |  a(l(i)) <= a(l(j))         */
/*    icmpix(i)   = a : a(i) <=  ax     |  a(l(i)) <=  a(lx)          */
/*    icmpxj(j)   = a :  ax  <= a(j)    |   a(lx)  <= a(l(j))         */
/*    ----------------------------------+-------------------------    */
/*    moveij(i,j) :      a(i)=a(j)      |      l(i)=l(j)              */
/*    moveix(i)   :      a(i)=ax        |      l(i)=lx                */
/*    movexj(i)   :      ax=a(j)        |      lx=l(j)                */
/*    ----------------------------------+-------------------------    */
/*    swapij(i,j) :   at=a(i)           |   lt=l(i)                   */
/*                :      a(i)=a(j)      |      l(i)=l(j)              */
/*                :           a(j)=at   |           l(j)=lt           */
/*    ----------------------------------+-------------------------    */
/*    rotxij(i,j) : (ax=a(i)) a(i)=a(j) | (lx=l(i)) l(i)=l(j)         */
/*                :  a(j)=ax & ax=a(i)  |  l(j)=lx & lx=l(i)          */
/*    ============================================================    */
/*    initil(n)   : set l(i)=i for i=1,n for index sorting            */
/*    ============================================================    */
      initil(n);
/*    +----------------------------------------------------------+    */
/*    | form heap (a(i),i=k,n) for k=n/2 ... 1                   |    */
/*    +----------------------------------------------------------+    */
      for(k=n/2; k>=1; k--) {
        movexj(k);
        shiftg(k,n);
      }
/*    +----------------------------------------------------------+    */
/*    | put max of a(1:m) in the correct position m              |    */
/*    | form heap (a(i),i=1,m-1) for m=n ... 2                   |    */
/*    +----------------------------------------------------------+    */
      for(m=n; m>=2; m--) {
        movexj(m);
        moveij(m,1);
        shiftg(1,m-1);
      }
      return(0);
}
/**********************************************************************/
      int shiftg(int k,int m) {
/*    int shiftg(k,m) int k,m; {                                      */
/*    ============================================================    */
      int i,j; int icmpij(),icmpix(); int moveij(),moveix();
/*    ============================================================    */
/*    given ax and heap a(k+1:m)  where  k  <=  m                     */
/*    shift ax down to form new heap a(k:m)                           */
/*    a: a(i) >= a(2*i)  &&  a(i) >= a(2*i+1)                         */
/*    ============================================================    */
      i=k;
  L60:j=i+i;
      if(j <= m) {
        if(j < m) {
          if(!icmpij(j+1,j)) j=j+1;
        }
        if(!icmpix(j)) {
/*        +------------------------------------------------------+    */
/*        | shift ax down to position j                          |    */
/*        +------------------------------------------------------+    */
          moveij(i,j);
          i=j;
          goto L60;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | no more shift down : i is the correct position for ax    |    */
/*    +----------------------------------------------------------+    */
      moveix(i);
      return(0);
}
/**********************************************************************/
