/**********************************************************************/
      int quickg(int n) {
/*    int quickg(nm) int n; {                                         */
/*    ============================================================    */
      int icmpij(),icmpix(),icmpxj();
      int moveij(),moveix(),movexj(),rotxij(),swapij();
      int i,j,k,m,nn,ix,il[21],iu[21];
/*    il(nn),iu(nn) permit sorting up to n=2**(nn+1)-1                */
/*    ============================================================    */
/*    quick  ascending sort (for decending : change  <=  to  >= )     */
/*    =================< key sorting >==+===< index sorting >=====    */
/*    dimension             a(n)        |       a(n),l(n)             */
/*    after sorting a : a(i) <= a(i+1)  |  a(l(i)) <= a(l(i+1))       */
/*                  d : a(i) >= a(i+1)  |  a(l(i)) >= a(l(i+1))       */
/*    ----------------------------------+-------------------------    */
/*    icmpij(i,j) = a : a(i) <= a(j)    |  a(l(i)) <= a(l(j))         */
/*    icmpix(i)   = a : a(i) <=  ax     |  a(l(i)) <=  a(lx)          */
/*    icmpxj(j)   = a :  ax  <= a(j)    |   a(lx)  <= a(l(j))         */
/*    ----------------------------------+-------------------------    */
/*    moveij(i,j) :      a(i)=a(j)      |      l(i)=l(j)              */
/*    moveix(i)   :      a(i)=ax        |      l(i)=lx                */
/*    movexj(i)   :      ax=a(j)        |      lx=l(j)                */
/*    ----------------------------------+-------------------------    */
/*    swapij(i,j) :   at=a(i)           |   lt=l(i)                   */
/*                :      a(i)=a(j)      |      l(i)=l(j)              */
/*                :           a(j)=at   |           l(j)=lt           */
/*    ----------------------------------+-------------------------    */
/*    rotxij(i,j) : (ax=a(i)) a(i)=a(j) | (lx=l(i)) l(i)=l(j)         */
/*                :  a(j)=ax & ax=a(i)  |  l(j)=lx & lx=l(i)          */
/*    ============================================================    */
/*    initil(n)   : set l(i)=i for i=1,n for index sorting            */
/*    ============================================================    */
      initil(n);
/*    ------------------------------------------------------------    */
      i=1;
      m=n;
      nn=1;
/*    ------------------------------------------------------------    */
  L10:if(i >= m) goto L70;
/*    +----------------------------------------------------------+    */
/*    | sorting a(i),a(ix),a(m)                                  |    */
/*    | and get ax=mid(a(i),a(ix),a(m))                          |    */
/*    +----------------------------------------------------------+    */
      ix=(i+m)/2;
      movexj(ix);
      if(!icmpix(i)) {
        rotxij(ix,i);
      }
      if(!icmpxj(m)) {
        rotxij(ix,m);
        if(!icmpix(i)) {
          rotxij(ix,i);
        }
      }
/*    ============================================================    */
/*    subroutine partition(a,i,m,j,k,ax)                              */
/*    ============================================================    */
/*    sorting a(i:m) by partition into a(i:k) and a(j:m)              */
/*    ============================================================    */
/*    such that  i <= k < j <= m  provided i < m                      */
/*    a(x) <= ax  for  i <= x <= k                                    */
/*    a(x)  = ax  for  k <  x <  j                                    */
/*    a(x) >= ax  for  j <= x <= m                                    */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | test right part for a(k)>ax & left part for a(j)<ax      |    */
/*    +----------------------------------------------------------+    */
      j=i;
      k=m;
  L40:k=k-1;
      if(!icmpix(k)) goto L40;
  L50:j=j+1;
      if(!icmpxj(j)) goto L50;
/*    ------------------------------------------------------------    */
      if(j <= k) {
        swapij(j,k);
        goto L40;
      }
/*    +----------------------------------------------------------+    */
/*    | end of partitioning : find longer partition to save      |    */
/*    +----------------------------------------------------------+    */
      if(k-i > m-j) {
/*      +--------------------------------------------------------+    */
/*      | save  left partition a(i:k) then sort a(j:m)           |    */
/*      +--------------------------------------------------------+    */
        il[nn]=i;
        iu[nn]=k;
        nn=nn+1;
        i=j;
      } else {
/*      +--------------------------------------------------------+    */
/*      | save right partition a(j:m) then sort a(i:k)           |    */
/*      +--------------------------------------------------------+    */
        il[nn]=j;
        iu[nn]=m;
        nn=nn+1;
        m=k;
      }
      goto L80;
/*    +----------------------------------------------------------+    */
/*    | get a saved partition a(i:m) for sorting                 |    */
/*    +----------------------------------------------------------+    */
  L70:nn=nn-1;
      if(nn == 0) return(0);
      i=il[nn];
      m=iu[nn];
/*    +----------------------------------------------------------+    */
/*    | use quick sort for long key array                        |    */
/*    +----------------------------------------------------------+    */
  L80:if(m-i >= 11 || i == 1) goto L10;
/*    +----------------------------------------------------------+    */
/*    | use shaker sort for short key array                      |    */
/*    +----------------------------------------------------------+    */
  L90:i=i+1;
      if(i > m) goto L70;
      if(icmpij(i-1,i)) goto L90;
      k=i;
      movexj(k);
  L95:moveij(k,k-1);
      k=k-1;
      if(!icmpix(k-1)) goto L95;
/*    ------------------------------------------------------------    */
      moveix(k);
      goto L90;
}
/**********************************************************************/
