#include <stdio.h>
#include <ctype.h>
/**********************************************************************/
      int eqno(int node,int ndf,FILE *fp_s
              ,int nrl[],int nvar[],int lvsn[]) {
/*    int eqno(node,ndf,fp_s,nrl,nvar,lvsn)
      int node,ndf,nrl[],nvar[],lvsn[]; FILE *fp_s; {                 */
/*    ============================================================    */
/*    dimension nrl(ndf,node),nvar(ndf,node),lvsn(node)               */
      int j,k,new,nfree;
      --nrl; nrl-=ndf; --nvar; nvar-=ndf; --lvsn;
/*    ============================================================    */
/*i   node      = number of nodes                                     */
/*i   ndf       = number of degrees of freedom for each node          */
/*i   fp_s      = file which stores the array lvsn(node)              */
/*i   nrl(k,j)  = node restraint list                                 */
/*              > 0 : restraint direction, its displacement = 0       */
/*              = 0 : allow displacement,                             */
/*                    its displacement = disp(nvar(k,j))              */
/*o   nvar(k,j) = 0 : for restraint direction                         */
/*              > 0 : sequence number of the unknown displacement     */
/*                    for k-th direction of node j                    */
/*w   lvsn(new) = the original node number of the new new-th node     */
/*    ============================================================    */
/*      j  | nrl(*,j)  |  nvar(*,j)  |  lvsn(j) !!  nvar(*,j)         */
/*    -----+-----------+-------------+----------++----------------    */
/*      1  |  1  1  0  |   0  0 17   |    4     !!   0  0  1          */
/*      2  |  0  0  0  |  11 12 13   |    5     !!   2  3  4          */
/*      3  |  0  0  0  |   5  6  7   |    3     !!   5  6  7          */
/*      4  |  1  0  0  |   0  1  2   |    6     !!   0  8  9          */
/*      5  |  1  0  0  |   0  3  4   |    2     !!   0 10 11          */
/*      6  |  0  0  0  |   8  9 10   |    7     !!  12 13 14          */
/*      7  |  0  0  0  |  14 15 16   |    1     !!  15 16 17          */
/*      8  |  1  1  0  |   0  0 18   |    8     !!   0  0 18          */
/*    ============================================================    */
/*    new program                     !!  original program            */
/*    --------------------------------++--------------------------    */
      nfree=0;                        /*  nfree=0;                    */
      if(fp_s != NULL) {
        rewind(fp_s);
        fread(&lvsn[1],(int)sizeof(int),node,fp_s);
      }
      for(new=1; new<=node; new++) {  /*  for(j=1; j<=node; j++) {    */
        j=lvsn[new];
        for(k=1; k<=ndf; k++) {       /*    for(k=1; k<=ndf; k++) {   */
          if(nrl[k+j*ndf] == 0) {     /*      if(nrl[k+j*ndf] == 0) { */
            nfree=nfree+1;            /*        nfree=nfree+1;        */
            nvar[k+j*ndf]=nfree;      /*        nvar[k+j*ndf]=nfree;  */
          } else {                    /*      } else {                */
            nvar[k+j*ndf]=0;          /*        nvar[k+j*ndf]=0;      */
          }                           /*      }                       */
        }                             /*    }                         */
      }                               /*  }                           */
      return(0);                      /*  return(0);                  */
}                                     /* }                            */
/**********************************************************************/
