/**********************************************************************/
      int femrcm(int joep[],int joes[],int lvsn[],int eojp[],int eojs[]
                ,int nelm,int node) {
/*    int femrcm(joep,joes,lvsn,eojp,eojs,nelm,node)
      int joep[],joes[],lvsn[],eojp[],eojs[],nelm,node; {             */
/*    ============================================================    */
      int nbgn,nsiz,mem,nod,j,k,jstrt,jstop; int emrrcm();
      --joep; --joes; --lvsn; --eojp; --eojs;
/*    ============================================================    */
/*    perform the RCM ordering to get lvsn(node)                      */
/*    ------------------------------------------------------------    */
/*    input  : joep(nelm+1),joes(joep(nelm+1)-1),nelm,node            */
/*    output : eojp(node+1),eojs(eojp(node+1)-1),lvsn(node)           */
/*    ------------------------------------------------------------    */
/*i   joes(joep(i)),...,joes(joep(i+1)-1) = nodes of element i        */
/*o   eojs(eojp(j)),...,eojs(eojp(j+1)-1) = elements of node j        */
/*o   lvsn(i) = the original node number of the new i-th node         */
/*i   nelm    = number of elements                                    */
/*i   node    = number of nodes                                       */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | set lvsn(j) temporarily as the degree of node j          |    */
/*    +----------------------------------------------------------+    */
      for(nod=1; nod<=node; nod++) {
        lvsn[nod]=0;
      }
      for(mem=1; mem<=nelm; mem++) {
        jstrt=joep[mem];
        jstop=joep[mem+1]-1;
        for(j=jstrt; j<=jstop; j++) {
          nod=joes[j];
          lvsn[nod]=lvsn[nod]+1;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | setup a list of the element connected to each node       |    */
/*    | given lvsn(j) as the degree of node j                    |    */
/*    +----------------------------------------------------------+    */
      eojp[1]=1;
      for(nod=1; nod<=node; nod++) {
        eojp[nod+1]=eojp[nod]+lvsn[nod];
        lvsn[nod]=eojp[nod];
      }
      for(mem=1; mem<=nelm; mem++) {
        jstrt=joep[mem];
        jstop=joep[mem+1]-1;
        for(j=jstrt; j<=jstop; j++) {
          nod=joes[j];
          k=lvsn[nod];
          lvsn[nod]=k+1;
          eojs[k]=mem;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | set eojp(j) < 0 to mark node j as an un-re-numbered node |    */
/*    +----------------------------------------------------------+    */
      for(nod=1; nod<=node; nod++) {
        eojp[nod]=-eojp[nod];
      }
/*    +----------------------------------------------------------+    */
/*    | call emrrcm to re-number node begin from root = nod      |    */
/*    +----------------------------------------------------------+    */
      nbgn=1;
      for(nod=1; nod<=node; nod++) {
        if(eojp[nod] > 0) continue;
        emrrcm(nod,&joep[1],&joes[1],&eojp[1],&eojs[1]
                  ,&lvsn[nbgn],nelm,&nsiz);
        nbgn=nbgn+nsiz;
        if(nbgn > node) return(0);
      }
      return(0);
}
/**********************************************************************/
      int emrrcm(int iroot,int joep[],int joes[],int eojp[],int eojs[]
                ,int lvsn[],int nelm,int *pnsiz) {
/*    int emrrcm(iroot,joep,joes,eojp,eojs,lvsn,nelm,pnsiz)
      int iroot,joep[],joes[],eojp[],eojs[],lvsn[],nelm,*pnsiz; {     */
/*    ============================================================    */
      int i,j,k,l,i1,ns,nod,nsav,lvbgn,lvend,jstrt,jstop,mindeg,nsiz;
      int ndeg,ndif,root,nbnd,nlvl,nenv,iroo,nbno,nlvo,neno,lvbg[3];
      int mem,jx,jy,njx,njy,jxp,jyp,jxt,jyt,kstrt,kstop;
      int klvl=2,maxint=32767;
      --joep; --joes; --eojp; --eojs; --lvsn;
/*    ============================================================    */
      root=iroot;
      iroo=0;
      nlvl=0;
      nbnd=maxint;
      nenv=maxint;
/*    +----------------------------------------------------------+    */
/*    | single root begin re-number from here                    |    */
/*    +----------------------------------------------------------+    */
 L100:nsiz=1;
      lvsn[nsiz]=root;
      eojp[root]=-eojp[root];
/*    +----------------------------------------------------------+    */
/*    | multiple roots begin re-number from here                 |    */
/*    +----------------------------------------------------------+    */
 L110:nlvo=nlvl;
      nbno=nbnd;
      neno=nenv;
      nlvl=0;
      nbnd=0;
      nenv=0;
      lvend=0;
      for(k=1; k<=klvl; k++) {
        lvbg[k]=1;
      }
/*    +----------------------------------------------------------+    */
/*    | lvbgn & lvend = pointers to first & last of this level   |    */
/*    +----------------------------------------------------------+    */
 L200:nlvl=nlvl+1;
      lvbgn=lvend+1;
      lvend=nsiz;
      for(k=2; k<=klvl; k++) {
        lvbg[k-1]=lvbg[k];
      }
      lvbg[klvl]=lvbgn;
/*    +----------------------------------------------------------+    */
/*    | generate the new level by finding all the masked         |    */
/*    | un-re-numbered neighbors of nodes in this level          |    */
/*    +----------------------------------------------------------+    */
      for(i=lvbgn; i<=lvend; i++) {
        nod=lvsn[i];
        kstrt=abs(eojp[nod]);
        kstop=abs(eojp[nod+1])-1;
        if(kstrt > kstop) continue;
        nsav=nsiz;
        for(k=kstrt; k<=kstop; k++) {
          mem=eojs[k];
          if(joep[mem] < 0) continue;
          joep[mem]=-joep[mem];
          jstrt=abs(joep[mem]);
          jstop=abs(joep[mem+1])-1;
          for(j=jstrt; j<=jstop; j++) {
            nod=joes[j];
            if(eojp[nod] > 0) continue;
            eojp[nod]=-eojp[nod];
            nsiz=nsiz+1;
            lvsn[nsiz]=nod;
          }
        }
/*      ----------------------------------------------------------    */
        if(nsav >= nsiz) goto L320;
        ndif=nsiz-i;
        njx=nsav+1;
        njy=nsiz;
        if(njx >= njy) goto L380;
/*      +--------------------------------------------------------+    */
/*      | shaker sorting lvsn(njx) ... lvsn(njy)                 |    */
/*      +--------------------------------------------------------+    */
        jyp=njx;
        do {
          jxp=jyp;
          jyp=jyp+1;
          jy=lvsn[jyp];
          jyt=abs(eojp[jy+1])-abs(eojp[jy]);
/*        --------------------------------------------------------    */
          do {
            jx=lvsn[jxp];
            jxt=abs(eojp[jx+1])-abs(eojp[jx]);
            if(jxt <= jyt) break;
            lvsn[jxp+1]=jx;
            jxp=jxp-1;
          } while(jxp >= njx);
/*        --------------------------------------------------------    */
          lvsn[jxp+1]=jy;
        } while(jyp < njy);
        goto L380;
/*      +--------------------------------------------------------+    */
/*      | compute the exact envelope of rcm ordering             |    */
/*      | by reducing the envelope of cm ordering                |    */
/*      +--------------------------------------------------------+    */
 L320:  if(nsav <= i) goto L360;
        nod=lvsn[nsav];
        for(k=kstrt; k<=kstop; k++) {
          mem=eojs[k];
          jstrt=abs(joep[mem]);
          jstop=abs(joep[mem+1])-1;
          for(j=jstrt; j<=jstop; j++) {
            if(joes[j] == nod) goto L360;
          }
        }
        nsav=nsav-1;
        goto L320;
 L360:  ndif=nsav-i;
 L380:  if(ndif > nbnd) nbnd=ndif;
        nenv=nenv+ndif;
      }
      if(nsiz > lvend) goto L200;
/*    +----------------------------------------------------------+    */
/*    | no more node in the new level(all nodes are re-numbered) |    */
/*    | compare the depth(band,envelope) of two level structures |    */
/*    +----------------------------------------------------------+    */
      printf("\n ** root,nlvl,nbnd,nenv/lvsn(*)=%8d%8d%8d%8d"
                ,root,nlvl,nbnd,nenv);
      for(i=1; i<=nsiz; i++) {
        if(i%10 == 1) printf("\n"); printf("%8d",lvsn[i]);
      }
      if(root == abs(iroo) || nlvl == nsiz) goto L800;
      if(nlvl < nlvo) goto L700; if(nlvl > nlvo) goto L450;
      if(nbnd > nbno) goto L700; if(nbnd < nbno) goto L450;
      if(nenv > neno) goto L700; if(nenv < neno) goto L450;
      goto L800;
/*    +----------------------------------------------------------+    */
/*    | find new root from the last level with minimum degree    |    */
/*    +----------------------------------------------------------+    */
 L450:iroo=root;
      mindeg=nsiz;
      for(i=lvbgn; i<=lvend; i++) {
        nod=lvsn[i];
        ndeg=abs(eojp[nod+1])-abs(eojp[nod]);
        if(ndeg >= mindeg) continue;
        mindeg=ndeg;
        root=nod;
      }
/*    +----------------------------------------------------------+    */
/*    | reset the mark to restart the re-numbering               |    */
/*    +----------------------------------------------------------+    */
 L550:for(i=1; i<=nsiz; i++) {
        nod=lvsn[i];
        eojp[nod]=-eojp[nod];
      }
      for(mem=1; mem<=nelm; mem++) {
        joep[mem]=abs(joep[mem]);
      }
      goto L100;
/*    +----------------------------------------------------------+    */
/*    | reconstruct previous level structure                     |    */
/*    +----------------------------------------------------------+    */
 L700:root=iroo;
      goto L550;
/*    +----------------------------------------------------------+    */
/*    | reverse the cuthill-mckee ordering                       |    */
/*    +----------------------------------------------------------+    */
 L800:ns=nsiz/2;
      l=nsiz;
      for(i=1; i<=ns; i++) {
        nod=lvsn[i];
        lvsn[i]=lvsn[l];
        lvsn[l]=nod;
        l=l-1;
      }
      for(mem=1; mem<=nelm; mem++) {
        joep[mem]=abs(joep[mem]);
      }
      if(nenv > neno) goto L550;
      if(iroo < 0) {*pnsiz=nsiz; return(0);}
      iroo=-root;
/*    +----------------------------------------------------------+    */
/*    | use all nodes in the last klvl levels as multiple roots  |    */
/*    +----------------------------------------------------------+    */
      i1=lvend-lvbg[1]+2;
      for(i=i1; i<=nsiz; i++) {
        nod=lvsn[i];
        eojp[nod]=-eojp[nod];
      }
      nsiz=i1-1;
      goto L110;
}
/**********************************************************************/
