#include <math.h>
/**********************************************************************/
      int genrcm(int node,int xadj[],int adjn[],int lvsn[]) {
/*    int genrcm(node,xadj,adjn,lvsn)
      int node,xadj[],adjn[],lvsn[]; {                                */
/*    ============================================================    */
      int nbgn,nsiz,j,jx,jy,njx,njy,jxp,jyp,jxt,jyt; int mrrcm();
      --xadj; --adjn; --lvsn;
/*    ============================================================    */
/*    perform the RCM ordering to get lvsn(node)                      */
/*    ------------------------------------------------------------    */
/*    input  : xadj(node+1),adjn(xadj(node+1)-1),node                 */
/*    output : lvsn(node),  adjn : sorted by degree in incr. order    */
/*    ------------------------------------------------------------    */
/*o   adjn(xadj(j)),...,adjn(xadj(j+1)-1) = adjacency nodes of j      */
/*o   lvsn(i) = the original node number of the new i-th node         */
/*i   node    = number of nodes                                       */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | set lvsn(j) temporarily as the degree of node j          |    */
/*    +----------------------------------------------------------+    */
      for(j=1; j<=node; j++) {
        lvsn[j]=xadj[j+1]-xadj[j];
      }
/*    +----------------------------------------------------------+    */
/*    | shaker sorting adjn(njx) ... adjn(njy)                   |    */
/*    +----------------------------------------------------------+    */
      for(j=1; j<=node; j++) {
        njx=xadj[j];
        njy=xadj[j+1]-1;
        if(njx >= njy) continue;
        jyp=njx;
        do {
          jxp=jyp;
          jyp=jyp+1;
          jy=adjn[jyp];
          jyt=lvsn[jy];
/*        --------------------------------------------------------    */
          do {
            jx=adjn[jxp];
            jxt=lvsn[jx];
            if(jxt <= jyt) break;
            adjn[jxp+1]=jx;
            jxp=jxp-1;
          } while(jxp >= njx);
/*        --------------------------------------------------------    */
          adjn[jxp+1]=jy;
        } while(jyp < njy);
      }
/*    +----------------------------------------------------------+    */
/*    | set xadj(j) < 0 to mark node j as an un-re-numbered node |    */
/*    +----------------------------------------------------------+    */
      for(j=1; j<=node; j++) {
        xadj[j]=-xadj[j];
      }
/*    +----------------------------------------------------------+    */
/*    | call mrrcm to re-number node begin from root = j         |    */
/*    +----------------------------------------------------------+    */
      nbgn=1;
      for(j=1; j<=node; j++) {
        if(xadj[j] > 0) continue;
        mrrcm(j,&xadj[1],&adjn[1],&lvsn[nbgn],&nsiz);
        nbgn=nbgn+nsiz;
        if(nbgn > node) return(0);
      }
      return(0);
}
/**********************************************************************/
      int mrrcm(int iroot,int xadj[],int adjn[],int lvsn[],int *pnsiz) {
/*    int mrrcm(iroot,xadj,adjn,lvsn,pnsiz)
      int iroot,xadj[],adjn[],lvsn[],*pnsiz; {                        */
/*    ============================================================    */
      int i,j,k,l,i1,ns,nod,nsav,lvbgn,lvend,jstrt,jstop,mindeg,nsiz;
      int ndeg,ndif,root,nbnd,nlvl,nenv,iroo,nbno,nlvo,neno,lvbg[3];
      int klvl=2,maxint=32767;
      --xadj; --adjn; --lvsn;
/*    ============================================================    */
      root=iroot;
      iroo=0;
      nlvl=0;
      nbnd=maxint;
      nenv=maxint;
/*    +----------------------------------------------------------+    */
/*    | single root begin re-number from here                    |    */
/*    +----------------------------------------------------------+    */
 L100:nsiz=1;
      lvsn[nsiz]=root;
      xadj[root]=-xadj[root];
/*    +----------------------------------------------------------+    */
/*    | multiple roots begin re-number from here                 |    */
/*    +----------------------------------------------------------+    */
 L110:nlvo=nlvl;
      nbno=nbnd;
      neno=nenv;
      nlvl=0;
      nbnd=0;
      nenv=0;
      lvend=0;
      for(k=1; k<=klvl; k++) {
        lvbg[k]=1;
      }
/*    +----------------------------------------------------------+    */
/*    | lvbgn & lvend = pointers to first & last of this level   |    */
/*    +----------------------------------------------------------+    */
 L200:nlvl=nlvl+1;
      lvbgn=lvend+1;
      lvend=nsiz;
      for(k=2; k<=klvl; k++) {
        lvbg[k-1]=lvbg[k];
      }
      lvbg[klvl]=lvbgn;
/*    +----------------------------------------------------------+    */
/*    | generate the new level by finding all the masked         |    */
/*    | un-re-numbered neighbors of nodes in this level          |    */
/*    +----------------------------------------------------------+    */
      for(i=lvbgn; i<=lvend; i++) {
        nod=lvsn[i];
        jstrt=abs(xadj[nod]);
        jstop=abs(xadj[nod+1])-1;
        if(jstrt > jstop) continue;
        nsav=nsiz;
        for(j=jstrt; j<=jstop; j++) {
          nod=adjn[j];
          if(xadj[nod] > 0) continue;
          xadj[nod]=-xadj[nod];
          nsiz=nsiz+1;
          lvsn[nsiz]=nod;
        }
/*      +--------------------------------------------------------+    */
/*      | compute the exact envelope of rcm ordering             |    */
/*      | by reducing the envelope of cm ordering                |    */
/*      +--------------------------------------------------------+    */
        ndif=nsiz-i;
        if(nsav >= nsiz) {
 L320:    if(nsav <= i) goto L360;
          nod=lvsn[nsav];
          for(j=jstrt; j<=jstop; j++) {
            if(adjn[j] == nod) goto L360;
          }
          nsav=nsav-1;
          goto L320;
 L360:    ndif=nsav-i;
        }
        if(ndif > nbnd) nbnd=ndif;
        nenv=nenv+ndif;
      }
      if(nsiz > lvend) goto L200;
/*    +----------------------------------------------------------+    */
/*    | no more node in the new level(all nodes are re-numbered) |    */
/*    | compare the depth(band,envelope) of two level structures |    */
/*    +----------------------------------------------------------+    */
      printf("\n ** root,nlvl,nbnd,nenv/lvsn(*)=%8d%8d%8d%8d"
                ,root,nlvl,nbnd,nenv);
      for(i=1; i<=nsiz; i++) {
        if(i%10 == 1) printf("\n"); printf("%8d",lvsn[i]);
      }
      if(root == abs(iroo) || nlvl == nsiz) goto L800;
      if(nlvl < nlvo) goto L700; if(nlvl > nlvo) goto L450;
      if(nbnd > nbno) goto L700; if(nbnd < nbno) goto L450;
      if(nenv > neno) goto L700; if(nenv < neno) goto L450;
      goto L800;
/*    +----------------------------------------------------------+    */
/*    | find new root from the last level with minimum degree    |    */
/*    +----------------------------------------------------------+    */
 L450:iroo=root;
      mindeg=nsiz;
      for(i=lvbgn; i<=lvend; i++) {
        nod=lvsn[i];
        ndeg=abs(xadj[nod+1])-abs(xadj[nod]);
        if(ndeg >= mindeg) continue;
        mindeg=ndeg;
        root=nod;
      }
/*    +----------------------------------------------------------+    */
/*    | reset the mark to restart the re-numbering               |    */
/*    +----------------------------------------------------------+    */
 L550:for(i=1; i<=nsiz; i++) {
        nod=lvsn[i];
        xadj[nod]=-xadj[nod];
      }
      goto L100;
/*    +----------------------------------------------------------+    */
/*    | reconstruct previous level structure                     |    */
/*    +----------------------------------------------------------+    */
 L700:root=iroo;
      goto L550;
/*    +----------------------------------------------------------+    */
/*    | reverse the cuthill-mckee ordering                       |    */
/*    +----------------------------------------------------------+    */
 L800:ns=nsiz/2;
      l=nsiz;
      for(i=1; i<=ns; i++) {
        nod=lvsn[i];
        lvsn[i]=lvsn[l];
        lvsn[l]=nod;
        l=l-1;
      }
      if(nenv > neno) goto L550;
      if(iroo < 0) {*pnsiz=nsiz; return(0);}
      iroo=-root;
/*    +----------------------------------------------------------+    */
/*    | use all nodes in the last klvl levels as multiple roots  |    */
/*    +----------------------------------------------------------+    */
      i1=lvend-lvbg[1]+2;
      for(i=i1; i<=nsiz; i++) {
        nod=lvsn[i];
        xadj[nod]=-xadj[nod];
      }
      nsiz=i1-1;
      goto L110;
}
/**********************************************************************/
