/**********************************************************************/
      int graphs(int joep[],int joes[],int jajt[],int jajp[],int jajs[]
                ,int nelm,int node,int *nedg) {
/*    int graphs(joep,joes,jajt,jajp,jajs,nelm,node,nedg)
      int joep[],joes[],jajt[],jajp[],jajs[],nelm,node,*nedg; {       */
/*    ============================================================    */
      int next,j,ie,jt,jx,jy,kx,ky,njx,njy,nja,njb,jxn,jxp,jyp,jxt,jyt;
      --joep; --joes; --jajt; --jajp; --jajs;
/*    ============================================================    */
/*    input  : joep(nelm+1),joes(joep(nelm+1)-1),nelm,node            */
/*    output : jajp(node+1),jajs(jajp(node+1)-1),jajt(node),nedg      */
/*    ------------------------------------------------------------    */
/*i   joes(joep(i)),...,joes(joep(i+1)-1) = nodes of element i        */
/*o   jajs(jajp(j)),...,jajs(jajp(j+1)-1) = adjacency nodes of j      */
/*o   jajt(j) = degree of node j                                      */
/*i   nelm    = number of elements                                    */
/*i   node    = number of nodes                                       */
/*o   nedg    = number of edges                                       */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | setup temporarily lower adjacency linked lists           |    */
/*    | adjacency nodes of j are jajs(jajp(j)),                  |    */
/*    |                     jajs(jajs(jajp(j)+1)),               |    */
/*    |                jajs(jajs(jajs(jajp(j)+1)+1)),...         |    */
/*    +----------------------------------------------------------+    */
      next=1;
      for(j=1; j<=node; j++) {
        jajp[j]=-j;
        jajt[j]=0;
      }
      for(ie=1; ie<=nelm; ie++) {
        nja=joep[ie];
        njb=joep[ie+1]-1;
        for(kx=nja; kx<=njb; kx++) {
          jx=joes[kx];
          for(ky=nja; ky<=njb; ky++) {
            jy=joes[ky];
            if(jx >= jy) continue;
/*          +----------------------------------------------------+    */
/*          | get the pointer of the first adjacency node        |    */
/*          +----------------------------------------------------+    */
            jxp=jajp[jx];
            if(jxp <= 0) {
              jajp[jx]=next;
              goto L150;
            }
/*          +----------------------------------------------------+    */
/*          | test if node jy is already in adj. lists of node jx|    */
/*          | yes : continue                                     |    */
/*          | no  : get the pointer of the next adjacency node   |    */
/*          +----------------------------------------------------+    */
 L120:      if(jajs[jxp] == jy) continue;
            jxn=jajs[jxp+1];
            if(jxn <= 0) {
              jajs[jxp+1]=next;
              goto L150;
            }
            jxp=jxn;
            goto L120;
/*          +----------------------------------------------------+    */
/*          | put adj. node at the end of list & update pointer  |    */
/*          | update deg. of nodes jx & jy : jajt(jx) & jajt(jy) |    */
/*          +----------------------------------------------------+    */
 L150:      jajs[next]=jy;
            jajs[next+1]=-jx;
            next=next+2;
            jajt[jx]=jajt[jx]+1;
            jajt[jy]=jajt[jy]+1;
          }
        }
      }
/*    +----------------------------------------------------------+    */
/*    | setup adjacency structure for rcm method                 |    */
/*    | given jajt(j) as the degree of node j                    |    */
/*    +----------------------------------------------------------+    */
      jajp[1]=1;
      for(j=1; j<=node; j++) {
        jajp[j+1]=jajp[j]+jajt[j];
        jajt[j]=0;
      }
      for(ie=1; ie<=nelm; ie++) {
        nja=joep[ie];
        njb=joep[ie+1]-1;
        for(kx=nja; kx<=njb; kx++) {
          jx=joes[kx];
          jxt=jajt[jx];
          for(ky=nja; ky<=njb; ky++) {
            jy=joes[ky];
            if(jx == jy) continue;
            jxp=jajp[jx];
            for(jt=1; jt<=jxt; jt++) {
              if(jajs[jxp] == jy) goto L260;
              jxp=jxp+1;
            }
            jajs[jxp]=jy;
            jxt=jxt+1;
 L260:;   }
          jajt[jx]=jxt;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | shaker sorting jajs(njx) ... jajs(njy)                   |    */
/*    | in increasing order of degree for adj nodes of each node |    */
/*    +----------------------------------------------------------+    */
      for(j=1; j<=node; j++) {
        njx=jajp[j];
        njy=jajp[j+1]-1;
        if(njx >= njy) continue;
        jyp=njx;
        do {
          jxp=jyp;
          jyp=jyp+1;
          jy=jajs[jyp];
          jyt=jajt[jy];
/*        --------------------------------------------------------    */
          do {
            jx=jajs[jxp];
            jxt=jajt[jx];
            if(jxt <= jyt) break;
            jajs[jxp+1]=jx;
            jxp=jxp-1;
          } while(jxp >= njx);
/*        --------------------------------------------------------    */
          jajs[jxp+1]=jy;
        } while(jyp < njy);
      }
/*    +----------------------------------------------------------+    */
/*    | compute the numbers of the edges                         |    */
/*    +----------------------------------------------------------+    */
      *nedg=jajp[node+1]-1;
      return(0);
}
/**********************************************************************/
