#include <math.h>
struct {int n; double x[99],f[99],d[99],c[100];} ran000;
/**********************************************************************/
      double gauss(double amean,double sigma) {
/*    double gauss(amean,sigma) double amean,sigma; {                 */
/*    ============================================================    */
      double a,snp1,fun; int i; double ranfun();
      static long ix=-1;
/*    ============================================================    */
/*    use mixed method (invert method & reject-select method)         */
/*    to find the normal distributed number                           */
/*    ============================================================    */
      if(ix < 0) {
         ix=11111;
/*       +-------------------------------------------------------+    */
/*       | set n,x(1:n),f(1:n),d(2:n),c(1:n+1)                   |    */
/*       | for unit std. div. zero mean normal dist.             |    */
/*       +-------------------------------------------------------+    */
         ran000.n   =1;
         ran000.x[0]=0.0;
         ran000.c[0]=exp(-0.5)/sqrt(6.283185307179586);
         ran000.c[1]=ran000.c[0];
         ran000.f[0]=0.5;
      }
/*    ------------------------------------------------------------    */
      fun = amean + sigma * ranfun(&ix);
      return(fun);
}
/**********************************************************************/
      double denfun(double x) {
/*    double denfun(x) double x; {                                    */
/*    ============================================================    */
      double fun; static double rsqr2p=0.3989422804014327;
/*    ============================================================    */
/*    denfun = density function of a random number x                  */
/*    for unit std. div. zero mean normal dist.                       */
/*    ============================================================    */
      fun = rsqr2p * exp(-0.5*x*x);
      return(fun);
}
/**********************************************************************/
      int finvl(double dis,double *var,double *den) {
/*    int finvl(dis,var,den) double dis,*var,*den; {                  */
/*    ============================================================    */
/*    input : dis = distribution function                             */
/*    output: var = random number                                     */
/*            den = density function                                  */
/*    ------------------------------------------------------------    */
/*    exponential distribution (var  >=  0)                           */
/*    mean = standard diviation = sigma = 1                           */
/*    ============================================================    */
      *var = log(dis);
/*    *den = exp(*var)                                                */
      *den = dis;
      return(0);
}
/**********************************************************************/
      int finvr(double dis,double *var,double *den) {
/*    int finvr(dis,var,den) double dis,*var,*den; {                  */
/*    ============================================================    */
      *var = -log(dis);
/*    *den = exp(-*var)                                               */
      *den = dis;
      return(0);
}
/**********************************************************************/
