extern struct {int n; double x[99],f[99],d[99],c[100];} ran000;
/**********************************************************************/
      double random(long *pix) {
/*    double random(pix) long *pix; {                                 */
/*    ============================================================    */
      double fun; long ix;  /* long maxn=2147483647; */
      ix=*pix;
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | random number by linear congruential method              |    */
/*    | for 32 bits integer*4: c=51605, m-1=2147483647           |    */
/*    | for 16 bits integer*2: c=405,   m-1=32767                |    */
/*    | ix = mod( 51605*ix+3, 2**32)                             |    */
/*    +----------------------------------------------------------+    */
      ix = 51605*ix + 3;
/*    +----------------------------------------------------------+    */
/*    | next statement changes the sign bit from 1 to 0          |    */
/*    | that is : ix = mod( 51605*ix+3, 2**31)                   |    */
/*    |           for 1's complement, cancel +1                  |    */
/*    +----------------------------------------------------------+    */
/*    ix = (ix << 1) >> 1;  */ /* if(ix < 0) ix=ix+maxn+1; */
      ix = ix & 0x7fffffff;
/*    +----------------------------------------------------------+    */
/*    | random = uniform distributed number between 0 and 1      |    */
/*    +----------------------------------------------------------+    */
      fun = ix/2147483647.0;
/*    +----------------------------------------------------------+    */
/*    | if you can not avoid overflow error                      |    */
/*    | use follows for 32 bits integer*4:                       |    */
/*    +----------------------------------------------------------+    */
/*    ix = (405*ix+3)%32768;                                          */
/*    fun = ix/32767.0;                                               */
      *pix=ix; return(fun);
}
/**********************************************************************/
      double ranfun(long *ix) {
/*    double ranfun(ix) long *ix; {                                   */
/*    ============================================================    */
      double u0,u1,u2,xx,yy,zz,den; double denfun(),random();
      int    i,ibgn,iend;           int    finvl(),finvr();
/*    ============================================================    */
/*    general program for any distributed random number               */
/*    by mixed method : invert method & reject-select method          */
/*    ------------------------------------------------------------    */
/*    given : n,x(1:n),f(1:n),d(2:n),c(1:n+1) & following routines    */
/*    denfun(xx) = density function of xx                             */
/*    finvl(dis,var,den) & finvr(dis,var,den)                         */
/*    = referential distribution function for first & last sections   */
/*      (var can be find by invert method from dis)                   */
/*    input : dis = distribution function                             */
/*    output: var = random number                                     */
/*            den = density function                                  */
/*    ===============================================                 */
/*     n   |    conditions    |    reqd. functions                    */
/*    =====+==================+======================                 */
/*    n=0  |                  |  denfun, finvl                        */
/*    -----+------------------+----------------------                 */
/*         |       f(1)=0     |  denfun,        finvr                 */
/*    n=1  |   0 < f(1) < 1   |  denfun, finvl, finvr   f[0]=f(1)     */
/*         |       f(1)=1     |  denfun, finvl                        */
/*    -----+------------------+----------------------                 */
/*         |  0=f(1)  f(n)=1  |  denfun                               */
/*         |  0=f(1)  f(n)<1  |  denfun,        finvr                 */
/*    n>1  |  0<f(1)  f(n)<1  |  denfun, finvl, finvr                 */
/*         |  0<f(1)  f(n)=1  |  denfun, finvl                        */
/*    ===============================================                 */
/*    +----------------------------------------------------------+    */
/*    | if f(i) = referential distribution function              |    */
/*    | here is for goto L50                                     |    */
/*    +----------------------------------------------------------+    */
  L50:
/*1   ------------------------------------------------------------    */
      u0 = random(ix);
/*2   +----------------------------------------------------------+    */
/*    | find i by binary search such that                        |    */
/*    | f(i-1) < u0 <= f(i)                                      |    */
/*    +----------------------------------------------------------+    */
      ibgn=0;
      iend=ran000.n;
  L10:if (ibgn >= iend) {
        i=iend;
      } else {
        i=(ibgn+iend)/2;
        if (u0 < ran000.f[i]) {
          iend=i;
          goto L10;
        } else if (u0 > ran000.f[i]) {
          ibgn=i+1;
          goto L10;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | if f(i) = actual distribution function                   |    */
/*    | here is for goto L50                                     |    */
/*    +----------------------------------------------------------+    */
/*L50:                                                                */
/*3   ------------------------------------------------------------    */
      u1 = random(ix);
      u2 = random(ix);
/*4   ------------------------------------------------------------    */
      if (i == 0) {
        finvl (u1,&xx,&den);
        zz = ran000.c[i] * den;
      } else if (i == ran000.n) {
        finvr (u1,&xx,&den);
        zz = ran000.c[i] * den;
      } else {
        xx = ran000.x[i-1] + (ran000.x[i] - ran000.x[i-1]) * u1;
        if (ran000.d[i] >= u2) {
          return(xx);
        }
        zz = ran000.c[i];
      }
/*5   ------------------------------------------------------------    */
      yy = denfun (xx);
/*    if (yy > zz) {printf("\n error in ranfun"); exit(1);}           */
/*6   +----------------------------------------------------------+    */
/*    | reject xx                                                |    */
/*    +----------------------------------------------------------+    */
      if (yy < zz*u2) goto L50;
/*    +----------------------------------------------------------+    */
/*    | select xx                                                |    */
/*    +----------------------------------------------------------+    */
      return(xx);
}
/**********************************************************************/
