#include <math.h>
/**********************************************************************/
      int linsch(int nx,int ns,int ne,int n,double xold[],double xnew[]
                ,double sn[],double sc[],double pfac[],double ppen[]
                ,double c[],double beztyp[],int (*gfn)()) {
/*    int linsch(nx,ns,ne,n,xold,xnew,sn,sc,pfac,ppen,c,beztyp,gfn)
      double xold[],xnew[],sn[],sc[],pfac[],ppen[],c[],beztyp[];
      int nx,ns,ne,n,(*gfn)(); {                                      */
/*    ============================================================    */
      double fm,fo,fx,xm,xo,xx,xn,buffer[14];
      int    istep,ivy,i; int spt(); double xmin();
      double errx=1.0e-6,errd=1.0e-4,dmag=0.0,dx=0.04; int nstp=15;
/*    ============================================================    */
/*    find minimier xnew(n) of gfn(xnew(n))                           */
/*    search along the bezier curve of (xo,xc,xn) or (xo,xv,xn)       */
/*    ------------------------------------------------------------    */
/*i   nx        = number of original variables                        */
/*i   ns        = number of constraints gj(xp(nx)) <= 0               */
/*i   ne        = number of constraints hi(xp(nx))  = 0               */
/*i   xold(n)   = xold = xp(nx)[,s(ns),ls(ns),le(ne)]                 */
/*o   xnew(n)   = xnew = xp(nx)[,s(ns),ls(ns),le(ne)]                 */
/*i   sn(n)     = xn - xold = newton direction                        */
/*i   sc(n)     = xc - xold = cauchy direction                        */
/*i   pfac(nx)  = scalar factor of xp(nx)                             */
/*i   beztyp(2) = nb,v for type of bezier curve (see sub. spt)        */
/*s   spt       = sub. to get xnew from xx                            */
/*s   gfn       = sub. to get general obj. function of xnew(n)        */
/*              = gfnpen,gfnlag,gfmlag                                */
/*    ::for penalty function                                          */
/*i   n         = nx                                                  */
/*i   xold(n)   = xp(nx)                                              */
/*i   ppen(6)   = r(3),t,c1,c2                                        */
/*w   c(2*nc)   = gj(xp(nx)),hi(xp(nx)),dysj/dgj,dyei/dhi             */
/*    ::for lagrange multiplier                                       */
/*i   n         = nx+ns+ns+ne                                         */
/*i   xold(n)   = xp(nx),s(ns),ls(ns),le(ne)                          */
/*i   pfac(nx+1  :nx+n  ) = newton point xn(n)     : for gfmlag       */
/*i   pfac(nx+n+1:nx+n+n) = modified diagonal d(n) : for gfmlag       */
/*w   c(nc)     = gj(xp(nx)),hi(xp(nx))                               */
/*    ============================================================    */
      xx=1.0e30;
      fx=1.0e30;
      xn=0.0;                                /* initialize */
      xm=xx;                                 /* minimizer  */
      fm=fx;                                 /* minimum f  */
      for(istep=1; istep<=nstp; istep++) {
        xo=xx;
        fo=fx;
        xx=xn;
        spt(n,xold,sn,sc,xnew,xx,beztyp);    /* get xnew[n] from xx   */
        gfn(nx,ns,ne,xnew,pfac,ppen,c,&fx);  /* fx=f(xx) from xnew[n] */
        if(fx < fm) {
          fm=fx;
          xm=xx;
        }
        xn=xmin(xx,fx,dx,istep,&ivy,buffer);
        if(istep == 2 && dmag == 0.0) errd=errd*fabs((fx-fo)/(xx-xo));
        printf("\n buf(14)");
        for(i=0; i<14; i++) {
          if(i%6 == 0) printf("\n");
          printf("%13.5le",buffer[i]);
        }
        if(istep >= 4 || ivy != 0) {
          if(fabs(xx-xo) <= errx) break;
          if(fabs(fx-fo) <= errd*fabs(xx-xo)) break;
        }
      }
      spt(n,xold,sn,sc,xnew,xm,beztyp);
      return(0);
}
/**********************************************************************/
