/**********************************************************************/
      int fr(int n,double xp[],double gc[]
                  ,double gp[],double s[],int istep) {
/*    int fr(n,xp,gc,gp,s,istep)
      double xp[],gc[],gp[],s[]; int n,istep; {                       */
/*    ============================================================    */
      static double cc,pp,poc; int i;
/*    ============================================================    */
/*    find conjugate direction sp(n) for given gp(n),sc(n)            */
/*    ------------------------------------------------------------    */
/*i   n     = number of variables                                     */
/*i   xp(n) = this point (unused in this subroutine)                  */
/*i   gc(n) = gradient at xc (unused, for consistence with pr)        */
/*i   gp(n) = gradient at xp                                          */
/*i   s (n) = sc(n) : conjugate direction at xc (for istep>0 only)    */
/*o         = sp(n) : conjugate direction at xp                       */
/*i   istep = 0 : sp(i) = -gp(i)   (sc(n) unused)                     */
/*i         > 0 : sp(i) = -gp(i) + sc(i) * (gp.gp)/(gc.gc)            */
/*i   cc    = gc.gc   (for istep>0 only)                              */
/*o         = gp.gp                                                   */
/*    ============================================================    */
/*    pr(n,xp,gp,gp,s,-istep); return(0);                             */
      pp=0.0;
      for(i=0; i<n; i++) {
        pp=pp+gp[i]*gp[i];
      }
      if(istep == 0) {
        for(i=0; i<n; i++) {
          s[i]=-gp[i];
        }
      } else {
        poc=pp/cc;
        for(i=0; i<n; i++) {
          s[i]=-gp[i]+s[i]*poc;
        }
      }
      cc=pp;
      return(0);
}
/**********************************************************************/
      int pr(int n,double xp[],double gc[]
                  ,double gp[],double s[],int istep) {
/*    int pr(n,xp,gc,gp,s,istep)
      double xp[],gc[],gp[],s[]; int n,istep; {                       */
/*    ============================================================    */
      static double cc,cp,pp,poc; int i;
/*    ============================================================    */
/*    find conjugate direction sp(n) for given gc(n),gp(n),sc(n)      */
/*    ------------------------------------------------------------    */
/*i   n     = number of variables                                     */
/*i   xp(n) = this point (unused in this subroutine)                  */
/*i   gc(n) = gradient at xc (for istep>0 only)                       */
/*i   gp(n) = gradient at xp                                          */
/*i   s (n) = sc(n) : conjugate direction at xc (for istep<>0 only)   */
/*o         = sp(n) : conjugate direction at xp                       */
/*i   istep = 0 : sp(i) = -gp(i)   (gc(n) and sc(n) unused)           */
/*i         > 0 : sp(i) = -gp(i) + sc(i) * (gp.gp-gc.gp)/(gc.gc)      */
/*i         < 0 : sp(i) = -gp(i) + sc(i) * gp.gp/(gc.gc)              */
/*i   cc    = gc.gc   (for istep<>0 only)                             */
/*o         = gp.gp                                                   */
/*    ============================================================    */
      pp=0.0;
      for(i=0; i<n; i++) {
        pp=pp+gp[i]*gp[i];
      }
      if(istep == 0) {
        for(i=0; i<n; i++) {
          s[i]=-gp[i];
        }
      } else {
        cp=pp;
        if(istep > 0) {
          for(i=0; i<n; i++) {
            cp=cp-gc[i]*gp[i];
          }
        }
        poc=cp/cc;
        for(i=0; i<n; i++) {
          s[i]=-gp[i]+s[i]*poc;
        }
      }
      cc=pp;
      return(0);
}
/**********************************************************************/
