#include <stdio.h>
#include <ctype.h>
#include <math.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_s,*fp_w;
      static double eps,a[4000]; int ndim=4000;  /* clear with static */
      int    n1,n2,n3,n4,n5,n6,n7,n8,m1,m2,m3,m4,m5,k1,k2,k3,k4;
      int    nx,ns,ne,is,ic,maxs,ngw,ngwa,nxxs,nxxb; int inpxdx(),slp();
/*    ============================================================    */
/*    sequential linear programming by double secant method           */
/*    ============================================================    */
      if(argc<3) {printf("Usage : slslag infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ============================================================    */
      freeii(&nx,fp_r); freeii(&ns,fp_r); freeii(&ne,fp_r);
      freeii(&is,fp_r); freeii(&ic,fp_r); freeii(&maxs,fp_r);
      freer8(&eps,fp_r);
      if(is > 0) {if((fp_s=fopen("slp.is","w+b"))==NULL) exit(-1);}
/*    ------------------------------------------------------------    */
      ngw =ns+ne+1;
      ngwa=ns+ne+2;     /* constrained eqs.+ objective fun.+ big.m    */
      nxxb=nx+nx+1;     /* positive increment + negative inc.+ rhs    */
      nxxs=nx+nx+ns;    /* positive inc.+ negative inc.+ slack var.   */
/*    ------------------------------------------------------------    */
      n1=0;
      n2=n1+nx;                 /* xx(nx)                             */
      n3=n2+nx;                 /* dx(nx)                             */
      n4=n3+nx;                 /* dxm(nx)                            */
      n5=n4+nx;                 /* xxu(nx)                            */
      n6=n5+nx;                 /* xxl(nx)                            */
      n7=n6+ns;                 /* ggu(ns)                            */
      n8=n7+ngw;                /* gwo(ngw)                           */
      m1=n8+ngw;                /* gwn(ngw)                           */
      m2=m1+ngwa*nxxb;          /* a(nia,nja) = a(ns+ne+2,nx+nx+ns)   */
      m3=m2+ngwa;               /* li(nia)                            */
      m4=m3+nxxb;               /* lj(nja)                            */
      m5=m4+nxxs;               /* d(nja)                             */
      k1=m5+nxxs;               /* x(nja)                             */
      k2=k1+ngwa*nxxb;          /* b(nia,nja)                         */
      if(is >= 0) k2=k1;        /* b is not reqd for is >= 0          */
      k3=k2+ngwa;               /* mi(nia)                            */
      k4=k3+nxxb;               /* mj(nja)                            */
      if(is == 0) k4=k1;        /* mi,mj are not reqd for is == 0     */
      if(k4 > ndim) {printf("\n dimension too small !"); exit(1);}
/*    +----------------------------------------------------------+    */
/*    | input xx(nx),dxm(nx),xxu(nx),xxl(nx),ggu(ns)             |    */
/*    +----------------------------------------------------------+    */
      inpxdx(&a[n1],&a[n3],&a[n4],&a[n5],&a[n6],nx,ns,fp_r);
/*    +----------------------------------------------------------+    */
/*    | call slp to perform sequential linear programming        |    */
/*    +----------------------------------------------------------+    */
      slp(&a[n1],&a[n2],&a[n3],&a[n4],&a[n5],&a[n6],&a[n7],&a[n8]
              ,nx,ns,ne,ngw,eps,maxs
              ,&a[m1],&a[m2],&a[m3],&a[m4],&a[m5],ngwa,nxxb,nxxs
              ,&a[k1],&a[k2],&a[k3],is,ic,fp_s,fp_w);
      exit(0);
}
/**********************************************************************/
      int inpxdx(double xx[],double dxm[],double xxu[],double xxl[]
                ,double ggu[],int nx,int ns,FILE *fp_r) {
/*    int inpxdx(xx,dxm,xxu,xxl,ggu,nx,ns,fp_r)
      double xx[],dxm[],xxu[],xxl[],ggu[]; int nx,ns; FILE *fp_r; {   */
/*    ============================================================    */
      int j;
/*    ============================================================    */
/*    read initial values xx(nx), and maximum move size dxm(nx)       */
/*    read upper bounds  xxu(nx), and lower bounds xxl(nx)            */
/*    read upper bounds of slack variables ggu(ns)                    */
/*    ============================================================    */
      for(j=0; j<nx; j++) freer8(&xx [j],fp_r);
      for(j=0; j<nx; j++) freer8(&dxm[j],fp_r);  /* if unbound :      */
      for(j=0; j<nx; j++) freer8(&xxu[j],fp_r);  /*    xxu[j]=0       */
      for(j=0; j<nx; j++) freer8(&xxl[j],fp_r);  /*    xxl[j]=0       */
      for(j=0; j<ns; j++) freer8(&ggu[j],fp_r);  /*    ggu[i]=0       */
      return(0);
}
/**********************************************************************/
      int slp(double xx[],double dx[],double dxm[],double xxu[]
         ,double xxl[],double ggu[],double gwo[],double gwn[]
         ,int nx,int ns,int ne,int mgw,double eps,int maxs
         ,double a[],int li[],int lj[],double d[],double x[]
         ,int nia,int nja,int njx,double b[],int mi[],int mj[]
         ,int is,int ic,FILE *fp_s,FILE *fp_w) {
/*    int slp(xx,dx,dxm,xxu,xxl,ggu,gwo,gwn,nx,ns,ne,mgw,eps,maxs
             ,a,li,lj,d,x,nia,nja,njx,b,mi,mj,is,ic,fp_s,fp_w)
      double xx[],dx[],dxm[],xxu[],xxl[],ggu[],gwo[],gwn[];
      double a[],d[],x[],b[];  int nx,ns,ne,mgw,eps,maxs;
      int li[],lj[],nia,nja,njx,mi[],mj[],is,ic; FILE *fp_s,fp_w; {   */
/*    ============================================================    */
      double dxj,dxnj,dxmj,dxmax,wold,wdif,tmp;
      int    i,j,nsh,ngw,ngwa,nxxs,nxxb,icase,kkk;
      int    dsm(),outmed(),outfnl(),fff();
/*    ============================================================    */
/*    sequential linear programming by double secant method           */
/*    ------------------------------------------------------------    */
/*    input   : nx,ns,ne,mgw,eps,maxs,nia,nja,njx,is,ic               */
/*            : xx(nx),dxm(nx),xxu(nx),xxl(nx),ggu(ns)                */
/*    output  : xx(1:nx),gwo(1:ns+ne),gwo(ns+ne+1)                    */
/*    working : dx(nx),gwn(mgw),a(nia,nja)                            */
/*            : a,li,lj,d,x : for linear programming (see linear)     */
/*            : mi,mj : for linear programming (required if is<>0)    */
/*            : b     : for linear programming (required if is< 0)    */
/*    ------------------------------------------------------------    */
/*i   nx        = number of original variables                        */
/*i   ns        = number of  <=  constraints                          */
/*i   ne        = number of  ==  constraints                          */
/*i   mgw      >= ngw  = ns+ne+1                                      */
/*i   eps       = relative error for convergence control              */
/*i   maxs      = maximum allowed numbers of linear programming       */
/*i   nia      >= ngwa = ns+ne+2  : dimension of simplex tabulea      */
/*i   nja      >= nxxb = nx+nx+1  : dimension of simplex tabulea      */
/*i   njx      >= nxxs = nx+nx+ns : var^+, var^-, slack-var           */
/*i   is,ic     = see subroutine linear                               */
/*i   xx(nx)    = initial values of original variables                */
/*o             = optimum values of original variables                */
/*w   dx(nx)    = move limits                                         */
/*i   dxm(nx)   = maximum move size                                   */
/*i   xxu(nx)   = upper bounds of original variables                  */
/*i   xxl(nx)   = lower bounds of original variables                  */
/*i   ggu(ns)   = upper bounds of slack variables for  <=  constr.    */
/*o   gwo(1:ng) = constrained values at optimum (ng=ns+ne)            */
/*o   gwo(ng+1) = objective function at optimum                       */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | set constants                                            |    */
/*    +----------------------------------------------------------+    */
      ngw =ns+ne+1;
      ngwa=ns+ne+2;
      nxxb=nx+nx+1;
      nxxs=nx+nx+ns;
/*    +----------------------------------------------------------+    */
/*    | check initial setting of xx,dxm,xxu,xxl(nx) and ggu(ns)  |    */
/*    | set initial dx(nx), wold, nsh = number of lp performed   |    */
/*    +----------------------------------------------------------+    */
/*    inpxdx(xx,dxm,xxu,xxl,ggu,nx,ns)                                */
      for(j=0; j<nx; j++) {
        if(dxm[j] <= 0.0) {
          dxm[j]=0.10*fabs(xx[j]); if(dxm[j] < 0.1) dxm[j]=0.1;
        }
        dx[j]=fabs(dxm[j]);
        if(xxu[j] <= xxl[j]) {
          xxu[j]= 1.0e10;            /* set to infinity for xxu=xxl=0 */
          xxl[j]=-1.0e10;
        }
        if(xx[j] > xxu[j]) xx[j]=xxu[j];
        if(xx[j] < xxl[j]) xx[j]=xxl[j];
      }
      for(i=0; i<ns; i++) {
        if(ggu[i] <= 0.0) ggu[i]=1.0e10; /* set to infinity for ggu=0 */
      }
      wold=0.0;                          /* old objective function    */
      nsh =0;                            /* iteration count           */
/*    +----------------------------------------------------------+    */
/*    | call dsm for slp by double secant method                 |    */
/*    | to find x(nxxs) from given xx(nx),dx(nx)                 |    */
/*    +----------------------------------------------------------+    */
 L200:dsm(xx,dx,xxu,xxl,ggu,gwo,gwn,nx,ns,ne,mgw,&icase,&kkk
               ,a,li,lj,d,x,nia,nja,njx,b,mi,mj,is,ic,fp_s,fp_w);
/*    +----------------------------------------------------------+    */
/*    | update variables xx(nx), move limits dx(nx) & count nsh  |    */
/*    +----------------------------------------------------------+    */
      dxmax=0.0;                                /* for converge. test */
      for(j=0; j<nx; j++) {
        dxj=x[2*j]-x[2*j+1];                    /* movement of var. j */
        dxnj=fabs(dxj);
        dxmj=fabs(dxm[j]);
        if((tmp=dxnj/dxmj) > dxmax) dxmax=tmp;  /* maximum movement   */
        if(dxj*dxm[j] < 0 && nsh != 0) dxnj=dxnj/2; /* reduce m.limit */
        if(dxmj < (tmp=(1+dxnj/dx[j])*dxnj)) tmp=dxmj;
        if(0.25*dx[j] > tmp) tmp=0.25*dx[j];    /* if move dir.change */
        if(0.04 *dxmj > tmp) tmp=0.04 *dxmj;    /* update dx[j]       */
        if(4*eps*dxmj > tmp) tmp=4*eps*dxmj;
        dx[j]=tmp;
        dxm[j]=dxmj; if(dxj < 0) dxm[j]=-dxm[j];/* save move dir.     */
        xx[j]=xx[j]+dxj;                        /* update xx[j]       */
      }
      nsh=nsh+1;                                /* iteration count    */
/*    +----------------------------------------------------------+    */
/*    | output intermediate results                              |    */
/*    +----------------------------------------------------------+    */
      outmed(xx,dx,x,d,nx,nxxs,nsh,icase,kkk);
/*    +----------------------------------------------------------+    */
/*    | test convergence                                         |    */
/*    +----------------------------------------------------------+    */
      wdif=wold-gwo[ngw-1];
      wold=gwo[ngw-1];                     /* save objective function */
      if(nsh >= maxs) goto L300;           /* maximum allowed number  */
      if(icase != 0)  goto L200;           /* infeasible or unbounded */
      if(fabs(wdif) <= 0.001*fabs(wold)) goto L300;  /* obj. function */
      if(dxmax > eps) goto L200;           /* max. movement too small */
/*    +----------------------------------------------------------+    */
/*    | output final results & return                            |    */
/*    +----------------------------------------------------------+    */
 L300:fff(nx,ns,ne,xx,&gwo[ngw-1],gwo);
      outfnl(nsh,nx,ns,ne,xx,gwo[ngw-1],gwo);
      return(0);
}
/**********************************************************************/
      int dsm(double xx[],double dx[],double xxu[],double xxl[]
         ,double ggu[],double gwo[],double gwn[]
         ,int nx,int ns,int ne,int mgw,int *icase,int *kkk
         ,double a[],int li[],int lj[],double d[],double x[]
         ,int nia,int nja,int njx,double b[],int mi[],int mj[]
         ,int is,int ic,FILE *fp_s,FILE *fp_w) {
/*    int dsm(xx,dx,xxu,xxl,ggu,gwo,gwn,nx,ns,ne,mgw,icase,kkk
             ,a,li,lj,d,x,nia,nja,njx,b,mi,mj,is,ic,fp_s,fp_w)
      double xx[],dx[],xxu[],xxl[],ggu[],gwo[],gwn[],a[],d[],x[],b[];
      int nx,ns,ne,mgw,*icase,*kkk;
      int li[],lj[],nia,nja,njx,mi[],mj[],is,ic; FILE *fp_s,*fp_w; {  */
/*    ============================================================    */
/*    dimension xx(nx),dx(nx),xxu(nx),xxl(nx),ggu(ns)                 */
/*    dimension gwo(mgw),gwn(mgw)                                     */
/*    dimension a(nia,nja),li(nia),lj(nja),d(njx),x(njx)              */
/*    dimension b(nia,nja),mi(nia),mj(nja)                            */
      double avag,asum,tmp,spos=1.0,sneg=-1.0;
      int i,j,jj,ja,jb,ngw,nxx,nxxs,nxxb; int linear(),grdgw(),fff();
/*    ============================================================    */
/*    double secant method for sequential linear programming          */
/*    setup simplex tableau and call linear for linear programming    */
/*    ------------------------------------------------------------    */
/*    input   : nx,ns,ne,mgw,eps,maxs,nia,nja,njx,is,ic               */
/*            : xx(nx),dx(nx),xxu(nx),xxl(nx),ggu(ns)                 */
/*    working : gwo(mgw),gwn(mgw)                                     */
/*            : a,li,lj,d,x,b,mi,mj : for linear programming          */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | set constants                                            |    */
/*    +----------------------------------------------------------+    */
      ngw =ns+ne+1;
      nxx =nx+nx;
      nxxb=nxx+1;
/*    +----------------------------------------------------------+    */
/*    | compute gwo(1:ng)=g(i), gwo(ng+1)=f_obj at xx(nx)        |    */
/*    | setup simplex tableau : a(1:ng+1,1:nx+nx)    (ng=ns+ne)  |    */
/*    +----------------------------------------------------------+    */
      fff(nx,ns,ne,xx,&gwo[ngw-1],gwo);
      grdgw(xx,dx,gwo,gwn, a     ,spos,nx,ns,ne,mgw,nia+nia);
      grdgw(xx,dx,gwo,gwn,&a[nia],sneg,nx,ns,ne,mgw,nia+nia);
/*    ------------------------------------------------------------    */
      for(j=0; j<nxx; j=j+2) {
       ja=j*nia; jb=ja+nia;      /* \ . use \./ if this . /           */
       for(i=0; i<ns+ne; i++) {  /*   \.  is feasible  ./  \./ secant */
        asum=a[i+ja]+a[i+jb];    /*     +    region   +               */
        if(asum >= 0) continue;  /*      .\         /.  ... nonlinear */
        avag=(a[i+ja]-a[i+jb])/2;/*        .\     /.        constrain */
        a[i+ja]= avag;           /* __________\./___________          */
        a[i+jb]=-avag;           /* use _._ if this is feasible region*/
       }                         /* _._ tangent                       */
      }
/*    +----------------------------------------------------------+    */
/*    | set upper bound d(j) and variable index lj(j)            |    */
/*    +----------------------------------------------------------+    */
      j=0;
      for(jj=0; jj<nx; jj++) {
        lj[j]=j+1;
        d[j]=xxu[jj]-xx[jj]; if(dx[jj] < d[j]) d[j]=dx[jj];
        j=j+1;
        lj[j]=j+1;
        d[j]=xx[jj]-xxl[jj]; if(dx[jj] < d[j]) d[j]=dx[jj];
        j=j+1;
      }
/*    +----------------------------------------------------------+    */
/*    | set upper bound d(nxx+i) of slack var. & basic var. index|    */
/*    | set simplex tableau : a(1:ng+1,nx+nx+1) = rhs of constra.|    */
/*    +----------------------------------------------------------+    */
      jj=(nxxb-1)*nia;
      nxxs=nxx;
      for(i=0; i<ngw; i++) {
        li[i]=0;
        if(i < ns) {
          li[i]=nxxs+1;
          d[nxxs]=ggu[i];
          nxxs=nxxs+1;
        }
        a[i+jj]=-gwo[i];
      }
/*    +----------------------------------------------------------+    */
/*    | perform linear programming                               |    */
/*    +----------------------------------------------------------+    */
      linear(a,li,lj,d,x,ngw,nxxb,nxxs,icase,kkk
            ,nia,nja,b,mi,mj,is,ic,fp_s,fp_w);
      return(0);
}
/**********************************************************************/
      int grdgw(double xx[],double dx[],double gwo[],double gwn[]
               ,double dgw[],double s
               ,int nx,int ns,int ne,int mgw,int nia2) {
/*    int grdgw(xx,dx,gwo,gwn,dgw,s,nx,ns,ne,mgw,nia2)
      double xx[],dx[],gwo[],gwn[],dgw[],s; int nx,ns,ne,mgw,nia2; {  */
/*    ============================================================    */
/*    dimension xx(nx),dx(nx),gwo(mgw),gwn(mgw),dgw(nia2,nx);         */
      double xxj,dxp;  int i,j,jj;  int fff();
/*    ============================================================    */
/*    compute gradients by forward or backward difference             */
/*    ------------------------------------------------------------    */
/*i   xx(nx)    = values of variables                                 */
/*i   dx(nx)    = delta values of variables > 0                       */
/*i   gwo(ng+1) = constra. g(1:ng) & obj.fun. f_obj at xx(nx)         */
/*w   gwn(ng+1) = constra. g(1:ng) & obj.fun. f_obj at xx(nx)+dx(j)   */
/*o   dgw(i,j)  = (g_i(xx(j)+dx(j))-g_i(xx(j)))/dx(j) if s=+1         */
/*o   dgw(i,j)  = (g_i(xx(j)-dx(j))-g_i(xx(j)))/dx(j) if s=-1         */
/*i   nx        = number of original variables    (ng=ns+ne)          */
/*i   ns,ne     = number of  <= , ==  constraints (ngw=ng+1)          */
/*    ============================================================    */
      for(j=0; j<nx; j++) { jj=j*nia2;
/*      +--------------------------------------------------------+    */
/*      | compute constraint gwn(1:ns+ne)=g(i) & gwn(ngw)=f_obj  |    */
/*      +--------------------------------------------------------+    */
        xxj=xx[j];
        xx[j]=xx[j]+dx[j]*s;
        dxp=fabs(xx[j]-xxj);
        fff(nx,ns,ne,xx,&gwn[ns+ne],gwn);
        xx[j]=xxj;
/*      +--------------------------------------------------------+    */
/*      | compute dgw(i,j)=dg(i)/dx(j) & dgw(ngw,j)=df_obj/dx(j) |    */
/*      +--------------------------------------------------------+    */
        for(i=0; i<ns+ne+1; i++) {
          dgw[i+jj]=(gwn[i]-gwo[i])/dxp;
        }
      }
      return(0);
}
/**********************************************************************/
      int outmed(double xx[],double dx[],double x[],double d[]
                ,int nx,int nxxs,int nsh,int icase,int kkk) {
/*    int outmed(xx,dx,x,d,nx,nxxs,nsh,icase,kkk)
      double xx[],dx[],x[],d[]; int nx,nxxs,nsh,icase,kkk; {          */
/*    ============================================================    */
      int printv();
/*    ============================================================    */
/*    output intermediate results                                     */
/*    ============================================================    */
      printf("\n ----------------------------- ");
      printf("\n nsh,icase,kkk =%5d%5d%5d",nsh,icase,kkk);
      printv(d,nxxs," d =");
      printv(x,nxxs," x =");
      printv(dx,nx, "dx =");
      printv(xx,nx, "xx =");
      return(0);
}
/**********************************************************************/
      int outfnl(int nsh,int nx,int ns,int ne
                ,double xx[],double wo,double gwo[]) {
/*    int outfnl(nsh,nx,ns,ne,xx,wo,gwo)
      double xx[],wo,gwo[]; int nsh,nx,ns,ne; {                       */
/*    ============================================================    */
      int printv();
/*    ============================================================    */
/*    output final results                                            */
/*    ============================================================    */
      printf("\n ========= \n after %d linear programming:",nsh);
      printf("\n the optimum objective function is %12.4le",wo);
      printv(xx,nx,"values of variables");
      printv(gwo,ns+ne,"values of constraint");
      return(0);
}
/**********************************************************************/
      int printv(double a[],int n,char *msg) {
/*    int printv(a,n,msg) double a[]; int n; char *msg; {             */
/*    ============================================================    */
      int i;
/*    ============================================================    */
      printf("\n %s",msg);
      for(i=0; i<n; i++) {
        if(i%6 == 0) printf("\n");
        printf("%13.5le",a[i]);
      }
      return(0);
}
/**********************************************************************/
