#include <math.h>
/**********************************************************************/
      int spt(int n,double xold[],double sn[],double sc[]
                   ,double xnew[],double t,double beztyp[]) {
/*    int spt(n,xold,sn,sc,xnew,t,beztyp)
      double xold[],sn[],sc[],xnew[],t,beztyp[]; int n; {             */
/*    ============================================================    */
      double tc,tn; int i,nb; double powdi();
/*    ============================================================    */
/*    find a point on bezier curve for given t and (xo,xc,xn)         */
/*    ------------------------------------------------------------    */
/*i   n       = number of variables                                   */
/*i   xold(n) = xo      = initial point                               */
/*i   sn(n)   = xn - xo = newton direction                            */
/*i   sc(n)   = xc - xo = cauchy direction                            */
/*o   xnew(n) = xo + t^nb*(xn-xo) + (1-t^nb-(1-t)^nb) * (xv-xo)       */
/*            = xo + t^nb*(xn-xo) + (1-t^nb-(1-t)^nb)*v*(xc-xo)       */
/*              xv = v*xc + (1-v)*xo                                  */
/*i   t = t   = parameter of bezier curve                             */
/*i   nb      = fabs(beztyp(1)) = order of bezier curve               */
/*            = 0 : for straight line oc (sn,beztyp(2:2) unuse)       */
/*            = 1 : for straight line on (sc,beztyp(2:2) unuse)       */
/*            > 1 : for bezier curve of order nb, but if              */
/*                  beztyp(1) < 0 : use line on for t>=1 or t<=0      */
/*i   v       = fabs(beztyp(2)) <= 1                                  */
/*    ============================================================    */
      nb=fabs(beztyp[0]);
      if(nb == 0) {
        for(i=0; i<n; i++) {
          xnew[i]=xold[i]+t*sc[i];
        }
      } else if(nb == 1 || beztyp[1] == 0
             || (beztyp[0] < 0 && (t >= 1 || t <= 0))) {
        for(i=0; i<n; i++) {
          xnew[i]=xold[i]+t*sn[i];
        }
      } else {
        tn=powdi(t,nb);
        tc=(1-tn-powdi(1-t,nb))*fabs(beztyp[1]);
        for(i=0; i<n; i++) {
          xnew[i]=xold[i]+tn*sn[i]+tc*sc[i];
        }
      }
      return(0);
}
/**********************************************************************/
      double powdi(double b,int i) {
/*    double powdl(b,i) double b; int i; {                            */
/*    ============================================================    */
      double p;
/*    ============================================================    */
/*    return b**i                                                     */
/*    ============================================================    */
      if(i < 0) {i=-i; b=1.0/b;}
      if((i & 1) != 0) p=b; else p=1.0;
      while ((i >>= 1) != 0) {
        b=b*b;
        if((i & 1) != 0) p=p*b;
      }
      return(p);
}
/**********************************************************************/
