#include <math.h>
#define x1 b[0]
#define x2 b[1]
#define x3 b[2]
#define x4 b[3]
#define x5 b[4]
#define f1 b[5]
#define f2 b[6]
#define f3 b[7]
#define f4 b[8]
#define f5 b[9]
#define xb b[10]
#define xl b[11]
#define xm b[12]
#define xr b[13]
#define xe b[14]
#define fb b[15]
#define fl b[16]
#define fm b[17]
#define fr b[18]
#define fe b[19]
#define st b[20]
#define vy b[21]
#define vl b[22]
#define vr b[23]
#define vn b[24]
/**********************************************************************/
      double xmin(double x,double f,double dx
                 ,int istep,int *ivy,double b[]) {
/*    double xmin(x,f,dx,istep,ivy,b)
      double x,f,dx,b[]; int istep,*ivy; {                            */
/*    ============================================================    */
      double xx,ddx,ddf,fmm,rate,pmax=1.0e30;
      int    iget,i,il,ir,in; int quadft();
/*    ============================================================    */
/*    find  xmin                                                      */
/*    ------------------------------------------------------------    */
/*    xmin  = new guess of x for minimizing f(x)                      */
/*    x     = argument of function                                    */
/*    f     = f(x) = function value of x                              */
/*    dx    = return xmin=x+dx if no better formula to find xmin      */
/*    istep = number of call to function xmin                         */
/*    ivy   = 1/0 if valley set is found/not found                    */
/*    b(25) = buffer must not be changed between each calling istep   */
/*    ------------------------------------------------------------    */
/*    for istep = 1  :  (x1=x,f1=f) (st=1) (vy=0)                     */
/*        xmin  = x1 + dx   if dx != 0                                */
/*        xmin  = x1 + 0.1  if dx == 0                                */
/*    for istep = 2  :  (x2=x,f2=f) (st=2) (vy=0)                     */
/*        xmin  = x1 + (x1-x2)*2  if f1<f2                            */
/*        xmin  = x2 + (x2-x1)*2  if f2<f1                            */
/*    for istep > 2  :  (x3=x,f3=f) (st>2) (vy=1 if found valley)     */
/*        xmin  = y1  from quad eq of newest pts (x1,x2,x3,x4,x5)     */
/*        xmin  = y2  from quad eq of valley set (xb,xl,xm,xr,xe)     */
/*                    if vy=1 and when y1 is na or outside (xl,xr)    */
/*    ============================================================    */
      if (istep == 1) {
        for(i=0; i<25; i++) {
          b[i]=pmax;
        }
        st=0;
        vy=0;
        vl=0;
        vr=0;
        vn=6;
      }
      st=st+1;
      il=vl;
      ir=vr;
      in=vn-1;
      if (in < 1) in=1;
/*    +----------------------------------------------------------+    */
/*    | save  the newest 5 points to (x1,x2,x3,x4,x5)            |    */
/*    +----------------------------------------------------------+    */
      for(i=0; i<9; i++) {
        b[i]=b[i+1];
      }
      x5=x;
      f5=f;
/*    +----------------------------------------------------------+    */
/*    | find  new points (xl,xm,xr) that bracket the root        |    */
/*    +----------------------------------------------------------+    */
      if(x > xm) {
        if(f > fm || (f == fm && fr > fl)) {
          xe=xr;
          fe=fr;
          xr=x;
          fr=f;
          ir=4;
          if(fm*(xe-xr)+fr*(xm-xe)+fe*(xr-xm) > 0.0) ir=5;
        } else {
          xb=xl;
          fb=fl;
          xl=xm;
          fl=fm;
          xm=x;
          fm=f;
          il=2;
          ir=4;
          if(fb*(xm-xl)+fl*(xb-xm)+fm*(xl-xb) > 0.0) il=1;
          if(fm*(xe-xr)+fr*(xm-xe)+fe*(xr-xm) > 0.0) ir=5;
        }
      } else if(x < xm) {
        if(f > fm || (f == fm && fl > fr)) {
          xb=xl;
          fb=fl;
          xl=x;
          fl=f;
          il=2;
          if(fb*(xm-xl)+fl*(xb-xm)+fm*(xl-xb) > 0.0) il=1;
        } else {
          xe=xr;
          fe=fr;
          xr=xm;
          fr=fm;
          xm=x;
          fm=f;
          ir=4;
          il=2;
          if(fm*(xe-xr)+fr*(xm-xe)+fe*(xr-xm) > 0.0) ir=5;
          if(fb*(xm-xl)+fl*(xb-xm)+fm*(xl-xb) > 0.0) il=1;
        }
      }
      if(b[il+14] == pmax) il=il+1;
      if(b[ir+14] == pmax) ir=ir-1;
      if(fl < pmax && fr < pmax) vy=1;
      iget=0;
      xx=0.0;
/*    +----------------------------------------------------------+    */
/*    | find a new point from qradratic eq on (x1,x2,x3,x4,x5)   |    */
/*    | if it is concave upward  d2f/dx2 = 1/ddf > 0             |    */
/*    | and make sure that abs(xx-(x5+x3)/2) < 3*abs(x5-x3)      |    */
/*    |                                                          |    */
/*    | x3  x4      x5    <---3.75*(x5-x4)--->    xxmax          |    */
/*    |  *---*---+---*---+---x---+---x---+---x---+-*             |    */
/*    |        *---+---+---x---+---+---x---+---+---*             |    */
/*    |        0        <---3*(x5-x3)--->        -ddx            |    */
/*    +----------------------------------------------------------+    */
      if(st > 2) {
        fmm=(f5-f4)*(x3-x4)-(f3-f4)*(x5-x4);
        if(fmm != 0.0) {
          ddf=(x5-x3)*(x5-x4)*(x3-x4)/fmm;
          if(ddf <= 0.0) in=4;
        } else {
          in=4;
        }
        if(in == 1) {
          quadft(&b[0],&b[5],5,&xx,&iget);
          ddx=0.5*(x5+x3)-xx;
          if(iget != 0) iget=6;
        }
        if(iget == 0 && in <= 3) {
          ddx=0.5*(f5-f3)/(x5-x3)*ddf;
          iget=5;
        }
        if(iget != 0) {
          rate=fabs(ddx/(x5-x3))/3.0;
          if(rate <= 1.0) rate=1.0;
          xx=0.5*(x5+x3)-ddx/rate;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | if minimum is bracketed by (xl,xm,xr) and if no xx get   |    */
/*    | or xx goes outside (xl,xr) then use quadratic equation   |    */
/*    +----------------------------------------------------------+    */
      if(vy != 0) {
        if(iget == 0 || (xx-xl)*(xx-xr) > 0.0) {
          if(ir-il == 4) quadft(&b[10],&b[15],5,&xx,&iget);
          if(iget == 0 || (xx-xl)*(xx-xr) > 0.0) {
            fmm=(fr-fm)*(xl-xm)-(fl-fm)*(xr-xm);
            xx=0.5*(xr+xl);
            if(fmm != 0.0) xx=xx-0.5*(fr-fl)*(xr-xm)*(xl-xm)/fmm;
            iget=3;
          }
        }
      }
/*    +----------------------------------------------------------+    */
/*    | if none xx get so far, then:                             |    */
/*    | if known at least 2 points, go the downward side         |    */
/*    | if known only one point, set xx=x+dx or xx=x+0.1         |    */
/*    +----------------------------------------------------------+    */
      if(iget == 0) {
        if(st >= 2) {
          if(f5 > f4) {
            xx=x4;
            x4=x5;
            x5=xx;
            xx=f4;
            f4=f5;
            f5=xx;
          }
          xx=x5+(x5-x4)*2.0;
          iget=2;
        } else {
          if(dx != 0.0) {
            xx=x+dx;
          } else {
            xx=x+0.1;
          }
          iget=1;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | for debug                                                |    */
/*    +----------------------------------------------------------+    */
      x1=iget;
      f1=xx;
/*    ------------------------------------------------------------    */
      vl=il;
      vr=ir;
      vn=in;
      *ivy=vy;
      return(xx);
}
#undef xm
/**********************************************************************/
      int quadft(double x[],double y[],int n,double *xm,int *iget) {
/*    int quadft(x,y,n,xm,iget) double x[],y[],*xm; int n,*iget; {    */
/*    ============================================================    */
/*    dimension x(n),y(n),a(6,6),l(2,6),c(6)                          */
      double a[36],c[6];
      int    l[12],i,nsd;
/*    ============================================================    */
/*    fit a quadratic curve for (x(i),y(i),i=1,n), n=5                */
/*    c1 + c2*x + c3*y + c4*x**2 +c5*x*y + c6*y**2 = 0                */
/*    then call quadxm to find the minimizer xm of y(x)               */
/*    where : ci = a(i,6)                                             */
/*    ------------------------------------------------------------    */
/*    input  : x(n),y(n) & n=5 (iget=0)                               */
/*    output : xm & iget=4 if xm found                                */
/*    ============================================================    */
      for(i=0; i<n; i++) {
        a[i   ]=1.0;
        a[i+ 6]=x[i];
        a[i+12]=y[i];
        a[i+18]=x[i]*x[i];
        a[i+24]=x[i]*y[i];
        a[i+30]=y[i]*y[i];
        a[5+i*6]=0.0;
      }
      a[5+30]=0.0;
/*    ------------------------------------------------------------    */
      lufpdc(a,l,6,&nsd,6);
      if(nsd > 1) return(0);
      lufpsg(a,c,l,6,1,6);
      quadxm(c,xm,iget);
      return(0);
}
/**********************************************************************/
      int quadxm(double c[],double *xm,int *iget) {
/*    int quadxm(c,xm,iget) double c[],*xm; int *iget; {              */
/*    ============================================================    */
      double d1,d2,x0,y0,dem; int i;
      --c;
/*    ============================================================    */
/*    find the minimizer xm of y(x) from the quadratic eq             */
/*q1  c1 + c2*x + c3*y + c4*x**2 + c5*x*y + c6*y**2 = 0               */
/*    dem = c5**2 - 4*c4*c6                                           */
/*    ------------------------------------------------------------    */
/*    for hyperbolic (dem>0) or elliptic (dem<0) :                    */
/*q2  d1 + c4*(x-x0)**2 + c5*(x-x0)*(y-y0) + c6*(y-y0)**2 = 0         */
/*    where :                                                         */
/*    x0 = (2*c2*c6 - c3*c5)/dem  :  c2 + 2*c4*x0 + c5*y0 = 0         */
/*    y0 = (2*c3*c4 - c2*c5)/dem  :  c3 + c5*x0 + 2*c6*y0 = 0         */
/*    d1 = c1 + c2*x0 + c3*y0 + c4*x0**2 + c5*x0*y0 + c6*y0**2        */
/*       = c1                 - c4*x0**2 - c5*x0*y0 - c6*y0**2        */
/*       = c1 +(c2*x0 + c3*y0)*0.5                                    */
/*    so :                                                            */
/*    dq2/dx  :  2*c4*(x-x0) + c5*(y-y0) = 0                          */
/*    if (d1*c4*dem > 0)  xm=x0-sqrt(d1*c4*dem)*(c5/(c4*dem))         */
/*          note that    (xm-x0) same sign as  -(c5/(c4*dem))         */
/*          therefore    (ym-y0) same sign as  dem                    */
/*          that is  ym>y0 for hyperbolic; ym<y0 for elliptic         */
/*    since :                                                         */
/*    (y-y0) = -(2*c4/c5)*(x-x0) --> q2                               */
/*q3  d1 + (c4 - 2*c4 + 4*c6*c4**2/c5**2)*(x-x0)**2 = 0               */
/*    (x-x0)**2 = (d1*c5**2)/(c4*dem)                                 */
/*    ------------------------------------------------------------    */
/*    for parabolic (dem=0)                                           */
/*    dq1/dx  :  c2 + 2*c4*x + c5*y = 0                               */
/*    if (c5 == 0) {    : xm=-0.5*c2/c4  (and if(c3*c4 < 0))          */
/*    if (c5 != 0) {    : xm=d1/d2       (and if(d2 != 0))            */
/*    where : d1 = c1 - c3*c2/c5 + c6*(c2/c5)**2                      */
/*            d2 = 2*c3*c4/c5 - 4*c6*c2*c4/c5**2                      */
/*    since :                                                         */
/*    for c5 != 0                                                     */
/*    y = - c2/c5 - (2*c4/c5)*x --> q1                                */
/*    c1 - c3*c2/c5 + c6*(c2/c5)**2                                   */
/*       + (c2 - 2*c3*c4/c5 - c2 + 4*c6*c2*c4/c5**2)*x                */
/*       + (c4- 2*c4 + 4*c6*c4**2/c5**2)*x**2 = 0                     */
/*l4  d1 - d2*x = 0                                                   */
/*    for c5 == 0 & c3*c4 != 0          (also c6=0, since dem=0)      */
/*q5  c1 + c2*x + c3*y + c4*x**2 = 0    (y is min if c3*c4  < 0)      */
/*    ============================================================    */
      printf("\n c"); for(i=1; i<=6; i++) printf("%12.4le",c[i]);
      dem=c[5]*c[5]-4.0*c[4]*c[6];
      if(dem != 0) {
        x0=(2.0*c[2]*c[6]-c[3]*c[5])/dem;
        y0=(2.0*c[3]*c[4]-c[2]*c[5])/dem;
        d1=c[1]+(c[2]*x0+c[3]*y0)*0.5;
        d2=d1*c[4]*dem;
        if(d2 > 0) {
          *xm=x0-sqrt(d2)*c[5]/(c[4]*dem);
          *iget=4;
          printf("\n d%12.4le%12.4le%12.4le%12.4le%12.4le%12.4le"
                                           ,dem,x0,y0,d1,d2,*xm);
        }
      } else {
        if(c[5] != 0) {
          d1=c[1]-(c[3]-c[6]*(c[2]/c[5]))*(c[2]/c[5]);
          d2=2.0*c[3]*c[4]/c[5]-4.0*c[6]*c[2]*c[4]/(c[5]*c[5]);
          if(d2 != 0) {
            *xm=d1/d2;
            *iget=4;
            printf("\n e%12.4le%12.4le%12.4le%12.4le",dem,d1,d2,*xm);
          }
        } else {
          if(c[3]*c[4] < 0) {
            *xm=-0.5*c[2]/c[4];
            *iget=4;
            printf("\n f%12.4le%12.4le",dem,*xm);
          }
        }
      }
      return(0);
}
/**********************************************************************/
