#include <math.h>
/**********************************************************************/
      int mkloop(int nopp[],int ponp[],int pons[],int polp[],int pols[]
                ,int ponu[],int lvsn[],int lvsp[],int lvsb[]
                ,int np,int nn,int nl) {
/*    int mkloop(nopp,ponp,pons,polp,pols,ponu,lvsn,lvsp,lvsb,np,nn,nl)
      int nopp[],ponp[],pons[],polp[],pols[],ponu[],lvsn[],lvsp[],lvsb[]
         ,np,nn,nl; {                                                 */
/*    ============================================================    */
      int k,il,jl,ml,in,jn,ir,jr,ip,jp,ix,iy,it,jt,kt,ibg,ied,jbg,jed;
      nopp-=3; --ponp; --pons; --polp; --pols;
               --ponu; --lvsn; --lvsp; --lvsb;
/*    ============================================================    */
/*    input  : nopp(2,np),np,nn                                       */
/*    oouput : ponp(nn+1),pons(2*np),polp(nl+1),pols(polp(nl+1)-1),nl */
/*    working: ponu(nn),lvsn(nn),lvsp(nn),lvsb(nn)                    */
/*    ------------------------------------------------------------    */
/*    np,nn,nl   = numbers of pipes, nodes, loops                     */
/*    nopp(2,ip) = positive pipe flow                                 */
/*                 from node nopp(1,ip) to nopp(2,ip)                 */
/*    ponp,pons  = pipe list of nodes                                 */
/*    polp,pols  = pipe list of loops                                 */
/*    ponu(in)   = index for the usage of pipes connected to node in  */
/*               = ponp(in+1) : no   pipe  used : unused node         */
/*               = ponp(in)   : all  pipes used : used   node         */
/*               = in between : some pipes used : used   node         */
/*    ponp(in)   < 0 : to mark node in as labeled                     */
/*    nopp(1,ip) < 0 : to mark pipe ip as used                        */
/*    nopp(2,ip) < 0 : input value for a dummy pipe btwn 2 reservoirs */
/*                     it is used in the only loop rooted by itself   */
/*    lvsn,lvsp,lvsb = node, pipe, backward_pntr in level structure   */
/*    ------------------------------------------------------------    */
/*    connected pipes of node in : pons( ponp(in) : ponp(in+1)-1) )   */
/*    connected pipes of loop il : pols( polp(il) : polp(il+1)-1) )   */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | count the no. of pipes connecting to node in : ponu(in)  |    */
/*1   +----------------------------------------------------------+    */
      for(in=1; in<=nn; in++) {
        ponu[in]=0;
      }
      for(ip=1; ip<=np; ip++) {
        for(k=1; k<=2; k++) {
          in=abs(nopp[k+ip*2]);
          ponu[in]=ponu[in]+1;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | setup pointers to the pipe list for the nodes            |    */
/*    +----------------------------------------------------------+    */
      ponp[1]=1;
      for(in=1; in<=nn; in++) {
        ponp[in+1]=ponp[in]+ponu[in];
        ponu[in]=ponp[in];
      }
/*    +----------------------------------------------------------+    */
/*    | setup pipe list of nodes                                 |    */
/*    +----------------------------------------------------------+    */
      for(ip=1; ip<=np; ip++) {
        for(k=1; k<=2; k++) {
          in=abs(nopp[k+ip*2]);
          it=ponu[in];
          pons[it]=ip*(2*k-3);
          ponu[in]=it+1;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | initialize a loop array                                  |    */
/*    +----------------------------------------------------------+    */
      nl=0;
      polp[nl+1]=1;
      ml=np-nn+1;
/*    +----------------------------------------------------------+    */
/*    | setup a level structure for an unused pipe: nopp(1,ip)>0 |    */
/*    | the pipe must has at least one  used  node: node ir      |    */
/*    | node ir is a used node but not labeled as a root node    |    */
/*2   +----------------------------------------------------------+    */
      ir=1;
 L200:ibg=ponp[ir];
      ied=ponp[ir+1]-1;
      for(it=ibg; it<=ied; it++) {
        ip=abs(pons[it]);
        if(nopp[1+ip*2] <= 0) continue;     /* skip used pipes */
/*      +--------------------------------------------------------+    */
/*      | make ip as a root pipe and jr as a root node : jl = 1  |    */
/*      | mark node jr as labeled : ponp(jr) < 0                 |    */
/*3     +--------------------------------------------------------+    */
        jr=nopp[1+ip*2]+abs(nopp[2+ip*2])-ir;
        ponp[jr]=-ponp[jr];
        jl=1;
        lvsn[jl]=jr;
        lvsp[jl]=pons[it];
        lvsb[jl]=0;
        il=1;
/*4     ----------------------------------------------------------    */
        do {
          in=lvsn[il];
          jbg=abs(ponp[in]);
          jed=abs(ponp[in+1])-1;
          for(jt=jbg; jt<=jed; jt++) {
            jp=abs(pons[jt]);
/*          +----------------------------------------------------+    */
/*          | never go through unused pipe from used node        |    */
/*          +----------------------------------------------------+    */
/*          | ponu(in)=ponp(in+1):unus node:OK for all unus pipe |    */
/*          | ponu(in)=ponp(in)  :used node:OK for all used pipe |    */
/*          | ponu(in)=in between:used node:OK for usd pips only |    */
/*          +----------------------------------------------------+    */
            if(ponu[in] <= jed && nopp[1+jp*2] > 0) continue;
            if(nopp[2+jp*2] < 0) continue;
            jn=abs(nopp[1+jp*2])+nopp[2+jp*2]-in;
            if(ponp[jn] < 0) continue;
            if(jp == ip) continue;
/*5         ------------------------------------------------------    */
            ponp[jn]=-ponp[jn];
            jl=jl+1;
            lvsn[jl]=jn;
            lvsp[jl]=pons[jt];
            lvsb[jl]=il;
            if(jn == ir) goto L500;
          }
/*6       --------------------------------------------------------    */
          il=il+1;
        } while(il <= jl);
/*      +--------------------------------------------------------+    */
/*      | reset index for labeled nodes                          |    */
/*6     | always mark the root pipe and its end nodes as used    |    */
/*7     +--------------------------------------------------------+    */
 L500:  for(il=1; il<=jl; il++) {
          in=lvsn[il];
          ponp[in]=abs(ponp[in]);
        }
/*      ----------------------------------------------------------    */
        ponu[ir]=ponu[ir]-1;
        ponu[jr]=ponu[jr]-1;
        nopp[1+ip*2]=-nopp[1+ip*2];
/*      ----------------------------------------------------------    */
        if(in != ir) continue;
/*      +--------------------------------------------------------+    */
/*      | trace back the level structure for pipes of new loop   |    */
/*7     +--------------------------------------------------------+    */
        nl=nl+1;
        kt=polp[nl];
/*      ----------------------------------------------------------    */
        do {
          jp=abs(lvsp[jl]);
          if(nopp[1+jp*2] > 0) {
            in=nopp[1+jp*2];
            jn=nopp[2+jp*2];
            ponu[in]=ponu[in]-1;
            ponu[jn]=ponu[jn]-1;
            nopp[1+jp*2]=-in;
          }
          pols[kt]=lvsp[jl];
          kt=kt+1;
          jl=lvsb[jl];
        } while(jl > 0);
/*      ----------------------------------------------------------    */
        polp[nl+1]=kt;
      }
/*    +----------------------------------------------------------+    */
/*    | find a used node which has at least one unused pipe : ir |    */
/*    |   or an unused node for another separate district   : iy |    */
/*    +----------------------------------------------------------+    */
/*    | ponu(ir)=ponp(ir+1): unused node: ng for all unused pipe |    */
/*    | ponu(ir)=ponp(ir)  : used   node: ng for all  used  pipe |    */
/*8   | ponu(ir)=in between: used   node: ok for any unused pipe |    */
/*9   +----------------------------------------------------------+    */
      ix=ir;
      iy=nn+1;
      do {
        ir=ir+1;
        if(ir > nn) ir=1;
        if(ir == ix) {
           if(iy > nn) break;
           ml=ml+1;
           ir=iy;
           goto L200;
        }
        if(ponu[ir] == ponp[ir]) continue;
        if(ponu[ir] != ponp[ir+1]) goto L200;
        if(ir < iy) iy=ir;
      } while(1);
/*    ------------------------------------------------------------    */
 L900:if(nl != ml) printf("\n error in mkloop");
      for(ip=1; ip<=np; ip++) {
        nopp[1+ip*2]=abs(nopp[1+ip*2]);
      }
      return(0);
}
/**********************************************************************/
